*CMZ :  0.03/03 29/08/91  11.05.17  by  Peter Schleper
*-- Author :    C.Jacobsson   15/05/91
      SUBROUTINE DGTHRU
C-----------------------------------------------------------------------
C
C   topological event analysis: thrust
C
C   Author:     H. Albrecht. feb 82
C   Changed by: C.Jacobsson for H1PHAN 910513
C   Changed by: K. Rabbertz for DISENT: implicit none           22.11.96
C                                       single -> double prec.
C
C-----------------------------------------------------------------------

ckr
      IMPLICIT NONE
ckr

#include "qjmacs.inc"
C-----------------------------------------------------------------------
ckr add. declaration
      INTEGER I,J,L,ITER
      DOUBLE PRECISION VCX,VCY,VCZ,VLX,VLY,VLZ,VMX,VMY,VMZ
      DOUBLE PRECISION VNX,VNY,VNZ,VNEW,VMAX,VSUM
ckr ende
      DATA VMX,VMY,VMZ/999999.D0,999999.D0,999999.D0/

* MORE THAN 2 TRACKS
      IF (JTBI.GT.2) THEN

        VMAX = 0.D0
        DO 30 I=1,JTBI-1
          DO 20 J=I+1,JTBI
            VCX = QPI(2,I) * QPI(3,J) - QPI(2,J) * QPI(3,I)
            VCY = QPI(3,I) * QPI(1,J) - QPI(3,J) * QPI(1,I)
            VCZ = QPI(1,I) * QPI(2,J) - QPI(1,J) * QPI(2,I)
            VLX = 0.D0
            VLY = 0.D0
            VLZ = 0.D0

            DO 10 L=1,JTBI
              IF (L .EQ. I .OR. L .EQ. J)  GO TO 10
              IF (QPI(1,L) * VCX + QPI(2,L) * VCY +
     &            QPI(3,L) * VCZ .GE. 0.D0)  THEN
                VLX = VLX + QPI(1,L)
                VLY = VLY + QPI(2,L)
                VLZ = VLZ + QPI(3,L)
              ELSE
                VLX = VLX - QPI(1,L)
                VLY = VLY - QPI(2,L)
                VLZ = VLZ - QPI(3,L)
              ENDIF
10          CONTINUE

*           make all four sign-combinations for I,J

            VNX = VLX + QPI(1,J) + QPI(1,I)
            VNY = VLY + QPI(2,J) + QPI(2,I)
            VNZ = VLZ + QPI(3,J) + QPI(3,I)
            VNEW = VNX**2 + VNY**2 + VNZ**2
            IF (VNEW .GT. VMAX)  THEN
              VMAX = VNEW
              VMX = VNX
              VMY = VNY
              VMZ = VNZ
            ENDIF

            VNX = VLX + QPI(1,J) - QPI(1,I)
            VNY = VLY + QPI(2,J) - QPI(2,I)
            VNZ = VLZ + QPI(3,J) - QPI(3,I)
            VNEW = VNX**2 + VNY**2 + VNZ**2
            IF (VNEW .GT. VMAX)  THEN
              VMAX = VNEW
              VMX = VNX
              VMY = VNY
              VMZ = VNZ
            ENDIF

            VNX = VLX - QPI(1,J) + QPI(1,I)
            VNY = VLY - QPI(2,J) + QPI(2,I)
            VNZ = VLZ - QPI(3,J) + QPI(3,I)
            VNEW = VNX**2 + VNY**2 + VNZ**2
            IF (VNEW .GT. VMAX)  THEN
              VMAX = VNEW
              VMX = VNX
              VMY = VNY
              VMZ = VNZ
            ENDIF

            VNX = VLX - QPI(1,J) - QPI(1,I)
            VNY = VLY - QPI(2,J) - QPI(2,I)
            VNZ = VLZ - QPI(3,J) - QPI(3,I)
            VNEW = VNX**2 + VNY**2 + VNZ**2
            IF (VNEW .GT. VMAX)  THEN
              VMAX = VNEW
              VMX = VNX
              VMY = VNY
              VMZ = VNZ
            ENDIF
20        CONTINUE
30      CONTINUE

*       sum momenta of all particles and iterate

        DO 50 ITER=1,4
          QPO(1,1) = 0.D0
          QPO(2,1) = 0.D0
          QPO(3,1) = 0.D0
          DO 40  I=1,JTBI
            IF (VMX * QPI(1,I) + VMY * QPI(2,I) +
     +          VMZ * QPI(3,I) .GE. 0.D0)  THEN
              QPO(1,1) = QPO(1,1) + QPI(1,I)
              QPO(2,1) = QPO(2,1) + QPI(2,I)
              QPO(3,1) = QPO(3,1) + QPI(3,I)
            ELSE
              QPO(1,1) = QPO(1,1) - QPI(1,I)
              QPO(2,1) = QPO(2,1) - QPI(2,I)
              QPO(3,1) = QPO(3,1) - QPI(3,I)
            ENDIF
40        CONTINUE
          VNEW = QPO(1,1)**2 + QPO(2,1)**2 + QPO(3,1)**2
          IF (VNEW .EQ. VMAX)  GO TO 70
          VMAX = VNEW
          VMX = QPO(1,1)
          VMY = QPO(2,1)
          VMZ = QPO(3,1)
50      CONTINUE

* ONLY TWO TRACKS
      ELSEIF (JTBI.EQ.2) THEN

        IF (QPI(1,1) * QPI(1,2) + QPI(2,1) * QPI(2,2) +
     &      QPI(3,1) * QPI(3,2) .GE. 0.D0)  THEN
          QPO(1,1) = QPI(1,1) + QPI(1,2)
          QPO(2,1) = QPI(2,1) + QPI(2,2)
          QPO(3,1) = QPI(3,1) + QPI(3,2)
        ELSE
          QPO(1,1) = QPI(1,1) - QPI(1,2)
          QPO(2,1) = QPI(2,1) - QPI(2,2)
          QPO(3,1) = QPI(3,1) - QPI(3,2)
        ENDIF

* ONLY ONE TRACK
      ELSEIF (JTBI.EQ.1) THEN

        QPO(1,1) = QPI(1,1)
        QPO(2,1) = QPI(2,1)
        QPO(3,1) = QPI(3,1)

* NO TRACKS
      ELSE

        QPO(1,1) = 0.D0
        QPO(2,1) = 0.D0
        QPO(3,1) = 0.D0
        QPO(4,1) = 0.D0
        QTBOR(1,1) = 0.D0
        JTBO = 1
        GOTO 1000

      ENDIF


      VNEW = QPO(1,1)**2 + QPO(2,1)**2 + QPO(3,1)**2

*     normalize thrust -division by total momentum

   70 VSUM = 0.D0
      DO 80 I=1,JTBI
        JTBOF(1,I) = 1
   80   VSUM = VSUM + SQRT (QPI(1,I)**2 + QPI(2,I)**2 + QPI(3,I)**2)
      QTBOR(1,1) = SQRT (VNEW) / VSUM
      QPO(4,1) = SQRT (QPO(1,1)**2 + QPO(2,1)**2 + QPO(3,1)**2)
      JTBO = 1

1000  RETURN
      END
