      subroutine HZ03094(IFLAG)
****************************************************************************
* Purpose: diffractive charm in DIS ZEUS
*
* Event selection:
*
* 1.5 GeV2 < Q2 < 200 GeV2
* 0.02 < y < 0.7
* xpom < 0.035
* beta < 0.8
*
* 1.5 < pt(D*)[lab] 
* |eta(D*)[lab]| < 1.5
*
* Running:
* Beams:
*
* Arguments: iflag=1 initialisation
*            iflag=2 filling
*            iflag=3 termination
*
* written by: h. jung
****************************************************************************
      IMPLICIT NONE
#include "hzfunc.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
* Rapgap IPRO test
*+KEEP, RGPARAS.
      DOUBLE PRECISION PT2CUT,THEMA,THEMI,Q2START,W_Q2,OMEG2
      INTEGER IRUNA,IQ2,IRUNAEM
      INTEGER IPRO
      COMMON/RAPA /IPRO,IRUNA,IQ2,IRUNAEM,Q2START,W_Q2,OMEG2
      DOUBLE PRECISION SCALFA
      COMMON/SCALF/ SCALFA
      COMMON/PTCUT/ PT2CUT(100)
      COMMON/ELECT/ THEMA,THEMI
      REAL ULALPS,ULALEM
      EXTERNAL ULALPS,ULALEM



*
      integer ikpipis
      common /ikeep/ ikpipis
*
      integer ncharmq
* common that gives the position of particles in X and Y system
      integer nxobj,nyobj,nxgag,nygag
      double precision pom
      common /diffhad/pom(5),nxobj(5000),nyobj(5000),nxgag,nygag


      Double precision plab(5,NMXHEP)
*
      Integer i,iflag,ihep
      Character*5 xxxx
*
      Real pi,rd,eb,ee,epb
c      Parameter (ee=27.5)
      Integer ierr,ibeam,igam,iel,idum,idhe,idmo1,idmo2
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
      double precision phb(4)
*
      integer err_flag
      real xnd0,alphem,sigma_tot,x_d,p,pt,et,rap,dst_xsec
      real dst_xsec_error
      Parameter (pi=3.1415927,rd=180./pi)
      Integer nentry
      Real x,y,q2,enel,thel,phiel,efwd,th,lx,lxj
*
      Integer maxhi,modjet,maxjet
      Parameter (maxhi=2000,modjet=2,maxjet=30)
      Real  selj(maxjet,4),help,empz,empzh,xg,empzl,empzhl,xgl
      Integer ipjet(maxjet),l,k
      Real nev(maxhi),lum,lumnb,xw,nev2(maxhi)
      Real deta,ptj2,thj
      Real xpom,xpom2,xpom3
      real x_pom,beta,xgluon,shat,p_sh(4),p_mx(4),mx2,mx
      real shat_12,xgobs_12
      Real xmas,ymas,t
      Real pj1,pj2,pr
      Integer njet,nj,nsel,ij,nhst,iy,iprot,ndplus,nd0,ndstar
      integer ndstar2,ndstar3,ndstar4
      real kpisflag
      Integer nq,nphi,idstar
      Real ptdcut,rapcut
      Double precision rcone
      Parameter (rcone=1.)
      Double Precision phi,sca_prod,abs_vec,phit,sphi
      Double Precision gxpe(3),gxpq(3),pv1(3),pv2(3),pv3(3),pv3n(3)
c info from generator
      Integer iprog
      Real pthg,shg,xpg,zqg,phig,tg,xpomg,w2
      Common/partons/pthg,shg,xpg,zqg,phig,tg,xpomg,iprog
      Logical lp,charmdis,charmdif,ldstar
      Data lp/.false./
**********hadgap
      real ehg,pxhg,pyhg,pzhg,exg,pxxg,pyxg,pzxg
****egamfind
      real eg,thg
      real rq2g,ryg,rxbjg
      integer ivscl,ivgam
      integer irad,idph
      integer ikinq2y,i_do_radcor
      real epzg,epzeg
*********************************************************************
      Integer nx
      Real n2,nall,nall2,nall3,nxp01
      Real xmin,xmax
      save xxxx,nev,nall
      Data xxxx/'03094 '/,NENTRY/0/
* additions from PT
      integer idiff
      real xbj
      real ps,pts,ets,ths,phangs,phang,raps,xd,xgobs,weight
      real cqmass(1)
* charm quark mass in the reconstruction of zpom
      data cqmass / 1.5 /
	Integer icharm,ncharm,ndstart
* vectors for binning
      integer nq2bin,nxpombin
	Parameter (nq2bin=5)
	Parameter (nxpombin=5)
c q2bins are in logq2
      real q2bin(nq2bin+1),xpombin(nxpombin+1)
	data q2bin/0.17,0.6,1.0,1.3,1.55,2.3/
      data xpombin / 0.000001,0.003, 0.006, 0.010, 0.02, 0.035 /

      integer nbetabin
      Parameter (nbetabin=5)
	real betabin(nbetabin+1)
	data betabin/0.0,0.1,0.2,0.3,0.45,0.8/
	Integer nptbin
	Parameter (nptbin=5)
	Real ptbin(nptbin+1)
	Data ptbin/1.5,2.4,3.3,4.2,5.4,10./
	Integer netabin
	Parameter (netabin=5)
	Real etabin(netabin+1)
	data etabin/-1.5,-0.9,-0.3,0.3,0.9,1.5/
	
c data points
      Real xspom(5),xspomst(5)	
      Data xspom/28.,25.4,18.6,13.7,13.7/
      Data xspomst/4.9,4.7,3.6,2.2,2.4/
c xpom < 0.034
	Real xspt(5),xsptst(5)
	Data xspt/307.,151.,70.,26.,2.8/
	Data xsptst/50.,20.,11.,5.,0.9/
      Real xseta(5),xsetast(5)
	Data xseta/212.,213.,195.,125.,134./
	Data xsetast/36.,31.,29.,28.,36./
	Real xsbeta(5),xsbetast(5)
	Data xsbeta/4153.,654.,311.,91.,33./
	Data xsbetast/410.,125.,69.,39.,13/
	Real xsq2(5),xsq2st(5)
	Data xsq2/534.,324.,342.,225.,41/
	Data xsq2st/87.,51.,50.,43.,13./
        
        save nall2, nall3, n2, nxp01, ndstar, ncharm

c

*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
* reset counters
         nall=0.
         nall2=0.
         nall3=0.
         n2=0.
	   nxp01 = 0
	   ndstar = 0
	   ncharm = 0
         call Vzero(nev,maxhi)
         call Vzero(nev2,maxhi)
*
*
* Initialisation: The following MUST always be done
* (i) make subdirectory in PAWC
* - use the name as the xxxxxx in HZxxxxxx subroutine
* (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
* book histos
*
         nx=6
         xmin=0.05e-2
         xmax=0.35e-02



* histos for D*
*
*
         call hbookb(900,'ZEUS log10(q2) MC',nq2bin,q2bin,0.)
         call hbookb(901,'ZEUS beta MC',nbetabin,betabin,0.)
         call hbookb(902,'ZEUS xpom MC',nxpombin,xpombin,0.)
         call hbookb(903,'ZEUS eta MC',netabin,etabin,0.)
         call hbookb(904,'ZEUS pt MC',nptbin,ptbin,0.)
*
         call hbookb(-900,'ZEUS log10(q2) dat',nq2bin,q2bin,0.) 
	   Call hpak (-900,xsq2)
	   Call hpake (-900,xsq2st)
         call hbookb(-901,'ZEUS beta dat',nbetabin,betabin,0.)
	   Call hpak (-901,xsbeta)
 	   Call hpake (-901,xsbetast)
         call hbookb(-902,'ZEUS xpom dat',nxpombin,xpombin,0.)
	   Call hpak (-902,xspom)
 	   Call hpake (-902,xspomst)
         call hbookb(-903,'ZEUS eta dat',netabin,etabin,0.)
	   Call hpak (-903,xseta)
	   Call hpake (-903,xsetast)
         call hbookb(-904,'ZEUS pt dat',nptbin,ptbin,0.)
	   Call hpak (-904,xspt)
	   Call hpake (-904,xsptst)
	   write(6,*) ' hz03094 '
*
*********************************************************************
*
*                      Event Processing
*
*********************************************************************
      Else if(iflag.eq.2) then
*
* Filling: The following MUST always be done
* (i) move to the correct sub-directory in PAWC
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         xw=1.
         nall=nall+xw
*
*--------------------------------------------------------------------
* Get beam and boson vectors
*--------------------------------------------------------------------
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
* Take the beam energy from the steering
         epb=real(PHEP(4,ibeam))
         eb=real(PHEP(4,idum))
         ee=eb
c         if (abs(abs(eb)-ee).gt.0.1) then
c            if (nentry.lt.10) then
c               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
c            elseif (nentry.eq.10) then
c               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
c     +              ' ...last message ! '
c            endif
c            return
c         endif

         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            call VZERO(ph,5)
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif

*
* get electron variables for kinematic selection
*
         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(*,*) 'Hz'//xxxx,' electron not found '
            return
         endif
         enel=real(PHEP(4,iel))
         thel=real(HZPHMANG(PHEP(3,iel), sqrt(PHEP(1,iel)**2+PHEP(2,
     +   iel)**2)))*rd
         phiel=real(HZPHMANG(phep(1,iel),phep(2,iel)))


*--------------------------------------------------------------------
* Get Event Kinematics
*--------------------------------------------------------------------
         q2=real(HZDISKIN(1))
         x =real(HZDISKIN(2))
         y =real(HZDISKIN(3))

         w2=q2*(1.-x)/x
*
         if (lp) then
            write(*,*) 'Hz'//xxxx,' x y q2=',x,y,q2
         endif


* get diffractive kinematics
         do i=1,4
            p_mx(i)=0.
         enddo

         x_pom=1.
         xpom=999.
         call hzhadgap(xmas,ymas,xpom,t)
         mx2=xmas**2


         if (( xpom.le.1.).and.(xpom.ge.x)) then
            x_pom=xpom
         else
            write (6,*)'Hz'//xxxx,' xpom out of range: xpom,x: ;',xpom,x
            return
         endif


         if (lp) then
            write(6,*) 'Hz'//xxxx,' x_pom= ',x_pom,' m_x ',sqrt(mx2)
            write(6,*) 'Hz'//xxxx,' m_y= ',ymas,' t=',t
         endif


            Do 10   ihep=1,nhep
*     do not count scattered electron
               if(ihep.eq.iel) goto 10
               idhe=idhep(ihep)
*  proton tag
               if ( abs(idhe).eq.2212.and.jmohep(1,ihep).eq.2 ) then
                  iprot = ihep
               endif
* real pomeron
               if ( abs(idhe).eq.100) then
                  do i=1,4
                     pbeam(i)=PHEP(i,ihep)
                  enddo
               endif
 10         continue


c               if(jmohep(1,5).ne.2) write(6,*)'mother not a proton',
c     &              irad,jmohep(1,5)
c               if(idhep(5).ne.100) write(6,*)'not a pomeron',
c     &              irad,jmohep(1,5)


c            if( xpom.le.x_pom) x_pom=xpom
            if (lp) then
               write(6,*) 'Hz'//xxxx,' enel= ',enel,' thel= ',thel
               write(6,*) 'Hz'//xxxx,' y= ',y,' q2= ',q2
               write(6,*) 'Hz'//xxxx,' x_pom= ',x_pom,' m_x ',
     &              sqrt(mx2)
            endif
            if(x_pom.lt.x) then
               if(lp) then
                  write(6,*) ' hz03094: x < x_pom = '
                  write(6,*) ' hz03094: x = ',x,'
     &                 x_pom = ',xpom,'t = ',t
                  write(6,*) ' hz03094: xmas = ',xmas,' ymas = ',ymas
                  write(6,*) ' hz03094: q2 = ',q2,' y = ',y
                  write(6,*) 'Hz'//xxxx,' nxgag,nygag ',nxgag,nygag
                  write(6,*) 'Hz'//xxxx,' nxobj ',(nxobj(i),i=1,nxgag)
                  write(6,*) 'Hz'//xxxx,' nyobj ',(nyobj(i),i=1,nygag)
               endif
               return
            endif
* define beta
         beta=(q2)/(q2+mx2)
*------------------------------------------------------------------__
* DIS and diffractive selection
*------------------------------------------------------------------__
         charmdif=.true.
c this is for final publication
         if (y.lt.0.02) charmdif=.false.
         if (y.gt.0.7) charmdif=.false.
         if (q2.lt.1.5) charmdif=.false.
         if (q2.gt.200.) charmdif=.false.
         if (x_pom.gt.0.035) charmdif=.false.
c         if (ymas.gt.1.6) charmdif=.false.
c         if (abs(t).gt.1.0) charmdif=.false.
* D* cuts
         ptdcut = 1.5
         rapcut = 1.5
* Histogram weight
         weight=1.0

***************************************
* Individual control histograms

         if (charmdif) then

*
            idstar = -1000
            nall2=nall2+xw

***


            icharm = 0
* Assume JETSET gets the correct branching fraction
            do ihep=1,nhep
            if ( idhep(ihep) .eq. 4 .and.isthep(ihep).eq.2) then
		   icharm = 1
		   ncharm = ncharm + 1
		endif
            if ( Iabs(idhep(ihep)) .eq. 413 ) then
		if(Icharm.eq.1.and.idhep(ihep).eq.413) then
		   ndstart = ndstart + 1
		   endif
               Do i=1,4
                  Phb(i)=PHEP(i,ihep)
               enddo


* LAB variables
               call hzgetvar(phb,p,pt,et,th,phang,rap,err_flag)
               if(pt.gt.ptdcut
     &	   .and.abs(rap).le.rapcut
     &         .and.beta.lt.0.8) then
			 ndstar = ndstar + 1
                   call hfill(900,real(log10(q2)),0.,weight)
                   call hfill(901,real(beta),0.,weight)
                   call hfill(902,real(x_pom),0.,weight)
                   call hfill(903,real(rap),0.,weight)
                   call hfill(904,real(pt),0.,weight)
                   call hfill(991,real(sqrt(W2)),0.,weight)
			 if(x_pom.lt.0.01) nxp01 = nxp01 + 1
               endif
            endif
            enddo
*
         endif
*********************************************************************
*
*                      Termination
*
*********************************************************************

      Else if(iflag.eq.3) then

* Termination: The following MUST always be done
* (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         lum=999999999.
         lumnb=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
            lumnb=real(nall)/real(xsec)*1000.
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif
*
         write(6,*) ''
         write(6,*) 'hz',xxxx
         write(6,*) 'hz03094(DIFFRACTIVE):'
         write(6,*) 'number of events generated',nall
         write(6,*) 'lumi',lum

         write(6,*) 'hz03094(DIFFRACTIVE): Total Cross(nb)= ',
     &        real(xsec)/1000.
         write(6,*) ' c -> D*: ',real(ndstart)/real(ncharm),
     &        real(ndstart),real(ncharm)




*
*
*      normalize the histos
*
         write(6,*) 'hz',xxxx,' Number of D* = ',ndstar
         dst_xsec= real(ndstar)/real(nall)*xsec*.001
         dst_xsec_error=dst_xsec*(sqrt(real(ndstar))/real(ndstar))

        write(6,*) 'hz',xxxx,'  D* x section = ',dst_xsec,'+/-',
     &        dst_xsec_error

         write(6,*) 'hz',xxxx,' xpom < 0.1 Number of D* = ',nxp01
         dst_xsec= real(nxp01)/real(nall)*xsec*.001
         dst_xsec_error=dst_xsec*(sqrt(real(ndstar))/real(ndstar))

        write(6,*) 'hz',xxxx,' xpom < 0.1:  D* x section = ',
     &       dst_xsec,'+/-', dst_xsec_error

 	



c         write(6,*)'check!!!!!',nall,nall2,ndstar,xsec,dst_xsec,lum

         if(ndstar.gt.1) then
*
* now do the cross section normalisation
            call hopera(900,'+E',900,900,1./lum,0.)
            call hopera(901,'+E',901,901,1./lum,0.)
            call hopera(902,'+E',902,902,1./lumnb,0.)
            call hopera(903,'+E',903,903,1./lum,0.)
            call hopera(904,'+E',904,904,1./lum,0.)
            call hopera(991,'+E',991,991,1./lum,0.)

* now normalise histo with 1/binwidth
            call hzhinrm(900,0, 1., 1 )
            call hzhinrm(901,0, 1., 1 )
            call hzhinrm(902,0, 1., 1 )
            call hzhinrm(903,0, 1., 1 )
            call hzhinrm(904,0, 1., 1 )
            call hzhinrm(991,0, 1., 1 )

         endif
*

      endif
*
      RETURN
      END
	

