*CMZ :  2.00/06 02/05/2002  14.57.20  by  Tancredi Carli
*CMZ :  1.01/15 14/05/98  11.05.42  by  Tancredi Carli
*CMZ :  1.01/11 09/12/97  16.44.12  by  Tancredi Carli
*CMZ :  1.01/07 10/10/97  19.46.50  by  Tancredi Carli
*CMZ :  1.01/05 04/09/96  17.56.33  by   Tancredi Carli
*CMZ :  1.00/02 12/03/96  18.57.45  by  Tancredi Carli
*CMZ :  0.00/11 19/02/96  10.25.14  by  Tancredi Carli
*CMZ :  0.00/09 16/02/96  17.15.47  by  Tancredi Carli
*CMZ :  0.00/08 15/02/96  11.03.41  by  Tancredi Carli
*CMZ :  0.00/04 26/01/96  13.36.15  by  Tancredi Carli
*CMZU:  0.00/03 16/01/96  18.07.56  by  Tancredi Carli
*CMZ :  0.00/01 05/01/96  18.27.51  by  HZtool
*-- Author :
************************************************************************
      Subroutine hz95007(iflag)
************************************************************************
* Subroutine hz95007                                                   *
* ==================                                                   *
*                                                                      *
* Author: Nick Brook (brook@v2.ph.gla.ac.uk)                           *
*                                                                      *
* This routine plots the multiplicit and log(1./xp) distbns            *
* in the current region of the Breit frame.                            *
* The distbn are corrected for particles coming from K0s and Lambdas   *
*                                                                      *
*                                                                      *
* Reference: Z Phys C67(1995) 93.                                      *
*            DESY 95-007                                               *
*                                                                      *
* Modified: add data histogram with stat error only   13.2.96          *
*           include hzchisq                                            *
*            add check on beam energy
************************************************************************
*
* HERA tuning defined commons
*
      Implicit Double Precision(A-H,O-Z)
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzhbook.inc"
*
      COMMON/QUEST/IQUEST(100)
*
* Set up local variables
*
      Integer idum,ierr,nentry
      Character xxxx*5
      Real eb,ee
      Parameter (ee=26.7)
      Character*80 chtitl
      Character*2 cid
      Dimension plab(4), pbrt(4), pbeam(4), pgam(4), pgam5(5)
      Real chmult(25), chmulte(25), chmults(25)
      Real chlogx(25), chlogxe(25), chlogxs(25)
      Dimension qbins(8), xbins(5), qmean(10)
      Real chmean(10), chsig(10), xpmean
      Real par(3), step(3), pmin(3),pmax(3),sigpar(3),chi2
      Real xmi, xma, ymi, yma
      Integer ids(10), id
      Real  Nacc(10)
      Character*8 Tags(11)
      Real event(11)
      Integer iqu, iql, ixu, ixl
      Data Tags/'Qmean','Q2low','Q2high','xbjlow','xbjhigh',
     +          'nch','nchstat','nchsys','logxp','logxstat',
     1          'logxsys'/
*
      Real data1(25,10), erro1(25,10), syse1(25,10)
      Real data2(22,10), erro2(22,10), syse2(22,10)
      Real qdat(10)
      Real chdat(10), chdate(10), chdats(10)
      Real xpdat(10), xpdate(10), xpdats(10)
*
      Data nentry/0/
      Data xxxx/'95007'/
      data ids/12,13,23,33,24,34,44,54,65,75/
      data Nacc /10*0./
*
* Data points from plots
*
      data data1/
     + .334,.335,.227,.084,.018,.0027,.0002,18*0.,
     1 .289,.343,.241,.097,.025,.0039,.0016,.00003,17*0.,
     2 .190,.279,.266,.167,.073,.022,.0025,.0008,17*0.,
     3 .115,.190,.261,.227,.119,.059,.018,.010,.0006,16*0.,
     4 .151,.283,.285,.185,.070,.022,.0044,.0016,17*0.,
     5 .076,.185,.276,.237,.133,.066,.019,.0050,.0014,16*0.,
     6 .069,.118,.215,.232,.173,.105,.054,.020,.010,.0038,.0009,14*0.,
     7 .045,.084,.127,.235,.169,.143,.106,.048,.027,.012,.0041,14*0.,
     8 .014,.052,.090,.175,.211,.159,.119,.096,.052,.026,.0060,14*0.,
     9 .015,.040,.065,.130,.107,.173,.078,.139,.085,.111,.048,2*0.,
     + .0089,11*0./
      data erro1/
     + .008,.008,.007,.004,.002,.0006,.0002,18*0.,
     1 .008,.009,.007,.005,.002,.0010,.0017,.0003,17*0.,
     2 .008,.011,.010,.009,.006,.003,.0010,.0007,17*0.,
     3 .010,.012,.016,.014,.010,.007,.004,.003,.0007,16*0.,
     4 .007,.010,.010,.077,.005,.003,.0012,.0010,17*0.,
     5 .006,.009,.012,.010,.007,.005,.028,.0013,.0007,16*0.,
     6 .008,.011,.015,.015,.013,.010,.007,.004,.003,.0020,.0009,14*0.,
     7 .015,.019,.020,.030,.023,.021,.021,.013,.011,.007,.0028,14*0.,
     8 .008,.018,.022,.035,.036,.028,.023,.021,.015,.009,.0036,14*0.,
     9 .014,.023,.028,.037,.043,.049,.028,.047,.032,.052,.033,2*0.,
     + .0104,11*0./
      data syse1/
     + .050,.025,.043,.021,.011,.0017,.0005,18*0.,
     1 .094,.021,.043,.033,.010,.0053,.0017,.0004,17*0.,
     2 .033,.032,.018,.032,.025,.017,.0019,.0013,17*0.,
     3 .055,.038,.033,.013,.012,.011,.014,.007,.0014,16*0.,
     4 .039,.053,.011,.049,.024,.012,.0062,.0018,17*0.,
     5 .024,.043,.027,.013,.027,.031,.067,.0021,.0021,16*0.,
     6 .045,.038,.037,.016,.024,.035,.012,.013,.005,.0030,.0010,14*0.,
     7 .057,.042,.028,.050,.049,.045,.063,.012,.014,.007,.0063,14*0.,
     8 .020,.038,.027,.055,.058,.055,.038,.100,.049,.015,.0091,14*0.,
     9 .029,.024,.041,.161,.049,.079,.122,.046,.074,.085,.054,2*0.,
     + .0252,11*0./
      data data2/
     + .001,.014,.061,.201,.262,.419,.613,.661,.675,.580,.420,.306,.259,
     + .133,.104,.019,.101,5*0.,
     1 .003,.008,.059,.145,.289,.485,.660,.699,.694,.616,.506,.366,.383,
     1 .138,.069,.048,.020,5*0.,
     2 0.,.007,.035,.123,.294,.394,.723,.971,1.002,.945,.741,.675,.520,
     2 .277,.271,.132,.046,.022,4*0.,
     3 0.,.002,.022,.129,.336,.549,.629,.778,1.176,1.209,1.013,.906,
     3 .828,.723,.431,.294,.245,.093,4*0.,
     4 2*0.,.006,.065,.093,.304,.419,.641,1.016,.932,.984,.727,.622,
     4 .512,.304,.177,.166,.068,.057,.040,2*0.,
     5 2*0.,.009,.022,.096,.299,.449,.632,.940,1.031,1.299,1.119,1.077,
     5 .746,.640,.457,.310,.138,.071,.042,.080,0.,
     6 3*0.,.048,.096,.225,.307,.750,.803,1.099,1.245,1.240,1.457,1.111,
     6 1.023,.761,.642,.338,.351,.105,.005,0.,
     7 3*0.,.003,.076,.191,.402,.484,.907,1.226,1.457,1.299,2.073,1.272,
     7 1.302,1.022,.823,.667,.774,.186,.151,.091,
     8 3*0.,.117,.131,.456,.382,.745,1.525,1.141,1.140,1.707,1.662,
     8 1.538,1.964,1.478,1.191,.799,.552,.310,.019,.029,
     9 4*0.,.168,.144,.449,.701,.772,1.418,2.151,1.818,2.394,1.616,
     9 1.843,1.307,1.723,2.593,.993,.884,.210,.075/
      data erro2/
     + .001,.005,.012,.026,.027,.035,.044,.046,.046,.043,.036,.031,.032,
     + .023,.024,.009,.118,5*0.,
     1 .002,.003,.012,.020,.030,.040,.048,.049,.049,.046,.044,.038,.036,
     1 .027,.018,.017,.013,5*0.,
     2 0.,.005,.012,.023,.044,.045,.067,.083,.083,.078,.065,.068,.064,
     2 .042,.047,.037,.021,.017,4*0.,
     3 0.,.003,.012,.040,.076,.094,.094,.097,.138,.141,.118,.111,.113,
     3 .116,.082,.077,.087,.054,4*0.,
     4 2*0.,.004,.019,.017,.039,.041,.055,.075,.065,.071,.056,.055,.053,
     4 .039,.028,.035,.023,.032,.056,2*0.,
     5 2*0.,.009,.010,.022,.048,.055,.061,.077,.081,.097,.086,.090,.069,
     5 .071,.058,.049,.032,.023,.021,.071,0.,
     6 3*0.,.046,.037,.054,.060,.106,.100,.120,.128,.121,.143,.118,.118,
     6 .105,.104,.070,.106,.043,.052,0.,
     7 3*0.,.005,.054,.086,.137,.136,.203,.238,.273,.231,.348,.233,.240,
     7 .214,.195,.186,.267,.113,.100,.097,
     8 3*0.,.156,.083,.199,.132,.240,.427,.268,.247,.353,.308,.335,.431,
     8 .347,.317,.236,.229,.190,.022,.035,
     9 4*0.,.194,.125,.270,.323,.348,.539,.744,.523,.647,.496,.541,.436,
     9 .538,.883,.466,.490,.175,.094/
      data syse2/
     + .002,.009,.015,.090,.029,.073,.079,.098,.073,.113,.025,.056,.080,
     + .019,.018,.033,.119,5*0.,
     1 .003,.007,.008,.027,.034,.088,.140,.094,.039,.050,.117,.043,.128,
     1 .053,.010,.029,.025,5*0.,
     2 0.,.005,.010,.043,.074,.023,.099,.130,.215,.198,.058,.097,.138,
     2 .082,.059,.033,.034,.015,4*0.,
     3 0.,.032,.038,.026,.076,.181,.104,.086,.372,.285,.166,.156,.285,
     3 .121,.114,.104,.125,.060,4*0.,
     4 2*0.,.007,.029,.014,.089,.032,.089,.187,.120,.176,.157,.161,.089,
     4 .092,.027,.086,.068,.043,.040,2*0.,
     5 2*0.,.007,.028,.081,.109,.083,.086,.095,.101,.251,.138,.196,.102,
     5 .081,.043,.089,.048,.034,.058,.113,0.,
     6 3*0.,.057,.013,.045,.113,.243,.107,.091,.268,.131,.281,.417,.141,
     6 .143,.231,.065,.244,.182,.083,0.,
     7 3*0.,.044,.054,.172,.141,.096,.156,.263,.573,.304,.810,.146,.113,
     7 .223,.197,.122,.368,.208,.260,.070,
     8 3*0.,.074,.442,.265,.202,.224,.891,.181,1.308,.318,.712,.451,
     8 .526,.343,.143,.267,.294,.187,.097,.033,
     9 4*0.,.135,.148,.296,.689,1.869,1.024,1.183,.576,.877,.457,.943,
     9 .205,1.047,1.744,.633,.436,.229,.150/
*
      data qdat/3.8,3.8,5.3,7.3,5.3,7.4,10.4,14.5,20.4,29.2/
      data chdat/1.12,1.25,1.73,2.35,1.83,2.47,3.05,3.77,4.49,5.57/
      data chdate/.02,.02,.04,.07,.03,.05,.09,.22,.30,.65/
      data chdats/.15,.25,.23,.11,.27,.23,.31,.40,.54,1.21/
      data xpdat/1.49,1.50,1.70,1.94,1.70,1.92,2.18,2.25,2.78,2.85/
      data xpdate/.02,.03,.03,.06,.03,.03,.06,.10,.22,.21/
      data xpdats/.06,.06,.06,.11,.09,.07,.10,.23,.26,.24/

      save qbins, xbins

*
      If(iflag.eq.1) then
*
* Initialisation: The following MUST always be done
* (i) make subdirectory in PAWC
*      - use the name as the xxxxxx in HZxxxxxx subroutine
* (i) make subdirectory in o/p file
*
        Call hcdir('//PAWC',' ')
        call hmdir('95007','S')
        Call hcdir('//HISTO',' ')
        call hmdir('95007','S')
*
* book your histograms
*
        Do kd = 1, 10
          write(cid,'(I2)') ids(kd)
          call hbook1(ids(kd),' multi ('//cid//')',25,0.,25.,0.)
          call hidopt(ids(kd),'STAT')
          call hbook1(100+ids(kd),' log(1/xp) ('//cid//')',
     +                22,-0.55,4.95,0.)
        Enddo
        Call hbookn(1000,'Monte Carlo',11,' ',200,TAGS)
        Call hbookn(1001,'Data',11,' ',200,TAGS)
*
* set your plot/paper specific cuts
*
        qbins(1) = 10.
        qbins(2) = 20.
        qbins(3) = 40.
        qbins(4) = 80.
        qbins(5) = 160.
        qbins(6) = 320.
        qbins(7) = 640.
        qbins(8) = 1280.
        xbins(1) = 6.0e-04
        xbins(2) = 1.2e-03
        xbins(3) = 2.4e-03
        xbins(4) = 1.0e-02
        xbins(5) = 5.0e-02
*
      Else if(iflag.eq.2) then
* Filling: The following MUST always be done
* (i) move to the correct sub-directory in PAWC
*
        call hcdir('//PAWC/95007',' ')
        q2  = hzdiskin(1)
        xbj = hzdiskin(2)
        If(q2.ge.qbins(1).and.q2.lt.qbins(2).and.
     +     xbj.ge.xbins(1).and.xbj.lt.xbins(2)) then
           id = 12
           Nacc(1) = Nacc(1) + wtx
           qmean(1) = qmean(1) + sqrt(q2)
        Else If(q2.ge.qbins(1).and.q2.lt.qbins(2).and.
     +     xbj.ge.xbins(2).and.xbj.lt.xbins(3)) then
           id = 13
           Nacc(2) = Nacc(2) + wtx
           qmean(2) = qmean(2) + sqrt(q2)
        Else If(q2.ge.qbins(2).and.q2.lt.qbins(3).and.
     +     xbj.ge.xbins(2).and.xbj.lt.xbins(3)) then
           id = 23
           Nacc(3) = Nacc(3) + wtx
           qmean(3) = qmean(3) + sqrt(q2)
        Else If(q2.ge.qbins(3).and.q2.lt.qbins(4).and.
     +     xbj.ge.xbins(2).and.xbj.lt.xbins(3)) then
           id = 33
           Nacc(4) = Nacc(4) + wtx
           qmean(4) = qmean(4) + sqrt(q2)
        Else If(q2.ge.qbins(2).and.q2.lt.qbins(3).and.
     +     xbj.ge.xbins(3).and.xbj.lt.xbins(4)) then
           id = 24
           Nacc(5) = Nacc(5) + wtx
           qmean(5) = qmean(5) + sqrt(q2)
        Else If(q2.ge.qbins(3).and.q2.lt.qbins(4).and.
     +     xbj.ge.xbins(3).and.xbj.lt.xbins(4)) then
           id = 34
           Nacc(6) = Nacc(6) + wtx
           qmean(6) = qmean(6) + sqrt(q2)
        Else If(q2.ge.qbins(4).and.q2.lt.qbins(5).and.
     +     xbj.ge.xbins(3).and.xbj.lt.xbins(4)) then
           id = 44
           Nacc(7) = Nacc(7) + wtx
           qmean(7) = qmean(7) + sqrt(q2)
        Else If(q2.ge.qbins(5).and.q2.lt.qbins(6).and.
     +     xbj.ge.xbins(3).and.xbj.lt.xbins(4)) then
           id = 54
           Nacc(8) = Nacc(8) + wtx
           qmean(8) = qmean(8) + sqrt(q2)
        Else If(q2.ge.qbins(6).and.q2.lt.qbins(7).and.
     +     xbj.ge.xbins(4).and.xbj.lt.xbins(5)) then
           id = 65
           Nacc(9) = Nacc(9) + wtx
           qmean(9) = qmean(9) + sqrt(q2)
        Else If(q2.ge.qbins(7).and.q2.lt.qbins(8).and.
     +     xbj.ge.xbins(4).and.xbj.lt.xbins(5)) then
           id = 75
           Nacc(10) = Nacc(10) + wtx
           qmean(10) = qmean(10) + sqrt(q2)
        Else
           Return
        Endif
*
* Fill your histograms
*
          jel = hzidelec(idum)
          if(jel.lt.0) Return
          if(hzipgam(pgam5).lt.0) Return
          if(hzibeam(ip,il).ne.1) Return
* check on electron beam energy
          nentry=nentry+1
          ierr=HZIBEAM(ibeam,idum)
          if (.not.(ierr.eq.1)) then
           write(6,*) 'HZ'//xxxx,' beams not found ! '
           return
          endif
*
          eb=real(PHEP(4,idum))
          if (abs(abs(eb)-ee).gt.0.2) then
           if (nentry.lt.10) then
            write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
           elseif (nentry.eq.10) then
            write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &      ' ...last message ! '
           endif
C           return
          endif
*
          do ivec = 1, 4
            pbeam(ivec) = phep(ivec,ip)
            pgam(ivec) = pgam5(ivec)
          enddo
          Call hzbrtini(pbeam,pgam,ierr)
          nch = 0
          do 30 ihep = 1, nhep
            If(isthep(ihep).eq.1.and.ihchrg(ihep).ne.0
     +         .and.ihep.ne.jel) then
             idpart=abs(idhep(jmohep(1,ihep)))
             If(idpart.eq.310.or.idpart.eq.3122) goto 30
             do ivec=1,4
               plab(ivec) = phep(ivec,ihep)
             enddo
             Call hzbrt(plab,pbrt,ierr)
             if(pbrt(3).lt.0.) then
               nch = nch + 1
               xp = 2.*sqrt(pbrt(1)**2+pbrt(2)**2+pbrt(3)**2)
     +               /sqrt(q2)
               call hfill(100+id,-1.*real(log(xp)),0.,wtx)
             endif
            Endif
 30       continue
          call hfill(id,real(nch),0.,wtx)
*
      Else if(iflag.eq.3) then
* Termination: The following MUST always be done
* (i) Move to the correct PAW subdirectory
*
        call hcdir('//PAWC/95007',' ')
*
* Histo manipulation
* Deal with data plots
*
        Do kd = 1, 10
          nacc(kd) = max(1.,nacc(kd))
          qmean(kd) = qmean(kd)/dble(nacc(kd))
          chmean(kd) = hstati(ids(kd),1,' ',1)
          chsig(kd)  = chmean(kd)/sqrt(real(nacc(kd)))
          Call hgive(ids(kd),chtitl,nx,xmi,xma,ny,ymi,yma,nwt,loc)
          Call hopera(ids(kd),'+e',ids(kd),ids(kd),
     +            1./real(nacc(kd))*real(nx)/(xma-xmi),0.)
C*TC>
          call hzhinfo(ids(kd),nacc(kd))
C*TC<
          id=-1000-ids(kd)
          call hbook1(id,chtitl,25,0.,25.,0.)
          Call ucopy(data1(1,kd),chmult,25)
          Call ucopy(erro1(1,kd),chmulte,25)
          Call hpak(id,chmult)
          Call hpake(id,chmulte)
          call hbook1(-ids(kd),chtitl,25,0.,25.,0.)
          Call ucopy(data1(1,kd),chmult,25)
          Call ucopy(erro1(1,kd),chmulte,25)
          Call ucopy(syse1(1,kd),chmults,22)
          do ipt = 1, 25
            chmulte(ipt) = sqrt(chmulte(ipt)**2+chmults(ipt)**2)
          enddo
          Call hpak(-ids(kd),chmult)
          Call hpake(-ids(kd),chmulte)
          kids = 100+ids(kd)
          xpmean = hstati(kids,1,' ',1)
          Call hgive(kids,chtitl,nx,xmi,xma,ny,ymi,yma,nwt,loc)
          call hxi(kids,xpmean+1.,limup)
          call hxi(kids,xpmean-1.,limlo)
          iquest(11) = limlo
          iquest(12) = limup
          par(1)= hmax(kids)
          par(2) = xpmean
          par(3) = hstati(kids,2,' ',1)
          Call hfithn(kids,'G','NQR',3,par,step,pmin,pmax,sigpar,chi2)
          Call hopera(kids,'+e',kids,kids,
     +            1./real(nacc(kd))*real(nx)/(xma-xmi),0.)
C*TC>
          call hzhinfo(kids,nacc(kd))
C*TC<
          id=-1000-kids
          call hbook1(id,chtitl,22,-0.55,4.95,0.)
          Call ucopy(data2(1,kd),chlogx,22)
          Call ucopy(erro2(1,kd),chlogxe,22)
          Call hpak(id,chlogx)
          Call hpake(id,chlogxe)
          call hbook1(-kids,chtitl,22,-0.55,4.95,0.)
          Call ucopy(data2(1,kd),chlogx,22)
          Call ucopy(erro2(1,kd),chlogxe,22)
          Call ucopy(syse2(1,kd),chlogxs,22)
          do ipt = 1, 22
            chlogxe(ipt) = sqrt(chlogxe(ipt)**2+chlogxs(ipt)**2)
          enddo
          Call hpak(-kids,chlogx)
          Call hpake(-kids,chlogxe)
*
          Write(6,*) ' Monte Carlo Data '//gen
          Write(6,1001) kd,qmean(kd)
          Write(6,1002) ' n_ch         = ',chmean(kd),' +/- ',chsig(kd)
          Write(6,1002) ' log(1/xp)max = ',par(2),' +/- ',sigpar(2)
          Write(6,*) ' '
          Write(6,*) ' ZEUS data '
          Write(6,1001) kd,qdat(kd)
          Write(6,1003) ' n_ch         = ',chdat(kd),' +/- ',
     +                         chdate(kd),' +/- ',chdats(kd)
          Write(6,1003) ' log(1/xp)max = ',xpdat(kd),' +/- ',
     +                         xpdate(kd),' +/- ',xpdats(kd)
          Write(6,*) ' '
          if(kd.eq.1) then
            iql = 1
            iqu = 2
            ixl = 1
            ixu = 2
          else if(kd.eq.2) then
            iql = 1
            iqu = 2
            ixl = 2
            ixu = 3
          else if(kd.eq.3) then
            iql = 2
            iqu = 3
            ixl = 2
            ixu = 3
          else if(kd.eq.4) then
            iql = 3
            iqu = 4
            ixl = 2
            ixu = 3
          else if(kd.eq.5) then
            iql = 2
            iqu = 3
            ixl = 3
            ixu = 4
          else if(kd.eq.6) then
            iql = 3
            iqu = 4
            ixl = 3
            ixu = 4
          else if(kd.eq.7) then
            iql = 4
            iqu = 5
            ixl = 3
            ixu = 4
          else if(kd.eq.8) then
            iql = 5
            iqu = 6
            ixl = 3
            ixu = 4
          else if(kd.eq.9) then
            iql = 6
            iqu = 7
            ixl = 4
            ixu = 5
          else if(kd.eq.10) then
            iql = 7
            iqu = 8
            ixl = 4
            ixu = 5
          Endif
          event(1) = real(qmean(kd))
          event(2) = real(qbins(iql))
          event(3) = real(qbins(iqu))
          event(4) = real(xbins(ixl))
          event(5) = real(xbins(ixu))
          event(6) = real(chmean(kd))
          event(7) = real(chsig(kd))
          event(8) = 0.
          event(9) = real(par(2))
          event(10) = real(sigpar(2))
          event(11) = 0.
          Call hfn(1000,event)
          event(1) = real(qdat(kd))
          event(6) = real(chdat(kd))
          event(7) = real(chdate(kd))
          event(8) = real(chdats(kd))
          event(9) = real(xpdat(kd))
          event(10) = real(xpdate(kd))
          event(11) = real(xpdats(kd))
          Call hfn(1001,event)
          call HZCHISQ(-ids(kd),ids(kd))
          call HZCHISQ(-1000-ids(kd),ids(kd))
          call HZCHISQ(-kids,kids)
          call HZCHISQ(-1000-kids,kids)
        Enddo

      Endif
*
      Return
 1001 Format(/,1X,' bin # ',I2,' Mean Q = ',F4.1)
 1002 Format(A,F4.2,A,F4.2)
 1003 Format(A,F4.2,A,F4.2,A,F4.2)
      End
