*CMZ :  1.01/15 14/05/98  11.01.37  by  Tancredi Carli
*CMZ :  1.01/11 14/11/97  10.34.18  by  Tancredi Carli
*CMZ :  1.01/07 08/10/97  16.10.08  by  Tancredi Carli
*CMZ :  1.01/04 01/08/96  19.06.45  by   Tancredi Carli
*-- Author :
*
*CMZ :  1.01/03 09/04/96  19.55.00  by  Tancredi Carli
*CMZ :  1.01/02 09/04/96  18.16.46  by  Tancredi Carli
*-- Author : Tancredi Carli
      subroutine HZ95036(IFLAG)
****************************************************************************
* Purpose: produced histograms for:
*           o) rap max distribution (not corrected)
*           o) Mx distribution (not corrected)
*           o) ...still missing F2d
* Event selection:
*
* Running: Ee=26.7 HERA running 1992
* Reference: Phys. Lett. B 348 (1995) 681-696
* Arguments: iflag=1 initialisation
*            iflag=1 filling
*            iflag=3 termination
*
* NOTE: The H1 data provided here are not corrected. They
*       can therefore not be compared directly to the
*       Monte Carlo curves !!!
*
* written by: Tancredi Carli and Renate Mohr
*             (carli@mail.desy.de mohr@mail.desy.de)
*             data put in non-equidistant bins by M. Sutton
****************************************************************************
      IMPLICIT NONE
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'95036'/
*
      Real pi,rd,ee,eb,wbin
      Logical evcut,lp
      Integer iel,idum,id,jhep,iturn,imax,jmax
      Real nev,nsel
      Parameter (pi=3.1415927,rd=180./pi,ee=26.7)
      Data lp/.false./
C     Data lp/.true./
      Real x,y,q2,enel,thel,th,thj,thcut,rapmax,pt,p
      Real xmi,xma,ymi,yma,rapi,rapj
      Integer ny
      Character chtitl*80
      Real thmin,thmax,ener,gapmax,rcrit
*
      Integer nx,mx,neta
      Real tmx,tnx,smx,smy,x0,y0
      Parameter (nx=16,mx=15)
      Real yn(nx),rap(nx),eyn(nx),erap(nx)
      Real xm(mx),xmy(mx),exmy(mx)
      Real VMIN,VMAX,xcmin,xcmax
      Real prem(4),pmx(4),xinvx,xinvr
      Real xeta(nmxhep)
      Real xpom,beta
      Integer ierr,ibeam,igam
      Integer n85,n12,n25,n50
      Parameter (n85=8,n12=22,n25=18,n50=14)
      Real beta85(n85),x85(n85),f285(n85),st85(n85),sy85(n85)
      Real beta12(n12),x12(n12),f212(n12),st12(n12),sy12(n12)
      Real beta25(n25),x25(n25),f225(n25),st25(n25),sy25(n25)
      Real beta50(n50),x50(n50),f250(n50),st50(n50),sy50(n50)
      Real rapbin(nx+1)
      Save nev,nsel

      save eyn, yn

*
******************************************************************************
* Data points from plots (in postscript co-ordinates)
      Data rap /111.,129.,147.,164.,182.,199.,217.,235.,252.,270.,
     &          284.,293.,301.,308.,315.,322./
      Data  yn /663.,691.,697.,706.,706.,706.,704.,706.,708.,719.,
     &          729.,739.,755.,777.,781.,705./
      Data erap/120.,138.,156.,155.,191.,209.,226.,244.,263.,279.,
     &          290.,297.,304.,311.,318.,319./
      Data  eyn/667.,691.01,697.01,706.01,706.01,706.01,704.01,706.01,
     &          708.01,719.01,729.01,739.01,755.01,777.01,781.01,705.01/
*
      Data xmy /514.,554.,526.,515.,495.,486.,470.,469.,466.,463.,
     &          457.,457.,457.,456.,456./
      Data exmy/  9., 10.,  9.,  8.,  7.,  6.,  0.,  0.,  0.,  0.,
     &            0.,  0.,  0.,  0.,  0./
      Data  xm /418.,435.,450.,467.,482.,499.,515.,533.,547.,563.,
     &          579.,595.,611.,627.,643./
* Q2 8.5 GeV2
      Data beta85/0.065,0.065,2*0.175,0.375,0.375,0.65,0.65/
      Data    x85/0.00024,0.00042,0.00024,0.00042,0.00024,0.00042,
     &            0.00024,0.00042/
      Data   f285/4.21,3.65,24.4,25.14,84.85,40.85,139.25,37.66/
      Data   st85/1.68,1.23,7.33,5.62,23.72,11.48,56.85,17.77/
      Data   sy85/2.44,1.51,4.5,6.38,17.53,8.97,35.43,8.12/
* Q2 12 GeV2
      Data beta12/5*0.065,6*0.175,6*0.375,5*0.65/
      Data    x12/0.0024 ,0.00042,0.00075,0.00133,0.00237,
     &            0.00024,0.00042,0.00075,0.00133,0.00237,
     &            0.00421,0.00024,0.00042,0.00075,0.00133,
     &            0.00237,0.00421,0.00042,0.00075,0.00133,
     &            0.00237,0.00421/
      Data   f212/  12.45,   4.38,   4.43,   0.60,   1.31,
     &              34.99,  15.82,   6.20,   3.99,   1.85,
     &               1.00,  56.41,  41.30,  31.88,   9.54,
     &               6.05,   3.84,  58.00,  35.34,  25.57,
     &              25.04,   3.44/
      Data   st12/   3.39,   1.29,   0.87,   0.38,   0.38,
     &                9.6,   3.94,   1.72,   1.05,   0.54,
     &                0.51, 21.72,  10.18,   7.58,   2.64,
     &                1.53,  1.18,  19.94,   9.71,   6.03,
     &                 4.7,  1.88/
      Data  sy12/     4.72,  1.22,   1.84,   0.39,   0.47,
     &                 8.4,  2.67,   1.37,   0.77,    0.52,
     &                0.49, 17.15,   8.15,   4.65,    1.70,
     &                0.89,  1.17,   8.08,   4.78,    3.44,
     &                3.95,  1.93/
* Q2 25 GeV
      Data  beta25/3*0.065,5*0.175,5*0.375,5*0.650/
      Data     x25/0.00075,0.00133,0.00237,0.00075,0.00133,
     &             0.00237,0.00421,0.0075 ,0.00075,0.00133,
     &             0.00237,0.00421,0.0075 ,0.00075,0.00133,
     &             0.00237,0.00421,0.0075/
      Data    f225/   2.20,   1.08,   1.29,  12.89,   3.08,
     &                2.57,   1.71,   0.82,  37.64,  13.52,
     &                6.54,   2.42,   1.93,  37.02,  26.54,
     &               12.76,   7.43,   1.30/
      Data   st25/     0.7,   0.39,   0.30,   2.42,   0.90,
     &                0.57,   0.40,   0.37,   7.85,   3.09,
     &                1.52,   0.64,   0.65,  10.13,   6.31,
     &                2.95,   1.71,   0.74/
      Data   sy25/    0.51,   0.32,   0.43,   2.53,   0.85,
     &                0.95,   0.41,   0.33,   6.30,    1.94,
     &                0.90,   0.40,   0.55,   6.01,    3.99,
     &                1.87,   0.99,   0.63/
*Q2=50 GeV2
      Data beta50/4*0.175,5*0.375,5*0.675/
      Data    x50/0.00133,0.00237,0.00421,0.00750,0.00133,
     &            0.00237,0.00421,0.00750, 0.0133,0.00133,
     &            0.00237,0.00421,0.00750,0.0133/
      Data   f250/   7.04,   2.84,   2.33,   1.35,  22.68,
     &              11.03,   4.34,   1.89,   1.09,  21.33,
     &              17.47,   9.34,   1.69,  0.96/
      Data  st50/    2.44,   1.06,   0.80,   0.55,   7.85,
     &               3.32,   1.45,   0.74,   0.81,   13.07,
     &               6.95,   3.45,   1.13,    0.78/
      Data sy50/     3.12,   0.87,   1.09,    0.71,   3.64,
     &               1.83,   0.80,   0.54,    0.54,   3.75,
     &               2.95,   2.07,   0.89,    0.62/
******************************************************************************
*
      IF (iflag.eq.1) then
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
       Call hcdir('//PAWC',' ')
       call hmdir(xxxx,'S')
       Call hcdir('//HISTO',' ')
       call hmdir(xxxx,'S')
*
       nev=0.
       nsel=0.
*
*      transformation constants
*
       tmx=4./141.
       tnx=-5.404255319
*
*      do transformation form PS coordinates to physics coordinates
*
       do i=1,nx
          eyn(i)=10**(abs(eyn(i)-yn(i)/2.)/38.-20.1052)
          yn(i) =10**(yn(i)/38.-20.1052)
          erap(i)= abs(erap(i)-rap(i))*tmx
          rap(i) = rap(i)*tmx - tnx
       enddo
       rapbin(1)=rap(1)-erap(1)
       do i=1,nx
          rapbin(i+1) = rap(i)+erap(i)
       enddo
*
       smx=1./6.
       smy=1./9400.
       x0=410.
       y0=453.
*
       do i=1,mx
        xm(i)  =smx*(xm(i)-x0)
        xmy(i) =smy*(xmy(i)-y0)
        exmy(i)=smy*0.5*exmy(i)
       enddo
*
       xcmin=tmx*111.+tnx
       xcmax=tmx*322.+tnx
       wbin=abs(xcmax-xcmin)/float(nx)
       xcmin=xcmin-wbin/2.
       xcmax=xcmax+wbin/2.
       if (lp) then
        write(6,*) ' book= 10 xcmin= ',xcmin,' xcmax= ',xcmax,
     &  ' wbin= ',wbin
       endif
*
*      book your histograms  (data: ID<0)
*
C      call hbook1(-10,' dN/drapmax ',nx,xcmin,xcmax, 0.)
       call hbookb(-10,' dN/drapmax ',nx,rapbin, 0.)
       call hbook1( 10,' dN/drapmax ',28,xcmin,xcmax, 0.)
C      call hbookb( 10,' dN/drapmax ',nx,rapbin, 0.)
       call hbook1(110,' dN/drapmax ',50,-3.25,4.25,0.)
*
       xcmin=smx*(418.-x0)
       xcmax=smx*(643.-x0)
       wbin=abs(xcmax-xcmin)/float(mx)
       xcmin=xcmin-wbin/2.
       xcmax=xcmax+wbin/2.
       if (lp) then
        write(6,*) ' book= 11 xcmin= ',xcmin,' xcmax= ',xcmax,
     &  ' wbin = ',wbin
       endif
*
       call hbook1(-11,' Mx ',mx,xcmin,xcmax, 0.)
       call hbook1( 11,' Mx ',mx,xcmin,xcmax, 0.)
       call hbook1( 12,' Mremn     ',20, 0.,20.,0.)
       call hbook1( 13,' y         ',25, 0., 1.,0.)
       call hbook1( 14,' log(xpom) ',15,-4., 0.,0.)
       call hbook1( 15,' beta      ',20, 0., 1.,0.)
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*      Filling: The following MUST always be done
*      (i) move to the correct sub-directory in PAWC
*
       call hcdir('//PAWC/'//xxxx,' ')
*
*      Event selection
*
       q2=real(HZDISKIN(1))
       x =real(HZDISKIN(2))
       y =real(HZDISKIN(3))
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' x= ',x,' q2= ',q2,' y= ',y
*
*      get position of scattered electron, energy,Pt and polar angle
*
       iel=HZIDELEC(idum)
       if (iel.eq.-1) then
        write(6,*) 'Hz'//xxxx,' electron not found '
        return
       endif
*
       enel=real(PHEP(4,iel))
       Thel=real(HZPHMANG(PHEP(3,iel),
     &               sqrt(PHEP(1,iel)**2+PHEP(2,iel)**2)))
       if (lp) write(6,*) 'Hz'//xxxx,
     &                       ' enel= ',enel,' thel= ',thel*rd
*
*      cut on kinematics
*
       evcut= thel*rd.gt.155.
       evcut= q2.gt.7.5.and.q2.lt.70..and.evcut
       evcut= y.gt.0.03.and.y.lt.0.7 .and.evcut
       evcut= x.gt.0.00024.and.x.lt.0.0133.and.evcut
*
       if (lp) write(6,*) 'Hz'//xxxx,' evcut= ',evcut
*
       if (.not.evcut) return
*
*      calculate etamax (i.e. critical angle where sum of energy
*      in a cone with opening thcut exceeds 0.4 GeV)
*
       thmin=2.9777
       thmax=999.
       gapmax=-999.
       rcrit=0.
       neta=0
       thcut=thmin+0.1
       iturn=0
*
*      sum energy in cone between thmin and thcut
*      (if this energy exceed 0.4 than thcut is found
*
 10    iturn=iturn+1
       ener=0.
       do 20 ihep=1,nhep
*
*       skip first unstable particles and electron
*
        if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 20
*
        th=real(HZPHMANG(PHEP(3,ihep),
     &              sqrt(PHEP(1,ihep)**2+PHEP(2,ihep)**2)))
*
        if (th.ge.1.e-4.and.abs(th-pi).gt.1.e-4 .and.iturn.eq.1) then
         neta=neta+1
         xeta(neta)=-log(tan(th/2.))
        endif
*
C        if (th*rd.gt.thmin .and. th*rd.lt.thcut) then
C          p = real(PHEP(4,ihep))
C          ener = p + ener
C         write(6,*) ' ener= ',ener,' p= ',p,' id= ',idhep(ihep)
C        endif
        if (th*rd.gt.thmin .and. th.lt.thmax .and.
     &       real(PHEP(4,ihep)).gt.0.4 ) then
         thmax=th
        endif
 20    continue
*
C      write(6,*) ' thcut= ',thcut,' ener= ',ener
C       if(ener.le.0.4) then
C        thcut=thcut+0.1
C        goto 10
C       endif
*
CC      if (thcut.lt.pi*rd .and. thcut.gt.1.e-4) then
CC       th=thcut/rd
CCC      rapmax= -log(tan(th/2.))
CC       rapmax= -log(tan(thmax/2.))
CC      else
CC       rapmax=999
CC       write(6,*)  'Hz'//xxxx,' thcut= ',thcut,' ???? '
CC      endif
*
      if (lp) then
       write(6,*) 'Hz'//xxxx,' rapmax= ',rapmax,' thcut= ',thcut,
     & ' thmax= ',thmax*rd
      endif
*

      if ((thmax.gt.1e-4) .and. (thmax.lt.(pi-1.e-4))) then
C     if ((thmax.gt.1e-4) .and. (thmax-pi).gt.1.e-4) then
         rapmax= -log(tan(thmax/2.))
         nev=nev+wtx
         call hfill(10, rapmax,0., wtx)
         call hfill(110,rapmax,0., wtx)
      endif
*
*     calculate invariant mass of remnant and Mx-system
*
       do i=1,4
        pmx(i)=0.
        prem(i)=0.
       enddo
*
* sort array xeta according to rapidity using M103 form CERNLIB
*
       call FLPSOR(xeta,neta)
*
* find largest gap
*
       do 15 i=1,neta-1
        rapi=xeta(i)
        rapj=xeta(i+1)
        if (abs(rapi-rapj).ge.gapmax) then
         gapmax=abs(rapi-rapj)
         rcrit=amin1(rapi,rapj)
        endif
 15    continue
*
        do 30 ihep=1,nhep
        if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 30
        th=real(HZPHMANG(PHEP(3,ihep),
     &              sqrt(PHEP(1,ihep)**2+PHEP(2,ihep)**2)))
*
        if (abs(th).ge.1.e-4 .and. abs(th-pi).ge.1.e-4) then
         rapi= -log(tan(th/2.))
         if (rapi.lt.rcrit) then
          pmx(1)=pmx(1)+sngl(phep(1,ihep))
          pmx(2)=pmx(2)+sngl(phep(2,ihep))
          pmx(3)=pmx(3)+sngl(phep(3,ihep))
          pmx(4)=pmx(4)+sngl(phep(4,ihep))
         else
          prem(1)=prem(1)+sngl(phep(1,ihep))
          prem(2)=prem(2)+sngl(phep(2,ihep))
          prem(3)=prem(3)+sngl(phep(3,ihep))
          prem(4)=prem(4)+sngl(phep(4,ihep))
         endif
        endif
*
  30   continue
*
       xinvx=sqrt( pmx(4)**2-(pmx(3)**2+pmx(2)**2+pmx(1)**2))
       xinvr=sqrt(prem(4)**2-(prem(3)**2+prem(2)**2+prem(1)**2))
*
       if (q2+xinvx**2 .ne. 0.) then
        beta=q2/(q2+xinvx**2)
       else
        write(6,*) ' q2+xinv= 0 ! '
       endif
       if (q2.ne.0.) then
        xpom=(  (q2+xinvx**2)/q2)*x
       else
        write(6,*) ' q2= 0 ! '
       endif
*
       if (lp) then
        write(6,*) 'Hz'//xxxx,' gapmax= ',gapmax
        write(6,*) 'Hz'//xxxx,' rcrit= ',rcrit,' rapmx= ',rapmax
        write(6,*) 'Hz'//xxxx,' mx= ',xinvx,' Xr= ',xinvr
        write(6,*) 'Hz'//xxxx,' beta= ',beta,' xpom= ',xpom
       endif
*
*      Note that the H1 rap gap selection is approximatly
*      equivalent to a cut in Xpom
*
Ce      if (xpom.lt.0.05 .and. rapmax.lt.3.2) then
        if (xpom.lt.0.05) then
         nsel=nsel+wtx
         call hfill(11, xinvx       ,0., wtx)
         call hfill(12, xinvr       ,0., wtx)
         call hfill(13, y           ,0., wtx)
         call hfill(14, log10(xpom) ,0., wtx)
         call hfill(15, beta        ,0., wtx)
        endif
*
************************************************************************
*
      Else if(iflag.eq.3) then
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
       call hcdir('//PAWC/'//xxxx,' ')
*
* Histo normalization
*
        write(6,*) ' nev= ',nev
        call HZHINRM(10,0,nev,1)
        call HZHINRM(110,0,nev,1)
*
        call HZHINRM(11,0,nsel,1)
        call HZHINRM(12,0,nsel,1)
        call HZHINRM(13,0,nsel,1)
        call HZHINRM(14,0,nsel,1)
        call HZHINRM(15,0,nsel,1)
*
*      Deal with data plots
*
       Call hpak (-10,yn)
       Call hpake(-10,eyn)
*
      Endif
*
      RETURN
      END
