*CMZ :  1.01/15 12/08/98  10.38.06  by  Tancredi Carli
*CMZ :  1.01/11 09/12/97  16.44.12  by  Tancredi Carli
*CMZ :  1.01/07 10/10/97  19.46.51  by  Tancredi Carli
*CMZ :  1.01/05 06/09/96  18.29.24  by   Tancredi Carli
*CMZ :  1.00/02 12/03/96  18.37.10  by  Tancredi Carli
*CMZ :  1.00/01 22/02/96  17.21.46  by  Tancredi Carli
*CMZ :  0.00/09 16/02/96  17.15.48  by  Tancredi Carli
*CMZ :  0.00/08 15/02/96  12.22.32  by  Tancredi Carli
*CMZ :  0.00/03 16/01/96  18.08.21  by  Tancredi Carli
*CMZ :  0.00/01 05/01/96  18.24.07  by  HZtool
*-- Author :
      Subroutine hz95221(iflag)
******************************************************************************
*  Subroutine hz95221                                                        *
*  ==================                                                        *
*                                                                            *
* Author: Jane Bromley (bromley@v2.ph.gla.ac.uk)                             *
*                                                                            *
* This routine plots distributions of charged hadron multiplicities in the   *
* hadronic centre of mass frame as a function of the scaled longitudinal     *
* momentum xF and the transverse momentum pT* in a restricted Q2 and W2      *
* range.  Data is given for events with and without a large rapidity gap.    *
*                                                                            *
* Beams: 26.7 GeV electrons, 820 GeV protons   [1993 HERA running]           *
*                                                                            *
* Event selection:                                                           *
* 75 < W < 175 GeV                                                           *
* 10 < Q2 < 160 GeV^2                                                        *
* For the pT* distributions, xF > 0.05                                       *
*                                                                            *
* Reference:  DESY 95-221                                                    *
* Modified: histogram identifier scheme changed as in other routines         *
*           IDdata=-IDmc                                                     *
*           In addition MC histograms with same bins as data                 *
*           Introduce check on electron beam energy
******************************************************************************
*
*        HERA tuning defined commons:
*
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzhbook.inc"
*
* Local variables
*
      Character xxxx*5
      character*80 chtitl
      real xmi, xma, ymi, yma, nnrg, nlrg
      Save xmi, xma, ymi, yma, nnrg, nlrg
*
      Real Nacc
      Save Nacc
      double precision  pgam(5),pgam4(4),q2,w2,eta,etamax
      double precision pt,xf,theta,plab(4),phcm(4),pbeam(4)
      integer nx,ny,ip,il,ierr,I,J,L,ntrack,jflag,idum,lepid
      Real eb,ee
      Save eb
      Real tmperr(7)
      Integer id, ierrp
      Parameter (ee=26.7)
      Integer nentry
* CUTS:
      double precision q2cut(2), w2cut(2), xfcut
*
* Data points from plots:
*
      Real nrgxf(8), nrgpt(11), nrgmpt(7), lrgxf(8),lrgpt(8),lrgmpt(7)
      Real xfnbin(9), ptnbin(12), ptlbin(9), bothxf(8), bothpt(11)

      Real nrgxfe(8), nrgpte(11),nrgmpte(7),lrgxfe(8),lrgpte(8)
      Real lrgmpte(7)
      Real bothxfe(8),bothpte(11),bothmpt(7),bothmpte(7),mptbin(8)
*
      Data xxxx/'95221'/
      Data nentry/0/

      data nrgxf/64.96, 27.92, 12.89, 6.67, 2.86, 1.15, 0.36, 0.07/
      data nrgxfe/10.56,4.28,1.98,.98,.45,.15,.08,.02/
      data nrgpt/1.05,2.84,3.89,3.34,2.24,1.10,0.47,0.23,0.08,0.03,0.01/
      data nrgpte/.19,.51,.60,.47,.33,.18,.07,.03,.01,.004,.0014/
      data nrgmpt/0.47,0.63,0.85,1.19,1.50,2.30,2.09/
      data nrgmpte/.02,.04,.05,.08,.16,.38,.74 /
      data lrgxf/26.97,19.70,12.16,6.49,4.02,1.41,0.68,0.31/
      data lrgxfe/3.17,1.55,1.82,1.17,.94,.50,.16,.1 /
      data lrgpt/1.36,4.31,4.91,3.44,1.45,0.64,0.09,0.001/
      data lrgpte/.5,.16,.41,.34,.55,.046,.02,.004 /
      data lrgmpt/0.19,0.24,0.35,0.41,0.38,0.50,0.37/
      data lrgmpte/.02,.06,.09,.19,.13,.16,.61 /
      data xfnbin/0.03,0.05,0.10,0.15,0.22,0.32,0.45,0.65,0.90/
      data ptnbin/0.0,0.10,0.20,0.40,0.60,0.80,1.2,1.5,2.0,2.75,3.5,5.0/
      data ptlbin/0.0,0.1,0.2,0.4,0.6,0.8,1.2,2.0,5.0/
      data bothxf/62.99,27.48,12.86,6.67,2.90,1.18,0.37,0.08/
      data bothxfe/9.62,4.04,2.,1.09,.47,.17,.08,.03 /
      data bothpt/1.10,2.92,3.98,3.35,2.22,1.07,0.45,.22,.07,.02,.01/
      data bothpte/.18,.52,.6,.47,.32,.18,.08,.03,.01,.004,.0014 /
      data bothmpt/.46,.61,.82,1.14,1.4,2.13,1.82/
      data bothmpte/.02,.04,.05,.08,.14,.43,.63/
      data mptbin/0.05,.1,.15,.22,.32,.45,.65,.90/
*
      save nrgxf,nrgxfe, nrgpt, nrgpte, nrgmpt, nrgmpte
      save lrgxf, lrgxfe,lrgpt,lrgpte,lrgmpt,lrgmpte
      Save xfnbin,ptnbin,ptlbin,bothxf, bothxfe,bothmpt
      Save bothmpte,mptbin

      save q2cut, w2cut

*
* INITIALISATION
*
        if (iflag.eq.1) then
*
        Nacc = 0.
        nnrg = 0.
        nlrg = 0.
*
	call hcdir('//PAWC',' ')
        call hmdir('95221','S')
        Call hcdir('//HISTO',' ')
        call hmdir('95221','S')
*
* Book histos:
*
       call Hbook1(111, 'fin bin xF - NRG', 50, 0., 1., 0.)
       call Hbook1(112, 'fin bin pt* - NRG', 50, 0., 5., 0.)
       call Hbprof(113, 'fin bin ptsq vs xf - NRG',
     & 20,0.,1.,0.,100.,' ')
*
       call Hbook1(121, 'fin bin xF - LRG', 50, 0., 1., 0.)
       call Hbook1(122, 'fin bin pt* - LRG', 50 , 0., 5., 0.)
       call Hbprof(123, 'fin bin ptsq vs xf - LRG',
     & 20,0.,1.,0.,100.,' ')

       call Hbook1(131, 'fin bin xF - both', 50, 0., 1., 0.)
       call Hbook1(132, 'fin bin pt* - both', 50 , 0., 5., 0.)
       call Hbprof(133, 'fin bin ptsq vs xf - both'
     & ,20,0.,1.,0.,100.,' ')
*
* Book histos with same bining as data
*
        call hbookb(11,'1/N dn/dxf(NRG data)',8,xfnbin,0.)
        call hbookb(12,'1/N dn/d-pt(NRG data)',11,ptnbin,0.)
        call hbookb(13,'seagull (NRG data)',7,mptbin,0.)
        call hbookb(1013,'seagull (NRG data)',7,mptbin,0.)
        call hbookb(2013,'seagull (NRG data)',7,mptbin,0.)
        call hbookb(21,'1/N dn/dxf(LRG data)',8,xfnbin,0.)
        call hbookb(22,'1/N dn/d-pt(LRG data)',8,ptlbin,0.)
        call hbookb(23,'seagull (LRG data)',7,mptbin,0.)
        call hbookb(1023,'seagull (LRG data)',7,mptbin,0.)
        call hbookb(2023,'seagull (LRG data)',7,mptbin,0.)
        call hbookb(31,'1/N dn/dxf(combined data)',8,xfnbin,0.)
        call hbookb(32,'1/N dn/d-pt(combined data)',11,ptnbin,0.)
        call hbookb(33,'seagull (combined data)',7,mptbin,0.)
        call hbookb(1033,'seagull (combined data)',7,mptbin,0.)
        call hbookb(2033,'seagull (combined data)',7,mptbin,0.)
*
* set cuts:
        q2cut(1)= 10.
        q2cut(2)= 160.
        w2cut(1) = 5625.
        w2cut(2) = 30625.
*
* ANALYSIS:
*
      Else if(iflag.eq.2) then
*
        call hcdir('//PAWC/95221',' ')
*
*  Check electron beam energy
*
       nentry=nentry+1
       ierr=HZIBEAM(ibeam,idum)
       if (.not.(ierr.eq.1)) then
        write(6,*) 'HZ'//xxxx,' beams not found ! '
        return
       endif
*
       eb=real(PHEP(4,idum))
       if (abs(abs(eb)-ee).ge.0.2) then
        if (nentry.lt.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
        elseif (nentry.eq.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &   ' ...last message ! '
        endif
C        return
       endif
*
* Event Selection:
*
*
         q2=hzdiskin(1)
         w2=hzdiskin(4)
*
         jflag = 0
         etamax = -20.
         xf = 0.
         pt = 0.
*
         if (q2.gt.q2cut(1).and.q2.lt.q2cut(2).and.
     &        w2.gt.w2cut(1).and.w2.lt.w2cut(2)) then
              Nacc = Nacc + wtx
*
* INITIALISE BOOST:
*
                 if (hzibeam(ip,il).ne.1) then
                    write (6,*) 'Proton beam not found'
                    return
                 endif
                 if (Hzipgam(pgam).lt.0) then
                    write (6,*) 'Photon momentum not found'
                    return
                 endif
                 lepid=hzidelec(idum)
                 if (lepid.lt.0) then
                     write (6,*) 'Id of electron not found'
                     return
                 endif
              do J=1,4
                 pbeam(J) = phep(J,ip)
                 pgam4(J)=pgam(J)
              end do
              call HZHCMINI(pbeam,pgam4,Ierr)
              if(Ierr.eq.1) then
                 write (6,*) ' HZHCMINIT failed'
                 return
              endif
*
* Fill histos:
*
         do 29 J = 1,Nhep
            if(jmohep(1,J).ge.1) then
            if(isthep(J).eq.1.and.J.ne.lepid.and.
     &        abs(idhep(jmohep(1,J))).ne.130.and.
     &        abs(idhep(jmohep(1,J))).ne.310.and.
     &        abs(idhep(jmohep(1,J))).ne.3122) then
              pt = sqrt(phep(1,J)**2+phep(2,J)**2)
              theta= hzphmang(phep(3,J),pt)
              if (theta.gt.1.e-4 .and. theta.lt.pi-1.e-4) then
               eta= -1.*log(tan(theta/2.))
              else
               eta=-999.
              endif
              if(sqrt(w2).gt.175) then
                 if(eta.lt.6.) then
                    if (eta.gt.etamax) etamax=eta
                 endif
              elseif(sqrt(w2).lt.175.and.sqrt(w2).gt.70.) then
                 if(eta.lt.5.5) then
                    if (eta.gt.etamax) etamax=eta
                 endif
              endif
           endif
           endif
 29      end do

             if (etamax.ge.1.5) then
                 jflag = 1
                 nnrg = nnrg + wtx
             endif
             if (etamax.lt.1.5) then
                 jflag = 2
                 nlrg = nlrg + wtx
             endif

         do 30 I = 1,Nhep
         if(jmohep(1,I).ge.1) then
         if (isthep(I).eq.1.and.ihchrg(I).ne.0.and.
     &        abs(idhep(jmohep(1,I))).ne.130.and.
     &        abs(idhep(jmohep(1,I))).ne.310.and.
     &        abs(idhep(jmohep(1,I))).ne.3122.and.
     &        I.ne.lepid) then
             do J = 1,4
                 Plab(J)=phep(J,I)
             enddo
             call HZHCM(plab, phcm, Ierr)
             if(Ierr.eq.1)  then
                 write (6,*) ' HZHCM BOOST failed'
                 return
             endif
             pt = sqrt(phcm(1)**2+phcm(2)**2)
             xf = 2.*Phcm(3)/sqrt(W2)
             call Hf1(131, sngl(xf), wtx)
             call Hfill( 31, sngl(xf),0., wtx)
             if (xf.gt.0.05) then
                call Hf1(132, sngl(pt), wtx)
                call Hfill(133, sngl(xf), sngl(pt**2), wtx)
                call Hf1(32, sngl(pt), wtx)
                call Hf1(33, sngl(xf), sngl(pt**2)*wtx)
                call Hf1(1033, sngl(xf), wtx)
                call Hf1(2033, sngl(xf), sngl(pt**4)*wtx)
             endif
             call hf1(100+jflag*10+1,sngl(xf),wtx)
             call hfill(jflag*10+1,sngl(xf),0.,wtx)
             if (xf.gt.0.05) then
                call hf1(100+jflag*10+2, sngl(pt), wtx)
                call hfill(100+jflag*10+3,sngl(xf),sngl(pt**2),wtx)
                call hfill(jflag*10+2,sngl(pt),0., wtx)
                call hf1(jflag*10+3,sngl(xf),sngl(pt**2)*wtx)
                call hf1(1000+jflag*10+3,sngl(xf),wtx)
                call hf1(2000+jflag*10+3,sngl(xf),sngl(pt**4)*wtx)
             endif
         endif
         endif
 30	 continue
*                        for q2 and w2 cut
	 endif
*
* TERMINATION:
*
       Else if(iflag.eq.3) then
*
        call hcdir('//PAWC/95221',' ')
*
        write (6,*) 'Hz',xxxx,': '
        write (6,*) ' number accepted = ',Nacc
        write (6,*) ' num non Rap Gap events = ',nnrg
        write (6,*) ' num large Rap gap events = ',nlrg
*
        if (nlrg.eq.0.) nlrg = nacc
*
* Deal with data plots
*
        call hbookb(-11,'1/N dn/dxf(NRG data)',8,xfnbin,0.)
        call hbookb(-12,'1/N dn/d-pt(NRG data)',11,ptnbin,0.)
        call hbookb(-13,'seagull (NRG data)',7,mptbin,0.)
        call hbookb(-21,'1/N dn/dxf(LRG data)',8,xfnbin,0.)
        call hbookb(-22,'1/N dn/d-pt(LRG data)',8,ptlbin,0.)
        call hbookb(-23,'seagull (LRG data)',7,mptbin,0.)
        call hbookb(-31,'1/N dn/dxf(combined data)',8,xfnbin,0.)
        call hbookb(-32,'1/N dn/d-pt(combined data)',11,ptnbin,0.)
        call hbookb(-33,'seagull (combined data)',7,mptbin,0.)
        call hpak(-11,nrgxf)
        call hpake(-11,nrgxfe)
        call hpak(-12,nrgpt)
        call hpake(-12,nrgpte)
        call hpak(-13,nrgmpt)
        call hpake(-13,nrgmpte)
        call hpak(-21,lrgxf)
        call hpake(-21,lrgxfe)
        call hpak(-22,lrgpt)
        call hpake(-22,lrgpte)
        call hpak(-23,lrgmpt)
        call hpake(-23,lrgmpte)
        call hpak(-31,bothxf)
        call hpake(-31,bothxfe)
        call hpak(-32,bothpt)
        call hpake(-32,bothpte)
        call hpak(-33,bothmpt)
        call hpake(-33,bothmpte)
*
        do 33 J = 1,2
         Call hgive(110+J,chtitl,nx,xmi,xma,ny,ymi,yma,nwt,loc)
         Call hopera(110+J,'+e',110+J,110+J,
     +            1./real(nnrg)*real(nx)/(xma-xmi),0.)
*
         call hzhinfo(110+j,nnrg)
         call hzhinrm(10+j,0,nnrg,1)
         call hzhinfo(10+j,nnrg)
         call hzchisq(-10-j,10+j)
*
         Call hgive(120+J,chtitl,nx,xmi,xma,ny,ymi,yma,nwt,loc)
         Call hopera(120+J,'+e',120+J,120+J,
     +            1./real(nlrg)*real(nx)/(xma-xmi),0.)
*
         call hzhinfo(120+j,nlrg)
         call hzhinrm(20+j,0,nlrg,1)
         call hzchisq(-20-j,20+j)
*
         Call hgive(130+J,chtitl,nx,xmi,xma,ny,ymi,yma,nwt,loc)
         Call hopera(130+J,'+e',130+J,130+J,
     +            1./real(nacc)*real(nx)/(xma-xmi),0.)
         call hzhinfo(30+j,nacc)
         call hzhinrm(30+j,0,nacc,1)
         call hzchisq(-30-j,30+j)
*
 33     end do
*
        Do id = 13,33,10
        Call Hopera(id,'/',1000+id,id,1.,1.)
        Call Hopera(2000+id,'/',1000+id,2000+id,1.,1.)
        Call Hopera(id,'*',id,3000+id,1.,1.)
        call Hopera(2000+id,'-',3000+id,3000+id,1.,1.)
        Call Hopera(3000+id,'/',1000+id,3000+id,1.,1.)
        Call Hunpak(3000+id,tmperr,' ',0)
        Do ierrp = 1, 7
           tmperr(ierrp) = sqrt(tmperr(ierrp))
        Enddo
        Call Hpake(id,tmperr)
        Call hdelet(1000+id)
        Call hdelet(2000+id)
        Call hdelet(3000+id)
*
        call hzhinfo(id,nnrg)
        Call Hzchisq(-id,id)
       Enddo
*
      Endif
*
      Return
      End

