*CMZ :  2.00/06 02/05/2002  14.58.03  by  Tancredi Carli
*CMZ :  1.02/01 23/10/98  10.07.44  by  Tancredi Carli
*CMZ :  1.01/15 22/06/98  14.56.32  by  Tancredi Carli
*CMZ :  1.01/11 29/12/97  11.35.47  by  Tancredi Carli
*CMZ :  1.01/07 15/10/97  19.51.34  by  Tancredi Carli
*CMZ :  1.01/05 27/06/97  18.57.10  by  Tancredi Carli
*-- Author :    Tancredi Carli   04/09/96
      Subroutine hz96160(iflag)
      implicit none
      integer iflag
******************************************************************************
*  Subroutine hz96160                                                        *
*  ==================                                                        *
*                                                                            *
* Author: Birger Koblitz (koblitz@dice2.desy.de)                             *
*                                                                            *
* This routine plots distributions of charged multiplicities in the          *
* hadronic centre of mass system within 4 different eta ranges               *
* 1<eta<2, 1<eta<3, 1<eta<4 and 1<eta<5. The distributions are ploted for 4  *
* regions of W:  80<W<115, 115<W<150, 150<W<185, 185<W<200.                  *
* The routine also plots the mean charged multiplicity in these bins.        *
*                                                                            *
*                                                                            *
* Beams: 27.6 GeV positrons, 820 GeV protons   [1994 HERA running]           *
*                                                                            *
* Event selection:                                                           *
* 80 GeV < W < 220 GeV                                                       *
* 10 GeV < Q2                                                                *
* Energie of scattered positron > 12 GeV                                     *
* Energie deposited in polar angular range 4.4deg < theta < 15deg > 0.5 GeV  *
*                                                                            *
* Reference:                                                                 *
* Modified:                                                                  *
******************************************************************************
*
*        HERA tuning defined commons:
*
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzhbook.inc"
*
* Local variables
*
      Real                ee,eb
      Parameter           (ee=27.6)
      Character           xxxx*5
      Double Precision    w2,q2,eta,theta,pt
      Double precision    pbeam(4), pgam(4),pgam4(4)
      Double Precision    plab(4),pcms(4)
      Integer             IErr
      Integer             ebid,pbid,lepid,ip
      Integer             HId,NTotal,I,J,N
      Real                Nacc
*
      Integer             nx,nx2
      Parameter (nx=24,nx2=54)
      logical lp
      data lp/.false./
*
      Real                efwd,rd,pi,y(4),y2(nx),xy2(nx2)
      Real                NormC,S
      Real                EvInB(5),EnergB(4)
      Real                xmin,xmax,xmin2,xmax2
      Parameter           (pi=3.1415927,rd=180./pi)
* CUTS:
      Real    q2cut(2), w2cut(2)
*
* Data points from plots:
*

      Real eta2(4),eta3(4),eta4(4),eta5(4)
      Real eta2st(4),eta3st(4),eta4st(4),eta5st(4)
      Real eta2sy(4),eta3sy(4),eta4sy(4),eta5sy(4)
      Real d_eta(4),d_eta2(24)

      Real d1152(24),d1152t(24),d1152y(24)
      Real d1153(24),d1153t(24),d1153y(24)
      Real d1154(24),d1154t(24),d1154y(24)
      Real d1155(24),d1155t(24),d1155y(24)

      Real d1502(24),d1502t(24),d1502y(24)
      Real d1503(24),d1503t(24),d1503y(24)
      Real d1504(24),d1504t(24),d1504y(24)
      Real d1505(24),d1505t(24),d1505y(24)

      Real d1852(24),d1852t(24),d1852y(24)
      Real d1853(24),d1853t(24),d1853y(24)
      Real d1854(24),d1854t(24),d1854y(24)
      Real d1855(24),d1855t(24),d1855y(24)

      Real d2202(24),d2202t(24),d2202y(24)
      Real d2203(24),d2203t(24),d2203y(24)
      Real d2204(24),d2204t(24),d2204y(24)
      Real d2205(24),d2205t(24),d2205y(24)
*
      Data xxxx/'96160'/

      data eta2/2.46,2.50,2.63,2.66/
      data eta2st/0.03,0.03,0.04,0.04/
      data eta2sy/0.10,0.12,0.18,0.18/

      data eta3/4.90,5.06,5.32,5.35/
      data eta3st/0.04,0.05,0.07,0.06/
      data eta3sy/0.18,0.27,0.34,0.35/

      data eta4/6.45,7.00,7.51,7.66/
      data eta4st/0.06,0.05,0.06,0.07/
      data eta4sy/0.33,0.35,0.51,0.47/

      data eta5/6.90,7.72,8.45,8.81/
      data eta5st/0.05,0.05,0.06,0.08/
      data eta5sy/0.34,0.42,0.58,0.54/

      data d1152/15.79,22.55,20.62,15.96,10.21,6.07,3.85,2.24,
     &     1.15,0.68,0.49,0.19,0.07,0.05,0.,0.,0.,0.,0.,0.,0.,
     &     0.,0.,0./
      data d1152t/0.52,0.50,0.46,0.43,0.37,0.30,0.26,0.16,0.12,
     &     0.10,0.12,0.10,0.12,0.06,0.04,0.03,0.,0.,0.,0.,
     &     0.,0.,0.,0.00/
      data d1152y/2.18,1.92,1.24,2.29,1.06,1.54,0.48,0.62,0.42,0.31,
     &     0.24,0.26,0.13,0.06,0.,0.,0.,0.,0.,0.,0.,
     &     0.,0.,0./
      data d1153/3.26,8.01,12.84,14.03,13.38,11.73,9.84,7.94,5.91,
     &     4.00,3.21,2.22,1.49,0.90,0.54,0.36,0.14,
     &     0.08,0.,0.,0.,0.,0.,0./
      data d1153t/0.22,0.27,0.35,0.35,0.32,0.35,0.34,0.33,0.32,
     &     0.21,0.19,0.18,0.14,0.15,0.11,0.08,0.07,
     &     0.05,0.,0.,0.,0.,0.,0./
      data d1153y/1.58,1.29,1.30,0.21,2.22,0.46,0.71,0.52,1.20,
     &     0.82,0.56,1.06,0.66,0.53,0.53,0.57,0.19,
     &     0.10,0.,0.,0.,0.,0.,0./
      data d1154/0.78,2.73,5.73,9.55,11.11,12.76,12.19,11.17,9.22,
     &     7.72,5.69,3.95,2.76,1.79,1.22,0.67,0.40,
     &     0.24,0.13,0.,0.,0.,0.,0./
      data d1154t/0.09,0.18,0.28,0.29,0.32,0.35,0.32,0.37,0.31,
     &     0.33,0.24,0.22,0.23,0.18,0.15,0.12,0.11,
     &     0.11,0.08,0.,0.,0.,0.,0./
      data d1154y/1.66,0.94,1.45,1.46,1.21,2.22,1.28,0.96,0.48,
     &     1.37,1.31,1.00,0.96,0.80,0.62,0.68,0.43,
     &     0.33,0.19,0.,0.,0.,0.,0./
      data d1155/0.40,1.64,3.82,7.59,10.08,12.30,12.91,12.27,10.65,
     &     8.69,6.38,4.79,3.20,2.05,1.38,0.86,0.40,
     &     0.27,0.10,0.00,0.00,0.00,0.00,0.00/
      data d1155t/0.08,0.16,0.22,0.28,0.34,0.34,0.35,0.35,0.33,
     &     0.30,0.26,0.25,0.24,0.19,0.16,0.14,0.08,
     &     0.13,0.05,0.00,0.00,0.00,0.00,0.00/
      data d1155y/0.00,0.39,1.27,1.06,1.18,0.89,1.29,1.86,0.86,
     &     1.08,0.99,1.23,0.97,0.69,0.74,0.66,0.24,
     &     0.37,0.11,0.,0.,0.,0.,0./
      data d1502/16.80,21.55,19.69,15.19,10.54,6.76,4.15,2.55,1.29,
     &     0.64,0.31,0.20,0.12,0.07,0.03,0.00,0.00,
     &     0.00,0.00,0.00,0.00,0.00,0.00,0.00/
      data d1502t/0.62,0.54,0.50,0.48,0.36,0.34,0.27,0.20,0.14,
     &     0.10,0.07,0.04,0.03,0.03,0.02,0.00,0.00,
     &     0.00,0.00,0.00,0.00,0.00,0.00,0.00/
      data d1502y/0.55,1.05,0.53,0.77,0.31,0.75,0.50,0.76,0.48,
     &     0.62,0.14,0.07,0.15,0.07,0.04,0.00,0.00,
     &     0.00,0.00,0.00,0.00,0.00,0.00,0.00/
      data d1503/4.52,8.00,12.15,12.96,12.74,11.09,9.35,7.31,6.01,
     &     4.53,3.76,2.57,1.90,1.05,0.77,0.56,0.31,
     &     0.18,0.12,0.00,0.00,0.00,0.00,0.00/
      data d1503t/0.35,0.35,0.36,0.36,0.38,0.32,0.31,0.27,0.29,
     &     0.24,0.25,0.23,0.18,0.16,0.12,0.10,0.08,
     &     0.06,0.06,0.00,0.00,0.00,0.00,0.00/
      data d1503y/1.19,1.21,0.70,0.91,0.74,1.63,0.70,2.06,0.93,
     &     1.38,0.53,0.86,0.77,0.29,0.54,0.48,0.24,
     &     0.28,0.12,0.00,0.00,0.00,0.00,0.00/
      data d1504/1.09,2.57,4.72,8.09,9.96,11.23,11.27,10.32,9.21,
     &     8.03,6.51,5.32,3.84,2.96,1.81,1.25,0.76,
     &     0.46,0.25,0.14,0.08,0.00,0.00,0.00/
      data d1504t/0.18,0.19,0.24,0.29,0.33,0.36,0.33,0.31,0.34,
     &     0.30,0.29,0.26,0.23,0.23,0.18,0.16,0.12,
     &     0.10,0.09,0.06,0.05,0.00,0.00,0.00/
      data d1504y/0.77,1.12,0.70,0.74,0.95,0.95,1.37,0.25,0.52,
     &     0.29,0.87,0.88,0.88,0.53,0.65,0.33,0.62,
     &     0.29,0.20,0.23,0.11,0.00,0.00,0.00/
      data d1505/0.35,1.17,2.58,5.63,7.97,10.36,11.44,11.96,10.41,
     &     9.65,7.88,6.15,4.96,3.51,2.15,1.47,0.93,
     &     0.72,0.25,0.17,0.12,0.03,0.00,0.00/
      data d1505t/0.08,0.13,0.14,0.23,0.24,0.31,0.37,0.35,0.32,
     &     0.36,0.28,0.23,0.27,0.25,0.21,0.17,0.14,
     &     0.17,0.08,0.07,0.08,0.02,0.00,0.00/
      data d1505y/0.00,0.62,1.26,0.69,1.03,0.82,0.56,1.18,0.66,
     &     0.74,0.49,0.80,1.35,0.50,0.45,0.43,0.92,
     &     0.62,0.34,0.24,0.13,0.03,0.00,0.00/
      data d1852/16.01,19.56,19.73,16.01,11.19,7.21,4.11,2.80,1.40,
     &     0.91,0.33,0.31,0.10,0.13,0.08,0.00,0.00,
     &     0.00,0.00,0.00,0.00,0.00,0.00,0.00/
      data d1852t/0.58,0.63,0.54,0.60,0.50,0.34,0.30,0.25,0.17,
     &     0.15,0.08,0.07,0.04,0.07,0.06,0.00,0.00,
     &     0.00,0.00,0.00,0.00,0.00,0.00,0.00/
      data d1852y/5.43,1.10,1.58,1.37,1.20,0.70,0.81,0.93,0.81,
     &     0.48,0.23,0.18,0.10,0.18,0.14,0.00,0.00,
     &     0.00,0.00,0.00,0.00,0.00,0.00,0.00/
      data d1853/4.24,8.32,10.99,11.75,11.71,11.37,9.39,7.98,6.27,
     &     5.36,3.64,2.87,1.82,1.24,1.08,0.78,0.43,
     &     0.20,0.18,0.13,0.06,0.00,0.00,0.00/
      data d1853t/0.36,0.41,0.40,0.37,0.41,0.41,0.39,0.35,0.38,
     &     0.35,0.25,0.22,0.20,0.15,0.16,0.15,0.09,
     &     0.06,0.07,0.07,0.05,0.00,0.00,0.00/
      data d1853y/3.19,1.39,0.67,1.30,1.27,1.49,1.08,0.57,0.52,
     &     1.07,1.03,0.28,0.73,0.54,0.89,0.61,0.40,
     &     0.13,0.13,0.24,0.10,0.00,0.00,0.00/
      data d1854/1.13,2.56,4.69,6.81,8.77,9.87,10.47,9.68,9.10,
     &     8.10,6.90,5.76,4.92,3.59,2.71,1.59,1.11,
     &     0.86,0.49,0.31,0.09,0.17,0.13,0.00/
      data d1854t/0.15,0.20,0.24,0.30,0.35,0.38,0.34,0.33,0.34,
     &     0.34,0.31,0.30,0.28,0.25,0.24,0.16,0.12,
     &     0.13,0.13,0.11,0.05,0.09,0.09,0.00/
      data d1854y/1.51,1.55,2.38,1.00,1.02,1.56,0.32,0.94,0.57,
     &     1.05,0.81,0.72,1.71,1.32,0.97,0.72,0.93,
     &     0.46,0.32,0.63,0.14,0.30,0.26,0.00/
      data d1855/0.28,1.09,2.21,4.18,6.61,8.24,9.77,11.04,10.87,
     &     9.89,8.18,7.07,5.76,4.88,3.42,2.43,1.31,
     &     1.07,0.55,0.43,0.12,0.18,0.16,0.00/
      data d1855t/0.08,0.13,0.14,0.20,0.23,0.31,0.34,0.33,0.34,
     &     0.35,0.35,0.31,0.34,0.31,0.26,0.25,0.17,
     &     0.19,0.14,0.13,0.05,0.08,0.11,0.00/
      data d1855y/0.00,1.03,0.71,1.28,2.08,1.36,1.20,0.89,0.66,
     &     1.13,0.44,0.56,1.15,1.50,0.89,1.00,0.78,
     &     0.64,0.51,0.50,0.51,0.32,0.31,0.00/
      data d2202/15.76,19.66,19.56,15.76,11.08,6.95,4.63,3.20,1.36,
     &     0.95,0.47,0.33,0.11,0.05,0.03,0.00,0.00,
     &     0.00,0.00,0.00,0.00,0.00,0.00,0.00/
      data d2202t/0.68,0.76,0.62,0.61,0.58,0.45,0.38,0.32,0.16,
     &     0.15,0.12,0.10,0.04,0.04,0.02,0.00,0.00,
     &     0.00,0.00,0.00,0.00,0.00,0.00,0.00/
      data d2202y/3.11,0.78,1.75,2.03,1.85,0.86,0.97,1.14,0.74,
     &     0.79,0.31,0.50,0.09,0.10,0.05,0.00,0.00,
     &     0.00,0.00,0.00,0.00,0.00,0.00,0.00/
      data d2203/4.24,8.00,10.74,11.51,11.76,11.65,9.74,7.96,6.83,
     &     5.12,3.70,2.52,1.79,1.39,1.11,0.66,0.44,
     &     0.29,0.14,0.10,0.06,0.05,0.00,0.00/
      data d2203t/0.42,0.45,0.57,0.47,0.48,0.53,0.47,0.43,0.44,
     &     0.34,0.30,0.24,0.19,0.17,0.16,0.13,0.10,
     &     0.10,0.06,0.05,0.04,0.04,0.00,0.00/
      data d2203y/3.18,0.48,1.52,0.69,2.08,1.27,1.62,0.91,1.06,
     &     1.16,1.24,0.88,0.76,0.92,1.23,0.33,0.27,
     &     0.19,0.19,0.14,0.29,0.10,0.00,0.00/
      data d2204/1.07,2.81,5.22,6.70,7.98,9.18,9.07,10.18,9.10,
     &     7.95,7.50,6.10,4.98,3.46,2.60,2.03,1.29,
     &     1.00,0.71,0.39,0.21,0.17,0.11,0.00/
      data d2204t/0.24,0.30,0.32,0.33,0.37,0.34,0.40,0.50,0.41,
     &     0.34,0.34,0.38,0.33,0.26,0.22,0.21,0.16,
     &     0.16,0.15,0.09,0.07,0.10,0.04,0.00/
      data d2204y/2.96,1.27,0.73,0.50,0.87,0.58,0.87,0.63,0.68,
     &     1.57,1.83,0.78,1.30,0.77,0.75,0.58,0.80,
     &     0.65,0.22,0.35,0.18,0.26,0.13,0.00/
      data d2205/0.27,0.96,2.37,3.73,5.47,7.50,8.49,10.08,10.54,
     &     10.40,9.20,8.03,6.48,4.78,3.81,2.32,2.13,
     &     1.14,0.83,0.64,0.30,0.13,0.19,0.03/
      data d2205t/0.09,0.13,0.23,0.24,0.27,0.30,0.35,0.39,0.46,
     &     0.43,0.44,0.40,0.30,0.29,0.27,0.21,0.22,
     &     0.14,0.12,0.14,0.07,0.07,0.08,0.02/
      data d2205y/0.00,1.96,0.68,1.12,0.99,0.83,1.24,1.61,1.18,
     &     1.71,1.00,1.12,0.99,0.95,1.22,0.78,1.08,
     &     0.67,0.44,0.29,0.39,0.18,0.26,0.05/

      save NAcc, EnergB, w2cut

*
* INITIALISATION
*
      if (iflag.eq.1) then
*
        NAcc = 0.
        do I=1,4
          EnergB(I)=0.
        end do
*
	call hcdir('//PAWC',' ')
        call hmdir(xxxx,'S')
        Call hcdir('//HISTO',' ')
        call hmdir(xxxx,'S')
*
* Book histos:
*
        call Hbook1(112, 'W-dep of MCM - 1 eta 2', 4, 80.,220., 0.)
        call Hbook1(113, 'W-dep of MCM - 1 eta 3', 4, 80.,220., 0.)
        call Hbook1(114, 'W-dep of MCM - 1 eta 4', 4, 80.,220., 0.)
        call Hbook1(115, 'W-dep of MCM - 1 eta 5', 4, 80.,220., 0.)
*
        xmin=-0.5
        xmax=23.5
*
        xmin2=-0.5
        xmax2=53.5
*
        call Hbook1(212,
     &  'MC distribution 80GeV W 115 , 1<eta<2',nx,xmin,xmax,0.)
        call Hbook1(213,
     &  'MC distribution 80GeV W 115 , 1<eta<3',nx,xmin,xmax,0.)
        call Hbook1(214,
     &  'MC distribution 80GeV W 115 , 1<eta<4',nx,xmin,xmax,0.)
        call Hbook1(215,
     &  'MC distribution 80GeV W 115 , 1<eta<5',nx,xmin,xmax,0.)
*
        call Hbook1(1212,
     &  'MC distribution 80GeV W 115 , 1<eta<2',nx2,xmin2,xmax2,0.)
        call Hbook1(1213,
     &  'MC distribution 80GeV W 115 , 1<eta<3',nx2,xmin2,xmax2,0.)
        call Hbook1(1214,
     &  'MC distribution 80GeV W 115 , 1<eta<4',nx2,xmin2,xmax2,0.)
        call Hbook1(1215,
     &  'MC distribution 80GeV W 115 , 1<eta<5',nx2,xmin2,xmax2,0.)
*
        call Hbook1(222,
     &  'MC distribution 115GeV W 150 , 1<eta<2',nx,xmin,xmax,0.)
        call Hbook1(223,
     &  'MC distribution 115GeV W 150 , 1<eta<3',nx,xmin,xmax,0.)
        call Hbook1(224,
     &  'MC distribution 115GeV W 150 , 1<eta<4',nx,xmin,xmax,0.)
        call Hbook1(225,
     &  'MC distribution 115GeV W 150 , 1<eta<5',nx,xmin,xmax,0.)
*
        call Hbook1(1222,
     &  'MC distribution 115GeV W 150 , 1<eta<2',nx2,xmin2,xmax2,0.)
        call Hbook1(1223,
     &  'MC distribution 115GeV W 150 , 1<eta<3',nx2,xmin2,xmax2,0.)
        call Hbook1(1224,
     &  'MC distribution 115GeV W 150 , 1<eta<4',nx2,xmin2,xmax2,0.)
        call Hbook1(1225,
     &  'MC distribution 115GeV W 150 , 1<eta<5',nx2,xmin2,xmax2,0.)
*
        call Hbook1(232,
     &  'MC distribution 150GeV W 185 , 1<eta<2',nx,xmin,xmax,0.)
        call Hbook1(233,
     &  'MC distribution 150GeV W 185 , 1<eta<3',nx,xmin,xmax,0.)
        call Hbook1(234,
     &  'MC distribution 150GeV W 185 , 1<eta<4',nx,xmin,xmax,0.)
        call Hbook1(235,
     &  'MC distribution 150GeV W 185 , 1<eta<5',nx,xmin,xmax,0.)
*
        call Hbook1(1232,
     &  'MC distribution 150GeV W 185 , 1<eta<2',nx2,xmin2,xmax2,0.)
        call Hbook1(1233,
     &  'MC distribution 150GeV W 185 , 1<eta<3',nx2,xmin2,xmax2,0.)
        call Hbook1(1234,
     &  'MC distribution 150GeV W 185 , 1<eta<4',nx2,xmin2,xmax2,0.)
        call Hbook1(1235,
     &  'MC distribution 150GeV W 185 , 1<eta<5',nx2,xmin2,xmax2,0.)
*
        call Hbook1(242,
     &  'MC distribution 185GeV W 220 , 1<eta<2',nx,xmin,xmax,0.)
        call Hbook1(243,
     &  'MC distribution 185GeV W 220 , 1<eta<3',nx,xmin,xmax,0.)
        call Hbook1(244,
     &  'MC distribution 185GeV W 220 , 1<eta<4',nx,xmin,xmax,0.)
        call Hbook1(245,
     &  'MC distribution 185GeV W 220 , 1<eta<5',nx,xmin,xmax,0.)
*
        call Hbook1(1242,
     &  'MC distribution 185GeV W 220 , 1<eta<2',nx2,xmin2,xmax2,0.)
        call Hbook1(1243,
     &  'MC distribution 185GeV W 220 , 1<eta<3',nx2,xmin2,xmax2,0.)
        call Hbook1(1244,
     &  'MC distribution 185GeV W 220 , 1<eta<4',nx2,xmin2,xmax2,0.)
        call Hbook1(1245,
     &  'MC distribution 185GeV W 220 , 1<eta<5',nx2,xmin2,xmax2,0.)
*
* set cuts:
*
        w2cut(1) = 40.*40
        w2cut(2) = 220.*220.
*
* ANALYSIS:
*
      end if
      if(iflag.eq.2) then
*
        call hcdir('//PAWC',' ')
        call hcdir(xxxx,' ')
        do I=1,5
          EvInB(I)=0.
        end do
*
        if (lp) then
         write(6,*) 'START wtx= ',wtx,' EvInB(I)= ',EvInB
        endif
*
*  Check electron beam energy
*
       NTotal=NTotal+1
       ierr=HZIBEAM(pbid,ebid)
       if (.not.(ierr.eq.1)) then
        write(6,*) 'HZ'//xxxx,' Beams not found ! '
        return
       endif
       eb=real(PHEP(4,ebid))
       if (abs(abs(eb)-ee).ge.0.2) then
        if (NTotal.lt.10) then
         write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
C         call lulist(1)
        elseif (NTotal.eq.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &   ' ...last message ! '
        endif
C        return
       endif

*
* Event Selection:
*
         q2=hzdiskin(1)
         w2=hzdiskin(4)
         if (lp) then
          write(6,*)
     &    ' Q2= ',real(q2),' W2= ',real(w2),' w2xut= ',w2cut
         endif
*
         if (real(w2).gt.w2cut(1).and.real(w2).lt.w2cut(2)
     &   .and.real(q2).gt.10.) then
*
* INITIALISE BOOST:
*
           if (Hzipgam(pgam).lt.0) then
             write (6,*) 'Photon momentum not found'
             return
           endif
           lepid=hzidelec(0)
           if (lepid.lt.0) then
             write (6,*) 'Id of electron not found'
             return
           endif
           do J=1,4
             pbeam(J) = PHEP(J,pbid)
             pgam4(J) = pgam(J)
           end do
*
           call HZHCMINI(pbeam,pgam4,IErr)
           if(IErr.eq.1) then
             write (6,*) xxxx,' HZHCMINIT failed'
             return
           endif
*
          if (lp) write(6,*) ' ..start on Wfwd '
*
* Fill histos:
*
*
*      Cut on forward energy
*
           efwd=0.
           do I=1,NHEP
             if (isthep(I).eq.1.and.I.ne.lepid) then
               theta=real(HZPHMANG(PHEP(3,I),
     &              sqrt(PHEP(1,I)**2+PHEP(2,I)**2)))*rd
               if(theta.gt.4.4.and.theta.lt.15.) then
                 efwd=real(PHEP(4,I))+efwd
               endif
             endif
           enddo
*
           if (lp) then
            write(6,*) ' Enel= ',PHEP(4,lepid),' efwd= ',efwd
            write(6,*) ' nhep =',nhep
           endif
*
           if (PHEP(4,lepid).gt.12.0.and.efwd.ge.0.5) then
             Nacc = Nacc + wtx
             do I = 1,Nhep
*
               if (lp) then
                write(6,*) i,idhep(i),' isthep(I)= ',isthep(I),
     &          ' IHCHRG(I)= ',IHCHRG(I)
               endif
*
               if(isthep(I).eq.1.and.I.ne.lepid
     &           .and.IHCHRG(I).ne.0) then
                 do J=1,4
                   plab(J) = phep(J,I)
                 end do
                 if (lp) then
                  write(6,*) ' plab= ',plab
                  write(6,*) ' pcms= ',pcms
                 endif
                 call HZHCM(plab, pcms, Ierr)
                 if(Ierr.eq.1)  then
                   write (6,*) ' HZHCM BOOST failed'
                   return
                 endif
                 pt=sqrt(pcms(1)**2+pcms(2)**2)
                 theta= hzphmang(pcms(3),pt)
                 eta= -1.*log(tan(theta/2.))
                 HId=int(eta+1.0)
*
                 if (hid.ge.1.and.hid.le.5) then
                  if (lp) then
                   write(6,*) theta*rd,' eta= ',eta,' hid= ',hid
                   write(6,*) hid,'  EvInB(HId)= ', EvInB(HId)
                  endif
*
                  
                  EvInB(HId)=EvInB(HId)+1.
                 endif
*
                 if(HId.ge.2.and.HId.le.5) then
                   call HF1(HId+110,sngl(sqrt(w2)),wtx)
                 endif
*
               endif
             end do
*
             if (lp) then
              write(6,*) ' wtx= ',wtx,' EvInB(I)= ',EvInB
             endif
*
             do I=2,4
               EvInB(I+1)=EvInB(I)+EvInB(I+1)
             end do
             J=int((sqrt(w2)-45.)/35.)
             if (j.ge.1) then
             EnergB(J)=EnergB(J)+wtx
             do I=2,5
              call HF1(I+J*10+200,EvInB(I),wtx)
              call HF1(1000+I+J*10+200,EvInB(I),wtx)
             end do
             if (lp) then
              write(6,*) i,j,' wtx= ',wtx,' EvInB(I)= ',EvInB
             endif
             endif
           endif
*
         endif
       endif
*
*
* TERMINATION:
*
      if(iflag.eq.3) then
*
        call hcdir('//PAWC',' ')
        call hcdir(xxxx,' ')
*
        write (6,*) 'Hz',xxxx,': # events accepted = ',Nacc
*
* Deal with data plots
*
*
        call Hbook1(-112,
     &       'W-dep of MCM - 1<eta<2', 4, 80.,220., 0.)
        call Hbook1(-113,
     &       'W-dep of MCM - 1<eta<3', 4, 80.,220., 0.)
        call Hbook1(-114,
     &       'W-dep of MCM - 1<eta<4', 4, 80.,220., 0.)
        call Hbook1(-115,
     &       'W-dep of MCM - 1<eta<5', 4, 80.,220., 0.)
*
        call Hbook1(-122,
     &       '1<[c]<2 - statistical error', 4, 80.,220., 0.)
        call Hbook1(-123,
     &       '1<[c]<3 - statistical error', 4, 80.,220., 0.)
        call Hbook1(-124,
     &       '1<[c]<4 - statistical error', 4, 80.,220., 0.)
        call Hbook1(-125,
     &       '1<[c]<5 - statistical error', 4, 80.,220., 0.)
*
        call Hbook1(-132,
     &       '1<[c]<2 - systematic error', 4, 80.,220., 0.)
        call Hbook1(-133,
     &       '1<[c]<3 - systematic error', 4, 80.,220., 0.)
        call Hbook1(-134,
     &       '1<[c]<4 - systematic error', 4, 80.,220., 0.)
        call Hbook1(-135,
     &       '1<[c]<5 - systematic error', 4, 80.,220., 0.)
*
        call hpak(-112,eta2)
        do I=1,4
          d_eta(I)=sqrt(eta2st(I)**2+eta2sy(I)**2)
        end do
        call hpake(-112,d_eta)
        call hpak(-113,eta3)
        do I=1,4
          d_eta(I)=sqrt(eta3st(I)**2+eta3sy(I)**2)
        end do
        call hpake(-113,d_eta)
        call hpak(-114,eta4)
        do I=1,4
          d_eta(I)=sqrt(eta4st(I)**2+eta4sy(I)**2)
        end do
        call hpake(-114,d_eta)
        call hpak(-115,eta5)
        do I=1,4
          d_eta(I)=sqrt(eta5st(I)**2+eta5sy(I)**2)
        end do
        call hpake(-115,d_eta)
*
        call hpak(-122,eta2)
        call hpake(-122,eta2st)
        call hpak(-123,eta3)
        call hpake(-123,eta3st)
        call hpak(-124,eta4)
        call hpake(-124,eta4st)
        call hpak(-125,eta5)
        call hpake(-125,eta5st)
*
        call hpak(-132,eta2)
        call hpake(-132,eta2sy)
        call hpak(-133,eta3)
        call hpake(-133,eta3sy)
        call hpak(-134,eta4)
        call hpake(-134,eta4sy)
        call hpak(-135,eta5)
        call hpake(-135,eta5sy)
*
        call Hbook1(-212,
     &       'CM distribution - 1<eta<2, 80<W<115',24, -.5,23.5, 0.)
        call Hbook1(-213,
     &       'CM distribution - 1<eta<3, 80<W<115',24, -.5,23.5, 0.)
        call Hbook1(-214,
     &       'CM distribution - 1<eta<4, 80<W<115',24, -.5,23.5, 0.)
        call Hbook1(-215,
     &       'CM distribution - 1<eta<5, 80<W<115',24, -.5,23.5, 0.)
*
        call Hbook1(-222,
     &       'CM distribution - 1<eta<2, 115<W<150',24, -.5,23.5, 0.)
        call Hbook1(-223,
     &       'CM distribution - 1<eta<3, 115<W<150',24, -.5,23.5, 0.)
        call Hbook1(-224,
     &       'CM distribution - 1<eta<4, 115<W<150',24, -.5,23.5, 0.)
        call Hbook1(-225,
     &       'CM distribution - 1<eta<5, 115<W<150',24, -.5,23.5, 0.)
*
        call Hbook1(-232,
     &       'CM distribution - 1<eta<2, 150<W<185',24, -.5,23.5, 0.)
        call Hbook1(-233,
     &       'CM distribution - 1<eta<3, 150<W<185',24, -.5,23.5, 0.)
        call Hbook1(-234,
     &       'CM distribution - 1<eta<4, 150<W<185',24, -.5,23.5, 0.)
        call Hbook1(-235,
     &       'CM distribution - 1<eta<5, 150<W<185',24, -.5,23.5, 0.)
*
        call Hbook1(-242,
     &       'CM distribution - 1<eta<2, 185<W<220',24, -.5,23.5, 0.)
        call Hbook1(-243,
     &       'CM distribution - 1<eta<3, 185<W<220',24, -.5,23.5, 0.)
        call Hbook1(-244,
     &       'CM distribution - 1<eta<4, 185<W<220',24, -.5,23.5, 0.)
        call Hbook1(-245,
     &       'CM distribution - 1<eta<5, 185<W<220',24, -.5,23.5, 0.)
*
        call Hbook1(-312,
     &       'CM stat. err. - 1<eta<2, 80<W<115',24, -.5,23.5, 0.)
        call Hbook1(-313,
     &       'CM stat. err. - 1<eta<3, 80<W<115',24, -.5,23.5, 0.)
        call Hbook1(-314,
     &       'CM stat. err. - 1<eta<4, 80<W<115',24, -.5,23.5, 0.)
        call Hbook1(-315,
     &       'CM stat. err. - 1<eta<5, 80<W<115',24, -.5,23.5, 0.)
*
        call Hbook1(-322,
     &       'CM stat. err. - 1<eta<2, 115<W<150',24, -.5,23.5, 0.)
        call Hbook1(-323,
     &       'CM stat. err. - 1<eta<3, 115<W<150',24, -.5,23.5, 0.)
        call Hbook1(-324,
     &       'CM stat. err. - 1<eta<4, 115<W<150',24, -.5,23.5, 0.)
        call Hbook1(-325,
     &       'CM stat. err. - 1<eta<5, 115<W<150',24, -.5,23.5, 0.)
*
        call Hbook1(-332,
     &       'CM stat. err. - 1<eta<2, 150<W<185',24, -.5,23.5, 0.)
        call Hbook1(-333,
     &       'CM stat. err. - 1<eta<3, 150<W<185',24, -.5,23.5, 0.)
        call Hbook1(-334,
     &       'CM stat. err. - 1<eta<4, 150<W<185',24, -.5,23.5, 0.)
        call Hbook1(-335,
     &       'CM stat. err. - 1<eta<5, 150<W<185',24, -.5,23.5, 0.)
*
        call Hbook1(-342,
     &       'CM stat. err. - 1<eta<2, 185<W<220',24, -.5,23.5, 0.)
        call Hbook1(-343,
     &       'CM stat. err. - 1<eta<3, 185<W<220',24, -.5,23.5, 0.)
        call Hbook1(-344,
     &       'CM stat. err. - 1<eta<4, 185<W<220',24, -.5,23.5, 0.)
        call Hbook1(-345,
     &       'CM stat. err. - 1<eta<5, 185<W<220',24, -.5,23.5, 0.)
*
        call Hbook1(-412,
     &       'CM syst. err. - 1<eta<2, 80<W<115',24, -.5,23.5, 0.)
        call Hbook1(-413,
     &       'CM syst. err. - 1<eta<3, 80<W<115',24, -.5,23.5, 0.)
        call Hbook1(-414,
     &       'CM syst. err. - 1<eta<4, 80<W<115',24, -.5,23.5, 0.)
        call Hbook1(-415,
     &       'CM syst. err. - 1<eta<5, 80<W<115',24, -.5,23.5, 0.)
*
        call Hbook1(-422,
     &       'CM syst. err. - 1<eta<2, 115<W<150',24, -.5,23.5, 0.)
        call Hbook1(-423,
     &       'CM syst. err. - 1<eta<3, 115<W<150',24, -.5,23.5, 0.)
        call Hbook1(-424,
     &       'CM syst. err. - 1<eta<4, 115<W<150',24, -.5,23.5, 0.)
        call Hbook1(-425,
     &       'CM syst. err. - 1<eta<5, 115<W<150',24, -.5,23.5, 0.)
*
        call Hbook1(-432,
     &       'CM syst. err. - 1<eta<2, 150<W<185',24, -.5,23.5, 0.)
        call Hbook1(-433,
     &       'CM syst. err. - 1<eta<3, 150<W<185',24, -.5,23.5, 0.)
        call Hbook1(-434,
     &       'CM syst. err. - 1<eta<4, 150<W<185',24, -.5,23.5, 0.)
        call Hbook1(-435,
     &       'CM syst. err. - 1<eta<5, 150<W<185',24, -.5,23.5, 0.)
*
        call Hbook1(-442,
     &       'CM syst. err. - 1<eta<2, 185<W<220',24, -.5,23.5, 0.)
        call Hbook1(-443,
     &       'CM syst. err. - 1<eta<3, 185<W<220',24, -.5,23.5, 0.)
        call Hbook1(-444,
     &       'CM syst. err. - 1<eta<4, 185<W<220',24, -.5,23.5, 0.)
        call Hbook1(-445,
     &       'CM syst. err. - 1<eta<5, 185<W<220',24, -.5,23.5, 0.)
*
        call hpak(-212,d1152)
        do I=1,24
          d_eta2(I)=sqrt(d1152t(I)**2+d1152y(I)**2)
        end do
        call hpake(-212,d_eta2)
        call hpak(-213,d1153)
        do I=1,24
          d_eta2(I)=sqrt(d1153t(I)**2+d1153y(I)**2)
        end do
        call hpake(-213,d_eta2)
        call hpak(-214,d1154)
        do I=1,24
          d_eta2(I)=sqrt(d1154t(I)**2+d1154y(I)**2)
        end do
        call hpake(-214,d_eta2)
        call hpak(-215,d1155)
        do I=1,24
          d_eta2(I)=sqrt(d1155t(I)**2+d1155y(I)**2)
        end do
        call hpake(-215,d_eta2)
*
        call hpak(-222,d1502)
        do I=1,24
          d_eta2(I)=sqrt(d1502t(I)**2+d1502y(I)**2)
        end do
        call hpake(-222,d_eta2)
        call hpak(-223,d1503)
        do I=1,24
          d_eta2(I)=sqrt(d1503t(I)**2+d1503y(I)**2)
        end do
        call hpake(-223,d_eta2)
        call hpak(-224,d1504)
        do I=1,24
          d_eta2(I)=sqrt(d1504t(I)**2+d1504y(I)**2)
        end do
        call hpake(-224,d_eta2)
        call hpak(-225,d1505)
        do I=1,24
          d_eta2(I)=sqrt(d1505t(I)**2+d1505y(I)**2)
        end do
        call hpake(-225,d_eta2)
*
        call hpak(-232,d1852)
        do I=1,24
          d_eta2(I)=sqrt(d1852t(I)**2+d1852y(I)**2)
        end do
        call hpake(-232,d_eta2)
        call hpak(-233,d1853)
        do I=1,24
          d_eta2(I)=sqrt(d1853t(I)**2+d1853y(I)**2)
        end do
        call hpake(-233,d_eta2)
        call hpak(-234,d1854)
        do I=1,24
          d_eta2(I)=sqrt(d1854t(I)**2+d1854y(I)**2)
        end do
        call hpake(-234,d_eta2)
        call hpak(-235,d1855)
        do I=1,24
          d_eta2(I)=sqrt(d1855t(I)**2+d1855y(I)**2)
        end do
        call hpake(-235,d_eta2)
*
        call hpak(-242,d2202)
        do I=1,24
          d_eta2(I)=sqrt(d2202t(I)**2+d2202y(I)**2)
        end do
        call hpake(-242,d_eta2)
        call hpak(-243,d2203)
        do I=1,24
          d_eta2(I)=sqrt(d2203t(I)**2+d2203y(I)**2)
        end do
        call hpake(-243,d_eta2)
        call hpak(-244,d2204)
        do I=1,24
          d_eta2(I)=sqrt(d2204t(I)**2+d2204y(I)**2)
        end do
        call hpake(-244,d_eta2)
        call hpak(-245,d2205)
        do I=1,24
          d_eta2(I)=sqrt(d2205t(I)**2+d2205y(I)**2)
        end do
        call hpake(-245,d_eta2)
*
        call hpak(-312,d1152)
        call hpake(-312,d1152t)
        call hpak(-313,d1153)
        call hpake(-313,d1153t)
        call hpak(-314,d1154)
        call hpake(-314,d1154t)
        call hpak(-315,d1155)
        call hpake(-315,d1155t)
*
        call hpak(-412,d1152)
        call hpake(-412,d1152y)
        call hpak(-413,d1153)
        call hpake(-413,d1153y)
        call hpak(-414,d1154)
        call hpake(-414,d1154y)
        call hpak(-415,d1155)
        call hpake(-415,d1155y)
*
        call hpak(-322,d1502)
        call hpake(-322,d1502t)
        call hpak(-323,d1503)
        call hpake(-323,d1503t)
        call hpak(-324,d1504)
        call hpake(-324,d1504t)
        call hpak(-325,d1505)
        call hpake(-325,d1505t)
*
        call hpak(-422,d1502)
        call hpake(-422,d1502y)
        call hpak(-423,d1503)
        call hpake(-423,d1503y)
        call hpak(-424,d1504)
        call hpake(-424,d1504y)
        call hpak(-425,d1505)
        call hpake(-425,d1505y)
*
        call hpak(-332,d1852)
        call hpake(-332,d1852t)
        call hpak(-333,d1853)
        call hpake(-333,d1853t)
        call hpak(-334,d1854)
        call hpake(-334,d1854t)
        call hpak(-335,d1855)
        call hpake(-335,d1855t)
*
        call hpak(-432,d1852)
        call hpake(-432,d1852y)
        call hpak(-433,d1853)
        call hpake(-433,d1853y)
        call hpak(-434,d1854)
        call hpake(-434,d1854y)
        call hpak(-435,d1855)
        call hpake(-435,d1855y)
*
        call hpak(-342,d2202)
        call hpake(-342,d2202t)
        call hpak(-343,d2203)
        call hpake(-343,d2203t)
        call hpak(-344,d2204)
        call hpake(-344,d2204t)
        call hpak(-345,d2205)
        call hpake(-345,d2205t)
*
        call hpak(-442,d2202)
        call hpake(-442,d2202y)
        call hpak(-443,d2203)
        call hpake(-443,d2203y)
        call hpak(-444,d2204)
        call hpake(-444,d2204y)
        call hpak(-445,d2205)
        call hpake(-445,d2205y)
*
* Add the MCM Diagrams with different eta
        do I=2,4
          call HOpera(110+I,'+E',111+I,111+I,1.0,1.0)
        end do
*
* Normalize the MCM diagrams using number of events in the 4 energie bins
        do J=1,4
          if(EnergB(J).eq.0.) then
            write(6,*)'Error: Number of accepted events is 0.'
            write(6,*)'Energie bin:',J
            NormC=1.0
          else
            NormC=1.0/EnergB(J)
          end if
          if (lp) then
           write(6,*) '  EnergB(J) = ',EnergB(J),' y= ',y
          endif
          do I=2,5
            call HUNPAK(110+I,y,' ',0)
            y(J)=y(J)*NormC
            call HPAK(110+I,y)
            call HUNPKE(110+I,y,' ',0)
            y(J)=y(J)*NormC
            call HPAKE(110+I,y)
*
            call hzhinfo(110+I,NormC)
            call hzchisq(-1*(110+I),110+I)
          end do
        end do

* Normalize the CM-distribution diagrams
        do J=1,4
          do I=2,5
            call HUNPAK(200+10*J+I,y2,' ',0)
            S=0.0
            do N=1,nx
              S=y2(N)+S
            end do
            if (lp) then
             write(6,*) ' s- ',s
            endif
            call HOpera(200+10*J+I,'+E',200+10*J+I,
     &           200+10*J+I,100.0/S,0.0)
            call hzhinfo(200+10*J+I,s)
            call hzchisq(-1*(200+10*J+I),200+10*J+I)
          end do
        end do
*
        do J=1,4
          do I=2,5
            call HUNPAK(1000+200+10*J+I,xy2,' ',0)
            S=0.0
            do N=1,nx2
              S=xy2(N)+S
            end do
            call HOpera(1000+200+10*J+I,'+E',1000+200+10*J+I,
     &           1000+200+10*J+I,100.0/S,0.0)
            call hzhinfo(1000+200+10*J+I,s)
          end do
        end do
*
*
*
      Endif
*
      Return
      End
