*CMZ :  1.01/15 22/06/98  15.32.51  by  Tancredi Carli
*CMZ :  1.01/11 01/01/98  16.54.05  by  Tancredi Carli
*CMZ :  1.01/07 15/10/97  17.37.24  by  Tancredi Carli
*CMZ :  1.01/05 15/07/97  10.39.53  by  Tancredi Carli
*CMZ :  1.01/03 15/05/96  19.46.03  by  Tancredi Carli
*-- Author :  Frank Botterweck 25-05-96
      subroutine HZ96215(IFLAG)
***************************************************************************
*
* Last update:  clean up
*               add data from UK analysis (someone owes me big!)
*               remove data not in published paper
*
* 5-jun-97 Michael Kuhlen
*
****************************************************************************
*       update: Included ptmax 0.5 - 1.5 with Et (0.-2.) > 6
*               Included eta 3-4
*
*
*  data 7/6/96
*
*
****************************************************************************
****************************************************************************
*  Last update: data statistical errors are included in histogram + 10
*               there are multiplicty histograms for the 9+1 bins
*               these are convenient when adding moca hbook files
*               to gain statistics.
*  data 7/6/96
*
*
****************************************************************************
****************************************************************************
*  Last update: data are included
*               Moca histograms are now normalized to bin-width
*
*  To be done ... parameters for data datastatements
*
****************************************************************************
* Purpose: produce histograms for:
*           o) CMS tracks
*           o) dn/deta, dn/deta pt>1, dn/dpt, and dn/dptmax, Et>6
*           o) pt spectra in eta bin 0.5-1.5 and 1.5-2.5
*           o) Et measured from 0.5-2.5 in etacms
*
* Event selection:
* Eel>12 GeV, 173.0>Thel>157.0, w2>4400 GeV**2 and cut on forward energy
*
*  Histograms:  in all cases: iq= kin bin (0-9)
*                             iofeta = 30 , ieta eta interval for pt.
*
* -Intermediate , reset for each event
*       20 000 + 100                    , eta
*       20 000 + 200                    , eta pt>1
*       20 000 + 300 + iofeta*(ieta-1)  , pt , for eta interval ieta
*
* -Event summed, filled after each event.
*
*       10 000 + 100 + iofeta*(ieta-1) + iq  , eta ,          d n
*       10 000 + 110 + iofeta*(ieta-1) + iq  , eta ,          d n**2
*
*       10 000 + 200 + iofeta*(ieta-1) + iq  , eta , pt>1 ,   d n
*       10 000 + 210 + iofeta*(ieta-1) + iq  , eta , pt>1 ,   d n**2
*
*       10 000 + 300 + iofeta*(ieta-1) + iq  , pt ,   d n
*       10 000 + 310 + iofeta*(ieta-1) + iq  , pt ,   d n**2
*       10 000 + 350 + iofeta*(ieta-1) + iq  , pt ,   <pT> per pt bin
*
*       10 000 + 400 + iofeta*(ieta-1) + iq  , ptmax , dNa
*       10 000 + 450 + iofeta*(ieta-1) + iq  , ptmax , <ptmax>
*
* -Final normalized histograms
*
*       10 000 + 100 + iofeta*(ieta-1) + iq  , eta ,          1/N dn/deta
*
*       10 000 + 200 + iofeta*(ieta-1) + iq  , eta , pt>1 ,   1/N dn/deta
*
*       10 000 + 300 + iofeta*(ieta-1) + iq  , pt ,  1/N dn/dpt
*       10 000 + 350 + iofeta*(ieta-1) + iq  , pt ,   <pT> per pt bin
*
*       10 000 + 400 + iofeta*(ieta-1) + iq  , ptmax , dNa   1/Na dNa/dptmax
*       10 000 + 450 + iofeta*(ieta-1) + iq  , ptmax , <ptmax>
*
*  For data the final  histograms get negative id.
*  Statistical errors are stored in -id - 10
*
*
* Running: Ee=27.6, Ep=820, no polarization, HERA running 1994
* Reference:
* Arguments: iflag=1 initialisation
*            iflag=1 filling
*            iflag=3 termination
*
* written by: Botti
****************************************************************************
      IMPLICIT NONE
      integer ibin
      integer neta,iofeta,ieta,jjbin,jbin
      parameter (neta=5,iofeta=30)
      real etsummed,etsummed1, ptmax(neta)
      real etalow(neta),etahig(neta)
      data etalow/ 0.5 , 1.5 , 3.0 , 3.0 , 3.5 /
      data etahig/ 1.5 , 2.5 , 4.0 , 3.5 , 4.0 /

*      parameter (nxbxf=7)
*      real xbxf(nxbxf+1)
*      data xbxf/
*     1   0. ,0.05 , 0.1, 0.2, 0.4, 0.6, 0.8, 1.0/
      integer nbptm
      parameter (nbptm=12)
      real xbptm(nbptm+1)
      data xbptm/
     &   0., 0.25, 0.50 , 0.75, 1.0
     &     , 1.25, 1.50 , 1.75, 2.0
     &     , 2.5 , 3.
     &     , 4., 5/
      integer nbpt
      parameter (nbpt=17)
      real xbpt1(nbpt+1)
      data xbpt1/
     1   0. , 0.2, 0.4, 0.6, 0.8, 1.0, 1.2, 1.4, 1.6, 1.8
     1 , 2.1, 2.5, 3.0, 4.0, 5.0, 6.0, 8.0,10.0 /

*     multiplicity counter
      real xmult

*data sequence statements
      real deta0x0 ( 18 )
      data deta0x0 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta0y0 ( 18 )
      data deta0y0 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 2.322577 , 2.457598,
     + 2.528338 , 2.402715 , 2.141174 , 1.649924 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0ey0 ( 18 )
      data deta0ey0 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.014777 , 0.013939,
     + 0.013827 , 0.013048 , 0.012309 , 0.012023 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0sy0 ( 18 )
      data deta0sy0 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.226442 , 0.180556,
     + 0.171047 , 0.150818 , 0.142905 , 0.134664 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0x1 ( 18 )
      data deta0x1 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta0y1 ( 18 )
      data deta0y1 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 2.177350 , 2.394072 , 2.455025,
     + 2.486309 , 2.512200 , 2.339928 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0ey1 ( 18 )
      data deta0ey1 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.046460 , 0.048209 , 0.049273,
     + 0.048474 , 0.048320 , 0.046787 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0sy1 ( 18 )
      data deta0sy1 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.317663 , 0.155949 , 0.280194,
     + 0.173537 , 0.179672 , 0.179167 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0x2 ( 18 )
      data deta0x2 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta0y2 ( 18 )
      data deta0y2 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 2.324203 , 2.269060 , 2.510778,
     + 2.549480 , 2.567664 , 2.341193 , 1.916110 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0ey2 ( 18 )
      data deta0ey2 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.049817 , 0.041039 , 0.044576,
     + 0.043917 , 0.043299 , 0.039829 , 0.042626 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0sy2 ( 18 )
      data deta0sy2 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.270717 , 0.156498 , 0.172475,
     + 0.191245 , 0.200157 , 0.208638 , 0.159855 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0x3 ( 18 )
      data deta0x3 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta0y3 ( 18 )
      data deta0y3 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 2.237587 , 2.480351 , 2.493410,
     + 2.643841 , 2.474443 , 2.313419 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0ey3 ( 18 )
      data deta0ey3 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.035239 , 0.034720 , 0.033804,
     + 0.035613 , 0.033563 , 0.032587 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0sy3 ( 18 )
      data deta0sy3 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.253824 , 0.153772 , 0.165751,
     + 0.195725 , 0.153256 , 0.169059 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0x4 ( 18 )
      data deta0x4 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta0y4 ( 18 )
      data deta0y4 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 2.369294 , 2.468037,
     + 2.472720 , 2.486072 , 2.248240 , 1.782471 , 1.116604,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0ey4 ( 18 )
      data deta0ey4 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.039748 , 0.039094,
     + 0.038228 , 0.037583 , 0.035924 , 0.035087 , 0.030254,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0sy4 ( 18 )
      data deta0sy4 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.202745 , 0.156611,
     + 0.229117 , 0.154936 , 0.145332 , 0.142499 , 0.105021,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0x5 ( 18 )
      data deta0x5 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta0y5 ( 18 )
      data deta0y5 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 2.258555 , 2.373175,
     + 2.482646 , 2.278014 , 2.025487 , 1.486322 , 0.838491,
     + 0.404204 , 0.170590 , 0.000000
     + /
      real deta0ey5 ( 18 )
      data deta0ey5 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.041068 , 0.036721,
     + 0.037151 , 0.033583 , 0.031456 , 0.028336 , 0.021748,
     + 0.015703 , 0.010752 , 0.000000
     + /
      real deta0sy5 ( 18 )
      data deta0sy5 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.323778 , 0.219632,
     + 0.161313 , 0.185944 , 0.171144 , 0.203854 , 0.177081,
     + 0.079731 , 0.035672 , 0.000000
     + /
      real deta0x6 ( 18 )
      data deta0x6 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.000000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta0y6 ( 18 )
      data deta0y6 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 2.257    , 2.379453,
     + 2.394166 , 2.169586 , 1.867416 , 1.123464 , 0.583172,
     + 0.264400 , 0.093353 , 0.030262
     + /
      real deta0ey6 ( 18 )
      data deta0ey6 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.034    , 0.051935,
     + 0.047427 , 0.042585 , 0.040818 , 0.029435 , 0.021869,
     + 0.015206 , 0.009496 , 0.005009
     + /
      real deta0sy6 ( 18 )
      data deta0sy6 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.249    , 0.269571,
     + 0.193730 , 0.140911 , 0.281627 , 0.200342 , 0.133837,
     + 0.063604 , 0.013411 , 0.006372
     + /
      real deta0x7 ( 18 )
      data deta0x7 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta0y7 ( 18 )
      data deta0y7 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 2.307968 , 2.551594 , 2.606660,
     + 2.634754 , 2.568604 , 2.394787 , 1.785188 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0ey7 ( 18 )
      data deta0ey7 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.040443 , 0.037237 , 0.037357,
     + 0.036852 , 0.035707 , 0.035296 , 0.033093 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0sy7 ( 18 )
      data deta0sy7 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.262974 , 0.181178 , 0.163738,
     + 0.178094 , 0.174253 , 0.149991 , 0.095275 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta0x8 ( 18 )
      data deta0x8 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta0y8 ( 18 )
      data deta0y8 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 2.444883 , 2.520633,
     + 2.611290 , 2.392796 , 2.008049 , 1.409134 , 0.804890,
     + 0.363043 , 0.163875 , 0.000000
     + /
      real deta0ey8 ( 18 )
      data deta0ey8 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.044866 , 0.041030,
     + 0.040703 , 0.036459 , 0.034055 , 0.027928 , 0.021629,
     + 0.015129 , 0.010877 , 0.000000
     + /
      real deta0sy8 ( 18 )
      data deta0sy8 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.238625 , 0.174674,
     + 0.164083 , 0.174590 , 0.131858 , 0.185018 , 0.183791,
     + 0.058654 , 0.037631 , 0.000000
     + /
*                                  data from UK
      real deta0x9 ( 18 )
      data deta0x9 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.000000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta0y9 ( 18 )
      data deta0y9 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 2.252    , 2.508207,
     + 2.466111 , 2.164084 , 1.626398 , 1.004962 , 0.493466,
     + 0.228442 , 0.000000 , 0.043968
     + /
      real deta0ey9 ( 18 )
      data deta0ey9 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.036    , 0.058572,
     + 0.052627 , 0.047958 , 0.038027 , 0.030043 , 0.021354,
     + 0.015490 , 0.000000 , 0.007551
     + /
      real deta0sy9 ( 18 )
      data deta0sy9 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.249    , 0.329920,
     + 0.168703 , 0.252231 , 0.246354 , 0.229767 , 0.117804,
     + 0.054844 , 0.000000 , 0.012014
     + /
*
      real deta1x0 ( 18 )
      data deta1x0 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta1y0 ( 18 )
      data deta1y0 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.167320 , 0.217762 , 0.249517,
     + 0.274188 , 0.258963 , 0.208398 , 0.133392 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1ey0 ( 18 )
      data deta1ey0 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.004188 , 0.004137 , 0.004375,
     + 0.004450 , 0.004004 , 0.003556 , 0.003562 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1sy0 ( 18 )
      data deta1sy0 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.048182 , 0.021508 , 0.010188,
     + 0.009320 , 0.009273 , 0.014047 , 0.019414 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1x1 ( 18 )
      data deta1x1 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta1y1 ( 18 )
      data deta1y1 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.182693 , 0.223598 , 0.214370,
     + 0.243840 , 0.233084 , 0.242939 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1ey1 ( 18 )
      data deta1ey1 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.014068 , 0.015739 , 0.014963,
     + 0.016143 , 0.014766 , 0.014992 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1sy1 ( 18 )
      data deta1sy1 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.063582 , 0.032032 , 0.082469,
     + 0.036096 , 0.040272 , 0.027586 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1x2 ( 18 )
      data deta1x2 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta1y2 ( 18 )
      data deta1y2 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.180000 , 0.189014 , 0.248015,
     + 0.240696 , 0.271640 , 0.210813 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1ey2 ( 18 )
      data deta1ey2 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.011919 , 0.011699 , 0.015093,
     + 0.013759 , 0.013689 , 0.010995 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1sy2 ( 18 )
      data deta1sy2 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.019182 , 0.035568 , 0.042533,
     + 0.023230 , 0.021233 , 0.013846 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1x3 ( 18 )
      data deta1x3 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta1y3 ( 18 )
      data deta1y3 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.184253 , 0.237522 , 0.225009,
     + 0.287443 , 0.264407 , 0.241901 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1ey3 ( 18 )
      data deta1ey3 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.009021 , 0.010938 , 0.009944,
     + 0.012029 , 0.010290 , 0.010127 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1sy3 ( 18 )
      data deta1sy3 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.016658 , 0.014231 , 0.012424,
     + 0.028236 , 0.014305 , 0.014975 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1x4 ( 18 )
      data deta1x4 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta1y4 ( 18 )
      data deta1y4 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.195286 , 0.225654 , 0.235799,
     + 0.274498 , 0.260185 , 0.234857 , 0.128618 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1ey4 ( 18 )
      data deta1ey4 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.013163 , 0.012172 , 0.012044,
     + 0.012818 , 0.011379 , 0.011173 , 0.009728 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1sy4 ( 18 )
      data deta1sy4 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.027193 , 0.028305 , 0.015761,
     + 0.021592 , 0.015574 , 0.019037 , 0.012740 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1x5 ( 18 )
      data deta1x5 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta1y5 ( 18 )
      data deta1y5 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.202716 , 0.240428,
     + 0.252368 , 0.231746 , 0.163663 , 0.096085 , 0.013240,
     + 0.000300 , 0.000000 , 0.000000
     + /
      real deta1ey5 ( 18 )
      data deta1ey5 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.010363 , 0.011498,
     + 0.011091 , 0.009868 , 0.008012 , 0.007557 , 0.002875,
     + 0.000279 , 0.000000 , 0.000000
     + /
      real deta1sy5 ( 18 )
      data deta1sy5 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.029652 , 0.026319,
     + 0.013409 , 0.011097 , 0.014180 , 0.025914 , 0.003906,
     + 0.000486 , 0.000000 , 0.000000
     + /
      real deta1x6 ( 18 )
      data deta1x6 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.000000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta1y6 ( 18 )
      data deta1y6 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.203 , 0.196807,
     + 0.222746 , 0.199840 , 0.127013 , 0.044789 , 0.009105,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1ey6 ( 18 )
      data deta1ey6 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.010 , 0.012662,
     + 0.012756 , 0.011414 , 0.008535 , 0.004595 , 0.002640,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1sy6 ( 18 )
      data deta1sy6 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.041 , 0.018449,
     + 0.016666 , 0.016364 , 0.043517 , 0.014931 , 0.007999,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1x7 ( 18 )
      data deta1x7 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta1y7 ( 18 )
      data deta1y7 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.217939 , 0.271109 , 0.313996,
     + 0.317236 , 0.338311 , 0.316494 , 0.178238 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1ey7 ( 18 )
      data deta1ey7 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.010495 , 0.011590 , 0.013168,
     + 0.012541 , 0.012367 , 0.012576 , 0.010753 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1sy7 ( 18 )
      data deta1sy7 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.030681 , 0.016816 , 0.023475,
     + 0.028950 , 0.028362 , 0.029980 , 0.016941 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1x8 ( 18 )
      data deta1x8 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.250000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta1y8 ( 18 )
      data deta1y8 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.244546 , 0.292619,
     + 0.320038 , 0.287161 , 0.210220 , 0.091631 , 0.021711,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1ey8 ( 18 )
      data deta1ey8 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.012472 , 0.013371,
     + 0.013554 , 0.011546 , 0.010237 , 0.006857 , 0.003954,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1sy8 ( 18 )
      data deta1sy8 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.021332 , 0.023142,
     + 0.021491 , 0.022309 , 0.013733 , 0.022542 , 0.009593,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1x9 ( 18 )
      data deta1x9 /
     + -2.750000 , -2.250000 , -1.750000 , -1.250000 , -0.750000,
     + -0.250000 , 0.250000 , 0.750000 , 1.000000 , 1.750000,
     + 2.250000 , 2.750000 , 3.250000 , 3.750000 , 4.250000,
     + 4.750000 , 5.250000 , 5.750000
     + /
      real deta1y9 ( 18 )
      data deta1y9 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.253 , 0.296094,
     + 0.292781 , 0.219977 , 0.105964 , 0.029185 , 0.002498,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1ey9 ( 18 )
      data deta1ey9 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.01200 , 0.017949,
     + 0.015594 , 0.013181 , 0.007009 , 0.003488 , 0.001130,
     + 0.000000 , 0.000000 , 0.000000
     + /
      real deta1sy9 ( 18 )
      data deta1sy9 /
     + 0.000000 , 0.000000 , 0.000000 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000 , 0.000000 , 0.044 , 0.040663,
     + 0.031058 , 0.024536 , 0.031559 , 0.006095 , 0.001575,
     + 0.000000 , 0.000000 , 0.000000
     + /
*KEEP,
      real dpte1x0 ( 17 )
      data dpte1x0 /
     + 0.162360 , 0.298877 , 0.490576 , 0.689316 , 0.890855,
     + 1.090134 , 1.293101 , 1.491562 , 1.694025 , 1.938814,
     + 2.282308 , 2.725309 , 3.411661 , 4.389038 , 5.492702,
     + 6.696726 , 8.906260
     + /
      real dpte1y0 ( 17 )
      data dpte1y0 /
     + 0.000000 , 3.809271 , 2.241907 , 1.184976 , 0.641582,
     + 0.331231 , 0.210534 , 0.127926 , 0.076379 , 0.055994,
     + 0.028325 , 0.014849 , 0.007091 , 0.002364 , 0.000933,
     + 0.000502 , 0.000054
     + /
      real dpte1ey0 ( 17 )
      data dpte1ey0 /
     + 0.000000 , 0.031118 , 0.020752 , 0.014522 , 0.010738,
     + 0.007553 , 0.006344 , 0.004836 , 0.003775 , 0.002712,
     + 0.001590 , 0.001044 , 0.000542 , 0.000292 , 0.000166,
     + 0.000107 , 0.000026
     + /
      real dpte1sy0 ( 17 )
      data dpte1sy0 /
     + 0.000000 , 0.503476 , 0.195446 , 0.097384 , 0.049776,
     + 0.041316 , 0.028940 , 0.013242 , 0.019292 , 0.010790,
     + 0.006085 , 0.002733 , 0.001375 , 0.000629 , 0.000339,
     + 0.000127 , 0.000048
     + /
      real dpte1x1 ( 17 )
      data dpte1x1 /
     + 0.157880 , 0.296208 , 0.488990 , 0.688672 , 0.892311,
     + 1.090899 , 1.293972 , 1.485585 , 1.684990 , 1.949313,
     + 2.308975 , 2.740007 , 3.284047 , 4.304148 , 5.500000,
     + 6.759059 , 9.000000
     + /
      real dpte1y1 ( 17 )
      data dpte1y1 /
     + 0.000000 , 3.964725 , 2.250483 , 1.181318 , 0.615708,
     + 0.369140 , 0.215639 , 0.124290 , 0.066408 , 0.053580,
     + 0.026624 , 0.018312 , 0.006078 , 0.002407 , 0.000000,
     + 0.000627 , 0.000000
     + /
      real dpte1ey1 ( 17 )
      data dpte1ey1 /
     + 0.000000 , 0.090217 , 0.061397 , 0.045599 , 0.033487,
     + 0.027907 , 0.021770 , 0.015804 , 0.011349 , 0.009564,
     + 0.005216 , 0.004773 , 0.001693 , 0.001057 , 0.000000,
     + 0.000399 , 0.000000
     + /
      real dpte1sy1 ( 17 )
      data dpte1sy1 /
     + 0.000000 , 0.429452 , 0.136517 , 0.126414 , 0.063365,
*     + 0.062731 , 0.038956 , 0.026626 , 0.088158 , 0.011617,
*     + 0.062731 , 0.038956 , 0.026626 , 0.044158 , 0.011617,
     + 0.062731 , 0.038956 , 0.026626 , 0.024158 , 0.011617,
*     + 0.008927 , 0.012334 , 0.003247 , 0.002807 , 0.000000,
     + 0.008927 , 0.009334 , 0.003247 , 0.002807 , 0.000000,
     + 0.000714 , 0.000000
     + /
      real dpte1x2 ( 17 )
      data dpte1x2 /
     + 0.161445 , 0.296189 , 0.490345 , 0.688699 , 0.891673,
     + 1.085692 , 1.293970 , 1.497802 , 1.695254 , 1.935458,
     + 2.277624 , 2.732543 , 3.469652 , 4.405536 , 5.514422,
     + 7.009683 , 9.000000
     + /
      real dpte1y2 ( 17 )
      data dpte1y2 /
     + 0.000000 , 3.877373 , 2.400283 , 1.145470 , 0.721684,
     + 0.290112 , 0.222869 , 0.135009 , 0.062534 , 0.060400,
     + 0.022993 , 0.011480 , 0.007940 , 0.000000 , 0.000000,
     + 0.000502 , 0.000000
     + /
      real dpte1ey2 ( 17 )
      data dpte1ey2 /
     + 0.000000 , 0.083579 , 0.060179 , 0.039119 , 0.033827,
     + 0.019545 , 0.019786 , 0.015707 , 0.009412 , 0.008625,
     + 0.004157 , 0.002718 , 0.002043 , 0.000000 , 0.000000,
     + 0.000364 , 0.000000
     + /
      real dpte1sy2 ( 17 )
      data dpte1sy2 /
     + 0.000000 , 0.445966 , 0.222516 , 0.073247 , 0.069923,
*     + 0.064002 , 0.033546 , 0.022772 , 0.021368 , 0.010949,
     + 0.064002 , 0.033546 , 0.022772 , 0.011368 , 0.010949,
     + 0.008113 , 0.004042 , 0.006983 , 0.000000 , 0.000000,
     + 0.000630 , 0.000000
     + /
      real dpte1x3 ( 17 )
      data dpte1x3 /
     + 0.160267 , 0.297412 , 0.489808 , 0.687823 , 0.888031,
     + 1.089949 , 1.295086 , 1.490131 , 1.697480 , 1.933894,
     + 2.277411 , 2.724032 , 3.414287 , 4.415628 , 5.464792,
     + 6.793752 , 9.529037
     + /
      real dpte1y3 ( 17 )
      data dpte1y3 /
     + 0.000000 , 4.035040 , 2.384313 , 1.281876 , 0.701290,
     + 0.358940 , 0.232133 , 0.127767 , 0.083752 , 0.064109,
     + 0.031486 , 0.014645 , 0.006462 , 0.002890 , 0.001080,
     + 0.000370 , 0.000000
     + /
      real dpte1ey3 ( 17 )
      data dpte1ey3 /
     + 0.000000 , 0.066086 , 0.046255 , 0.033595 , 0.025511,
     + 0.018077 , 0.015662 , 0.010941 , 0.009252 , 0.006927,
     + 0.004143 , 0.002176 , 0.001123 , 0.000767 , 0.000414,
     + 0.000195 , 0.000000
     + /
      real dpte1sy3 ( 17 )
      data dpte1sy3 /
     + 0.000000 , 0.438972 , 0.170568 , 0.093933 , 0.044942,
*     + 0.022098 , 0.032619 , 0.011751 , 0.025036 , 0.007435,
     + 0.022098 , 0.032619 , 0.011751 , 0.015036 , 0.007435,
     + 0.006797 , 0.003278 , 0.001214 , 0.001683 , 0.000932,
     + 0.000255 , 0.000000
     + /
      real dpte1x4 ( 17 )
      data dpte1x4 /
     + 0.167556 , 0.300000 , 0.491152 , 0.689191 , 0.894802,
     + 1.091834 , 1.295076 , 1.491754 , 1.687291 , 1.941291,
     + 2.270712 , 2.723969 , 3.409333 , 4.346185 , 5.521909,
     + 6.997241 , 8.728801
     + /
      real dpte1y4 ( 17 )
      data dpte1y4 /
     + 0.000000 , 3.885024 , 2.348275 , 1.242578 , 0.668143,
     + 0.303928 , 0.233712 , 0.141039 , 0.090458 , 0.059983,
     + 0.050754 , 0.021726 , 0.006169 , 0.000000 , 0.000000,
     + 0.000368 , 0.000043
     + /
      real dpte1ey4 ( 17 )
      data dpte1ey4 /
     + 0.000000 , 0.083776 , 0.059075 , 0.041913 , 0.031373,
     + 0.019496 , 0.019571 , 0.014651 , 0.012648 , 0.008208,
     + 0.007988 , 0.004470 , 0.001337 , 0.000000 , 0.000000,
     + 0.000236 , 0.000048
     + /
      real dpte1sy4 ( 17 )
      data dpte1sy4 /
     + 0.000000 , 0.526392 , 0.183135 , 0.104440 , 0.067856,
     + 0.047845 , 0.025207 , 0.034590 , 0.019041 , 0.011542,
     + 0.021529 , 0.011768 , 0.003204 , 0.000000 , 0.000000,
     + 0.000366 , 0.000086
     + /
      real dpte1x5 ( 17 )
      data dpte1x5 /
     + 0.175773 , 0.303910 , 0.493302 , 0.687073 , 0.890848,
     + 1.089773 , 1.290292 , 1.495525 , 1.708378 , 1.951255,
     + 2.253758 , 2.763419 , 3.447014 , 4.441384 , 5.490909,
     + 6.556049 , 9.000000
     + /
      real dpte1y5 ( 17 )
      data dpte1y5 /
     + 0.000000 , 0.000000 , 2.104012 , 1.171201 , 0.580983,
     + 0.336386 , 0.205590 , 0.141338 , 0.083767 , 0.054240,
     + 0.022451 , 0.012142 , 0.007565 , 0.000000 , 0.000000,
     + 0.000000 , 0.000000
     + /
*     + 0.022451 , 0.012142 , 0.007565 , 0.000971 , 0.001163,
      real dpte1ey5 ( 17 )
      data dpte1ey5 /
     + 0.000000 , 0.000000 , 0.062175 , 0.045082 , 0.032210,
     + 0.023304 , 0.019158 , 0.017185 , 0.012397 , 0.008173,
     + 0.003854 , 0.002599 , 0.001807 , 0.000349 , 0.000769,
     + 0.000000 , 0.000000
     + /
      real dpte1sy5 ( 17 )
      data dpte1sy5 /
     + 0.000000 , 0.000000 , 0.256033 , 0.159328 , 0.057842,
     + 0.070388 , 0.027805 , 0.038085 , 0.028985 , 0.014528,
     + 0.007980 , 0.004956 , 0.005243 , 0.001363 , 0.001020,
     + 0.000000 , 0.000000
     + /
*                               this data are from UK analysis
      real dpte1x6 ( 17 )
      data dpte1x6 /
     + 0.100000 , 0.300000 , 0.500000 , 0.700000 , 0.900000,
     + 1.100000 , 1.300000 , 1.500000 , 1.700000 , 1.950000,
     + 2.300000 , 2.750000 , 3.500000 , 4.500000 , 5.500000,
     + 7.000000 , 9.000000
     + /
      real dpte1y6 ( 17 )
      data dpte1y6 /
     + 2.570000 , 3.660000 , 2.250000 , 1.150000 , 0.620000,
     + 0.340000 , 0.210000 , 0.130000 , 0.093000 , 0.045400,
     + 0.039300 , 0.014800 , 0.007400 , 0.000000 , 0.0,
     + 0.000000 , 0.000000
     + /
      real dpte1ey6 ( 17 )
      data dpte1ey6 /
     + 0.101000 , 0.088000 , 0.700000 , 0.050000 , 0.037000,
     + 0.028000 , 0.023000 , 0.018000 , 0.015000 , 0.008200,
     + 0.007700 , 0.003800 , 0.002100 , 0.0      , 0.0,
     + 0.000    , 0.000000
     + /
      real dpte1sy6 ( 17 )
      data dpte1sy6 /
     + 0.32     , 0.28     , 0.11     , 0.10     , 0.041   ,
     + 0.046    , 0.043    , 0.017    , 0.023    , 0.0077  ,
     + 0.019    , 0.0098   , 0.0049   , 0.0      , 0.0     ,
     + 0.000    , 0.0000
     + /
      real dpte1x7 ( 17 )
      data dpte1x7 /
     + 0.162133 , 0.297150 , 0.489087 , 0.692878 , 0.889799,
     + 1.089919 , 1.292735 , 1.491898 , 1.692592 , 1.940659,
     + 2.281777 , 2.721463 , 3.382576 , 4.346806 , 5.536829,
     + 6.618409 , 8.963818
     + /
      real dpte1y7 ( 17 )
      data dpte1y7 /
     + 0.000000 , 4.113233 , 2.453447 , 1.333447 , 0.704757,
     + 0.416686 , 0.222304 , 0.173507 , 0.096993 , 0.068347,
     + 0.037876 , 0.019830 , 0.009541 , 0.003660 , 0.001623,
     + 0.000562 , 0.000000
     + /
      real dpte1ey7 ( 17 )
      data dpte1ey7 /
     + 0.000000 , 0.072634 , 0.050488 , 0.036494 , 0.025940,
     + 0.020593 , 0.014832 , 0.013475 , 0.010240 , 0.006818,
     + 0.004258 , 0.002825 , 0.001466 , 0.000877 , 0.000533,
     + 0.000266 , 0.000000
     + /
      real dpte1sy7 ( 17 )
      data dpte1sy7 /
     + 0.000000 , 0.463639 , 0.237014 , 0.116357 , 0.043690,
     + 0.045129 , 0.037385 , 0.017226 , 0.022884 , 0.018814,
     + 0.005120 , 0.003526 , 0.001889 , 0.002560 , 0.001138,
     + 0.000428 , 0.000000
     + /
      real dpte1x8 ( 17 )
      data dpte1x8 /
     + 0.171338 , 0.302290 , 0.492383 , 0.688816 , 0.891178,
     + 1.090408 , 1.286769 , 1.483307 , 1.693555 , 1.920627,
     + 2.294145 , 2.680084 , 3.452182 , 4.456293 , 5.388338,
     + 6.544116 , 8.738633
     + /
      real dpte1y8 ( 17 )
      data dpte1y8 /
     + 0.000000 , 0.000000 , 2.318220 , 1.244961 , 0.699909,
     + 0.386925 , 0.242838 , 0.135416 , 0.114591 , 0.059713,
     + 0.035617 , 0.016327 , 0.010424 , 0.003232 , 0.001346,
     + 0.001333 , 0.000000
     + /
      real dpte1ey8 ( 17 )
      data dpte1ey8 /
     + 0.000000 , 0.000000 , 0.068041 , 0.047018 , 0.034438,
     + 0.025872 , 0.020533 , 0.014654 , 0.015446 , 0.008157,
     + 0.005243 , 0.003399 , 0.002173 , 0.001046 , 0.000649,
     + 0.000706 , 0.000000
     + /
      real dpte1sy8 ( 17 )
      data dpte1sy8 /
     + 0.000000 , 0.000000 , 0.194213 , 0.085400 , 0.110409,
     + 0.033184 , 0.030204 , 0.031122 , 0.023996 , 0.009410,
     + 0.008817 , 0.005804 , 0.003938 , 0.001611 , 0.001403,
     + 0.001150 , 0.000000
     + /
*                              data from UK analysis
      real dpte1x9 ( 17 )
      data dpte1x9 /
     + 0.100000 , 0.300000 , 0.500000 , 0.700000 , 0.900000,
     + 1.100000 , 1.300000 , 1.500000 , 1.700000 , 1.950000,
     + 2.300000 , 2.750000 , 3.500000 , 4.500000 , 5.500000,
     + 7.000000 , 9.000000
     + /
      real dpte1y9 ( 17 )
      data dpte1y9 /
     + 2.41     , 3.59     , 2.17     , 1.12     , 0.68    ,
     + 0.36     , 0.26     , 0.165    , 0.126    , 0.082    ,
     + 0.040    , 0.0184   , 0.0106   , 0.0027   , 0.0008   ,
     + 0.0008   , 0.0004
     + /
      real dpte1ey9 ( 17 )
      data dpte1ey9 /
     + 0.101,     0.092,     0.071,     0.051,     0.041,
     + 0.029,     0.027,     0.021,     0.019,     0.013,
     + 0.0081,    0.0043,    0.0026,    0.0011,    0.00048,
     + 0.0005,    0.0006
     + /
      real dpte1sy9 ( 17 )
      data dpte1sy9 /
     + 0.23,      0.20,      0.14,      0.055,     0.069,
     + 0.037,     0.032,     0.031,     0.042,     0.015,
     + 0.014,     0.0084,    0.0037,    0.0020,    0.0020,
     + 0.00082 ,  0.000764
     + /
*KEEP,
      real dptc1x0 ( 17 )
      data dptc1x0 /
     + 0.147694 , 0.293846 , 0.490388 , 0.689648 , 0.891181,
     + 1.094106 , 1.291681 , 1.493362 , 1.689540 , 1.938333,
     + 2.277400 , 2.723569 , 3.409679 , 4.409751 , 5.409957,
     + 6.688886 , 8.575716
     + /
      real dptc1y0 ( 17 )
      data dptc1y0 /
     + 2.716896 , 4.025324 , 2.412090 , 1.303974 , 0.714159,
     + 0.411238 , 0.268062 , 0.164476 , 0.117168 , 0.078514,
     + 0.043880 , 0.024724 , 0.009706 , 0.003406 , 0.001390,
     + 0.000445 , 0.000120
     + /
      real dptc1ey0 ( 17 )
      data dptc1ey0 /
     + 0.022981 , 0.025334 , 0.018684 , 0.013582 , 0.010148,
     + 0.007755 , 0.006413 , 0.004905 , 0.004235 , 0.002892,
     + 0.001837 , 0.001267 , 0.000540 , 0.000315 , 0.000205,
     + 0.000080 , 0.000044
     + /
      real dptc1sy0 ( 17 )
      data dptc1sy0 /
     + 0.674440 , 0.266596 , 0.087826 , 0.040211 , 0.022999,
     + 0.016705 , 0.012547 , 0.009536 , 0.009050 , 0.005292,
     + 0.005121 , 0.002559 , 0.000720 , 0.000364 , 0.000367,
     + 0.000086 , 0.000095
     + /
      real dptc1x1 ( 17 )
      data dptc1x1 /
     + 0.142511 , 0.293595 , 0.492429 , 0.688975 , 0.891263,
     + 1.090830 , 1.291974 , 1.493928 , 1.682002 , 1.941305,
     + 2.263516 , 2.700239 , 3.397242 , 4.356895 , 5.416314,
     + 6.557664 , 8.570911
     + /
      real dptc1y1 ( 17 )
      data dptc1y1 /
     + 2.720804 , 4.083863 , 2.496331 , 1.273163 , 0.699145,
     + 0.412444 , 0.224467 , 0.113231 , 0.106218 , 0.074062,
     + 0.024571 , 0.019320 , 0.008643 , 0.002625 , 0.001826,
     + 0.000219 , 0.000249
     + /
      real dptc1ey1 ( 17 )
      data dptc1ey1 /
     + 0.076272 , 0.090533 , 0.068490 , 0.048173 , 0.036676,
     + 0.030753 , 0.021816 , 0.013863 , 0.015449 , 0.010920,
     + 0.004437 , 0.004089 , 0.002152 , 0.001121 , 0.000855,
     + 0.000161 , 0.000253
     + /
      real dptc1sy1 ( 17 )
      data dptc1sy1 /
     + 0.653494 , 0.292545 , 0.173902 , 0.073565 , 0.077007,
     + 0.124268 , 0.034480 , 0.034968 , 0.035378 , 0.020404,
*     + 0.020445 , 0.031317 , 0.003238 , 0.001298 , 0.002187,
*     + 0.020445 , 0.011317 , 0.003238 , 0.001298 , 0.002187,
     + 0.007445 , 0.006317 , 0.003238 , 0.001298 , 0.002187,
     + 0.000282 , 0.000398
     + /
      real dptc1x2 ( 17 )
      data dptc1x2 /
     + 0.145037 , 0.293841 , 0.492014 , 0.689552 , 0.890136,
     + 1.090716 , 1.288026 , 1.490909 , 1.680064 , 1.938085,
     + 2.268266 , 2.725070 , 3.450559 , 4.422081 , 5.562262,
     + 6.508696 , 8.325836
     + /
      real dptc1y2 ( 17 )
      data dptc1y2 /
     + 3.009003 , 4.060803 , 2.409950 , 1.295427 , 0.688230,
     + 0.358538 , 0.283491 , 0.152851 , 0.109202 , 0.071605,
     + 0.045236 , 0.017227 , 0.010488 , 0.001799 , 0.000447,
     + 0.000000 , 0.000000
     + /
      real dptc1ey2 ( 17 )
      data dptc1ey2 /
     + 0.073530 , 0.079836 , 0.058430 , 0.042968 , 0.031562,
     + 0.023344 , 0.023317 , 0.015650 , 0.013936 , 0.009507,
     + 0.006527 , 0.003302 , 0.001926 , 0.000637 , 0.000274,
     + 0.000000 , 0.000000
     + /
      real dptc1sy2 ( 17 )
      data dptc1sy2 /
     + 0.722265 , 0.211490 , 0.092714 , 0.064788 , 0.045429,
     + 0.060081 , 0.043523 , 0.025701 , 0.028262 , 0.011149,
     + 0.009932 , 0.003803 , 0.002574 , 0.000788 , 0.000607,
     + 0.000000 , 0.000000
     + /
      real dptc1x3 ( 17 )
      data dptc1x3 /
     + 0.144455 , 0.293716 , 0.490440 , 0.691144 , 0.889625,
     + 1.093596 , 1.289810 , 1.489009 , 1.694837 , 1.928929,
     + 2.261349 , 2.721453 , 3.429991 , 4.417402 , 5.503767,
     + 6.755540 , 9.000000
     + /
      real dptc1y3 ( 17 )
      data dptc1y3 /
     + 2.787075 , 4.250382 , 2.493271 , 1.352758 , 0.712999,
     + 0.389431 , 0.250610 , 0.167815 , 0.126229 , 0.073481,
     + 0.044784 , 0.026861 , 0.008675 , 0.002924 , 0.001291,
     + 0.000696 , 0.000000
     + /
      real dptc1ey3 ( 17 )
      data dptc1ey3 /
     + 0.054401 , 0.065158 , 0.047625 , 0.034854 , 0.025325,
     + 0.018405 , 0.015224 , 0.012717 , 0.011457 , 0.007153,
     + 0.005102 , 0.003385 , 0.001282 , 0.000686 , 0.000470,
     + 0.000286 , 0.000000
     + /
      real dptc1sy3 ( 17 )
      data dptc1sy3 /
     + 0.716546 , 0.248871 , 0.097121 , 0.064630 , 0.056193,
     + 0.032588 , 0.024290 , 0.021928 , 0.028998 , 0.014745,
     + 0.009205 , 0.004416 , 0.002052 , 0.000985 , 0.000869,
     + 0.000353 , 0.000053
     + /
      real dptc1x4 ( 17 )
      data dptc1x4 /
     + 0.146742 , 0.292988 , 0.487485 , 0.686987 , 0.893271,
     + 1.091360 , 1.294880 , 1.489839 , 1.686705 , 1.942431,
     + 2.267371 , 2.698091 , 3.383207 , 4.408684 , 5.587488,
     + 6.883616 , 9.210982
     + /
      real dptc1y4 ( 17 )
      data dptc1y4 /
     + 2.760948 , 4.037536 , 2.367485 , 1.255681 , 0.675033,
     + 0.434153 , 0.279069 , 0.145832 , 0.109532 , 0.070732,
     + 0.052800 , 0.015866 , 0.006439 , 0.002961 , 0.000837,
     + 0.000178 , 0.000000
     + /
      real dptc1ey4 ( 17 )
      data dptc1ey4 /
     + 0.064502 , 0.072324 , 0.051995 , 0.037350 , 0.027732,
     + 0.023808 , 0.019147 , 0.012863 , 0.011305 , 0.007496,
     + 0.006092 , 0.002745 , 0.001129 , 0.000773 , 0.000405,
     + 0.000121 , 0.000000
     + /
      real dptc1sy4 ( 17 )
      data dptc1sy4 /
     + 0.658177 , 0.312193 , 0.126168 , 0.068847 , 0.048266,
     + 0.030436 , 0.025059 , 0.025663 , 0.024075 , 0.009968,
     + 0.011006 , 0.004055 , 0.002327 , 0.001174 , 0.000611,
     + 0.000147 , 0.000000
     + /
      real dptc1x5 ( 17 )
      data dptc1x5 /
     + 0.152168 , 0.293684 , 0.490073 , 0.689051 , 0.892168,
     + 1.094797 , 1.294933 , 1.493060 , 1.684506 , 1.940361,
     + 2.287311 , 2.723493 , 3.371955 , 4.427608 , 5.390126,
     + 6.452320 , 8.346775
     + /
      real dptc1y5 ( 17 )
      data dptc1y5 /
     + 2.636499 , 3.922620 , 2.381756 , 1.286635 , 0.694123,
     + 0.385937 , 0.278184 , 0.157847 , 0.103332 , 0.068130,
     + 0.038561 , 0.020760 , 0.008837 , 0.002248 , 0.000874,
     + 0.000000 , 0.000000
     + /
      real dptc1ey5 ( 17 )
      data dptc1ey5 /
     + 0.062848 , 0.067031 , 0.050156 , 0.036455 , 0.027078,
     + 0.020217 , 0.018115 , 0.012973 , 0.010493 , 0.006988,
     + 0.004470 , 0.003031 , 0.001392 , 0.000648 , 0.000359,
     + 0.000000 , 0.000000
     + /
      real dptc1sy5 ( 17 )
      data dptc1sy5 /
     + 0.653414 , 0.344080 , 0.111256 , 0.061583 , 0.047735,
     + 0.029457 , 0.042323 , 0.021658 , 0.012918 , 0.007479,
     + 0.006905 , 0.005201 , 0.001568 , 0.000937 , 0.000556,
     + 0.000000 , 0.000000
     + /
      real dptc1x6 ( 17 )
      data dptc1x6 /
     + 0.157954 , 0.295517 , 0.489658 , 0.688904 , 0.890000,
     + 1.096887 , 1.297076 , 1.493314 , 1.697042 , 1.941818,
     + 2.281169 , 2.719217 , 3.419540 , 4.454938 , 5.406593,
     + 7.612245 , 8.712883
     + /
      real dptc1y6 ( 17 )
      data dptc1y6 /
     + 0.000000 , 3.857549 , 2.338637 , 1.267592 , 0.737240,
     + 0.368518 , 0.192383 , 0.146525 , 0.099048 , 0.061205,
     + 0.031139 , 0.018795 , 0.005526 , 0.001720 , 0.000463,
     + 0.000000 , 0.000000
     + /
      real dptc1ey6 ( 17 )
      data dptc1ey6 /
     + 0.000000 , 0.090714 , 0.066276 , 0.048257 , 0.038115,
     + 0.025283 , 0.016598 , 0.015687 , 0.013203 , 0.008737,
     + 0.005095 , 0.003476 , 0.001176 , 0.000631 , 0.000356,
     + 0.000000 , 0.000000
     + /
      real dptc1sy6 ( 17 )
      data dptc1sy6 /
     + 0.000000 , 0.445905 , 0.160504 , 0.127881 , 0.067323,
     + 0.029726 , 0.034040 , 0.023816 , 0.025680 , 0.012204,
     + 0.009643 , 0.005011 , 0.002181 , 0.000977 , 0.000472,
     + 0.000000 , 0.000000
     + /
      real dptc1x7 ( 17 )
      data dptc1x7 /
     + 0.145859 , 0.293751 , 0.490604 , 0.689643 , 0.890579,
     + 1.096949 , 1.292231 , 1.496885 , 1.694827 , 1.936240,
     + 2.287501 , 2.731355 , 3.406848 , 4.386663 , 5.386798,
     + 6.700425 , 8.544601
     + /
      real dptc1y7 ( 17 )
      data dptc1y7 /
     + 2.823874 , 4.133102 , 2.424724 , 1.382891 , 0.770065,
     + 0.491208 , 0.279378 , 0.189531 , 0.136135 , 0.101082,
     + 0.057862 , 0.034629 , 0.012369 , 0.006992 , 0.003135,
     + 0.000933 , 0.000308
     + /
      real dptc1ey7 ( 17 )
      data dptc1ey7 /
     + 0.058516 , 0.066088 , 0.048597 , 0.036252 , 0.027782,
     + 0.022113 , 0.016282 , 0.013617 , 0.011652 , 0.008505,
     + 0.005448 , 0.003899 , 0.001515 , 0.001308 , 0.000984,
     + 0.000346 , 0.000192
     + /
      real dptc1sy7 ( 17 )
      data dptc1sy7 /
     + 0.698489 , 0.236435 , 0.100596 , 0.051506 , 0.037120,
     + 0.043625 , 0.036412 , 0.021104 , 0.019520 , 0.013036,
     + 0.015160 , 0.011431 , 0.002317 , 0.001792 , 0.001483,
     + 0.000431 , 0.000474
     + /
      real dptc1x8 ( 17 )
      data dptc1x8 /
     + 0.151309 , 0.293659 , 0.489961 , 0.691081 , 0.890838,
     + 1.094539 , 1.289616 , 1.495800 , 1.691975 , 1.947166,
     + 2.285092 , 2.721915 , 3.386699 , 4.420917 , 5.375386,
     + 6.687088 , 8.527062
     + /
      real dptc1y8 ( 17 )
      data dptc1y8 /
     + 2.815146 , 3.989308 , 2.481748 , 1.253898 , 0.740500,
     + 0.437656 , 0.326755 , 0.208199 , 0.131678 , 0.083892,
     + 0.050112 , 0.027720 , 0.012471 , 0.000000 , 0.003019,
     + 0.000439 , 0.000134
     + /
      real dptc1ey8 ( 17 )
      data dptc1ey8 /
     + 0.069764 , 0.072636 , 0.054718 , 0.037935 , 0.029099,
     + 0.022025 , 0.020789 , 0.016036 , 0.012338 , 0.007976,
     + 0.005324 , 0.003817 , 0.001590 , 0.000000 , 0.001123,
     + 0.000205 , 0.000111
     + /
      real dptc1sy8 ( 17 )
      data dptc1sy8 /
     + 0.711585 , 0.285220 , 0.099777 , 0.058840 , 0.043242,
     + 0.042007 , 0.047663 , 0.022600 , 0.019342 , 0.015086,
     + 0.007371 , 0.004693 , 0.003836 , 0.000000 , 0.001625,
     + 0.000274 , 0.000136
     + /
      real dptc1x9 ( 17 )
      data dptc1x9 /
     + 0.159087 , 0.295322 , 0.492507 , 0.691324 , 0.893927,
     + 1.095948 , 1.286757 , 1.498794 , 1.685962 , 1.928382,
     + 2.290783 , 2.750410 , 3.480629 , 4.420528 , 5.072345,
     + 6.597868 , 9.000000
     + /
      real dptc1y9 ( 17 )
      data dptc1y9 /
     + 0.000000 , 3.832153 , 2.335656 , 1.385647 , 0.747305,
     + 0.446340 , 0.315724 , 0.188934 , 0.114273 , 0.102270,
     + 0.047921 , 0.031811 , 0.009681 , 0.002054 , 0.000874,
     + 0.000239 , 0.000000
     + /
      real dptc1ey9 ( 17 )
      data dptc1ey9 /
     + 0.000000 , 0.100071 , 0.072664 , 0.055077 , 0.039241,
     + 0.029086 , 0.027928 , 0.018905 , 0.014002 , 0.011979,
     + 0.006789 , 0.004841 , 0.001881 , 0.000726 , 0.000450,
     + 0.000169 , 0.000000
     + /
      real dptc1sy9 ( 17 )
      data dptc1sy9 /
     + 0.000000 , 0.526701 , 0.219943 , 0.105940 , 0.079783,
     + 0.059182 , 0.053690 , 0.024898 , 0.032368 , 0.024351,
     + 0.017462 , 0.013053 , 0.003569 , 0.001840 , 0.000736,
     + 0.000237 , 0.000000
     + /
*KEEP,
      real dptmc1x0 ( 12 )
      data dptmc1x0 /
     + 0.184909 , 0.383239 , 0.625135 , 0.870177 , 1.123248,
     + 1.366931 , 1.618030 , 1.872407 , 2.223640 , 2.726116,
     + 3.422122 , 4.408915
     + /
      real dptmc1y0 ( 12 )
C      data dptmc1y0 /
C     + 0.000000 , 0.378703 , 0.662712 , 0.617272 , 0.545168,
C     + 0.416210 , 0.300387 , 0.229335 , 0.155616 , 0.088815,
C     + 0.040083 , 0.014621
C     + /
      real dptmc1ey0 ( 12 )
      data dptmc1ey0 /
     + 0.000000 , 0.011082 , 0.017044 , 0.017496 , 0.017870,
     + 0.015604 , 0.013217 , 0.012017 , 0.006912 , 0.005196,
     + 0.002373 , 0.001407
     + /
      real dptmc1sy0 ( 12 )
      data dptmc1sy0 /
     + 0.000000 , 0.076599 , 0.065954 , 0.024231 , 0.029671,
     + 0.045498 , 0.031002 , 0.036342 , 0.033727 , 0.019826,
     + 0.006893 , 0.003985
     + /
      real dptmc1x1 ( 12 )
      data dptmc1x1 /
     + 0.190846 , 0.380396 , 0.621361 , 0.861916 , 1.127293,
     + 1.355656 , 1.621185 , 1.890611 , 2.205649 , 2.718820,
     + 3.400975 , 4.382236
     + /
      real dptmc1y1 ( 12 )
C      data dptmc1y1 /
C     + 0.142169 , 0.437253 , 0.725419 , 0.609752 , 0.601025,
C     + 0.348934 , 0.240537 , 0.239799 , 0.104868 , 0.074800,
C     + 0.031405 , 0.010037
C     + /
      real dptmc1ey1 ( 12 )
      data dptmc1ey1 /
     + 0.029371 , 0.051959 , 0.072994 , 0.069196 , 0.082287,
     + 0.054925 , 0.048711 , 0.054164 , 0.019990 , 0.020936,
     + 0.008157 , 0.004529
     + /
      real dptmc1sy1 ( 12 )
      data dptmc1sy1 /
     + 0.111852 , 0.140224 , 0.170602 , 0.089970 , 0.220207,
*     + 0.067577 , 0.113366 , 0.148308 , 0.077740 , 0.205908,
     + 0.067577 , 0.113366 , 0.148308 , 0.077740 , 0.055908,
     + 0.014900 , 0.005471
     + /
      real dptmc1x2 ( 12 )
      data dptmc1x2 /
     + 0.173446 , 0.380954 , 0.625297 , 0.880973 , 1.121135,
     + 1.365871 , 1.613911 , 1.870800 , 2.240837 , 2.713929,
     + 3.483297 , 4.454574
     + /
      real dptmc1y2 ( 12 )
C      data dptmc1y2 /
C     + 0.000000 , 0.301573 , 0.820497 , 0.658454 , 0.437798,
C     + 0.423712 , 0.309899 , 0.277312 , 0.159087 , 0.059154,
C     + 0.042440 , 0.009975
C     + /
      real dptmc1ey2 ( 12 )
      data dptmc1ey2 /
     + 0.000000 , 0.030722 , 0.069862 , 0.062159 , 0.051943,
     + 0.055969 , 0.046861 , 0.055611 , 0.025681 , 0.013933,
     + 0.008281 , 0.003708
     + /
      real dptmc1sy2 ( 12 )
      data dptmc1sy2 /
     + 0.000000 , 0.131102 , 0.119301 , 0.091600 , 0.088506,
     + 0.123725 , 0.101779 , 0.088202 , 0.053453 , 0.018133,
     + 0.014177 , 0.004573
     + /
      real dptmc1x3 ( 12 )
      data dptmc1x3 /
     + 0.180028 , 0.381590 , 0.629139 , 0.863371 , 1.119423,
     + 1.368836 , 1.615343 , 1.871934 , 2.232031 , 2.731070,
     + 3.436053 , 4.404230
     + /
      real dptmc1y3 ( 12 )
C      data dptmc1y3 /
C     + 0.000000 , 0.442598 , 0.707436 , 0.686856 , 0.455719,
C     + 0.343175 , 0.330933 , 0.193491 , 0.147872 , 0.090559,
C     + 0.036331 , 0.012230
C     + /
      real dptmc1ey3 ( 12 )
      data dptmc1ey3 /
     + 0.000000 , 0.034238 , 0.047598 , 0.050030 , 0.039567,
     + 0.034439 , 0.038396 , 0.028244 , 0.018548 , 0.013226,
     + 0.005896 , 0.003085
     + /
      real dptmc1sy3 ( 12 )
      data dptmc1sy3 /
     + 0.000000 , 0.118195 , 0.111540 , 0.103826 , 0.099728,
     + 0.056644 , 0.072793 , 0.044463 , 0.055527 , 0.023860,
     + 0.012071 , 0.006488
     + /
      real dptmc1x4 ( 12 )
      data dptmc1x4 /
     + 0.187797 , 0.386666 , 0.617034 , 0.885750 , 1.123402,
     + 1.364294 , 1.620372 , 1.866134 , 2.218742 , 2.706939,
     + 3.381609 , 4.378360
     + /
      real dptmc1y4 ( 12 )
C      data dptmc1y4 /
C     + 0.000000 , 0.408592 , 0.700393 , 0.569680 , 0.529493,
C     + 0.495197 , 0.249173 , 0.189880 , 0.184152 , 0.067487,
C     + 0.028653 , 0.012856
C     + /
      real dptmc1ey4 ( 12 )
      data dptmc1ey4 /
     + 0.000000 , 0.034243 , 0.052987 , 0.049159 , 0.053111,
     + 0.055188 , 0.032688 , 0.030169 , 0.023265 , 0.013199,
     + 0.005398 , 0.003478
     + /
      real dptmc1sy4 ( 12 )
      data dptmc1sy4 /
     + 0.000000 , 0.106887 , 0.076530 , 0.055801 , 0.080163,
     + 0.118662 , 0.048121 , 0.071336 , 0.057352 , 0.031075,
     + 0.006385 , 0.003883
     + /
      real dptmc1x5 ( 12 )
      data dptmc1x5 /
     + 0.188176 , 0.379771 , 0.624705 , 0.874184 , 1.121995,
     + 1.363787 , 1.624489 , 1.873053 , 2.220750 , 2.733312,
     + 3.381868 , 4.418096
     + /
      real dptmc1y5 ( 12 )
C      data dptmc1y5 /
C     + 0.097193 , 0.326301 , 0.748267 , 0.524361 , 0.574877,
C     + 0.544302 , 0.249174 , 0.166812 , 0.160329 , 0.081082,
C     + 0.042639 , 0.010993
C     + /
      real dptmc1ey5 ( 12 )
      data dptmc1ey5 /
     + 0.014934 , 0.024857 , 0.050682 , 0.039920 , 0.050235,
     + 0.053505 , 0.031388 , 0.024893 , 0.019081 , 0.013329,
     + 0.006957 , 0.003268
     + /
      real dptmc1sy5 ( 12 )
      data dptmc1sy5 /
     + 0.017889 , 0.121473 , 0.087695 , 0.146778 , 0.079286,
     + 0.151967 , 0.053383 , 0.049819 , 0.047239 , 0.033000,
     + 0.008974 , 0.006052
     + /
      real dptmc1x6 ( 12 )
      data dptmc1x6 /
     + 0.192167 , 0.386634 , 0.619908 , 0.866413 , 1.123692,
     + 1.367314 , 1.613110 , 1.866703 , 2.212215 , 2.718747,
     + 3.444129 , 4.458813
     + /
      real dptmc1y6 ( 12 )
C      data dptmc1y6 /
C     + 0.000000 , 0.384647 , 0.660024 , 0.598051 , 0.559137,
C     + 0.414873 , 0.367254 , 0.241776 , 0.152158 , 0.097696,
C     + 0.030112 , 0.008695
C     + /
      real dptmc1ey6 ( 12 )
      data dptmc1ey6 /
     + 0.000000 , 0.036691 , 0.057040 , 0.059170 , 0.063259,
     + 0.052215 , 0.055323 , 0.042393 , 0.024758 , 0.019683,
     + 0.006654 , 0.003139
     + /
      real dptmc1sy6 ( 12 )
      data dptmc1sy6 /
     + 0.000000 , 0.074195 , 0.099635 , 0.136125 , 0.089251,
     + 0.083469 , 0.091789 , 0.114501 , 0.070302 , 0.041458,
     + 0.015197 , 0.003896
     + /
      real dptmc1x7 ( 12 )
      data dptmc1x7 /
     + 0.182725 , 0.380908 , 0.626331 , 0.864909 , 1.127794,
     + 1.372597 , 1.618486 , 1.874856 , 2.229988 , 2.721170,
     + 3.415178 , 4.379633
     + /
      real dptmc1y7 ( 12 )
C      data dptmc1y7 /
C     + 0.000000 , 0.398140 , 0.607941 , 0.560910 , 0.633291,
C     + 0.353821 , 0.255633 , 0.281323 , 0.159120 , 0.093911,
C     + 0.042007 , 0.022187
C     + /
      real dptmc1ey7 ( 12 )
      data dptmc1ey7 /
     + 0.000000 , 0.029478 , 0.040971 , 0.041041 , 0.049498,
     + 0.033222 , 0.027853 , 0.033645 , 0.016735 , 0.012384,
     + 0.005557 , 0.004338
     + /
      real dptmc1sy7 ( 12 )
      data dptmc1sy7 /
     + 0.000000 , 0.085948 , 0.071773 , 0.061139 , 0.113478,
     + 0.068793 , 0.045759 , 0.074319 , 0.053392 , 0.024862,
     + 0.012757 , 0.007993
     + /
      real dptmc1x8 ( 12 )
      data dptmc1x8 /
     + 0.180208 , 0.387003 , 0.625232 , 0.867311 , 1.120728,
     + 1.372668 , 1.615781 , 1.873952 , 2.216092 , 2.722356,
     + 3.411063 , 4.422736
     + /
      real dptmc1y8 ( 12 )
C      data dptmc1y8 /
C     + 0.102897 , 0.354326 , 0.506606 , 0.690158 , 0.532990,
C     + 0.388945 , 0.342147 , 0.215148 , 0.172179 , 0.077980,
C     + 0.044665 , 0.000000
C     + /
      real dptmc1ey8 ( 12 )
      data dptmc1ey8 /
     + 0.014561 , 0.028793 , 0.036756 , 0.051760 , 0.045872,
     + 0.038234 , 0.036448 , 0.029044 , 0.019112 , 0.012030,
     + 0.006159 , 0.000000
     + /
      real dptmc1sy8 ( 12 )
      data dptmc1sy8 /
     + 0.025460 , 0.081474 , 0.077730 , 0.077400 , 0.065525,
     + 0.047710 , 0.058151 , 0.066686 , 0.028896 , 0.020013,
     + 0.012091 , 0.000000
     + /
      real dptmc1x9 ( 12 )
      data dptmc1x9 /
     + 0.200135 , 0.386295 , 0.637114 , 0.868089 , 1.124776,
     + 1.365027 , 1.621594 , 1.867857 , 2.230358 , 2.751206,
     + 3.482464 , 4.456751
     + /
      real dptmc1y9 ( 12 )
C      data dptmc1y9 /
C     + 0.072431 , 0.297398 , 0.519616 , 0.620743 , 0.660033,
C     + 0.489241 , 0.361023 , 0.291375 , 0.163068 , 0.116057,
C     + 0.046936 , 0.009534
C     + /
      real dptmc1ey9 ( 12 )
      data dptmc1ey9 /
     + 0.013741 , 0.030090 , 0.045420 , 0.057738 , 0.068828,
     + 0.060920 , 0.050485 , 0.045191 , 0.023678 , 0.019667,
     + 0.009359 , 0.003466
     + /
      real dptmc1sy9 ( 12 )
      data dptmc1sy9 /
     + 0.030971 , 0.119158 , 0.106133 , 0.119760 , 0.195143,
     + 0.104564 , 0.068266 , 0.118351 , 0.059613 , 0.023684,
     + 0.019451 , 0.006063
     + /
*                         kill data not in paper
      data dptmc1y0 /12*0./
      data dptmc1y1 /12*0./
      data dptmc1y2 /12*0./
      data dptmc1y3 /12*0./
      data dptmc1y4 /12*0./
      data dptmc1y5 /12*0./
      data dptmc1y6 /12*0./
      data dptmc1y7 /12*0./
      data dptmc1y8 /12*0./
      data dptmc1y9 /12*0./

*
* +seq,ptmen1.  wrong Et cut (was as ptmcn1)
*
      real dptme1x0 ( 12 )
      data dptme1x0 /
     + 0.202771 , 0.384896 , 0.618564 , 0.869944 , 1.114610,
     + 1.368176 , 1.614111 , 1.869093 , 2.224838 , 2.726034,
     + 3.416946 , 4.392986
     + /
      real dptme1y0 ( 12 )
      data dptme1y0 /
     + 0.147301 , 0.501329 , 0.765317 , 0.717118 , 0.523429,
     + 0.362050 , 0.244992 , 0.176594 , 0.106701 , 0.054390,
     + 0.028574 , 0.010089
     + /
      real dptme1ey0 ( 12 )
      data dptme1ey0 /
     + 0.009536 , 0.013565 , 0.019152 , 0.020641 , 0.018455,
     + 0.016130 , 0.013646 , 0.011732 , 0.006029 , 0.004407,
     + 0.002320 , 0.001306
     + /
      real dptme1sy0 ( 12 )
      data dptme1sy0 /
     + 0.057210 , 0.019192 , 0.072138 , 0.067982 , 0.040768,
     + 0.022480 , 0.017653 , 0.027660 , 0.012318 , 0.005982,
     + 0.003151 , 0.002096
     + /
      real dptme1x1 ( 12 )
      data dptme1x1 /
     + 0.195249 , 0.394963 , 0.619273 , 0.861081 , 1.128444,
     + 1.362864 , 1.611207 , 1.885785 , 2.245554 , 2.712126,
     + 3.266731 , 4.304149
     + /
      real dptme1y1 ( 12 )
      data dptme1y1 /
     + 0.091218 , 0.593429 , 0.727013 , 0.860689 , 0.571530,
     + 0.369275 , 0.169753 , 0.091503 , 0.080418 , 0.055826,
*     + 0.021832 , 0.011455
     + 0.021832 , 0.0
     + /
      real dptme1ey1 ( 12 )
      data dptme1ey1 /
     + 0.022045 , 0.060234 , 0.064289 , 0.087667 , 0.071651,
     + 0.060598 , 0.037175 , 0.024885 , 0.016545 , 0.016283,
     + 0.006109 , 0.005193
     + /
      real dptme1sy1 ( 12 )
      data dptme1sy1 /
     + 0.034227 , 0.135684 , 0.215162 , 0.207692 , 0.186556,
     + 0.129082 , 0.039624 , 0.029063 , 0.018332 , 0.029501,
     + 0.012946 , 0.012742
     + /
      real dptme1x2 ( 12 )
      data dptme1x2 /
     + 0.200945 , 0.382654 , 0.617252 , 0.867994 , 1.098701,
     + 1.366235 , 1.607693 , 1.872941 , 2.207174 , 2.711809,
     + 3.525543 , 4.406010
     + /
      real dptme1y2 ( 12 )
      data dptme1y2 /
     + 0.130296 , 0.489342 , 0.860071 , 0.818120 , 0.432392,
     + 0.398336 , 0.307884 , 0.132695 , 0.081799 , 0.045313,
     + 0.030736 , 0.000000
     + /
      real dptme1ey2 ( 12 )
      data dptme1ey2 /
     + 0.025995 , 0.041569 , 0.064554 , 0.070249 , 0.047104,
     + 0.053819 , 0.054364 , 0.024489 , 0.015116 , 0.013095,
     + 0.008724 , 0.000000
     + /
      real dptme1sy2 ( 12 )
      data dptme1sy2 /
     + 0.055735 , 0.117317 , 0.108463 , 0.084220 , 0.089345,
     + 0.124918 , 0.082824 , 0.038991 , 0.023164 , 0.016124,
*     + 0.031076 , 0.000000
     + 0.021076 , 0.000000
     + /
      real dptme1x3 ( 12 )
      data dptme1x3 /
     + 0.194332 , 0.382770 , 0.619234 , 0.874765 , 1.117384,
     + 1.374182 , 1.621574 , 1.868590 , 2.215757 , 2.726856,
     + 3.437006 , 4.449282
     + /
      real dptme1y3 ( 12 )
      data dptme1y3 /
     + 0.104089 , 0.565965 , 0.748645 , 0.760373 , 0.617378,
     + 0.344042 , 0.218119 , 0.154691 , 0.113766 , 0.044212,
     + 0.022475 , 0.010141
     + /
      real dptme1ey3 ( 12 )
      data dptme1ey3 /
     + 0.017002 , 0.037063 , 0.045324 , 0.050300 , 0.050338,
     + 0.034910 , 0.027396 , 0.024613 , 0.014828 , 0.007824,
     + 0.004100 , 0.002975
     + /
      real dptme1sy3 ( 12 )
      data dptme1sy3 /
     + 0.047094 , 0.055827 , 0.130618 , 0.064758 , 0.097302,
     + 0.040759 , 0.042923 , 0.041723 , 0.039867 , 0.013064,
     + 0.005316 , 0.004208
     + /
      real dptme1x4 ( 12 )
      data dptme1x4 /
     + 0.207279 , 0.384509 , 0.616529 , 0.867680 , 1.113051,
     + 1.365193 , 1.619674 , 1.878651 , 2.239346 , 2.733763,
     + 3.413449 , 4.277315
     + /
      real dptme1y4 ( 12 )
      data dptme1y4 /
     + 0.285807 , 0.435088 , 0.733734 , 0.595748 , 0.469296,
     + 0.364720 , 0.221340 , 0.211514 , 0.152605 , 0.079803,
     + 0.026088 , 0.000000
     + /
      real dptme1ey4 ( 12 )
      data dptme1ey4 /
     + 0.046350 , 0.033715 , 0.051358 , 0.049834 , 0.046043,
     + 0.045708 , 0.037577 , 0.037774 , 0.024422 , 0.019688,
     + 0.005926 , 0.000000
     + /
      real dptme1sy4 ( 12 )
      data dptme1sy4 /
     + 0.221412 , 0.053220 , 0.131420 , 0.229904 , 0.110190,
     + 0.049792 , 0.044699 , 0.067968 , 0.049138 , 0.045485,
     + 0.014664 , 0.000000
     + /
      real dptme1x5 ( 12 )
      data dptme1x5 /
     + 0.207511 , 0.382912 , 0.615533 , 0.872355 , 1.108377,
     + 1.362881 , 1.603137 , 1.844838 , 2.187179 , 2.767986,
     + 3.443208 , 4.441383
     + /
      real dptme1y5 ( 12 )
      data dptme1y5 /
*     + 0.266575 , 0.000000 , 0.685095 , 0.747259 , 0.460551,
     + 0.000000 , 0.000000 , 0.685095 , 0.747259 , 0.460551,
     + 0.346064 , 0.333248 , 0.168219 , 0.096491 , 0.062497,
*     + 0.000000 , 0.005688
     + 0.000000 , 0.00
     + /
      real dptme1ey5 ( 12 )
      data dptme1ey5 /
*     + 0.043613 , 0.000000 , 0.047425 , 0.065268 , 0.048393,
     + 0.000000 , 0.000000 , 0.047425 , 0.065268 , 0.048393,
     + 0.048948 , 0.055807 , 0.035843 , 0.016730 , 0.014805,
     + 0.000000 , 0.002025
     + /
      real dptme1sy5 ( 12 )
      data dptme1sy5 /
*     + 0.213136 , 0.000000 , 0.230165 , 0.160512 , 0.127354,
     + 0.000000 , 0.000000 , 0.230165 , 0.160512 , 0.127354,
     + 0.061714 , 0.154306 , 0.072489 , 0.039388 , 0.023713,
     + 0.000000 , 0.006689
     + /
      real dptme1x6 ( 12 )
      data dptme1x6 /
     + 0.210425 , 0.385929 , 0.616868 , 0.871532 , 1.112073,
     + 1.359845 , 1.599579 , 1.859565 , 2.287180 , 2.684467,
     + 3.526707 , 4.390825
     + /
      real dptme1y6 ( 12 )
C      data dptme1y6 /
C     + 0.063878 , 0.456321 , 0.955356 , 0.551346 , 0.848234,
C     + 0.419676 , 0.245302 , 0.141550 , 0.069251 , 0.033301,
C     + 0.016942 , 0.000000
C     + /
      real dptme1ey6 ( 12 )
      data dptme1ey6 /
     + 0.032819 , 0.055094 , 0.112145 , 0.081720 , 0.156660,
     + 0.094893 , 0.072446 , 0.048365 , 0.022048 , 0.015283,
     + 0.007937 , 0.000000
     + /
*                                   kill data that are not in paper
      data  dptme1y6 /12*0./
      real dptme1sy6 ( 12 )
      data dptme1sy6 /
     + 0.079927 , 0.107912 , 0.262210 , 0.266736 , 0.253641,
     + 0.194181 , 0.148307 , 0.056435 , 0.036521 , 0.019609,
     + 0.027449 , 0.000000
     + /
      real dptme1x7 ( 12 )
      data dptme1x7 /
     + 0.199226 , 0.389268 , 0.624265 , 0.868908 , 1.111049,
     + 1.370932 , 1.610264 , 1.873397 , 2.218633 , 2.728201,
     + 3.384680 , 4.340054
     + /
      real dptme1y7 ( 12 )
      data dptme1y7 /
     + 0.103731 , 0.493301 , 0.718031 , 0.748891 , 0.489432,
     + 0.326798 , 0.282407 , 0.212070 , 0.113748 , 0.062378,
     + 0.034230 , 0.013446
     + /
      real dptme1ey7 ( 12 )
      data dptme1ey7 /
     + 0.015585 , 0.032225 , 0.043475 , 0.048022 , 0.038199,
     + 0.031747 , 0.031186 , 0.031109 , 0.013006 , 0.010132,
     + 0.005617 , 0.003396
     + /
      real dptme1sy7 ( 12 )
      data dptme1sy7 /
     + 0.016671 , 0.065598 , 0.059168 , 0.064120 , 0.085843,
     + 0.038942 , 0.044795 , 0.088422 , 0.017622 , 0.020821,
     + 0.006168 , 0.006613
     + /
      real dptme1x8 ( 12 )
      data dptme1x8 /
     + 0.209039 , 0.380773 , 0.619529 , 0.872382 , 1.122359,
     + 1.372894 , 1.632871 , 1.856848 , 2.246414 , 2.686891,
     + 3.433805 , 4.462350
     + /
      real dptme1y8 ( 12 )
      data dptme1y8 /
     + 0.138039 , 0.484125 , 0.725545 , 0.572551 , 0.554438,
     + 0.426958 , 0.235656 , 0.218845 , 0.115849 , 0.046104,
     + 0.032936 , 0.012077
     + /
      real dptme1ey8 ( 12 )
      data dptme1ey8 /
     + 0.024487 , 0.035544 , 0.050695 , 0.048609 , 0.054016,
     + 0.051163 , 0.036354 , 0.036799 , 0.017381 , 0.010906,
     + 0.007583 , 0.004096
     + /
      real dptme1sy8 ( 12 )
      data dptme1sy8 /
     + 0.082345 , 0.058688 , 0.195956 , 0.155044 , 0.079829,
     + 0.097494 , 0.073143 , 0.054772 , 0.027915 , 0.020265,
     + 0.015152 , 0.006235
     + /
      real dptme1x9 ( 12 )
      data dptme1x9 /
     + 0.226678 , 0.379907 , 0.611574 , 0.870734 , 1.136144,
     + 1.361115 , 1.601790 , 1.880337 , 2.243956 , 2.757005,
     + 3.379965 , 4.301902
     + /
      real dptme1y9 ( 12 )
C      data dptme1y9 /
C     + 0.045820 , 0.380666 , 0.870468 , 0.712883 , 0.569571,
C     + 0.466016 , 0.191937 , 0.129547 , 0.129254 , 0.059675,
C     + 0.000000 , 0.007566
C     + /
*                         kill data not in paper
      data dptme1y9 /12*0./
      real dptme1ey9 ( 12 )
      data dptme1ey9 /
     + 0.022493 , 0.050039 , 0.102571 , 0.094273 , 0.104763,
     + 0.097506 , 0.051132 , 0.044968 , 0.034888 , 0.022207,
     + 0.000000 , 0.005998
     + /
      real dptme1sy9 ( 12 )
      data dptme1sy9 /
     + 0.086797 , 0.144056 , 0.143977 , 0.209282 , 0.171974,
     + 0.224550 , 0.108185 , 0.068172 , 0.047666 , 0.036321,
     + 0.000000 , 0.011041
     + /
* hbook parameters
      integer nbeta,ib
      parameter (nbeta=18)
      real eta0,eta1,pt0,pt1,ptbsiz,etabsiz
*      data eta0,eta1/-10.,10./
      data eta0,eta1/ -3., 6./
      data pt0,pt1/0.,5./
      real an11(nbeta),an21(nbeta),an12(nbeta),an22(nbeta)
      real ean11(nbeta),pnn(nbeta)
      real ap11(nbpt),ap12(nbpt),eap11(nbpt),ppp(nbpt)
      real apm1(nbptm),apm2(nbptm),eapm1(nbptm),ppm(nbptm)
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'96215'/
      character*30 string
*
      Real pi,dpi,rd,ee,eb,dphi
      Logical evcut,lp
      Integer jcut,ncut,iel,idum,id
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.6)
      Integer nentry,nevnt(2)
      Real  nev(0:9),nev1(0:9),nev2(0:9)
      real xnnev
      Data nev/10*0./,nev1/10*0./,lp/.false./,nentry/0/
      Data nev2/10*0./
      real xmean(0:9),q2mean(0:9)
      data xmean,q2mean/10*0.,10*0./
      Real x,y,q2,w2,enel,ptel,thel,efwd,th,rap,pt,et,p,costh
      Real xmi,xma,ymi,yma
      Integer nx,ny,nwt,loc
      Character chtitl*80
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
       Call hcdir('//PAWC',' ')
       call hmdir(xxxx,'S')
       Call hcdir('//HISTO',' ')
       call hmdir(xxxx,'S')

* Book kinematics and so on
       call hbook2(1,' logx vs logq2 ',100,0.5,2.,100,-5.,-1.0,0.)
       call hbook1(2,' logq2  ',100,0.5,2.,0.)
       call hbook1(3,' logx ',100,-5.,-1.,0.)
       call hbook1(4,' Eforward ',100,0.,50.,0.)

* Book multiplicity histograms
       do i = 0, 9
        id = 100 + i
        call hbook1(id,' Ch. Part. Multi All '
     &   ,100,-0.5,99.5,0.)
        id = 200 + i
        call hbook1(id,' Ch. Part. Multi Summed ET (0.5-2.5) gt 6 '
     &   ,100,-0.5,99.5,0.)
        id = 300 + i
        call hbook1(id,' Ch. Part. Multi Summed ET (0.0-2.0) gt 6 '
     &   ,100,-0.5,99.5,0.)
       enddo



* Book intermediate and final histograms.

* Intermediate dn/deta
       id = 21 000
       call hbook1(id,' dn/deta '
     &  ,nbeta,eta0,eta1,0.)
* Intermediate dn/deta pt> 1
       id = 22 000
       call hbook1(id,' dn/deta '
     &  ,nbeta,eta0,eta1,0.)

       do ieta=1,neta
* Intermediate dn/dpt, interval ieta
         id = 23 000 +  iofeta*(ieta-1)
          call hbookb(id,' dn/dpt intermediate '
     &    ,nbpt,xbpt1,0.)
       enddo

*
      do i=0,9

* Final dn**2/deta
       id = 11 000 + i +  10
       call hbook1( id,' dn**2/deta '
     &  ,nbeta,eta0,eta1,0.)

* Final dn/deta
       id = 11 000 + i
       call hbook1( id,' dn/deta '
     &  ,nbeta,eta0,eta1,0.)
       call hbook1(-id,' DATA dn/deta '
     &  ,nbeta,eta0,eta1,0.)
       call hbook1(-id-10,' DATA dn/deta EStat '
     &  ,nbeta,eta0,eta1,0.)
*
* to be done
*       if ( i .eq. 0  .and. meta0y0.eq.nbeta) then
*
       if ( i .eq. 0 ) then
         call hpak ( -id,deta0y0)
         call hpake( -id,deta0sy0)
         call hpak ( -id-10,deta0y0)
         call hpake( -id-10,deta0ey0)
       elseif ( i .eq. 1 ) then
         call hpak ( -id,deta0y1)
         call hpake( -id,deta0sy1)
         call hpak ( -id-10,deta0y1)
         call hpake( -id-10,deta0ey1)
       elseif ( i .eq. 2 ) then
         call hpak ( -id,deta0y2)
         call hpake( -id,deta0sy2)
         call hpak ( -id-10,deta0y2)
         call hpake( -id-10,deta0ey2)
       elseif ( i .eq. 3 ) then
         call hpak ( -id,deta0y3)
         call hpake( -id,deta0sy3)
         call hpak ( -id-10,deta0y3)
         call hpake( -id-10,deta0ey3)
       elseif ( i .eq. 4 ) then
         call hpak ( -id,deta0y4)
         call hpake( -id,deta0sy4)
         call hpak ( -id-10,deta0y4)
         call hpake( -id-10,deta0ey4)
       elseif ( i .eq. 5 ) then
         call hpak ( -id,deta0y5)
         call hpake( -id,deta0sy5)
         call hpak ( -id-10,deta0y5)
         call hpake( -id-10,deta0ey5)
       elseif ( i .eq. 6 ) then
         call hpak ( -id,deta0y6)
         call hpake( -id,deta0sy6)
         call hpak ( -id-10,deta0y6)
         call hpake( -id-10,deta0ey6)
       elseif ( i .eq. 7 ) then
         call hpak ( -id,deta0y7)
         call hpake( -id,deta0sy7)
         call hpak ( -id-10,deta0y7)
         call hpake( -id-10,deta0ey7)
       elseif ( i .eq. 8 ) then
         call hpak ( -id,deta0y8)
         call hpake( -id,deta0sy8)
         call hpak ( -id-10,deta0y8)
         call hpake( -id-10,deta0ey8)
       elseif ( i .eq. 9 ) then
         call hpak ( -id,deta0y9)
         call hpake( -id,deta0sy9)
         call hpak ( -id-10,deta0y9)
         call hpake( -id-10,deta0ey9)
       endif


* Final dn**2/deta pt>1
       id = 12 000 + i +  10
       call hbook1( id,' dn**2/deta '
     &  ,nbeta,eta0,eta1,0.)

* Final dn/deta pt>1
       id = 12 000 + i
       call hbook1( id,' dn/deta '
     &  ,nbeta,eta0,eta1,0.)
       call hbook1(-id,' DATA dn/deta '
     &  ,nbeta,eta0,eta1,0.)
       call hbook1(-id-10,' DATA dn/deta Estat'
     &  ,nbeta,eta0,eta1,0.)
       if ( i .eq. 0 ) then
         call hpak ( -id,deta1y0)
         call hpake( -id,deta1sy0)
         call hpak ( -id-10,deta1y0)
         call hpake( -id-10,deta1ey0)
       elseif ( i .eq. 1 ) then
         call hpak ( -id,deta1y1)
         call hpake( -id,deta1sy1)
         call hpak ( -id-10,deta1y1)
         call hpake( -id-10,deta1ey1)
       elseif ( i .eq. 2 ) then
         call hpak ( -id,deta1y2)
         call hpake( -id,deta1sy2)
         call hpak ( -id-10,deta1y2)
         call hpake( -id-10,deta1ey2)
       elseif ( i .eq. 3 ) then
         call hpak ( -id,deta1y3)
         call hpake( -id,deta1sy3)
         call hpak ( -id-10,deta1y3)
         call hpake( -id-10,deta1ey3)
       elseif ( i .eq. 4 ) then
         call hpak ( -id,deta1y4)
         call hpake( -id,deta1sy4)
         call hpak ( -id-10,deta1y4)
         call hpake( -id-10,deta1ey4)
       elseif ( i .eq. 5 ) then
         call hpak ( -id,deta1y5)
         call hpake( -id,deta1sy5)
         call hpak ( -id-10,deta1y5)
         call hpake( -id-10,deta1ey5)
       elseif ( i .eq. 6 ) then
         call hpak ( -id,deta1y6)
         call hpake( -id,deta1sy6)
         call hpak ( -id-10,deta1y6)
         call hpake( -id-10,deta1ey6)
       elseif ( i .eq. 7 ) then
         call hpak ( -id,deta1y7)
         call hpake( -id,deta1sy7)
         call hpak ( -id-10,deta1y7)
         call hpake( -id-10,deta1ey7)
       elseif ( i .eq. 8 ) then
         call hpak ( -id,deta1y8)
         call hpake( -id,deta1sy8)
         call hpak ( -id-10,deta1y8)
         call hpake( -id-10,deta1ey8)
       elseif ( i .eq. 9 ) then
         call hpak ( -id,deta1y9)
         call hpake( -id,deta1sy9)
         call hpak ( -id-10,deta1y9)
         call hpake( -id-10,deta1ey9)
       endif



       do ieta=1,neta
* Average  <pt> in pt interval
         id = 13 000 + i +  20 + iofeta*(ieta-1)
         if ( ieta.eq.1) then
           call hbookb(id,' dn/dpt 0.5-1.5 '
     &      ,nbpt,xbpt1,0.)
           call hbookb(-id,' DATA dn/dpt 0.5-1.5 '
     &      ,nbpt,xbpt1,0.)
*           call hbookb(-id-10,' DATA dn/dpt 0.5-1.5 Estat '
*     &      ,nbpt,xbpt1,0.)
           if ( i .eq. 0 ) then
             call hpak ( -id,dpte1x0)
           elseif ( i .eq. 1 ) then
             call hpak ( -id,dpte1x1)
           elseif ( i .eq. 2 ) then
             call hpak ( -id,dpte1x2)
           elseif ( i .eq. 3 ) then
             call hpak ( -id,dpte1x3)
           elseif ( i .eq. 4 ) then
             call hpak ( -id,dpte1x4)
           elseif ( i .eq. 5 ) then
             call hpak ( -id,dpte1x5)
           elseif ( i .eq. 6 ) then
             call hpak ( -id,dpte1x6)
           elseif ( i .eq. 7 ) then
             call hpak ( -id,dpte1x7)
           elseif ( i .eq. 8 ) then
             call hpak ( -id,dpte1x8)
           elseif ( i .eq. 9 ) then
             call hpak ( -id,dpte1x9)
           endif
         endif
         if ( ieta.eq.5) then
           call hbookb(id,' dn/dpt 3.5-4.0 '
     &      ,nbpt,xbpt1,0.)
         endif
         if ( ieta.eq.4) then
           call hbookb(id,' dn/dpt 3.0-3.5 '
     &      ,nbpt,xbpt1,0.)
         endif
         if ( ieta.eq.3) then
           call hbookb(id,' dn/dpt 3.0-4.0 '
     &      ,nbpt,xbpt1,0.)
         endif
         if ( ieta.eq.2) then
           call hbookb(id,' dn/dpt 1.5-2.5 '
     &      ,nbpt,xbpt1,0.)
           call hbookb(-id,' DATA dn/dpt 1.5-2.5 '
     &      ,nbpt,xbpt1,0.)
*           call hbookb(-id-10,' DATA dn/dpt 1.5-2.5 Estat'
*     &      ,nbpt,xbpt1,0.)
           if ( i .eq. 0 ) then
             call hpak ( -id,dptc1x0)
           elseif ( i .eq. 1 ) then
             call hpak ( -id,dptc1x1)
           elseif ( i .eq. 2 ) then
             call hpak ( -id,dptc1x2)
           elseif ( i .eq. 3 ) then
             call hpak ( -id,dptc1x3)
           elseif ( i .eq. 4 ) then
             call hpak ( -id,dptc1x4)
           elseif ( i .eq. 5 ) then
             call hpak ( -id,dptc1x5)
           elseif ( i .eq. 6 ) then
             call hpak ( -id,dptc1x6)
           elseif ( i .eq. 7 ) then
             call hpak ( -id,dptc1x7)
           elseif ( i .eq. 8 ) then
             call hpak ( -id,dptc1x8)
           elseif ( i .eq. 9 ) then
             call hpak ( -id,dptc1x9)
           endif
         endif

* Final  dn**2/dpt, interval ieta
         id = 13 000 + i +  10 + iofeta*(ieta-1)
         if ( ieta.eq.5)
     &     call hbookb(id,' dn**2/dpt 3.5-4.0 '
     &      ,nbpt,xbpt1,0.)
         if ( ieta.eq.4)
     &     call hbookb(id,' dn**2/dpt 3.0-3.5 '
     &      ,nbpt,xbpt1,0.)
         if ( ieta.eq.3)
     &     call hbookb(id,' dn**2/dpt 3.0-4.0 '
     &      ,nbpt,xbpt1,0.)
         if ( ieta.eq.1)
     &     call hbookb(id,' dn**2/dpt 0.5-1.5 '
     &      ,nbpt,xbpt1,0.)
         if ( ieta.eq.2)
     &     call hbookb(id,' dn**2/dpt 1.5-2.5 '
     &      ,nbpt,xbpt1,0.)

* Final  dn/dpt, interval ieta
         id = 13 000 + i +  iofeta*(ieta-1)
         if ( ieta.eq.1)then
           call hbookb( id,' dn/dpt 0.5-1.5 '
     &      ,nbpt,xbpt1,0.)
           call hbookb(-id,' DATA dn/dpt 0.5-1.5 '
     &      ,nbpt,xbpt1,0.)
           call hbookb(-id-10,' DATA dn/dpt 0.5-1.5 Estat '
     &      ,nbpt,xbpt1,0.)
           if ( i .eq. 0 ) then
             call hpak ( -id,dpte1y0)
             call hpake( -id,dpte1sy0)
             call hpak ( -id-10,dpte1y0)
             call hpake( -id-10,dpte1ey0)
           elseif ( i .eq. 1 ) then
             call hpak ( -id,dpte1y1)
             call hpake( -id,dpte1sy1)
             call hpak ( -id-10,dpte1y1)
             call hpake( -id-10,dpte1ey1)
           elseif ( i .eq. 2 ) then
             call hpak ( -id,dpte1y2)
             call hpake( -id,dpte1sy2)
             call hpak ( -id-10,dpte1y2)
             call hpake( -id-10,dpte1ey2)
           elseif ( i .eq. 3 ) then
             call hpak ( -id,dpte1y3)
             call hpake( -id,dpte1sy3)
             call hpak ( -id-10,dpte1y3)
             call hpake( -id-10,dpte1ey3)
           elseif ( i .eq. 4 ) then
             call hpak ( -id,dpte1y4)
             call hpake( -id,dpte1sy4)
             call hpak ( -id-10,dpte1y4)
             call hpake( -id-10,dpte1ey4)
           elseif ( i .eq. 5 ) then
             call hpak ( -id,dpte1y5)
             call hpake( -id,dpte1sy5)
             call hpak ( -id-10,dpte1y5)
             call hpake( -id-10,dpte1ey5)
           elseif ( i .eq. 6 ) then
             call hpak ( -id,dpte1y6)
             call hpake( -id,dpte1sy6)
             call hpak ( -id-10,dpte1y6)
             call hpake( -id-10,dpte1ey6)
           elseif ( i .eq. 7 ) then
             call hpak ( -id,dpte1y7)
             call hpake( -id,dpte1sy7)
             call hpak ( -id-10,dpte1y7)
             call hpake( -id-10,dpte1ey7)
           elseif ( i .eq. 8 ) then
             call hpak ( -id,dpte1y8)
             call hpake( -id,dpte1sy8)
             call hpak ( -id-10,dpte1y8)
             call hpake( -id-10,dpte1ey8)
           elseif ( i .eq. 9 ) then
             call hpak ( -id,dpte1y9)
             call hpake( -id,dpte1sy9)
             call hpak ( -id-10,dpte1y9)
             call hpake( -id-10,dpte1ey9)
           endif
         endif
         if ( ieta.eq.5)then
           call hbookb( id,' dn/dpt 3.5-4.0 '
     &      ,nbpt,xbpt1,0.)
         endif
         if ( ieta.eq.4)then
           call hbookb( id,' dn/dpt 3.0-3.5 '
     &      ,nbpt,xbpt1,0.)
         endif
         if ( ieta.eq.3)then
           call hbookb( id,' dn/dpt 3.0-4.0 '
     &      ,nbpt,xbpt1,0.)
         endif
         if ( ieta.eq.2)then
           call hbookb( id,' dn/dpt 1.5-2.5 '
     &      ,nbpt,xbpt1,0.)
           call hbookb(-id,' DATA dn/dpt 1.5-2.5 '
     &      ,nbpt,xbpt1,0.)
           call hbookb(-id-10,' DATA dn/dpt 1.5-2.5 Estat '
     &      ,nbpt,xbpt1,0.)
           if ( i .eq. 0 ) then
             call hpak ( -id,dptc1y0)
             call hpake( -id,dptc1sy0)
             call hpak ( -id-10,dptc1y0)
             call hpake( -id-10,dptc1ey0)
           elseif ( i .eq. 1 ) then
             call hpak ( -id,dptc1y1)
             call hpake( -id,dptc1sy1)
             call hpak ( -id-10,dptc1y1)
             call hpake( -id-10,dptc1ey1)
           elseif ( i .eq. 2 ) then
             call hpak ( -id,dptc1y2)
             call hpake( -id,dptc1sy2)
             call hpak ( -id-10,dptc1y2)
             call hpake( -id-10,dptc1ey2)
           elseif ( i .eq. 3 ) then
             call hpak ( -id,dptc1y3)
             call hpake( -id,dptc1sy3)
             call hpak ( -id-10,dptc1y3)
             call hpake( -id-10,dptc1ey3)
           elseif ( i .eq. 4 ) then
             call hpak ( -id,dptc1y4)
             call hpake( -id,dptc1sy4)
             call hpak ( -id-10,dptc1y4)
             call hpake( -id-10,dptc1ey4)
           elseif ( i .eq. 5 ) then
             call hpak ( -id,dptc1y5)
             call hpake( -id,dptc1sy5)
             call hpak ( -id-10,dptc1y5)
             call hpake( -id-10,dptc1ey5)
           elseif ( i .eq. 6 ) then
             call hpak ( -id,dptc1y6)
             call hpake( -id,dptc1sy6)
             call hpak ( -id-10,dptc1y6)
             call hpake( -id-10,dptc1ey6)
           elseif ( i .eq. 7 ) then
             call hpak ( -id,dptc1y7)
             call hpake( -id,dptc1sy7)
             call hpak ( -id-10,dptc1y7)
             call hpake( -id-10,dptc1ey7)
           elseif ( i .eq. 8 ) then
             call hpak ( -id,dptc1y8)
             call hpake( -id,dptc1sy8)
             call hpak ( -id-10,dptc1y8)
             call hpake( -id-10,dptc1ey8)
           elseif ( i .eq. 9 ) then
             call hpak ( -id,dptc1y9)
             call hpake( -id,dptc1sy9)
             call hpak ( -id-10,dptc1y9)
             call hpake( -id-10,dptc1ey9)
           endif
         endif

* Average  <ptmax> in ptmax interval
         id = 14 000 + i +  20 + iofeta*(ieta-1)
         if ( ieta.eq.5)then
           call hbookb( id,' dn/dptmax 3.5-4.0 '
     &      ,nbptm,xbptm,0.)
         endif
         if ( ieta.eq.4)then
           call hbookb( id,' dn/dptmax 3.0-3.5 '
     &      ,nbptm,xbptm,0.)
         endif
         if ( ieta.eq.3)then
           call hbookb( id,' dn/dptmax 3.0-4.0 '
     &      ,nbptm,xbptm,0.)
         endif
         if ( ieta.eq.1)then
           call hbookb( id,' dn/dptmax 0.5-1.5 '
     &      ,nbptm,xbptm,0.)
           call hbookb(-id,' DATA dn/dptmax 0.5-1.5 '
     &      ,nbptm,xbptm,0.)
           if ( i .eq. 0 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptme1x0
             call hpak ( -id,dptme1x0)
           elseif ( i .eq. 1 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptme1x1
             call hpak ( -id,dptme1x1)
           elseif ( i .eq. 2 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptme1x2
             call hpak ( -id,dptme1x2)
           elseif ( i .eq. 3 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptme1x3
             call hpak ( -id,dptme1x3)
           elseif ( i .eq. 4 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptme1x4
             call hpak ( -id,dptme1x4)
           elseif ( i .eq. 5 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptme1x5
             call hpak ( -id,dptme1x5)
           elseif ( i .eq. 6 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptme1x6
             call hpak ( -id,dptme1x6)
           elseif ( i .eq. 7 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptme1x7
             call hpak ( -id,dptme1x7)
           elseif ( i .eq. 8 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptme1x8
             call hpak ( -id,dptme1x8)
           elseif ( i .eq. 9 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptme1x9
             call hpak ( -id,dptme1x9)
           endif
         endif
         if ( ieta.eq.2)then
           call hbookb( id,' dn/dptmax 1.5-2.5 '
     &      ,nbptm,xbptm,0.)
           call hbookb(-id,' DATA dn/dptmax 1.5-2.5 '
     &      ,nbptm,xbptm,0.)
           if ( i .eq. 0 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptmc1x0
             call hpak ( -id,dptmc1x0)
           elseif ( i .eq. 1 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptmc1x1
             call hpak ( -id,dptmc1x1)
           elseif ( i .eq. 2 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptmc1x2
             call hpak ( -id,dptmc1x2)
           elseif ( i .eq. 3 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptmc1x3
             call hpak ( -id,dptmc1x3)
           elseif ( i .eq. 4 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptmc1x4
             call hpak ( -id,dptmc1x4)
           elseif ( i .eq. 5 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptmc1x5
             call hpak ( -id,dptmc1x5)
           elseif ( i .eq. 6 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptmc1x6
             call hpak ( -id,dptmc1x6)
           elseif ( i .eq. 7 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptmc1x7
             call hpak ( -id,dptmc1x7)
           elseif ( i .eq. 8 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptmc1x8
             call hpak ( -id,dptmc1x8)
           elseif ( i .eq. 9 ) then
*             write(6,*)' HZ961 hpak data ',-id,dptmc1x9
             call hpak ( -id,dptmc1x9)
           endif
         endif

* Final  dn/dptmax , interval ieta
         id = 14 000 + i +  iofeta*(ieta-1)
         if ( ieta.eq.5)then
           call hbookb( id,' dn/dptmax 3.5-4.0 '
     &      ,nbptm,xbptm,0.)
         endif
         if ( ieta.eq.4)then
           call hbookb( id,' dn/dptmax 3.0-3.5 '
     &      ,nbptm,xbptm,0.)
         endif
         if ( ieta.eq.3)then
           call hbookb( id,' dn/dptmax 3.0-4.0 '
     &      ,nbptm,xbptm,0.)
         endif
         if ( ieta.eq.1)then
           call hbookb( id,' dn/dptmax 0.5-1.5 '
     &      ,nbptm,xbptm,0.)
           call hbookb(-id,' DATA dn/dptmax 0.5-1.5 '
     &      ,nbptm,xbptm,0.)
           call hbookb(-id-10,' DATA dn/dptmax 0.5-1.5 Estat'
     &      ,nbptm,xbptm,0.)
           if ( i .eq. 0 ) then
             call hpak ( -id,dptme1y0)
             call hpake( -id,dptme1sy0)
             call hpak ( -id-10,dptme1y0)
             call hpake( -id-10,dptme1ey0)
           elseif ( i .eq. 1 ) then
             call hpak ( -id,dptme1y1)
             call hpake( -id,dptme1sy1)
             call hpak ( -id-10,dptme1y1)
             call hpake( -id-10,dptme1ey1)
           elseif ( i .eq. 2 ) then
             call hpak ( -id,dptme1y2)
             call hpake( -id,dptme1sy2)
             call hpak ( -id-10,dptme1y2)
             call hpake( -id-10,dptme1ey2)
           elseif ( i .eq. 3 ) then
             call hpak ( -id,dptme1y3)
             call hpake( -id,dptme1sy3)
             call hpak ( -id-10,dptme1y3)
             call hpake( -id-10,dptme1ey3)
           elseif ( i .eq. 4 ) then
             call hpak ( -id,dptme1y4)
             call hpake( -id,dptme1sy4)
             call hpak ( -id-10,dptme1y4)
             call hpake( -id-10,dptme1ey4)
           elseif ( i .eq. 5 ) then
             call hpak ( -id,dptme1y5)
             call hpake( -id,dptme1sy5)
             call hpak ( -id-10,dptme1y5)
             call hpake( -id-10,dptme1ey5)
           elseif ( i .eq. 6 ) then
             call hpak ( -id,dptme1y6)
             call hpake( -id,dptme1sy6)
             call hpak ( -id-10,dptme1y6)
             call hpake( -id-10,dptme1ey6)
           elseif ( i .eq. 7 ) then
             call hpak ( -id,dptme1y7)
             call hpake( -id,dptme1sy7)
             call hpak ( -id-10,dptme1y7)
             call hpake( -id-10,dptme1ey7)
           elseif ( i .eq. 8 ) then
             call hpak ( -id,dptme1y8)
             call hpake( -id,dptme1sy8)
             call hpak ( -id-10,dptme1y8)
             call hpake( -id-10,dptme1ey8)
           elseif ( i .eq. 9 ) then
             call hpak ( -id,dptme1y9)
             call hpake( -id,dptme1sy9)
             call hpak ( -id-10,dptme1y9)
             call hpake( -id-10,dptme1ey9)
           endif
         endif
         if ( ieta.eq.2)then
           call hbookb( id,' dn/dptmax 1.5-2.5 '
     &      ,nbptm,xbptm,0.)
           call hbookb(-id,' DATA dn/dptmax 1.5-2.5 '
     &      ,nbptm,xbptm,0.)
           call hbookb(-id-10,' DATA dn/dptmax 1.5-2.5 Estat'
     &      ,nbptm,xbptm,0.)
           if ( i .eq. 0 ) then
             call hpak ( -id,dptmc1y0)
             call hpake( -id,dptmc1sy0)
             call hpak ( -id-10,dptmc1y0)
             call hpake( -id-10,dptmc1ey0)
           elseif ( i .eq. 1 ) then
             call hpak ( -id,dptmc1y1)
             call hpake( -id,dptmc1sy1)
             call hpak ( -id-10,dptmc1y1)
             call hpake( -id-10,dptmc1ey1)
           elseif ( i .eq. 2 ) then
             call hpak ( -id,dptmc1y2)
             call hpake( -id,dptmc1sy2)
             call hpak ( -id-10,dptmc1y2)
             call hpake( -id-10,dptmc1ey2)
           elseif ( i .eq. 3 ) then
             call hpak ( -id,dptmc1y3)
             call hpake( -id,dptmc1sy3)
             call hpak ( -id-10,dptmc1y3)
             call hpake( -id-10,dptmc1ey3)
           elseif ( i .eq. 4 ) then
             call hpak ( -id,dptmc1y4)
             call hpake( -id,dptmc1sy4)
             call hpak ( -id-10,dptmc1y4)
             call hpake( -id-10,dptmc1ey4)
           elseif ( i .eq. 5 ) then
             call hpak ( -id,dptmc1y5)
             call hpake( -id,dptmc1sy5)
             call hpak ( -id-10,dptmc1y5)
             call hpake( -id-10,dptmc1ey5)
           elseif ( i .eq. 6 ) then
             call hpak ( -id,dptmc1y6)
             call hpake( -id,dptmc1sy6)
             call hpak ( -id-10,dptmc1y6)
             call hpake( -id-10,dptmc1ey6)
           elseif ( i .eq. 7 ) then
             call hpak ( -id,dptmc1y7)
             call hpake( -id,dptmc1sy7)
             call hpak ( -id-10,dptmc1y7)
             call hpake( -id-10,dptmc1ey7)
           elseif ( i .eq. 8 ) then
             call hpak ( -id,dptmc1y8)
             call hpake( -id,dptmc1sy8)
             call hpak ( -id-10,dptmc1y8)
             call hpake( -id-10,dptmc1ey8)
           elseif ( i .eq. 9 ) then
             call hpak ( -id,dptmc1y9)
             call hpake( -id,dptmc1sy9)
             call hpak ( -id-10,dptmc1y9)
             call hpake( -id-10,dptmc1ey9)
           endif
         endif

       enddo

      enddo


*********************************************************************
*                      Event Processing
*
*********************************************************************

      Else if(iflag.eq.2) then

*      Filling: The following MUST always be done
*      (i) move to the correct sub-directory in PAWC
*
       call hcdir('//PAWC/'//xxxx,' ')
*
*                                             Event selection
*



       q2=real(HZDISKIN(1))
       x =real(HZDISKIN(2))
*
C       call getkinbin(x,q2,ibin)
       ibin = 0
       if(    q2.gt. 5..and.q2.le.10.) then
         if(x.gt.0.0001.and.x.le.0.0002) ibin=1
         if(x.gt.0.0002.and.x.le.0.0005.and.q2.gt.6.) ibin=2
       elseif(q2.gt.10..and.q2.le.20.) then
         if(x.gt.0.0002.and.x.le.0.0005) ibin=3
         if(x.gt.0.0005.and.x.le.0.0008) ibin=4
         if(x.gt.0.0008.and.x.le.0.0015) ibin=5
         if(x.gt.0.0015.and.x.le.0.0040) ibin=6
       elseif(q2.gt.20..and.q2.le.50.) then
         if(x.gt.0.0005.and.x.le.0.0014) ibin=7
         if(x.gt.0.0014.and.x.le.0.0030) ibin=8
         if(x.gt.0.0030.and.x.le.0.0100) ibin=9
       endif
*
       if ( ibin.lt.1.or.ibin.gt.9) goto 9990

       y =real(HZDISKIN(3))
       w2=real(HZDISKIN(4))
*
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' x= ',x,' q2 ',q2,' y= ',y,' w2= ',w2
*
*                                             get electron variables
*
       iel=HZIDELEC(idum)
       if (iel.eq.-1) then
        write(6,*) 'Hz'//xxxx,' electron not found '
        goto 9990
       endif
       enel=real(PHEP(4,iel))
       thel=real(HZPHMANG(PHEP(3,iel),
     &               sqrt(PHEP(1,iel)**2+PHEP(2,iel)**2)))*rd
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' enel= ',enel,' thel= ',thel
*
*                                             kinematic selection
*                                             E-pz always ok!
       evcut= enel.gt.12.
       evcut= thel.gt.157. .and. thel.lt.173.0 .and. evcut
       evcut= w2.ge.4400..and. evcut
       evcut = y.gt.0.05 .and. evcut
*       evcut = (y.gt.0.05 .and. y.lt.0.6) .and. evcut
       if (evcut .and. .NOT.(y.gt.0.05 .and. y.lt.0.6)) then
         write(6,*)' Should not happen too often (never!) '
       endif
       if(.not.evcut) goto 9990

       call hfill(1,log10(q2),log10(x),wtx)
       call hfill(2,log10(q2),1.,wtx)
       call hfill(3,log10(x),1.,wtx)
*
*                                             cut on forward energy
*
       efwd=0.
       Do ihep=1,nhep
        if (isthep(ihep).eq.1.and.ihep.ne.iel) then
         th=real(HZPHMANG(PHEP(3,ihep),
     &              sqrt(PHEP(1,ihep)**2+PHEP(2,ihep)**2)))*rd
         if(th.gt.4.4.and.th.lt.15.) then
          efwd=real(PHEP(4,ihep))+efwd
         endif
        endif
       enddo
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' efwd= ',efwd,' evcut= ',evcut
*
       call hfill(4,efwd,1.,wtx)
*
       if(efwd.lt.0.5) goto 9990
*
*                                             find the kinematic bin number
*
*                                             events in 9 bins only
*       if( ibin.eq.0) goto 9990
*                                             set up CMS boost needed later
*
       ierr=HZIBEAM(ibeam,idum)
       if (.not.(ierr.eq.1)) then
        write(6,*) 'HZ'//xxxx,' beams not found ! '
        goto 9990
       else
        Do i=1,4
         pbeam(i)=PHEP(i,IBEAM)
        enddo
       endif
*
       eb=real(PHEP(4,idum))
       if (abs(abs(eb)-ee).gt.0.2) then
        if (nentry.lt.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
        elseif (nentry.eq.10) then
         write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &   ' ...last message ! '
        endif
C        goto 9990
       endif
*
       ierr=HZIPGAM(ph)
       if (ierr.eq.-1) then
        write(6,*) 'HZ'//xxxx,' boson vector not found ! '
C        call VZERO(ph,5)
        Do i=1,5
         ph(i)=0.
        enddo
       else
        Do i=1,4
         pgam(i)=ph(i)
        enddo
       endif
*
       call HZHCMINI(pbeam,pgam,ierr)
       if (ierr.eq.1) then
        write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
        goto 9990
       endif

* Reset intermediate histograms
       id = 20 000 + 1000
       call hreset(id,' ')
       id = 20 000 + 2000
       call hreset(id,' ')
       do ieta=1,neta
         id = 20 000 + 3000 + iofeta*(ieta-1)
         call hreset(id,' ')
       enddo
*
* reset multiplicity counter
       xmult=0.
* Reset event quantities
       etsummed=0.
       etsummed1=0.
       do ieta=1,neta
       ptmax(ieta)=-999.
       enddo
*
*                                             loop over objects
*
*
*                                             et in central rapidity bin
       do 2000 ihep=1,nhep
*                                             skip unstable particles and el.
       if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 2000
*
*                                             transform in CMS
*
           Do i=1,4
            Phc(i)=PHEP(i,ihep)
           enddo
* pcm in had cms
           call HZHCM(phc,pcm,ierr)
           if (ierr.eq.1) then
            write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
            goto 9990
           endif

*                                             get particle momenta

           p      = real(sqrt(pcm(1)**2+pcm(2)**2+pcm(3)**2 ))
           pt     = real(sqrt( pcm(1)**2+pcm(2)**2 ))
           if (p.eq.0.) then
            write(6,*) xxxx,' p = ',p,pcm
            goto 2000
           else
            et     = real(pcm(4)) * pt / p
            th     = (acos(real(pcm(3))/p))
            if (abs(     th*rd).lt.1.e-4 .or.
     &          abs(180.-th*rd).lt.1.e-4 ) then
C             write(6,*) xxxx,' th = ',th
             goto 2000
            else
             rap    = -log(tan( th/2. ))
*                                            check on rap=nan (e.g. pt=0)
              if (rap.ne.rap) then
               write(6,*) xxxx,'Warning:  rap = ',rap,' th= ',th*rd,
     &         ' particle skipped ! '
               goto 2000
              endif
            endif
           endif
*

* Summed Et between 0.5 and 2.5 in eta cms
           if ( rap.gt.0.5.and.rap.lt.2.5) etsummed=etsummed+et
           if ( rap.gt.0.0.and.rap.lt.2.0) etsummed1=etsummed1+et
c           write(6,*) ' .... rap,et ',rap,et
* Charged particle
           if ( ihchrg(ihep).ne. 0 )then

           xmult=xmult+1.

* Fill intermediate histograms
            id = 21 000
            call hfill(id,rap,1.,wtx)
            if ( pt.gt.1.)then
              id = 22 000
              call hfill(id,rap,1.,wtx)
            endif

            do ieta=1,neta
             if ( rap.gt.etalow(ieta) .and. rap.lt.etahig(ieta))then
              id = 23 000 + (ieta-1)*iofeta
              call hfill(id,pt,1.,wtx)
              do jjbin=0,1
                jbin=ibin*jjbin
                id = 13 000 + 20 + (ieta-1)*iofeta + jbin
                call hfill(id,pt,1.,pt*wtx)
              enddo
              if ( pt.gt.ptmax(ieta))ptmax(ieta)=pt
             endif
             enddo
* Find pt max
           endif

*                                             end loop over objects
 2000  continue



       id=20 000 + 1000
       call hunpak(id,an11,'HIST',0)
       id=20 000 + 2000
       call hunpak(id,an21,'HIST',0)
       do ib=1,nbeta
         an12(ib)=an11(ib)**2
         an22(ib)=an21(ib)**2
       enddo

       do jjbin=0,1
         jbin=jjbin*ibin
         id = 12 000 + jbin
         call hpakad(id,an21)
         id = 12 000 + jbin + 10
         call hpakad(id,an22)
         id = 11 000 + jbin
         call hpakad(id,an11)
         id = 11 000 + jbin + 10
         call hpakad(id,an12)
* Multi histograms
         call hfill(100+jbin,xmult,1.,wtx)
         if (  etsummed.gt.6.)then
         call hfill(200+jbin,xmult,1.,wtx)
         endif
         if (  etsummed1.gt.6.)then
         call hfill(300+jbin,xmult,1.,wtx)
         endif

       enddo


       do ieta=1,neta
         id=23 000 + (ieta-1)*iofeta
         call hunpak(id,ap11,'HIST',0)
         do ib=1,nbpt
           ap12(ib)=ap11(ib)**2
         enddo
         do jjbin=0,1
           jbin=jjbin*ibin
           id = 13 000 + jbin + (ieta-1)*iofeta
           call hpakad(id,ap11)
           id = 13 000 + jbin + 10 + (ieta-1)*iofeta
           call hpakad(id,ap12)
         enddo
       enddo

* for each kin-bin (including all!), update ptmax, and event params
       do jjbin=0,1
         jbin=ibin*jjbin
         do ieta=1,neta
           if ( ieta.eq.1.and. etsummed1.gt.6.)then
             nev2(jbin)=nev2(jbin)+wtx
             id = 14 000 +  jbin + (ieta-1)*iofeta
             call hfill(id,ptmax(ieta),1.,wtx)
             call hfill(id+20,ptmax(ieta),1.,wtx*ptmax(ieta))
           endif
           if ( ieta.ge.2.and. etsummed.gt.6.)then
             if ( ieta.eq.2)nev1(jbin)=nev1(jbin)+wtx
             id = 14 000 +  jbin + (ieta-1)*iofeta
             call hfill(id,ptmax(ieta),1.,wtx)
             call hfill(id+20,ptmax(ieta),1.,wtx*ptmax(ieta))
           endif
         enddo

         nev(jbin)   = nev(jbin)+wtx
         xmean(jbin) = xmean(jbin) + x
         q2mean(jbin)= q2mean(jbin) + q2

       enddo

 9990  continue


*********************************************************************
*
*                      Termination
*
*********************************************************************

      Else if(iflag.eq.3) then

*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
       call hcdir('//PAWC/'//xxxx,' ')
*
       do ibin=0,9

* ptmax spectrum
         do ieta=1,neta
         if (ieta.eq.1) xnnev=nev2(ibin)
         if (ieta.gt.1) xnnev=nev1(ibin)
         id = 14 000 +  ibin + iofeta*(ieta-1)
*         write(6,*)' hz961 Term , unpak id ',id,xnnev
         call hunpak(id,apm1,'HIST',0)
         id = 14 000 + 20 + ibin + iofeta*(ieta-1)
*         write(6,*)' hz961 Term , unpak id ',id,xnnev
         call hunpak(id,ppm,'HIST',0)
         do ib=1,nbptm
           if ( apm1(ib) .gt. 0.)then
            ppm(ib)=ppm(ib)/apm1(ib)
*           write(6,*)' ptmax ib ',ib,ppp(ib)
           else
            ppm(ib)=(xbptm(ib+1)+xbptm(ib))/2.
           endif
           if ( xnnev.gt.0)then
             eapm1(ib) = sqrt(apm1(ib))/xnnev
             apm1(ib)=apm1(ib)/xnnev
             eapm1(ib) = eapm1(ib)/(xbptm(ib+1)-xbptm(ib))
             apm1(ib)=apm1(ib)/(xbptm(ib+1)-xbptm(ib))
           else
             eapm1(ib) = 0.
             apm1(ib)= 0.
           endif
*           write(6,*)' ptmax ib ',ib,ppm(ib),apm1(ib),eapm1(ib)
         enddo
         id = 14 000 +  ibin + iofeta*(ieta-1)
         call hreset(id,' ')
         call hpak(id,apm1)
         call hpake(id,eapm1)
         call hzhinfo(id,xnnev)
         call HZchisq(-id,id)
*
         id = 14 000 + 20 + ibin + iofeta*(ieta-1)
         call hreset(id,' ')
         call hpak(id,ppm)
         enddo
* pt spectrum
         do ieta=1,neta
           id = 13 000 + 0 + ibin + iofeta*(ieta-1)
C           write(6,*)' hz961 Term , unpak id ',id,nev(ibin)
           call hunpak(id,ap11,'HIST',0)
           id = 13 000 + 10 + ibin + iofeta*(ieta-1)
C           write(6,*)' hz961 Term , unpak id ',id,nev(ibin)
           call hunpak(id,ap12,'HIST',0)
           id = 13 000 + 20 + ibin + iofeta*(ieta-1)
C           write(6,*) xxxx,' Term , unpak id ',id,nev(ibin)
           call hunpak(id,ppp,'HIST',0)
           do ib=1,nbpt
             if ( ap11(ib) .gt. 0.)then
               ppp(ib)=ppp(ib)/ap11(ib)
             else
              ppp(ib)=(xbpt1(ib+1)+xbpt1(ib))/2.
             endif
             if ( nev(ibin).gt.1)then
               ap11(ib)=ap11(ib)/nev(ibin)
               ap12(ib)=ap12(ib)/nev(ibin)
               eap11(ib) = sqrt((ap12(ib)-ap11(ib)**2)/(nev(ibin)-1.))
               ap11(ib) = ap11(ib)/(xbpt1(ib+1)-xbpt1(ib))
               eap11(ib) = eap11(ib)/(xbpt1(ib+1)-xbpt1(ib))
             else
               ap11(ib)=0.
               ap12(ib)=0.
               eap11(ib) =0.
             endif
C             write(6,*)' pt ',ib,ppp(ib),ap11(ib),eap11(ib),ap12(ib)
           enddo
           id = 13 000 + 0 + ibin + iofeta*(ieta-1)
           call hreset(id,' ')
           call hpak(id,ap11)
           call hpake(id,eap11)
           call hzhinfo(id,nev(ibin))
           call HZchisq(-id,id)
           id = 13 000 + 20 + ibin + iofeta*(ieta-1)
           call hreset(id,' ')
           call hpak(id,ppp)
           call hpake(id,eap11)
           call hzhinfo(id,nev(ibin))
           call HZchisq(-id,id)
         enddo
* eta spectra
         do j=1,2
           id = 10 000 + 1000*j + ibin
           call hunpak(id,an11,'HIST',0)
           id = 10 000 + 1000*j + 10 + ibin
           call hunpak(id,an12,'HIST',0)
           etabsiz=(eta1-eta0)/float(nbeta)
           do ib=1,nbeta
             pnn(ib)=eta0+ (ib-1)*etabsiz + etabsiz/2.
             if ( nev(ibin).gt.1)then
               an11(ib)=an11(ib)/nev(ibin)
               an12(ib)=an12(ib)/nev(ibin)
               ean11(ib) = sqrt((an12(ib)-an11(ib)**2)/(nev(ibin)-1.))
               an11(ib)=an11(ib)/etabsiz
               ean11(ib)=ean11(ib)/etabsiz
             else
               an11(ib)=0.
               an12(ib)=0.
               ean11(ib) =0.
             endif
*             write(6,*)' eta ib',ib,pnn(ib),an11(ib),ean11(ib),an12(ib)
           enddo
           id = 10 000 + 1000*j + ibin
           call hreset(id,' ')
           call hpak(id,an11)
           call hpake(id,ean11)
           call hzhinfo(id,nev(ibin))
           call HZchisq(-id,id)
         enddo
       enddo
*                                              normalize mean Et,x,q2
*                                              fill histos with that info
*                                              set errors of norm. histo 0
       do ibin=0,9
        if (nev(ibin).ne.0.) then
         xmean(ibin) =xmean(ibin)/nev(ibin)
         q2mean(ibin)=q2mean(ibin)/nev(ibin)
        else
          xmean(ibin) =-999.
         q2mean(ibin) =-999.
        endif
       enddo
*
       write(6,'(a,a)')    xxxx,' bin statistics: '
       write(6,'(a,10f9.2)') ' nev  = ',nev
       write(6,'(a,10f9.2)') ' nev1 = ',nev1
       write(6,'(a,10f7.5)') ' <x>  = ',xmean
       write(6,'(a,10f7.3)') ' <q2> = ',q2mean

      endif
*
      RETURN
      END
