      subroutine hz98085p(IFLAG)
***********************************************
* D*-data ZEUS  photoproduction DESY 98-085
* Cuts :    Q2 < 1
*        0.19< y_bj <0.87
*
***********************************************
      IMPLICIT NONE
*
      real enel,thel
      Real pi,dpi,rd,ee,eb,dphi
      Real xpt1,xpt2,xxd1,xxd2
      Logical evcut,lp,lctag,lstag
      data lp/.false./
*
      Character string*20
*
      Integer nev,nentry,nd0,ndplus,ndminus
      Real Qpi,qqradp,xntot,q2,x,y,w2
      Real ptl,pth,wl,wh,etal,etah
      Integer nbpt,nbw,nbeta
      Data nev/0/
      Integer ncut
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam,iel,idum,idhe,idmo1,idmo2
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real xnd0,alphem,sigma_tot,x_d,p,pt,et,th,rap
      real lum,binw
      data xnd0/0./
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"

*
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*6 xxxx
      Data xxxx/'98085p'/
      Real x1,x2,xkt1,xkt2
      Integer igl1,igl2
* Data points
* pt
      Integer nbptd
	Parameter (nbptd=6)
      Real spt(nbptd),sptstat(nbptd)
      Data spt/9.678, 4.940, 2.220, 1.076, 0.328, 0.0668/
      Data sptstat/1.158, 0.313, 0.128, 0.073, 0.024, 0.0081/
	Real xpt(nbptd+1)
	data xpt/2.,3.,4.,5.,6.,8.,12./
* eta pt>2
	Integer nbetd
	Parameter (nbetd=6)
	Real xeta(nbetd+1)
	Data xeta/-1.5,-1.,-0.5,0.,0.5,1.0,1.5/
      Real set2(6),set2stat(6)
      Data set2/8.895, 8.156, 7.605, 5.233, 3.207, 4.650/
      Data set2stat/0.810, 0.801, 0.785, 0.994, 1.020, 1.396/
* eta pt>3
      Real set3(6),set3stat(6)
      Data set3/2.965, 4.170, 3.875, 2.932, 2.110, 2.320/
      Data set3stat/0.229, 0.293, 0.275, 0.282, 0.285, 0.341/
* eta pt>4
      Real set4(6),set4stat(6)
      Data set4/1.021, 1.641, 1.877, 1.662, 1.090, 1.186/
      Data set4stat/0.096, 0.137, 0.143, 0.137, 0.117, 0.142/
* eta pt>6
      Real set6(6),set6stat(6)
      Data set6/0.052, 0.331, 0.460, 0.398, 0.374, 0.242/
      Data set6stat/0.052, 0.047, 0.061, 0.056, 0.045, 0.062/
* x_gamma
      Real sxga(8),sxgastat(8)
      Data sxga/0.32, 1.06, 1.20, 0.98, 1.24, 1.80, 3.70, 2.87/
      Data sxgastat/0.19, 0.30, 0.28, 0.31, 0.27, 0.36, 0.53, 0.37/
*
        Integer chjet
        SAVE chjet
C --- choose same jet finder as in the paper --- KTCLUS
        DATA chjet/3/
        CHARACTER*6 jetf

C --- information returned by jet finder
        INTEGER NJET
c        DOUBLE PRECISION Jets(50,8)
        DOUBLE PRECISION CONER
        SAVE CONER

C --- cuts arrays
        DOUBLE PRECISION rapcut(2),Etcut(2)
        DATA Etcut/7.0d0,6.0d0/
        DATA rapcut/-2.4d0,2.4d0/
C ---
        INTEGER loop, njrap, nxga, nxgad
        Real xgam, xgal, xgah
        DOUBLE PRECISION rapj(2),Etj(2)

	Real xgamma,et_j1,et_j2,rap_j1,rap_j2
      common/cwnco1/xgamma,et_j1,et_j2,rap_j1,rap_j2
	
	
      save nd0, ndplus, Qpi, qqradp
      save nbpt, ptl, pth, nbeta, etal, etah, nxga, nxgad, xgal, xgah
      save xntot

*
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
         nd0=0
         ndplus=0
         write(6,*)' hz98085p D* Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
         nbpt = 50
         ptl = 2.
         pth = 12.
         nbeta = 25
         etal = -1.5
         etah = 1.5
         nxga = 8
         nxgad = 8
         xgal = 0.
         xgah = 1.
         call hbook1(1,'pt d*    ',nbpt,ptl,pth,0.)
         call hbook1(3,'eta d* pt>2   ',nbeta,etal,etah,0.)
         call hbook1(5,'eta d* pt>3   ',nbeta,etal,etah,0.)
         call hbook1(7,'eta d* pt>4   ',nbeta,etal,etah,0.)
         call hbook1(9,'eta d* pt>6   ',nbeta,etal,etah,0.)
         call hbook1(11,'xgamma d*   ',nxga,xgal,xgah,0.)
         call hbook1(121,' beam1 log(xg) (all)',50,-5.,0.,0.)
         call hbook1(131,' beam2 log(xg) (all)',50,-5.,0.,0.)
         call hbook1(122,' beam1 kt_2 (all)',50,0.,10.,0.)
         call hbook1(132,' beam2 kt_2 (all)',50,0.,10.,0.)
         call hbook1(221,' beam1 log(xg) (xgamma.gt.0.75) ',50,-5.,0.,0.
     $        )
         call hbook1(231,' beam2 log(xg) (xgamma.gt.0.75) ',50,-5.,0.,0.
     $        )
         call hbook1(222,' beam1 kt_2 (xgamma.gt.0.75) ',100,0.,20.,0.)
         call hbook1(232,' beam2 kt_2 (xgamma.gt.0.75) ',100,0.,20.,0.)
         call hbook1(321,' beam1 log(xg) (xgamma.lt.0.75) ',50,-5.,0.,0.
     $        )
         call hbook1(331,' beam2 log(xg) (xgamma.lt.0.75) ',50,-5.,0.,0.
     $        )
         call hbook1(322,' beam1 kt_2 (xgamma.lt.0.75) ',100,0.,20.,0.)
         call hbook1(332,' beam2 kt_2 (xgamma.lt.0.75) ',100,0.,20.,0.)
	   
	   
c         call hbook1(-1,'pt d* ZEUS data   ',nbptd,2.,pth,0.)
         call hbookb(-1,'pt d* ZEUS data   ',nbptd,xpt,0.)
         call hbookb(-3,'eta d* pt>2 ZEUS data ',nbetd,xeta,0.)
         call hbookb(-5,'eta d* pt>3 ZEUS data ',nbetd,xeta,0.)
         call hbookb(-7,'eta d* pt>4 ZEUS data ',nbetd,xeta,0.)
         call hbookb(-9,'eta d* pt>6 ZEUS data ',nbetd,xeta,0.)
         call hbook1(-11,'xgamma d* ZEUS data ',nxgad,xgal,xgah,0.)
         call hpak(-1,spt)
         call hpake(-1,sptstat)
         call hpak(-3,set2)
         call hpake(-3,set2stat)
         call hpak(-5,set3)
         call hpake(-5,set3stat)
         call hpak(-7,set4)
         call hpake(-7,set4stat)
         call hpak(-9,set6)
         call hpake(-9,set6stat)
         call hpak(-11,sxga)
         call hpake(-11,sxgastat)


        call hbook1(501,' charm eta',100,-5.,5.,0.)
        call hbook1(502,' charm pt',100,0.,25.,0.)
        call hbook1(601,' D* eta',100,-5.,5.,0.)
        call hbook1(602,' D* pt',100,0.,25.,0.)

C --- standard cone radius is 1.0
          CALL HZJETRAD(2,CONER)
          IF (CONER.lt.0.0) THEN
            CONER=1.0
          ENDIF
          CALL HZJTNAME(chjet,jetf)

          WRITE(6,*)'**********************************************'
          WRITE(6,*)'* HZ98085p called, histograms will be output. *'
          WRITE(6,*)'*     Jet finder selected : ',jetf,'           *'
          WRITE(6,1001)'*        with cone radius : ',CONER,'   *'
          WRITE(6,*)'**********************************************'

 1001     FORMAT(A29,F5.2,A13)

*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         xntot=xntot+1
*
         q2=hzphokin(1)
         IF (q2.eq.-1) THEN
            PRINT*,'hz98085p: HZPHOKIN returns error for Q2'
         ELSEIF (q2.lt.0) THEN
            q2=abs(q2)
         ENDIF
         y=hzphokin(3)
         IF (y.eq.-1) THEN
            PRINT*,'hz98085p: HZPHOKIN returns error for y'
         ENDIF
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            goto 20
         endif
         w2 = y*4.*PHEP(4,idum)*PHEP(4,ibeam)
         if(sqrt(w2).lt.130.0.or.sqrt(w2).gt.280.0) then

            goto 20
         endif
         if(q2.gt.1.) then

            goto 20
         endif

*
*
*
* boost crap!
*
         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(6,*) 'Hz'//xxxx,' electron not found '
            goto 20
         endif
         enel=real(PHEP(4,iel))
         thel=real(HZPHMANG(PHEP(3,iel), sqrt(PHEP(1,iel)**2+PHEP(2,
     +   iel)**2)))*rd
         if (lp) write(6,*) 'Hz'//xxxx, ' enel= ',enel,' thel= ',thel
*
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            goto 20
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
            goto 20
         endif
*
         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            call VZERO(ph,5)
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif
*
         call HZHCMINI(pbeam,pgam,ierr)
         if (ierr.eq.1) then
            write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
            goto 20
         endif
*
         if(gen(1:3).eq.'RAP') then
            igl1=4
            igl2=6
         elseif(gen(1:3).eq.'CAS') then
            igl1= 4
            igl2= 6
         elseif(gen(1:3).eq.'PYT') then
            igl1= 5
            igl2= 6
         endif
	   
         xkt1 = real(sqrt(phep(1,igl1)**2+phep(2,igl1)**2))
         xkt2 = real(sqrt(phep(1,igl2)**2+phep(2,igl2)**2))
         x1=(phep(4,igl1)+dabs(phep(3,igl1)))/2d0/phep(4,1)
         x2=(phep(4,igl2)+dabs(phep(3,igl2)))/2d0/phep(4,2)
	   
	   
            xgam = -1.
*
            CALL hzjtfind(chjet,CONER,NJET,Jets)

            IF (NJET.ge.2) THEN
              njrap = 0
              DO loop=1,NJET
                IF(Jets(loop,1).ge.rapcut(1).and.
     +             Jets(loop,1).le.rapcut(2) ) THEN
                  njrap = njrap + 1
                  Etj(njrap)=Jets(loop,3)
                  rapj(njrap)=Jets(loop,1)
                  IF (njrap.eq.2) goto 13
                ENDIF ! rapcut
              ENDDO
*
* No, there are no two jets in the eta range
*
                                  goto 17
*
* Yes, there are two jets in the eta range
*
 13           continue
*
              IF (Etj(1).ge.Etcut(1).and.Etj(2).ge.Etcut(2))
     +            THEN

              xgam=(Etj(1)*exp(-1*rapj(1))+Etj(2)*exp(-1*rapj(2)))
     +           /(2*y*PHEP(4,idum))

              ENDIF ! Et cuts

            ENDIF ! NJET.ge.2
*
 17         continue

*
         lctag=.false.
         xnd0=0
         nev=nev+1

         call hfill(121,real(log10(x1)),0.,1.)
         call hfill(131,real(log10(x2)),0.,1.)
         call hfill(122,xkt1,0.,1.)
         call hfill(132,xkt2,0.,1.)
         Do 10 ihep=1,nhep
            idhe=idhep(ihep)
*
            if ( abs(idhe).eq.311 ) lstag=.true.
            if ( abs(idhe).eq.4 ) lctag=.true.
		if ( abs(idhe).eq.4 ) then
* LAB variables
               Do i=1,4
                  Phc(i)=PHEP(i,ihep)
               enddo
               call get_var(phc,p,pt,et,th,rap,err_flag)
               if ( err_flag.ne.0 ) goto 10
		   call hfill(501,real(rap),0.,1.)
		   call hfill(502,real(pt),0.,1.)
c		   write(6,*) ' charm rap,pt ',rap,pt

		endif
*
ccc            if ( abs(idhe) .eq. 421 ) then
            if ( abs(idhe) .eq. 413 ) then   

* LAB variables
               Do i=1,4
                  Phc(i)=PHEP(i,ihep)
               enddo
               call get_var(phc,p,pt,et,th,rap,err_flag)
               if ( err_flag.ne.0 ) goto 10
		   call hfill(601,real(rap),0.,1.)
		   call hfill(602,real(pt),0.,1.)
c		   write(6,*) ' D* rap,pt ',rap,pt
ccc            if ( abs(idhe) .eq. 4 ) then
               Do i=1,4
                  Phc(i)=PHEP(i,ihep)
               enddo
* pcm in had cms
               call HZHCM(phc,pcm,ierr)
               if (ierr.eq.1) then
                  write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
                  goto 20
               endif
*
*                                             get particle momenta
*
*
               idmo1=jmohep(1,ihep)
               idmo2=idhep(idmo1)
*          write(6,*)' D0 found ',xntot,lctag,idmo1,idmo2
* LAB variables
               call get_var(phc,p,pt,et,th,rap,err_flag)
               if ( err_flag.ne.0 ) goto 10                            
* CMS variables
*           call get_var(pcm,p,pt,et,th,rap,err_flag)
*           if ( err_flag.ne.0 ) goto 2000
               xnd0=xnd0+1
               x_d = 2*abs(p)/sqrt(w2)
*
               if (lp) write(6,*) ' x_d= ',x_d,' w2= ',w2
*

*           write(6,*)' d0 from d*+ '
                  if(rap.ge.-1.5.and.rap.le.1.5) then
                     call hfill(1,pt,1.,1.)
			   
			   
                     if(pt.gt.2.) then
			      call hfill(3,rap,1.,1.)
				endif
                     if(pt.gt.3.) then
			      call hfill(5,rap,1.,1.)
				endif
                     if(pt.gt.4.) then
			      call hfill(7,rap,1.,1.)
				endif
                     if(pt.gt.6.) then
			      call hfill(9,rap,1.,1.)
				endif
                     ndplus=ndplus+1
                     if(pt.gt.3..and.xgam.gt.0.) then                           
                           call hfill(11,xgam,1.,1.)
			         xgamma=xgam
				   et_j1=real(etj(1))
				   et_j2=real(etj(2))
				   rap_j1=real(rapj(1))
				   rap_j2=real(rapj(2))
c                           call  HFNT (3000)
                           if(xgam.gt.0.75) then 
                            call hfill(221,real(log10(x1)),0.,1.)
                            call hfill(231,real(log10(x2)),0.,1.)
                            call hfill(222,xkt1,0.,1.)
                            call hfill(232,xkt2,0.,1.)
		               else
                            call hfill(321,real(log10(x1)),0.,1.)
                            call hfill(331,real(log10(x2)),0.,1.)
                            call hfill(322,xkt1,0.,1.)
                            call hfill(332,xkt2,0.,1.)
				   endif
                           endif
                  endif
c               endif
*
               if (lp) write(6,*) ' pt x_d= ',pt,x_d,' ndplus= ',
     +         ndplus,nd0
*
            endif
   10    continue
*
         if ( lctag ) then
         endif
*
*
*
*
   20    continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         lum=999999999.
* x section in nb
         sigma_tot=xsec/1000.
         if (sigma_tot.ne.0.) then
            lum=real(xntot)/real(sigma_tot)
         else
            write(6,*) 'hz',xxxx,' sigma_tot=0 ! '
         endif
*
* Obtain total cross-section
         write(6,*) ' Total Cross section ',sigma_tot,xntot
*
         write(6,*)'      '
*
         do i=1,11,2
            if(i.eq.1) then
               binw = (pth - ptl)/nbpt
            elseif(i.le.10) then
               binw = (etah - etal)/nbeta
            elseif(i.ge.11) then
               binw = (xgah - xgal)/nxga
            endif
            binw = 1./binw
            call hopera(i,'+E',i,i,binw/lum,0.)
         enddo
      endif
      RETURN
      END
