*CMZ :  1.02/06 10/03/99  08.19.12  by  Hannes Jung
*-- Author :
      subroutine HZ98092(IFLAG)
****************************************************************************
* Purpose: diffractive jets in DIS (DESY 98-092)
*
*
* Event selection:
*
* Running:
*
* Arguments: iflag=1 initialisation
*            iflag=1 filling
*            iflag=3 termination
*
* written by:
****************************************************************************
      IMPLICIT NONE
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
* common that gives the position of particles in X and Y system
      integer nxobj,nyobj,nxgag,nygag
      double precision pom
      common /diffhad/pom(5),nxobj(5000),nyobj(5000),nxgag,nygag


      Integer numjet
c      Parameter (numjet=50)
      Parameter (numjet=200)
      Double precision pj(numjet,8)
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),plab(5,NMXHEP)
*
      Integer i,iflag,ihep
      Character*5 xxxx
*
      Real pi,rd,eb,ee
      Parameter (ee=27.5)
      Integer iel,idum,ibeam
      Parameter (pi=3.1415927,rd=180./pi)
      Integer nentry
      Real x,y,q2,enel,thel,efwd,th,lx,lxj
*
      Integer ierr
      Integer maxhi,modjet,maxjet
      Parameter (maxhi=2000,modjet=2,maxjet=30)
      Real  selj(maxjet,4),help,empz,empzh,xg,empzl,empzhl,xgl
      Integer ipjet(maxjet),l,k
      Real nev(maxhi),lum,xw,nev2(maxhi)
      Real deta,ptj2,thj
      Real xpom, x_pom,beta,xgluon,shat,p_sh(4),p_mx(4),mx2,mx
      Real xmas,ymas,t
      Real xgamma,eta1,eta2
      Real eppz,empzj,eppzj
      Real pj1,pj2,pr
      Integer njet,nj,nsel,ij,idhe,nhst,iy,ix
      Double precision rcone
      Parameter (rcone=1.)
      
      double precision djetmass
      
      Logical lp,disjet,gamjet
      Data lp/.false./
*      Data lp/.true./
*********************************************************************
      Integer nx,iprot
      Real n2,n2g,nall,nall2,nall2g
      Real xmin,xmax
      save xxxx,nev,nall
      Data xxxx/'98092'/,NENTRY/0/
      integer nz
      parameter (nz=4)
      real dxzb(5),dxz(4),dsecz(4),derz(4),dsysz(4),dstaz(4)
      data dxzb/0.2,0.4,0.6,0.8,1.0/
      data dxz/   0.3,    0.5,    0.7,   0.9/
      data dsecz/117.,67.7,20.2,7.09/
      data derz/ 41.6  , 25.3   ,11.5   , 6.7  /
      data dsysz/26.6  , 13.0   ,5.3    , 2.33   /
      data dstaz/32.   , 21.7   ,10.2    ,6.3/
      integer npt
      parameter (npt=2)
      real dptb(3),dptx(2),dsecpt(2),derpt(2),dsyspt(2),dstapt(2)
      data dptb/5.0, 7.0, 10.0/
      data dptx/   6.0 ,  8.5/
      data dsecpt/43.3 ,  8.82/
      data derpt/ 11.8   ,2.53  /
      data dsyspt/9.4    ,1.7  /
      data dstapt/6.2    ,1.78/
* now photo production
      integer gng
      parameter (gng=4)
      real gxgb(5),gxg(4),gsecxg(4),gerxg(4),gsysxg(4),gstaxg(4)
      data gxgb/0.2,0.4,0.6,0.8,1.0/
      data gxg/   0.3,    0.5,    0.7,   0.9/
c      data gsecxg/415.3,688.1,1051.2,738.3/
c      data gerxg/ 86.4,119.3,141.7,114.6 /
c      data gstaxg/65.8,82.7,101.7,78.3/
c      data gsysxg/56.0,86.0,98.7,83.7/
      data gsecxg/469.,762.,1180.,806./
      data gerxg/ 86.4,119.3,141.7,114.6 /
      data gstaxg/71.,93.,120.,98/
      data gsysxg/57.,106.,150.,89./
      integer gnz
      parameter (gnz=4)
      real gxzb(5),gxz(4),gsecz(4),gerz(4),gsysz(4),gstaz(4)
      data gxzb/0.2,0.4,0.6,0.8,1.0/
      data gxz/   0.3,    0.5,    0.7,   0.9/
c      data gsecz/966.2,860.2,718.2,241.0/
c      data gerz/ 215.97,152.1,115.3,50. /
c      data gstaz/116.9,87.8,73.9,41.6/
c      data gsysz/181.6,124.2,88.5,27.7 /
      data gsecz/1130.,938.,732.,242./
      data gerz/ 215.97,152.1,115.3,50. /
      data gstaz/140.,99.,85.,52./
      data gsysz/170.,112.,70.,23. /
      integer gnpt
      parameter (gnpt=4)
      real gptb(5),gptx(4),gsecpt(4),gerpt(4),gsyspt(4),gstapt(4)
      data gptb/5.0, 7.0, 9.0,11.0,13.0/
      data gptx/   6.0 ,  8.0, 10.0, 12.0/
c      data gsecpt/419.7,137.4,47.4,7.1/
c      data gerpt/ 50.3,21.9,7.3,2.5 /
c      data gstapt/21.4   ,11.7, 5.7, 2.1   /
c      data gsyspt/ 45.5,18.5,4.5,1.4/
      data gsecpt/462.,153.,49.7,6.65/
      data gerpt/ 52.,21.,7.4,2.17 /
      data gstapt/25. ,13., 6.7, 2.3   /
      data gsyspt/ 45.5,18.5,4.5,1.4/
      integer gneta
      parameter (gneta=6)
      real getab(7),getax(6),gseceta(6),gereta(6),gsyseta(6),gstaeta(6)
      data getab/-1.,-0.5,0.0,0.5,1.0,1.5,2.0/
c      data gseceta/577.1,674.3,576.1,345.8,175.9,114.1/
c      data gereta/ 77.5,86.3,81.4,59.6,39.3,26.1 /
c      data gstaeta/51.1,49.6,47.3,35.0,25.8,22.9/
c      data gsyseta/57.8,70.6,66.3,48.2,29.7,12.6/
      data gseceta/628.,717.,623.,398.,197.,115/
      data gereta/ 77.5,86.3,81.4,59.6,39.3,26.1 /
      data gstaeta/61.,60.,56.,41.,29.,26./
      data gsyseta/64.,83.,72.,49.,21.,11./

      save nall2, nall2g, n2


*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
         nall=0.
         nall2=0.
         nall2g=0.
         n2=0.
         call Vzero(nev,maxhi)
         call Vzero(nev2,maxhi)
*
*
* Initialisation: The following MUST always be done
* (i) make subdirectory in PAWC
* - use the name as the xxxxxx in HZxxxxxx subroutine
* (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
* book histos
*
         nx=6
         xmin=0.05e-2
         xmax=0.35e-02
*
         call hbook1(221,'  y     ',100,0.,1.,0.)
         call hbook1(222,'  Q2     ',100,0.,100.,0.)
         call hbook1(223,'  xpom    ',100,0.,0.1,0.)
         call hbook1(224,'  M_x  0-20  ',100,0.,20.,0.)
         call hbook1(225,'  M_x  0-100  ',100,0.,100.,0.)
         call hbook1(226,'  z ',100,0.,1.,0.)
         call hbook1(227,'  pt ',100,0.,50.,0.)
         call hbook1(228,'  M_y  0-20  ',100,0.,20.,0.)
         call hbook1(229,'  M_y  0-100  ',100,0.,100.,0.)
         call hbookb(100,' DIS dsigma/dz  data      ',nz, dxzb,0.)
         call hbookb(120,' DIS dsigma/dpt data      ',npt,dptb,0.)

         call hbookb(-100,' DIS dsigma/dz  (err_tot)      ',nz, dxzb,0.)
         call hbookb(-101,' DIS dsigma/dz  (err_syst)     ',nz, dxzb,0.)
         call hbookb(-102,' DIS dsigma/dz  (err_stat)     ',nz, dxzb,0.)
         call hbookb(-120,' DIS dsigma/dpt (err_tot)      ',npt,dptb,0.)
         call hbookb(-121,' DIS dsigma/dpt (err_syst)     ',npt,dptb,0.)
         call hbookb(-122,' DIS dsigma/dpt (err_stat)     ',npt,dptb,0.)

         call hbookb(1000,'  dsigma/dz  mc      ',gnz, gxzb,0.)
         call hbookb(1020,'  dsigma/dpt mc      ',gnpt,gptb,0.)
         call hbookb(1030,'  dsigma/dxgamma mc      ',gng,gxgb,0.)
         call hbookb(1040,'  dsigma/deta mc      ',gneta,getab,0.)

         call hbookb(-1000,'  dsigma/dz  (err_tot)      ',gnz, gxzb,0.)
         call hbookb(-1001,'  dsigma/dz  (err_syst)     ',gnz, gxzb,0.)
         call hbookb(-1002,'  dsigma/dz  (err_stat)     ',gnz, gxzb,0.)
         call hbookb(-1020,'  dsigma/dpt (err_tot)      ',gnpt,gptb,0.)
         call hbookb(-1021,'  dsigma/dpt (err_syst)     ',gnpt,gptb,0.)
         call hbookb(-1022,'  dsigma/dpt (err_stat)     ',gnpt,gptb,0.)
         call hbookb(-1030,'  dsigma/dxgamma (err_tot)  ',gng, gxgb,0.)
         call hbookb(-1031,'  dsigma/dxgamma (err_syst) ',gng, gxgb,0.)
         call hbookb(-1032,'  dsigma/dxgamma (err_stat) ',gng, gxgb,0.)
         call hbookb(-1040,'  dsigma/deta (err_tot)   ',gneta,getab,0.)
         call hbookb(-1041,'  dsigma/deta (err_syst)  ',gneta,getab,0.)
         call hbookb(-1042,'  dsigma/deta (err_stat)  ',gneta,getab,0.)




*
* pack data into histograms
*
         Call hpak (-100,dsecz)
         Call hpake(-100,derz)
         Call hpak (-101,dsecz)
         Call hpake(-101,dsysz)
         Call hpak (-102,dsecz)
         Call hpake(-102,dstaz)
         Call hpak (-120,dsecpt)
         Call hpake(-120,derpt)
         Call hpak (-121,dsecpt)
         Call hpake(-121,dsyspt)
         Call hpak (-122,dsecpt)
         Call hpake(-122,dstapt)
* photoproduction data
         Call hpak (-1000,gsecz)
         Call hpake(-1000,gerz)
         Call hpak (-1001,gsecz)
         Call hpake(-1001,gsysz)
         Call hpak (-1002,gsecz)
         Call hpake(-1002,gstaz)
         Call hpak (-1020,gsecpt)
         Call hpake(-1020,gerpt)
         Call hpak (-1021,gsecpt)
         Call hpake(-1021,gsyspt)
         Call hpak (-1022,gsecpt)
         Call hpake(-1022,gstapt)
         Call hpak (-1030,gsecxg)
         Call hpake(-1030,gerxg)
         Call hpak (-1031,gsecxg)
         Call hpake(-1031,gsysxg)
         Call hpak (-1032,gsecxg)
         Call hpake(-1032,gstaxg)
         Call hpak (-1040,gseceta)
         Call hpake(-1040,gereta)
         Call hpak (-1041,gseceta)
         Call hpake(-1041,gsyseta)
         Call hpak (-1042,gseceta)
         Call hpake(-1042,gstaeta)
         write(6,*) 'HZ'//xxxx
*
*********************************************************************
*
*                      Event Processing
*
*********************************************************************
      Else if(iflag.eq.2) then
*
* Filling: The following MUST always be done
* (i) move to the correct sub-directory in PAWC
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         xw=1.
         nall=nall+xw
*
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
c         write(6,*) ' hx98092: ',ibeam,idum,PHEP(4,idum),PHEP(4,ibeam)
         
c         call hzlihep(0) 
         
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
            return
         endif
         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
C         call VZERO(ph,5)
          Do i=1,5
           ph(i)=0.
          enddo
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif
*
* Event selection
*
         q2=abs(HZDISKIN(1))
         if(q2.gt.1) then
            x =real(HZDISKIN(2))
            y =real(HZDISKIN(3))
         else
            q2=abs(hzphokin(1))
            y=hzphokin(3)
         endif

c         write(6,*) ' q2 calc ',q2,abs(HZDISKIN(1)),abs(hzphokin(1))


         deta = -999.
         njet = 0
*
         if (lp) then
            write(*,*) 'Hz'//xxxx,' x y q2=',x,y,q2
         endif
*
* get electron variables for kinematic selection
*
         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(*,*) 'Hz'//xxxx,' electron not found '
            return
         endif
         enel=real(PHEP(4,iel))
         thel=real(HZPHMANG(PHEP(3,iel), sqrt(PHEP(1,iel)**2+PHEP(2,
     +   iel)**2)))*rd
*
*
*  do diffractive selection
         x_pom=1.
         xpom=999.
         do i=1,4
            p_mx(i)=0.
         enddo
         Do 10   ihep=1,nhep
* do not count scattered electron
            if(ihep.eq.iel) goto 10
            idhe=idhep(ihep)
*  proton tag

            if ( abs(idhe).eq.2212.and.jmohep(1,ihep).eq.2 ) then
               iprot = ihep
            endif
   10    continue
         call hzhadgap(xmas,ymas,xpom,t)
         do i=1,4
            pbeam(i)=pom(i)
         enddo
         mx2=xmas**2
         if( xpom.le.x_pom) x_pom=xpom
         if (lp) then
            write(6,*) 'Hz'//xxxx,' enel= ',enel,' thel= ',thel
            write(6,*) 'Hz'//xxxx,' y= ',y,' q2= ',q2
            write(6,*) 'Hz'//xxxx,' x_pom= ',x_pom,' m_x ',sqrt(mx2)
         endif
         if(x_pom.lt.x) then
            if(lp) then
               write(6,*) 'Hz'//xxxx,' x < x_pom = '
               write(6,*) 'Hz'//xxxx,' x = ',x,' x_pom = ',xpom,' t = '
     +         ,t
               write(6,*) 'Hz'//xxxx,' xmas = ',xmas,' ymas = ',ymas
               write(6,*) 'Hz'//xxxx,' q2 = ',q2,' y = ',y
               write(6,*) 'Hz'//xxxx,' nxgag,nygag ',nxgag,nygag
               write(6,*) 'Hz'//xxxx,' nxobj ',(nxobj(i),i=1,nxgag)
               write(6,*) 'Hz'//xxxx,' nyobj ',(nyobj(i),i=1,nygag)
            endif
            return
         endif
* twojet diffractive cuts for DIS
*   0.005 < xpom < 0.05
*   7.5 < Q^2 < 80 GeV^2
*   0.1 < y < 0.7
*   |t| < 1.0 GeV^2
*   M_Y < 1.6 GeV

         disjet=.true.
         gamjet=.true.
         if (y.lt.0.1) disjet=.false.
         if (y.gt.0.7) disjet=.false.
         if (q2.lt.7.5) disjet=.false.
         if (q2.gt.80.) disjet=.false.
         if (x_pom.gt.0.05) disjet=.false.
         if (x_pom.lt.0.005) disjet=.false.
         if (ymas.gt.1.6) disjet=.false.
         if (abs(t).gt.1.0) disjet=.false.

* twojet diffractive cuts photoproduction
*   xpom < 0.05
*   0 < Q^2 < 0.01 GeV^2
*   0.25 < y < 0.7
*   |t| < 1.0 GeV^2
*   M_Y < 1.6 GeV

         if (y.lt.0.25) gamjet=.false.
         if (y.gt.0.7) gamjet=.false.
         if (q2.gt.0.01) gamjet=.false.
         if (x_pom.gt.0.05) gamjet=.false.
         if (ymas.gt.1.6) gamjet=.false.
         if (abs(t).gt.1.0) gamjet=.false.

c         write(6,*) 'hz98092 disjet,gamjet ',disjet,gamjet

*
* find jets
         if (disjet) then
*
            nall2=nall2+xw

*
c fill all global histos
            call hfill(221,y,0.,xw)
            call hfill(222,q2,0.,xw)
            call hfill(223,x_pom,0.,xw)
            call hfill(224,xmas,0.,xw)
            call hfill(225,xmas,0.,xw)
            call hfill(228,ymas,0.,xw)
            call hfill(229,ymas,0.,xw)

            ierr=HZIPGAM(ph)
            if (ierr.eq.-1) then
               write(6,*) 'HZ'//xxxx,' boson vector not found ! '
C              call VZERO(ph,5)
               Do i=1,5
                ph(i)=0.
               enddo
            else
               Do i=1,4
                  pgam(i)=ph(i)
               enddo
            endif
*
            call HZHCMINI(pbeam,pgam,ierr)
            if (ierr.eq.1) then
               write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
               return
            endif
*
*       loop and boost
*
            empzh=0.
            empzhl=0.
            nhst = 1
            do 20 ihep=nhst,nhep
               Do i=1,4
                  Ph(i)=PHEP(i,ihep)
                  Plab(i,ihep)=PHEP(i,ihep)
                  phep(i,ihep)=0.0
               enddo
*
* do not count scattered electron
               if(ihep.eq.iel) goto 20
* do not count particles assigned to Y system
               do iy=1,nygag
                  if(ihep.eq.nyobj(iy)) goto 20
               enddo
               call HZHCM(ph,pcm,ierr)
               if (ierr.eq.1) then
                  write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
                  return
               endif
*
               if (isthep(ihep).ne.1.or.ihep.eq.iel) then
                  th=real(HZPHMANG(PHEP(3,ihep), sqrt(PHEP(1,ihep)**2+
     +            PHEP(2,ihep)**2)))*rd
               endif
*
               Do i=1,4
                  PHEP(i,ihep)=Pcm(i)

               enddo
               
               
               if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 20
               empzh=empzh+phep(4,ihep)+phep(3,ihep)
               if (th.gt.3.3.and.th.lt.176.) then
                  empzhl=empzhl+phep(4,ihep)+phep(3,ihep)
               endif

*
   20       continue
c            call hzlihep(0)
*
*       find the jets
*
            call hzjtfind(modjet,rcone,nj,pj)
            if (nj.gt.numjet) then
               write(6,*) 'Hz'//xxxx,' too many jets found ! '
               return
            endif
*
            nsel = 0
*
            do ij=1,nj
*
               ptj2=real(pj(ij,3))
*
*
* pt>5 GeV deta<2 qjcone
*

               if (ptj2.gt.5.) then
                  nsel = nsel + 1
                  ipjet(nsel)=ij
c check jet mass:
c                djetmass = pj(ij,4)**2-pj(ij,5)**2-pj(ij,6)**2-pj(ij,7)**2  
c                write(6,*) ' jet mass ', djetmass,pj(ij,4),pj(ij,5),pj(ij,6),pj(ij,7)
               endif
            enddo
            
            
*
            njet = nsel
            if (nsel.eq.2) then
               deta=abs(pj(ipjet(1),1)-pj(ipjet(2),1))
               if (lp) write(6,*) ' deta= ',deta,pj(ipjet(1),1),
     +         pj(ipjet(2),1)
*
* calculate shat and z_pom
               do i=1,4
                  p_sh(i)=pj(ipjet(1),3+i)+pj(ipjet(2),3+i)
               enddo
               shat=p_sh(1)**2 - p_sh(2)**2 - p_sh(3)**2 - p_sh(4)**2
               xgluon=(q2 + shat)/(q2 + mx2)
               if(lp) then
                  write(6,*) ' shat ',shat,mx2
                  write(6,*) ' z ',xgluon
               endif
               n2=n2+xw
c fill global histograms
               pj1=real(pj(ipjet(1),3))
               pj2=real(pj(ipjet(2),3))
               if(lp) then
                  write(6,*) ' pt_jets ',pj1,pj2
               endif
               call hfill(100,xgluon,0.,xw)
               call hfill(120,pj1,0.,xw)
               call hfill(120,pj2,0.,xw)
               call hfill(226,xgluon,0.,xw)
               call hfill(227,pj1,0.,xw)
               call hfill(227,pj2,0.,xw)
*
               empz=empz+pj(ipjet(2),4)+pj(ipjet(2),7)
               if (lp) write(6,*) ' Jet2: thj= ',thj,' EmPz= ', real(pj
     +         (ipjet(2),4)+pj(ipjet(2),7))
*
*
               if (empzh.ne.0.) then
                  xg=empz/empzh
               else
                  xg=-999.
               endif
*
               if (empzhl.ne.0.) then
                  xgl=empz/empzhl
               else
                  xgl=-999.
               endif


            endif
            do ihep=nhst,nhep
               Do i=1,4
                  PHEP(i,ihep)= Plab(i,ihep)
               enddo
            enddo
         endif

* here do the photoproduction stuff
         if (gamjet) then
*
            nall2g=nall2g+xw
c            write(6,*) ' gamjet ',nall2g,nall
            nhst = 1
* fill e+pz,e-pz from mx system
            eppz = 0.
            empz = 0.
            eppzj = 0.
            empzj = 0.
            do ix = 1,nxgag
               ihep = nxobj(ix)
               eppz = eppz + phep(4,ihep) - phep(3,ihep)
               empz = empz + phep(4,ihep) + phep(3,ihep)
            enddo
            do 30 ihep=nhst,nhep
               Do i=1,4
                  Ph(i)=PHEP(i,ihep)
                  Plab(i,ihep)=PHEP(i,ihep)
                  phep(i,ihep)=0.0
               enddo
*
* do not count scattered electron
               if(ihep.eq.iel) goto 30
* do not count particles assigned to Y system
               do iy=1,nygag
                  if(ihep.eq.nyobj(iy)) goto 30
               enddo
               Do i=1,4
                  PHEP(i,ihep)=Plab(i,ihep)
               enddo
   30       continue
*
*       find the jets
*
            call hzjtfind(modjet,rcone,nj,pj)
            if (nj.gt.numjet) then
               write(6,*) 'hz',xxxx,' too many jets found ! '
               return
            endif
            nsel = 0
*
            do ij=1,nj
*
               ptj2=real(pj(ij,3))
*
*
* pt>5 GeV deta<2 qjcone
*
               if (ptj2.gt.5.) then
                  nsel = nsel + 1
                  ipjet(nsel)=ij
               endif
            enddo
*
            njet = nsel
            if (nsel.eq.2) then
               deta=abs(pj(ipjet(1),1)-pj(ipjet(2),1))
*
* calculate shat and z_pom
               do i=1,4
                  p_sh(i)=pj(ipjet(1),3+i)+pj(ipjet(2),3+i)
               enddo
               n2g=n2g+xw
               pj1=real(pj(ipjet(1),3))
               pj2=real(pj(ipjet(2),3))
               empzj=pj(ipjet(1),4)+pj(ipjet(1),7) + pj(ipjet(2),4)+
     +         pj(ipjet(2),7)
               eppzj=pj(ipjet(1),4)-pj(ipjet(1),7) + pj(ipjet(2),4)-
     +         pj(ipjet(2),7)
*
*
               if (empz.ne.0.) then
                  xgluon=empzj/empz
               else
                  xgluon=-999.
               endif
               if (eppz.ne.0.) then
                  xgamma=eppzj/eppz
               else
                  xgamma=-999.
               endif
               eta1=real(pj(ipjet(1),1))
               eta2=real(pj(ipjet(2),1))
               if(eta1.gt.-1.0.and.eta1.lt.2.0.and.eta2.gt.-1.0.
     +         and.eta2.lt.2.0) then
                  call hfill(1000,xgluon,0.,xw)
                  call hfill(1020,pj1,0.,xw)
                  call hfill(1020,pj2,0.,xw)
                  call hfill(1030,xgamma,0.,xw)
                  call hfill(1040,eta1,0.,xw)
                  call hfill(1040,eta2,0.,xw)
               endif
            endif
            do ihep=nhst,nhep
               Do i=1,4
                  PHEP(i,ihep)= Plab(i,ihep)
               enddo
            enddo
         endif

*********************************************************************
*
*                      Termination
*
*********************************************************************

      Else if(iflag.eq.3) then

* Termination: The following MUST always be done
* (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif
*
         write(6,*) 'Hz'//xxxx,': Total Cross= ',
     +      real(xsec),' nall= ',nall
*
*
*      normalize the histos
*
         write(6,*) 'Hz'//xxxx,nall2,' out of which: DIS jets= ',n2
         write(6,*) 'Hz'//xxxx,nall2g,' out of which: gam-prod jets= ',
     +   n2g
         if(nall2.gt.1) then
*
* now do the cross section normalisation
            call hopera(100,'+E',100,100,1./lum,0.)
            call hzhinfo(100,nev(100))
            call hopera(120,'+E',120,120,1./lum,0.)
            call hzhinfo(120,nev(120))
* now normalise histo with 1/binwidth
            call hzhinrm( 100, 0, 1., 1 )
            call hzhinrm( 120, 0, 1., 1 )
         endif
         if(nall2g.gt.1) then
*
* now do the cross section normalisation
            call hopera(1000,'+E',1000,1000,1./lum,0.)
            call hzhinfo(1000,nev(1000))
            call hopera(1020,'+E',1020,1020,1./lum,0.)
            call hzhinfo(1020,nev(1020))
            call hopera(1030,'+E',1030,1030,1./lum,0.)
            call hzhinfo(1030,nev(1030))
            call hopera(1040,'+E',1040,1040,1./lum,0.)
            call hzhinfo(1040,nev(1040))
* now normalise histo with 1/binwidth
            call hzhinrm( 1000, 0, 1., 1 )
            call hzhinrm( 1020, 0, 1., 1 )
            call hzhinrm( 1030, 0, 1., 1 )
            call hzhinrm( 1040, 0, 1., 1 )
         endif
*

      endif
*
      RETURN
      END
