*CMZ :  2.00/06 02/05/2002  15.07.33  by  Tancredi Carli
*CMZ :  2.00/02 17/01/2000  11.01.28  by  Tancredi Carli
*-- Author :    Tancredi Carli   17/01/2000
      subroutine HZ99091(IFLAG)

**********************************************************************
*Running: Ee=27.6, Ep=820, no polarization
*
*
* Arguments: iflag=1 initialisation
*            iflag=2 filling
*            iflag=3 termination
*
* written by: Carmen Tesch
*             Reimer Selle
*             Dirk Kruecker
*             Guido Nellen (nellen@mail.desy.de)
*********************************************************************
      IMPLICIT NONE
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
* --- subroutine-specific settings
*
      Integer iflag,ihep,i,j,k,l
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'99091'/
      save xxxx
      character*60 string

      Real pi,dpi,rd,ee,eb
      Logical evcuthq,evcutahq,lp,evcutbhq,evcutalq,evcutblq
      Integer iel,idum,id
      Parameter (pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.6)

* set the debug flag   lp
      Data lp/.false./
*      data lp/.true./

*---  counting variables
      Integer nentry
      Data nentry/0/

* --- kinematic variables
      Real x,y,q2,w2,obf,enel,ptel,thel,efwd,th,rap,pt,et,p
      Real phel,phpa,php,etp
      Real dth

* --- normalization var.
      Real xmi,xma,ymi,yma
      Integer nx,ny,nwt,loc,binahq,binbhq,binalq,binblq

      Character chtitl*80,rout*7
      data rout/'HIQ2ET'/

* --- var. related to cms-boost
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4),pcme(4)

* --- Et in central + photo frag. region
      real etcent,etfrag



*********************************************************************
*
*                      data points from H1
*
*********************************************************************

* ---  low Q2 selection a), 17 histograms (bins in x-Q2)
*       etlq: transversal Energy-flow
*	eetlq: stat. E-flow - Error
*	setlq: first only syst. Err., later stat+sys. E-flow-Error
*       etalq: pseudo-rapidity in CMS (x-coordinate binning for histos)

      Real xmin,xmax
      Integer nb,nbin
      Parameter (nb=24,xmin=-6.,xmax=6.,nbin=17)
      Real etlq1(nb),etlq2(nb),etlq3(nb),etlq4(nb),etlq5(nb)
      Real etlq6(nb),etlq7(nb),etlq8(nb),etlq9(nb),etlq10(nb)
      Real etlq11(nb),etlq12(nb),etlq13(nb),etlq14(nb),etlq15(nb)
      Real etlq16(nb),etlq17(nb)
      Real eetlq1(nb),eetlq2(nb),eetlq3(nb),eetlq4(nb),eetlq5(nb)
      Real eetlq6(nb),eetlq7(nb),eetlq8(nb),eetlq9(nb),eetlq10(nb)
      Real eetlq11(nb),eetlq12(nb),eetlq13(nb),eetlq14(nb),eetlq15(nb)
      Real eetlq16(nb),eetlq17(nb)
      Real setlq1(nb),setlq2(nb),setlq3(nb),setlq4(nb),setlq5(nb)
      Real setlq6(nb),setlq7(nb),setlq8(nb),setlq9(nb),setlq10(nb)
      Real setlq11(nb),setlq12(nb),setlq13(nb),setlq14(nb),setlq15(nb)
      Real setlq16(nb),setlq17(nb)

*
*     energy flow data in the 17 bins
*     note: systematic errors are not included
*
      Data  etlq1/0.000,0.000,0.000,0.000,0.000,0.000,0.862,1.111,0.000,
     &     0.000,1.684,1.894,1.999,1.916,1.844,1.858,1.814,2.085,
     &     1.743,1.462,1.080,0.459,0.232,0.033/
      Data eetlq1/0.000,0.000,0.000,0.000,0.000,0.000,0.046,0.057,0.000,
     &     0.000,0.107,0.113,0.119,0.122,0.136,0.166,0.139,0.175,
     &     0.126,0.103,0.087,0.048,0.036,0.008/
      Data  etlq2/0.000,0.000,0.000,0.000,0.000,0.000,0.879,1.032,0.000,
     &     0.000,1.604,1.809,2.027,1.860,1.856,1.874,1.863,1.842,
     &     1.750,1.383,0.873,0.388,0.108 ,0.018/
      Data eetlq2/0.000,0.000,0.000,0.000,0.000,0.000,0.038,0.045,0.000,
     &     0.000,0.089,0.094,0.105,0.102,0.112,0.127,0.122,0.120,
     &     0.105,0.085,0.064,0.037,0.016,0.004/
      Data  etlq3/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.980,1.010,
     &     0.000,1.444,1.728,1.811,2.072,1.893,1.764,1.788,1.574,
     &     1.578,1.072,0.637,0.222,0.078,0.000/
      Data eetlq3/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.058,0.059,
     &     0.000,0.186,0.124,0.129,0.150,0.148,0.148,0.156,0.143,
     &     0.129,0.096,0.069,0.032,0.015,0.000/
      Data  etlq4/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.873,
     &     1.385,0.000,1.525,1.578,1.736,1.741,1.820,1.510,
     &     1.585,1.235,0.821,0.388,0.096,0.036,0.000/
      Data eetlq4/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.072,
     &      0.101,0.000,0.154,0.135,0.151,0.159,0.172,0.155,0.154,
     &      0.116,0.098,0.058,0.019,0.010,0.001/
      Data  etlq5/0.000,0.000,0.000,0.000,0.000,0.000,0.953,1.046,0.000,
     &     0.000,1.675,1.827,2.111,1.822,2.099,1.872,1.837,2.155,
     &     2.084,1.717,0.949,0.455,0.143,0.037/
      Data eetlq5/0.000,0.000,0.000,0.000,0.000,0.000,0.054,0.050,0.000,
     &     0.000,0.120,0.132,0.155,0.141,0.171,0.167,0.164,0.187,
     &     0.175,0.146,0.096,0.063,0.026,0.010/
      Data  etlq6/0.000,0.000,0.000,0.000,0.000,0.000,0.878,1.096,0.000,
     &     0.000,1.604,1.759,1.890,1.814,1.869,2.092,1.958,1.857,
     &     1.946,1.620,0.751,0.335,0.087,0.027/
      Data eetlq6/0.000,0.000,0.000,0.000,0.000,0.000,0.046,0.061,0.000,
     &     0.000,0.104,0.099,0.108,0.110,0.126,0.160,0.141,0.133,
     &     0.131,0.110,0.061,0.039,0.015,0.007/
      Data  etlq7/0.000,0.000,0.000,0.000,0.000,0.000,0.000,1.040,1.098,
     &     0.000,0.000,1.782,1.862,1.838,1.782,1.999,1.998,2.081,
     &     1.636,1.207,0.553,0.174,0.056,0.000/
      Data eetlq7/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.051,0.053,
     &     0.000,0.000,0.109,0.110,0.107,0.111,0.132,0.140,0.142,
     &     0.112,0.091,0.051,0.020,0.010,0.000/
      Data  etlq8/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,1.087,
     &     1.270,0.000,0.000,1.652,1.688,1.788,1.614,1.980,
     &     1.637,1.700,0.783,0.265,0.096,0.027,0.001/
      Data eetlq8/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.068,
     &     0.079,0.000,0.000,0.126,0.134,0.136,0.139,0.185,0.143,
     &     0.148,0.074,0.032,0.017,0.007,0.000/
      Data  etlq9/0.000,0.000,0.000,0.000,0.000,0.000,0.916,1.292,0.000,
     &     0.000,1.858,1.983,2.044,1.949,2.183,2.216,2.277,2.186,
     &     2.130,1.842,1.034,0.438,0.134,0.033/
      Data eetlq9/0.000,0.000,0.000,0.000,0.000,0.000,0.019,0.027,0.000,
     &     0.000,0.039,0.042,0.045,0.048,0.059,0.064,0.068,0.060,
     &     0.054,0.050,0.033,0.017,0.007,0.003 /
      Data  etlq10/0.000,0.000,0.000,0.000,0.000,0.000,0.000,1.085,
     &     1.479,0.000,1.623,1.886,1.925,1.866,2.025,2.072,2.200,2.194,
     &     2.148,1.419,0.698,0.274,0.085,0.021/
      Data eetlq10/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.029,
     &     0.040,0.000,0.044,0.046,0.050,0.050,0.068,0.072,0.077,
     &     0.067,0.062,0.045,0.025,0.014,0.006,0.002/
      Data  etlq11/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.890,
     &     1.282, 0.000,0.000,1.735,1.940,1.900,1.926,2.024,2.079,2.031,
     &     1.847,1.086,0.467,0.160,0.048,0.010/
      Data eetlq11/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.021,
     &     0.028,0.000,0.000,0.041,0.046,0.048,0.054,0.060,0.061,0.058,
     &     0.053,0.033,0.018,0.008,0.004,0.001/
      Data  etlq12/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &     1.056,1.492,0.000,1.474,1.821,1.946,1.838,1.994,2.047,1.859,
     &     1.479,0.716,0.281,0.072,0.017,0.003/
      Data eetlq12/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &     0.037,0.053,0.000,0.052,0.057,0.064,0.064,0.072,0.074,0.065,
     &     0.055,0.029,0.015,0.005,0.002,0.001/
      Data  etlq13/0.000,0.000,0.000,0.000,0.000,0.000,0.925,1.260,
     &     0.000,0.000,1.853,2.062,2.124,2.088,2.387,2.432,2.567,2.569,
     &     2.483,1.583,0.892,0.346,0.099,0.028/
      Data eetlq13/0.000,0.000,0.000,0.000,0.000,0.000,0.018,0.025,
     &     0.000,0.000,0.037,0.043,0.044,0.046,0.059,0.065,0.069,0.063,
     &     0.062,0.039,0.026,0.014,0.006,0.002/
      Data  etlq14/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.976,
     &     1.322,0.000,1.613,1.863,2.055,2.063,2.145,2.347,2.357,
     &     2.337,1.980,1.102,0.473,0.152,0.040,0.011/
      Data eetlq14/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.029,
     &     0.040,0.000,0.049,0.041,0.046,0.049,0.057,0.065,0.068,0.065,
     &     0.052,0.031,0.016,0.007,0.003,0.001/
      Data  etlq15/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &     1.064,1.548,0.000,1.551,1.903,2.125,2.073,2.187,2.250,2.259,
     &     1.334,0.577,0.266,0.071,0.020,0.005/
      Data eetlq15/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.000,
     &     0.035,0.050,0.000,0.051,0.061,0.065,0.065,0.078,0.078,0.078,
     &     0.046,0.026,0.013,0.006,0.002,0.001/
      Data  etlq16/0.000,0.000,0.000,0.000,0.000,0.000,0.844,1.269,
     &     0.000,1.488,1.777,2.089,2.284,2.277,2.611,2.976,2.813,2.682,
     &     2.335,1.571,0.704,0.336,0.091,0.013/
      Data eetlq16/0.000,0.000,0.000,0.000,0.000,0.000,0.052,0.078,
     &     0.000,0.137,0.111,0.097,0.100,0.113,0.154,0.174,0.179,0.168,
     &     0.128,0.096,0.058,0.027,0.010,0.003/
      Data  etlq17/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.961,
     &     1.233,0.000,1.468,1.818,2.073,2.179,2.401,2.634,2.604,2.278,
     &     1.506,0.812,0.303,0.095,0.024,0.007/
      Data eetlq17/0.000,0.000,0.000,0.000,0.000,0.000,0.000,0.030,
     &     0.039,0.000,0.075,0.057,0.064,0.070,0.087,0.097,0.096,0.079,
     &     0.054,0.033,0.016,0.008,0.003,0.001/


* syst errors %
* plug up-dated to 32%
      Data setlq1/6*0. ,0.32,0.32,0.00,0.00,0.10,0.10,0.10,0.10,0.10
     &     ,0.10,0.10,0.10,0.10,0.17,0.21,0.22,0.22,0.22/
      Data setlq2/6*0. ,0.32,0.32,0.00,0.00,0.10,0.10,0.10,0.10,0.10
     &     ,0.10,0.10,0.10,0.10,0.14,0.18,0.21,0.22,0.22/
      Data setlq3/7*0. ,0.32,0.32,0.00,0.09,0.09,0.09,0.09,0.09,0.09
     &     ,0.09,0.09,0.09,0.11,0.13,0.14,0.16,0.17/
      Data setlq4/8*0. ,0.32,0.32,0.00,0.10,0.10,0.10,0.10,0.10
     &     ,0.10,0.10,0.10,0.11,0.12,0.12,0.12,0.12/
      Data setlq5/6*0. ,0.32,0.32,0.00,0.00,0.10,0.10,0.10,0.10,0.10
     &     ,0.10,0.10,0.10,0.10,0.16,0.21,0.22,0.22,0.22/
       Data setlq6/6*0. ,0.32,0.32,0.00,0.00,0.10,0.10,0.10,0.10,0.10
     &     ,0.10,0.10,0.10,0.10,0.13,0.16,0.19,0.21,0.21/
       Data setlq7/7*0. ,0.32,0.32,0.00,0.00,0.10,0.10,0.10,0.10,0.10
     &      ,0.10,0.10,0.10,0.12,0.13,0.12,0.12,0.12/
       Data setlq8/8*0. ,0.32,0.32,0.00,0.00,0.13,0.13,0.13,0.13
     &      ,0.13,0.13,0.13,0.14,0.13,0.13,0.14,0.13/
       Data setlq9/6*0. ,0.32,0.32,0.00,0.00,0.10,0.10,0.10,0.10,0.10
     &      ,0.10,0.10,0.10,0.11,0.15,0.18,0.20,0.21,0.21/
       Data setlq10/7*0.  ,0.32,0.32,0.00,0.09,0.09,0.09,0.09,0.09,0.09
     &      ,0.09,0.09,0.10,0.13,0.13,0.13,0.13,0.12/
       Data setlq11/7*0.  ,0.32,0.32,0.00,0.00,0.09,0.09,0.09,0.09,0.09
     &      ,0.09,0.09,0.10,0.11,0.09,0.09,0.09,0.09/
       Data setlq12/8*0.  ,0.32,0.32,0.00,0.10,0.10,0.10,0.10,0.10
     &      ,0.10,0.10,0.10,0.10,0.10,0.10,0.10,0.10/
       Data setlq13/6*0.  ,0.32,0.32,0.00,0.00,0.09,0.09,0.09,0.09,0.09
     &      ,0.09,0.09,0.09,0.11,0.13,0.14,0.15,0.16,0.17/
       Data setlq14/7*0.  ,0.32,0.32,0.00,0.09,0.09,0.09,0.09,0.09,0.09
     &      ,0.09,0.09,0.10,0.10,0.09,0.09,0.09,0.11/
       Data setlq15/8*0.  ,0.32,0.32,0.00,0.10,0.10,0.10,0.10,0.10
     &      ,0.10,0.10,0.10,0.10,0.10,0.10,0.10,0.10/
       Data setlq16/6*0.  ,0.32,0.32,0.00,0.09,0.09,0.10,0.09,0.09,0.10
     &      ,0.10,0.09,0.09,0.12,0.11,0.11,0.11,0.11,0.09/
       Data setlq17/7*0.  ,0.32,0.32,0.00,0.10,0.10,0.10,0.10,0.10,0.10
     &      ,0.10,0.10,0.10,0.10,0.10,0.10,0.10,0.10/

*
* low Q2 selection b), 5 histograms (bins in Q2, 0.3<y<0.5)
*	wetlq: transversal Energy-flow
*	weetlq: stat. E-flow - Error
*	wsetlq: stat+sys. E-flow-Error

      Real wxmin,wxmax
      Integer wnb,wnbin
      Parameter (wnb=14,wxmin=-1.,wxmax=6.,wnbin=7)

      Real wetlq2(wnb),wetlq3(wnb),wetlq4(wnb),wetlq5(wnb)
      Real wetlq6(wnb)
      Real weetlq2(wnb),weetlq3(wnb),weetlq4(wnb),weetlq5(wnb)
      Real weetlq6(wnb)
      Real wsetlq2(wnb),wsetlq3(wnb),wsetlq4(wnb),wsetlq5(wnb)
      Real wsetlq6(wnb)

      Data  wetlq2/1.421,1.593,1.752,1.698,1.622,1.805,1.626,1.792,
     &          1.706,1.445,1.001,0.493,0.179,0.029/
      Data weetlq2/0.075,0.081,0.089,0.088,0.098,0.128,0.102,0.118,
     &          0.098,0.082,0.066,0.041,0.022,0.006/
      Data  wetlq3/1.390,1.525,1.755,1.672,1.826,1.720,1.817,1.946,
     &          1.996,1.722,0.955,0.478,0.146,0.050/
      Data weetlq3/0.085,0.095,0.110,0.110,0.130,0.134,0.137,0.145,
     &          0.138,0.118,0.078,0.053,0.021,0.011/
      Data  wetlq4/1.651,1.748,1.862,1.846,2.003,2.075,2.131,2.105,
     &          2.097,1.846,1.029,0.459,0.140,0.040/
      Data weetlq4/0.038,0.040,0.045,0.050,0.060,0.064,0.068,0.061,
     &          0.057,0.052,0.035,0.019,0.008,0.004/
      Data  wetlq5/1.748,1.878,1.963,1.960,2.231,2.326,2.483,2.499,
     &          2.499,1.684,0.908,0.391,0.131,0.039/
      Data weetlq5/0.044,0.051,0.051,0.058,0.071,0.078,0.084,0.077,
     &          0.078,0.052,0.033,0.019,0.010,0.004/
      Data  wetlq6/1.709,1.919,2.194,1.932,2.691,2.843,2.858,2.701,
     &          2.282,1.705,0.769,0.420,0.120,0.016/
      Data weetlq6/0.139,0.121,0.133,0.126,0.215,0.213,0.234,0.238,
     &          0.166,0.142,0.085,0.042,0.018,0.005/

*correct systematic errors fixed W 2-5 in %
      Data wsetlq2/  0.10,0.10,0.10,0.10,0.10,0.10
     &     ,0.10,0.10,0.10,0.10,0.10,0.10,0.10,0.10/
      Data wsetlq3/  0.10,0.10,0.10,0.10,0.10,0.10
     &     ,0.10,0.10,0.10,0.10,0.10,0.10,0.10,0.10/
      Data wsetlq4/  0.10,0.10,0.10,0.10,0.10,0.10
     &     ,0.10,0.10,0.10,0.10,0.10,0.10,0.10,0.10/
      Data wsetlq5/  0.09,0.09,0.09,0.09,0.09,0.09
     &     ,0.09,0.09,0.09,0.09,0.09,0.09,0.09,0.09/
      Data wsetlq6/  0.09,0.09,0.09,0.10,0.09,0.09
     &     ,0.09,0.09,0.09,0.09,0.09,0.10,0.09,0.09/

* mean values of x,q2,W and the origin(breitframe)
* selection a)
      Real lqmx17(17),lqmq217(17),lqmobf17(17)

      Data lqmx17/0.00008,0.00014,0.00026,0.00057,0.00016,0.00027,
     &     0.0005,0.00108,0.00036,0.00063,0.00111,0.00226,0.00093,
     &     0.00207,0.00472,0.00203,0.00704/
      Data lqmq217/3.2,3.8,3.9,4.2,6.3,7.0,7.0,7.3,13.1,14.1,
     &     14.1,14.9,
     &     28.8,31.2,33.2,59.4,70.2/
      data lqmobf17/4.7167,4.43686,4.12728,3.73465,4.37009,4.10841,
     &     3.8002,3.40567,3.96452,3.68458,3.40567,3.03627,3.4897,
     &     3.08186,2.67774,3.1063,2.47741/

* selection b)
      Real lqmq25(5)
      Data lqmq25/3.5,7.,14.,30.,61./


*  Et vs Q2 for the central rap / the photon frag.
*  one histogram each, with 5 bins in Q2

*  etlqce:  transversal Energy-flow,     central rapidity region
*  eetlqce: stat. E-flow - Error,          "        "       "
*  setlqce: stat. + syst. E-flow - Error,  "        "       "
*	etlqfr: transversal Energy-flow,   photon fragmentation region
*	eetlqfr: stat. E-flow - Error,           "        "       "
*	setlqfr: stat. + syst. E-flow - Error,   "        "       "


      real qbinslq(6),etlqce(5),eetlqce(5),setlqce(5)
      real etlqfr(5),eetlqfr(5),setlqfr(5)

      data qbinslq/2.5,5.,10.,20.,50.,100./

      data etlqce/1.6725,1.64,1.805,1.9205,2.0565/
      data eetlqce/0.0601706,0.0736722,0.030104,0.0360624,0.0899027/
      data setlqce/0.177744,0.17938,0.182993,0.176567,0.205764/

      data etlqfr/1.709,1.8815,2.118,2.491,2.7795/
      data eetlqfr/0.0779872,0.0997422,0.0456755,0.0569759,0.166883/
      data setlqfr/0.187853,0.212953,0.216669,0.231317,0.300712/



* ---  high Q2 selection a), 7 histograms (bins in x-Q2)
*       ethq: transversal Energy-flow
*	eethq: stat. E-flow - Error
*	sethq: stat+sys. E-flow-Error
*       etahq: pseudo-rapidity in CMS (x-coordinate binning for histos)

      Real ethq1(13),ethq2(12),ethq3(9),ethq4(10),ethq5(11)
      Real ethq6(9 ),ethq7(9)
	
      Real eethq1(13),eethq2(12),eethq3(9),eethq4(10),eethq5(11)
      Real eethq6(9 ),eethq7(9)

      Real sethq1(13),sethq2(12),sethq3(9),sethq4(10),sethq5(11)
      Real sethq6(9 ),sethq7(9)

      Real etahq1(14),etahq2(13),etahq3(10),etahq4(11),etahq5(12)
      Real etahq6(10),etahq7(10)

*    number of bins for x-Q2-histogram nr. 1: nb1=14
      Data etahq1/-1.75, -1.0, -0.5, 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0,
     &           3.5,   4.0,  4.75,5.75/	
*    nb2=13
      Data etahq2/-1.75, -1.0, -0.5, 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.0,
     &           3.5, 4.25, 5.25/
*    nb3=10
      Data etahq3/-1.25,-0.5,0.0,0.5,1.0,1.5,2.25,3.25,4.25,5.25/
*    nb4=11
      Data etahq4/-1.5, -0.5, 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.25, 4.25,
     &          5.25/ 	
*    nb5=12
      Data etahq5/-1.75, -1.0, -0.5, 0.0, 0.5, 1.0, 1.5, 2.0, 2.5, 3.25,
     &           4.25, 5.25/	
*    nb6=10
      Data etahq6/-1.75, -1.0, -0.5, 0.0, 0.5, 1.0, 1.75, 2.75, 3.75,
     &           4.75/
*    nb7=10
      Data etahq7/-2.0, -1.5, -1.0, -0.5, 0.0, 0.5, 1.0, 2.0, 3.0, 4.0/

      Data  ethq1/.000,2.077,2.390,2.444,2.727,3.070,3.603,3.469,3.454,
     &     2.725,1.837, .754, .130/
      Data eethq1/.000, .040, .053, .057, .079, .099, .137, .122, .100,
     &     .075, .058, .027, .008/
      Data  ethq2/ .000,1.879,2.319,2.642,2.814,3.288,3.473,3.589,3.089,
     &     2.221,1.138, .246/
      Data eethq2/.000, .043, .047, .057, .091, .105, .108, .106, .081,
     &     .061, .033, .011/
      Data  ethq3/.000,1.821,2.260,2.681,2.718,3.032,2.289, .744,
     &     .000/
      Data eethq3 /.000, .051, .060, .079, .090, .073, .053, .029,
     &     .000/
      Data  ethq4/2.126,2.569,2.937,3.126,4.224,4.408,3.973,3.935,1.852,
     &     .000/
      Data eethq4/ .094, .119, .163, .255, .412, .354, .304, .220, .102,
     &     .000/
      Data  ethq5/.000,1.937,2.353,2.865,3.100,3.661,4.150,3.873,2.974,
     &     1.182, .000/
      Data eethq5/.000, .075, .078, .106, .130, .173, .196, .164, .098,
     &     .043, .000/
      Data  ethq6/.000, .000,1.861,2.389,2.902,3.231,2.532, .000, .000/
      Data eethq6/.000, .000, .078, .087, .125, .104, .079, .000, .000/
      Data  ethq7/.000, .000,2.062,2.436,2.777,3.472,4.246,3.273,1.497/
      Data eethq7/.000, .000, .156, .115, .140, .228, .178, .129, .084/
      Data sethq1/.000, .299, .232, .190, .228, .257, .300, .333, .265,
     &     .218, .159, .094, .024/
      Data sethq2/.000, .189, .148, .198, .220, .246, .273, .266, .254,
     &     .224, .167, .057/
      Data sethq3/ .000, .188, .154, .231, .276, .277, .322, .214,
     &     .000/
      Data sethq4/ .162, .391, .320, .360, .538, .484, .432, .382, .188,
     &     .000/
      Data sethq5/ .000, .197, .170, .221, .264, .312, .361, .351, .344,
     &           .212, .000/
      Data sethq6/ .000, .000, .219, .209, .345, .386, .440, .000, .000/
      Data sethq7/ .000, .000, .230, .210, .271, .405, .477, .405, .359/


* high Q2 selection b), 3 histograms (bins in Q2, W approx. const.)
*	wethq: transversal Energy-flow
*	weethq: stat. E-flow - Error
*	wsethq: stat+sys. E-flow-Error
*       wetahq: pseudo-rapidity in CMS (x-coordinate binning for histos)

      Real wethq1(13),wethq2(12),wethq3(13)
      Real weethq1(13),weethq2(12),weethq3(13)
      Real wsethq1(13),wsethq2(12),wsethq3(13)
      Real wetahq1(14),wetahq2(13),wetahq3(14)
*
*     energy flow data in the 5 bins
*     note: systematic errors are not included in weethq

      Data  wethq1/0.,1.96144,2.26067,2.39531,2.54628,2.92249,3.42234,
     &     3.48024,3.4375,2.60368,1.76196,0.708719,0./
      Data weethq1/0.,0.0453798,0.0658047,0.0692139,0.118844,0.112638,
     &     0.153131,0.13977,0.113641,0.084296,0.0656442,0.029105,0./
      Data  wethq2/0.,2.13422,2.4708,2.76255,2.95303,3.48934,3.75384,
     &     3.80795,3.16871,2.60493,1.31544,0.307483/
      Data weethq2/0.,0.0669379,0.0795785,0.10199,0.137484,0.200204,
     &     0.211435,0.196098,0.139574,0.112423,0.0584927,0.0201879/
      Data  wethq3/0.,0,2.41631,2.56516,2.96521,3.26279,4.10874,
     &     4.48665,4.10311,3.86765,2.49623,0.,0./
      Data weethq3/0.,0,0.114194,0.103008,0.14824,0.215506,0.288596,
     &     0.266768,0.205114,0.197455,0.109017,0.,0./
      Data wsethq1/0.,0.285369,0.224487,0.194103,0.23986,0.239587,
     &     0.2777,0.281172,0.260204,0.197213,0.156636,0.0873512,0/
      Data wsethq2/0.,0.31699,0.234723,0.223517,0.248444,0.331568,
     &     0.3606,0.326333,0.323294,0.209277,0.118246,0.0427787/
      Data wsethq3/0.,0.,0.229923,0.217818,0.253925,0.311768,0.415278,
     &     0.410218,0.350569,0.367516,0.245055,0.,0./

*    nwb1=14
      Data wetahq1/-1.75, -1.0, -0.5, 0.0, 0.5, 1.0, 1.5, 2.0, 2.5,
     &     3.0, 3.5, 4.0, 4.75, 5.75/
*     nwb2=13
      Data wetahq2/-1.75, -1.0, -0.5, 0.0, 0.5, 1.0, 1.5, 2.0,
     &     2.5, 3.0, 3.5, 4.25, 5.25/
*    nwb3=14
      Data wetahq3/-2., -1.5, -1.0, -0.5, 0.0, 0.5, 1.0, 1.5, 2.0,
     &     2.5, 3.0, 3.75, 4.75, 5.75/

*  special q2-binning for Et vs Q2 for the central rap / the photon frag.
*  one histogram each, with 3 bins in Q2

*  ethqce:  transversal Energy-flow,     central rapidity region
*  eethqce: stat. E-flow - Error,          "        "       "
*  sethqce: stat. + syst. E-flow - Error,  "        "       "

*  ethqfr: transversal Energy-flow,   photon fragmentation region
*  eethqfr: stat. E-flow - Error,           "        "       "
*  sethqfr: stat. + syst. E-flow - Error,   "        "       "


      real qbinshq(4),ethqce(3),eethqce(3),sethqce(3)
      real ethqfr(3),eethqfr(3),sethqfr(3)

      data qbinshq/100.,220.,400.,90364./

      data ethqce/2.321799,2.61668,2.76518/
      data sethqce/0.203661,0.219599,0.21855/
      data eethqce/0.0477515,0.0646819,0.0902576/

      data ethqfr/3.45887,3.48839,3.98538/
      data sethqfr/0.255431,0.301307,0.329475/
      data eethqfr/0.0900693,0.120349,0.142355/

* mean values of x,q2,W and the origin(breitframe)

      real hqmx7(7),hqmQ27(7),hqmOBF7(7),hqmQ23(3)


* selection a)
      data hqmx7/0.0043,0.01,0.026,0.012,0.026,0.076,0.11/
      data hqmQ27/175.,253.,283.,511.,617.,682.,2200./
      data hqmobf7/2.74,2.34,1.88,2.19,1.84,1.31,1.15/

* selection b)
      data hqmQ23/191.,294.,1103./


*********************************************************************
*
*                      Initialization
*
*********************************************************************

      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file

       Call hcdir('//PAWC',' ')
       call hmdir(xxxx,'S')

       Call hcdir('//HISTO',' ')
       call hmdir(xxxx,'S')

*-------------------*
* low Q2 selection *
*-------------------*
* calc total errors out of stat. and syst. errors
       Do i=1,nb
          setlq1(i)=etlq1(i)*setlq1(i)
          setlq1(i)=sqrt(eetlq1(i)**2+setlq1(i)**2)
          setlq2(i)=etlq2(i)*setlq2(i)
          setlq2(i)=sqrt(eetlq2(i)**2+setlq2(i)**2)
          setlq3(i)=etlq3(i)*setlq3(i)
          setlq3(i)=sqrt(eetlq3(i)**2+setlq3(i)**2)
          setlq4(i)=etlq4(i)*setlq4(i)
          setlq4(i)=sqrt(eetlq4(i)**2+setlq4(i)**2)
          setlq5(i)=etlq5(i)*setlq5(i)
          setlq5(i)=sqrt(eetlq5(i)**2+setlq5(i)**2)
          setlq6(i)=etlq6(i)*setlq6(i)
          setlq6(i)=sqrt(eetlq6(i)**2+setlq6(i)**2)
          setlq7(i)=etlq7(i)*setlq7(i)
          setlq7(i)=sqrt(eetlq7(i)**2+setlq7(i)**2)
          setlq8(i)=etlq8(i)*setlq8(i)
          setlq8(i)=sqrt(eetlq8(i)**2+setlq8(i)**2)
          setlq9(i)=etlq9(i)*setlq9(i)
          setlq9(i)=sqrt(eetlq9(i)**2+setlq9(i)**2)
          setlq10(i)=etlq10(i)*setlq10(i)
          setlq10(i)=sqrt(eetlq10(i)**2+setlq10(i)**2)
          setlq11(i)=etlq11(i)*setlq11(i)
          setlq11(i)=sqrt(eetlq11(i)**2+setlq11(i)**2)
          setlq12(i)=etlq12(i)*setlq12(i)
          setlq12(i)=sqrt(eetlq12(i)**2+setlq12(i)**2)
          setlq13(i)=etlq13(i)*setlq13(i)
          setlq13(i)=sqrt(eetlq13(i)**2+setlq13(i)**2)
          setlq14(i)=etlq14(i)*setlq14(i)
          setlq14(i)=sqrt(eetlq14(i)**2+setlq14(i)**2)
          setlq15(i)=etlq15(i)*setlq15(i)
          setlq15(i)=sqrt(eetlq15(i)**2+setlq15(i)**2)
          setlq16(i)=etlq16(i)*setlq16(i)
          setlq16(i)=sqrt(eetlq16(i)**2+setlq16(i)**2)
          setlq17(i)=etlq17(i)*setlq17(i)
          setlq17(i)=sqrt(eetlq17(i)**2+setlq17(i)**2)
       enddo

       Do i=1,wnb
          wsetlq2(i)=wetlq2(i)*wsetlq2(i)
          wsetlq2(i)=sqrt(weetlq2(i)**2+wsetlq2(i)**2)
          wsetlq3(i)=wetlq3(i)*wsetlq3(i)
          wsetlq3(i)=sqrt(weetlq3(i)**2+wsetlq3(i)**2)
          wsetlq4(i)=wetlq4(i)*wsetlq4(i)
          wsetlq4(i)=sqrt(weetlq4(i)**2+wsetlq4(i)**2)
          wsetlq5(i)=wetlq5(i)*wsetlq5(i)
          wsetlq5(i)=sqrt(weetlq5(i)**2+wsetlq5(i)**2)
          wsetlq6(i)=wetlq6(i)*wsetlq6(i)
          wsetlq6(i)=sqrt(weetlq6(i)**2+wsetlq6(i)**2)
       enddo


* booking histos
* selection a)

       Do i=1,nbin
          write(string,'(A,I2)') '1/N dEt/d[c] CMS x-Q2-bin nr. ',i
          call hbook1(-i,string,nb,xmin,xmax, 0.)
          call hbook1(i,string,nb,xmin,xmax, 0.)
          write(string,'(A,I2,A)') '1/N dEt/d[c] CMS x-Q2-bin nr. ',i
     &         ,' stat. err. only'
          call hbook1(-100-i,string,nb,xmin,xmax, 0.)
       enddo

       call hbprof(-31,'mean x vs. x-Q2-bin, no err.',17,0.5,17.5,
     &      -1.E30,1.E30,' ')
       call hbprof( 31,'mean x vs. x-Q2-bin',17,0.5,17.5,
     &      -1.E30,1.E30,' ')
       call hbprof(-32,'mean Q2 vs. x-Q2-bin, no err.',17,0.5,17.5,
     &      -1.E30,1.E30,' ')
       call hbprof( 32,'mean Q2 vs. x-Q2-bin',17,0.5,17.5,
     &      -1.E30,1.E30,' ')
       call hbprof(-33,'mean origin(breitframe) vs. x-Q2-bin, no err.'
     &      ,17,0.5,17.5,-1.E30,1.E30,' ')
       call hbprof( 33,'mean origin(breitframe) vs. x-Q2-bin'
     &      ,17,0.5,17.5,-1.E30,1.E30,' ')	
       call hbook1(35,'number of events vs. x-Q2-bin',17,0.5,17.5, 0.)


       call hbarx(31)
       call hbarx(32)
       call hbarx(33)


* ---- pack data into histograms ; 17 bins
*      histos with full errors
       Call hpak (-1,etlq1)
       Call hpake(-1,setlq1)
       Call hpak (-2,etlq2)
       Call hpake(-2,setlq2)
       Call hpak (-3,etlq3)
       Call hpake(-3,setlq3)
       Call hpak (-4,etlq4)
       Call hpake(-4,setlq4)
       Call hpak (-5,etlq5)
       Call hpake(-5,setlq5)
       Call hpak (-6,etlq6)
       Call hpake(-6,setlq6)
       Call hpak (-7,etlq7)
       Call hpake(-7,setlq7)
       Call hpak (-8,etlq8)
       Call hpake(-8,setlq8)
       Call hpak (-9,etlq9)
       Call hpake(-9,setlq9)
       Call hpak (-10,etlq10)
       Call hpake(-10,setlq10)
       Call hpak (-11,etlq11)
       Call hpake(-11,setlq11)
       Call hpak (-12,etlq12)
       Call hpake(-12,setlq12)
       Call hpak (-13,etlq13)
       Call hpake(-13,setlq13)
       Call hpak (-14,etlq14)
       Call hpake(-14,setlq14)
       Call hpak (-15,etlq15)
       Call hpake(-15,setlq15)
       Call hpak (-16,etlq16)
       Call hpake(-16,setlq16)
       Call hpak (-17,etlq17)
       Call hpake(-17,setlq17)

* ---- histos with stat errors only
       Call hpak (-101,etlq1)
       Call hpake(-101,eetlq1)
       Call hpak (-102,etlq2)
       Call hpake(-102,eetlq2)
       Call hpak (-103,etlq3)
       Call hpake(-103,eetlq3)
       Call hpak (-104,etlq4)
       Call hpake(-104,eetlq4)
       Call hpak (-105,etlq5)
       Call hpake(-105,eetlq5)
       Call hpak (-106,etlq6)
       Call hpake(-106,eetlq6)
       Call hpak (-107,etlq7)
       Call hpake(-107,eetlq7)
       Call hpak (-108,etlq8)
       Call hpake(-108,eetlq8)
       Call hpak (-109,etlq9)
       Call hpake(-109,eetlq9)
       Call hpak (-110,etlq10)
       Call hpake(-110,eetlq10)
       Call hpak (-111,etlq11)
       Call hpake(-111,eetlq11)
       Call hpak (-112,etlq12)
       Call hpake(-112,eetlq12)
       Call hpak (-113,etlq13)
       Call hpake(-113,eetlq13)
       Call hpak (-114,etlq14)
       Call hpake(-114,eetlq14)
       Call hpak (-115,etlq15)
       Call hpake(-115,eetlq15)
       Call hpak (-116,etlq16)
       Call hpake(-116,eetlq16)
       Call hpak (-117,etlq17)
       Call hpake(-117,eetlq17)


* ---- histos with no error
       call hpak (-31,lqmx17)
       call hpak (-32,lqmq217)
       call hpak (-33,lqmobf17)

       call hbarx(31)
       call hbarx(32)
       call hbarx(33)


* selection b)

       Do i=1,5
          write(string,'(A,I2)') '1/N dEt/d[c] CMS Q2-bin nr. ',i
          call hbook1(-i-20,string,wnb,wxmin,wxmax, 0.)
          call hbook1(i+20,string,wnb,wxmin,wxmax, 0.)
          write(string,'(A,I2,A)') '1/N dEt/d[c] CMS Q2-bin nr. '
     &         ,i,' stat. err. only'
          call hbook1(-120-i,string,wnb,wxmin,wxmax, 0.)
       enddo

       string='1/N dEt/d[c] CMS for -0.5"o#[c]"o#0.5 vs Q2'
       call hbookb(-26,string,5,qbinslq,0.)
       call hbookb(26,string,5,qbinslq,0.)
       write(string,'(A,A)') '1/N dEt/d[c] CMS for -0.5"o#[c]"o#0.5',
     &      'vs Q2, stat. err. only'
       call hbookb(-126,string,5,qbinslq,0.)

       string='1/N dEt/d[c] CMS for 2"o#[c]"o#3 vs Q2'
       call hbookb(-27,string,5,qbinslq,0.)
       call hbookb(27,string,5,qbinslq,0.)
       string='1/N dEt/d[c] CMS for 2"o#[c]"o#3 vs Q2, stat. err. only'
       call hbookb(-127,string,5,qbinslq,0.)

       call hbprof(-34,'mean Q2 vs. Q2-bin,no errors',5,0.5,5.5,
     &      -1.E30,1.E30,' ')
       call hbprof( 34,'mean Q2 vs. Q2-bin',5,0.5,5.5,
     &      -1.E30,1.E30,' ')
       call hbook1(36,'number of events vs. Q2-bin',5,0.5,5.5,0.)

       call hbarx(26)
       call hbarx(27)

       call hbarx(34)

* histos with total errors
       Call hpak (-21,wetlq2)
       Call hpake(-21,wsetlq2)
       Call hpak (-22,wetlq3)
       Call hpake(-22,wsetlq3)
       Call hpak (-23,wetlq4)
       Call hpake(-23,wsetlq4)
       Call hpak (-24,wetlq5)
       Call hpake(-24,wsetlq5)
       Call hpak (-25,wetlq6)
       Call hpake(-25,wsetlq6)

       Call hpak (-26,etlqce)
       Call hpake(-26,setlqce)
       Call hpak (-27,etlqfr)
       Call hpake(-27,setlqfr)

* histos with stat. errors only
       Call hpak (-121,wetlq2)
       Call hpake(-121,weetlq2)
       Call hpak (-122,wetlq3)
       Call hpake(-122,weetlq3)
       Call hpak (-123,wetlq4)
       Call hpake(-123,weetlq4)
       Call hpak (-124,wetlq5)
       Call hpake(-124,weetlq5)
       Call hpak (-125,wetlq6)
       Call hpake(-125,weetlq6)

       Call hpak (-126,etlqce)
       Call hpake(-126,eetlqce)
       Call hpak (-127,etlqfr)
       Call hpake(-127,eetlqfr)

* histos with no errors
       call hpak (-34,lqmq25)

*-------------------*
* high Q2 selection *
*-------------------*
* booking the histos for selection a), which uses 7 x-Q2-bins

       string='1/N dEt/d[c] CMS x-Q2-bin nr. 1'
       call hbookb(-41,string,13,etahq1,0.)
       call hbookb(41,string,13,etahq1,0.)
       string='1/N dEt/d[c] CMS x-Q2-bin nr. 1, stat. err. only'
       call hbookb(-141,string,13,etahq1,0.)

       string='1/N dEt/d[c] CMS x-Q2-bin nr. 2'
       call hbookb(-42,string,12,etahq2,0.)
       call hbookb(42,string,12,etahq2,0.)
       string='1/N dEt/d[c] CMS x-Q2-bin nr. 2, stat. err. only'
       call hbookb(-142,string,12,etahq2,0.)

       string='1/N dEt/d[c] CMS x-Q2-bin nr. 3'
       call hbookb(-43,string,9,etahq3,0.)
       call hbookb(43,string,9,etahq3,0.)
       string='1/N dEt/d[c] CMS x-Q2-bin nr. 3, stat. err. only'
       call hbookb(-143,string,9,etahq3,0.)

       string='1/N dEt/d[c] CMS x-Q2-bin nr. 4'
       call hbookb(-44,string,10,etahq4,0.)
       call hbookb(44,string,10,etahq4,0.)
       string='1/N dEt/d[c] CMS x-Q2-bin nr. 4, stat. err. only'
       call hbookb(-144,string,10,etahq4,0.)

       string='1/N dEt/d[c] CMS x-Q2-bin nr. 5'
       call hbookb(-45,string,11,etahq5,0.)
       call hbookb(45,string,11,etahq5,0.)
       string='1/N dEt/d[c] CMS x-Q2-bin nr. 5, stat. err. only'
       call hbookb(-145,string,11,etahq5,0.)

       string='1/N dEt/d[c] CMS x-Q2-bin nr. 6'
       call hbookb(-46,string,9,etahq6,0.)
       call hbookb(46,string,9,etahq6,0.)
       string='1/N dEt/d[c] CMS x-Q2-bin nr. 6, stat. err. only'
       call hbookb(-146,string,9,etahq6,0.)

       string='1/N dEt/d[c] CMS x-Q2-bin nr. 7'
       call hbookb(-47,string,9,etahq7,0.)
       call hbookb(47,string,9,etahq7,0.)
       string='1/N dEt/d[c] CMS x-Q2-bin nr. 7, stat. err. only'
       call hbookb(-147,string,9,etahq7,0.)

       call hbprof(-61,'mean x vs. x-Q2-bin, no err.',7,0.5,7.5,
     &      -1.E30,1.E30,' ')
       call hbprof( 61,'mean x vs. x-Q2-bin',7,0.5,7.5,
     &      -1.E30,1.E30,' ')
       call hbprof(-62,'mean Q2 vs. x-Q2-bin, no err.',7,0.5,7.5,
     &      -1.E30,1.E30,' ')
       call hbprof( 62,'mean Q2 vs. x-Q2-bin',7,0.5,7.5,
     &      -1.E30,1.E30,' ')
       call hbprof(-63,'mean origin(breitframe) vs. x-Q2-bin, no err.'
     &      ,7,0.5,7.5,-1.E30,1.E30,' ')
       call hbprof( 63,'mean origin(breitframe) vs. x-Q2-bin'
     &      ,7,0.5,7.5,-1.E30,1.E30,' ')	
       call hbook1(65,'number of events vs. x-Q2-bin',7,0.5,7.5,0.)

       call hbarx(61)
       call hbarx(62)
       call hbarx(63)


* fill the data histos for selection a)
* histos with full errors
       Call hpak (-41,ethq1)
       Call hpake(-41,sethq1)
       Call hpak (-42,ethq2)
       Call hpake(-42,sethq2)
       Call hpak (-43,ethq3)
       Call hpake(-43,sethq3)
       Call hpak (-44,ethq4)
       Call hpake(-44,sethq4)
       Call hpak (-45,ethq5)
       Call hpake(-45,sethq5)
       Call hpak (-46,ethq6)
       Call hpake(-46,sethq6)
       Call hpak (-47,ethq7)
       Call hpake(-47,sethq7)

* histos with only statistical errors
       Call hpak (-141,ethq1)
       Call hpake(-141,eethq1)
       Call hpak (-142,ethq2)
       Call hpake(-142,eethq2)
       Call hpak (-143,ethq3)
       Call hpake(-143,eethq3)
       Call hpak (-144,ethq4)
       Call hpake(-144,eethq4)
       Call hpak (-145,ethq5)
       Call hpake(-145,eethq5)
       Call hpak (-146,ethq6)
       Call hpake(-146,eethq6)
       Call hpak (-147,ethq7)
       Call hpake(-147,eethq7)

* histos with no errors
       call hpak(-61,hqmx7)
       call hpak(-62,hqmQ27)
       call hpak(-63,hqmobf7)

* booking the histos concerning selection b)
       string='1/N dEt/d[c] CMS Q2-bin nr. 1'
       call hbookb(-51,string,13,wetahq1,0.)
       call hbookb(51,string,13,wetahq1,0.)
       string='1/N dEt/d[c] CMS Q2-bin nr. 1, stat err. only'
       call hbookb(-151,string,13,wetahq1,0.)

       string='1/N dEt/d[c] CMS Q2-bin nr. 2'
       call hbookb(-52,string,12,wetahq2,0.)
       call hbookb(52,string,12,wetahq2,0.)
       string='1/N dEt/d[c] CMS Q2-bin nr. 2, stat err. only'
       call hbookb(-152,string,12,wetahq2,0.)

       string='1/N dEt/d[c] CMS Q2-bin nr. 3'
       call hbookb(-53,string,13,wetahq3,0.)
       call hbookb(53,string,13,wetahq3,0.)
       string='1/N dEt/d[c] CMS Q2-bin nr. 3, stat err. only'
       call hbookb(-153,string,13,wetahq3,0.)

       string='1/N dEt/d[c] CMS for -0.5"o#[c]"o#=0.5 vs Q2'
       call hbookb(-54,string,3,qbinshq,0.)
       call hbookb(54,string,3,qbinshq,0.)
       string='1/N dEt/d[c] CMS for -0.5"0#[c]"o#0.5 vs Q2,
     &      stat. err. only'
       call hbookb(-154,string,3,qbinshq,0.)

       string='1/N dEt/d[c] CMS for 2"o#[c]"o#3 vs Q2'
       call hbookb(-55,string,3,qbinshq,0.)
       call hbookb(55,string,3,qbinshq,0.)
       string='1/N dEt/d[c] CMS for 2"o#[c]"o#3 vs Q2, stat. err. only'
       call hbookb(-155,string,3,qbinshq,0.)

       call hbprof(-64,'mean Q2 vs. Q2-bin,no errors',3,0.5,3.5,
     &      -1.E30,1.E30,' ')
       call hbprof( 64,'mean Q2 vs. Q2-bin',3,0.5,3.5,
     &      -1.E30,1.E30,' ')
       call hbook1(66,'number of events vs. Q2-bin',3,0.5,3.5,0.)

       call hbarx(54)
       call hbarx(55)
       call hbarx(64)


* fill the data histos
* histos with full errors
       Call hpak (-51,wethq1)
       Call hpake(-51,wsethq1)
       Call hpak (-52,wethq2)
       Call hpake(-52,wsethq2)
       Call hpak (-53,wethq3)
       Call hpake(-53,wsethq3)
       Call hpak (-54,ethqce)
       Call hpake(-54,sethqce)
       Call hpak (-55,ethqfr)
       Call hpake(-55,sethqfr)

* histos with only stat. errors
       Call hpak (-151,wethq1)
       Call hpake(-151,weethq1)
       Call hpak (-152,wethq2)
       Call hpake(-152,weethq2)
       Call hpak (-153,wethq3)
       Call hpake(-153,weethq3)
       Call hpak (-154,ethqce)
       Call hpake(-154,eethqce)
       Call hpak (-155,ethqfr)
       Call hpake(-155,eethqfr)

* ---- histos with no errors
       call hpak(-64,hqmQ23)

* ---- book histos that contain crossection/number of gen. events
       call hbook1(71,'gen. crossection',1,0.,1.,0.)
       call hbook1(72,'gen. number of events',1,0.,1.,0.)


* ---- book dummy histgrams, that help in the Et-calculation
       do i=1,17
          call hcopy(i,1000+i,' ')
       enddo
       do i=1,5
          call hcopy(20+i,1020+i,' ')
       enddo
       do i=1,7
          call hcopy(40+i,1040+i,' ')
       enddo
       do i=1,3
          call hcopy(50+i,1050+i,' ')
       enddo


*********************************************************************
*
*                      Event Processing
*
*********************************************************************

      elseif (iflag.eq.2) then


* filling: The following MUST always be done
* (i) move to the correct sub-directory in PAWC
         call hcdir('//PAWC/'//xxxx,' ')



* get kinematic variables
         q2=real(HZDISKIN(1))
         x =real(HZDISKIN(2))
         y =real(HZDISKIN(3))
         w2=real(HZDISKIN(4))
         obf=log(1/x-1)/2

         if (lp) write(6,*) 'Hz'//xxxx, ' x= ',x,
     &       ' Q2 ',q2,' y= ',y,' w2= ',w2,'O(BF)=',obf,' wtx= ',wtx

* ------ get electron variables
         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(6,*) 'Hz'//xxxx,' electron not found '
            goto 9990
         endif
         enel=real(PHEP(4,iel))
         thel=real(HZPHMANG(PHEP(3,iel),
     &        sqrt(PHEP(1,iel)**2+PHEP(2,iel)**2)))*rd

         if (lp) write(6,*) 'Hz'//xxxx,
     &        ' enel= ',enel,'GeV',' thel= ',thel,'Degrees'


* ----- calculate forward energy
         efwd=0.
         Do ihep=1,nhep
            if (isthep(ihep).eq.1.and.ihep.ne.iel) then
               th=real(HZPHMANG(PHEP(3,ihep),
     &              sqrt(PHEP(1,ihep)**2+PHEP(2,ihep)**2)))*rd
               if(th.gt.4.4.and.th.lt.15.) then
                  efwd=real(PHEP(4,ihep))+efwd
               endif
            endif
         enddo

         if (lp) write(6,*) 'Hz'//xxxx,
     &        ' efwd= ',efwd


*------ calc. flag for selection
*        evcutalq = low Q2 selection a)
*        evcutblq = low Q2 selection b)
*        evcutahq = high Q2 selection a)
*        evcutbhq = high Q2 selection b) (w ~185 GeV)

         evcutalq= enel.gt.12.
         evcutalq= (thel.gt.157.).and.(thel.lt.176.0).and. evcutalq
         evcutalq= (w2.ge.4400.).and. evcutalq
         evcutalq = evcutalq.and.(efwd.gt.0.5)

         evcutblq= enel.gt.12.
         evcutblq= y.gt.0.3 .and. y.lt.0.5 .and. evcutblq

         evcutahq= thel.gt.12. .and. thel.lt.150.0
         evcutahq= (y.gt.0.05).and.(y.lt.0.6).and.evcutahq
         evcutahq= w2.ge.4400..and. evcutahq
         evcutahq = evcutahq.and.(efwd.gt.0.5)

         evcutbhq= thel.gt.12. .and. thel.lt.150.0
         evcutbhq= (y.gt.0.05).and.(y.lt.0.6).and.evcutbhq
         evcutbhq= w2.gt.27110. .and. w2.lt.45182. .and. evcutbhq

         if (lp) then
            write(6,*) ' evcutalq= ',evcutalq
            write(6,*) ' evcutblq= ',evcutblq
            write(6,*) ' evcutahq= ',evcutahq
            write(6,*) ' evcutbhq= ',evcutbhq
         endif

* ------ early event skip?
         if (.not.(evcutalq.or.evcutblq.or.evcutahq.or.evcutbhq)) then
            goto 9990
         endif

* ------ find the bin numbers
*        low Q2 selection a), x-Q2 bins
         binalq = 0
         if(q2.gt.2.5.and.q2.le.5.) then
            if(x.gt.0.00005.and.x.le.0.0001) binalq=1
            if(x.gt.0.0001.and.x.le.0.0002) binalq=2
            if(x.gt.0.0002.and.x.le.0.00035) binalq=3
            if(x.gt.0.00035.and.x.le.0.0010) binalq=4
         elseif(q2.gt.5..and.q2.le.10.) then
            if(x.gt.0.0001.and.x.le.0.0002) binalq=5
            if(x.gt.0.0002.and.x.le.0.00035) binalq=6
            if(x.gt.0.00035.and.x.le.0.0007) binalq=7
            if(x.gt.0.0007.and.x.le.0.0020) binalq=8
         elseif(q2.gt.10..and.q2.le.20.) then
            if(x.gt.0.0002.and.x.le.0.0005) binalq=9
            if(x.gt.0.0005.and.x.le.0.0008) binalq=10
            if(x.gt.0.0008.and.x.le.0.0015) binalq=11
            if(x.gt.0.0015.and.x.le.0.040) binalq=12
         elseif(q2.gt.20..and.q2.le.50.) then
            if(x.gt.0.0005.and.x.le.0.0014) binalq=13
            if(x.gt.0.0014.and.x.le.0.0030) binalq=14
            if(x.gt.0.0030.and.x.le.0.0100) binalq=15
         elseif(q2.gt.50..and.q2.le.100.) then
            if(x.gt.0.0008.and.x.le.0.0030) binalq=16
            if(x.gt.0.0030.and.x.le.0.0200) binalq=17
         endif

         if (lp) write(6,*) 'Hz'//xxxx,'binalq=',binalq
         if (binalq.eq.0) then
            evcutalq=.false.
         endif

* ------ low Q2 selection b), Q2 bins
         binblq = 0
         if(q2.gt.2.5.and.q2.le.5.) binblq=1
         if(q2.gt.5..and.q2.le.10.) binblq=2
         if(q2.gt.10..and.q2.le.20.) binblq=3
         if(q2.gt.20..and.q2.le.50.) binblq=4
         if(q2.gt.50..and.q2.le.100.) binblq=5

         if (lp) write(6,*) 'Hz'//xxxx,'binblq=',binblq
         if (binblq.eq.0) then
            evcutblq=.false.
         endif

* ------ high Q2 selection a), x-Q2 bins
         binahq=0
         if (evcutahq) then
            if(q2.gt.100..and.q2.le.400.) then
               if(x.gt.0.00251.and.x.le.0.00631) binahq=1
               if(x.gt.0.00631.and.x.le.0.0158) binahq=2
               if(x.gt.0.0158.and.x.le.0.0398) binahq=3
            elseif(q2.gt.400.and.q2.le.1100.) then
               if(x.gt.0.00631.and.x.le.0.0158) binahq=4
               if(x.gt.0.0158.and.x.le.0.0398) binahq=5
               if(x.gt.0.0398.and.x.le.1.) binahq=6
            elseif(q2.gt.1100..and.q2.le.100000.) then
               if(x.gt.0..and.x.le.1.) binahq=7
            endif
         endif

         if (lp) then
            write(6,*) ' binahq= ',binahq
         endif
         if (binahq.eq.0) then
            evcutahq=.false.
         endif

* ------ high Q2 selection b), Q2 bins
         binbhq=0
         if (evcutbhq) then
            if(q2.gt.100..and.q2.le.220.) then
               binbhq=1
            elseif(q2.gt.220..and.q2.le.400.) then
               binbhq=2
            elseif(q2.gt.400.) then
               binbhq=3
            endif
         endif

         if (lp) then
            write(6,*) ' binbhq= ',binbhq
       endif
       if (binbhq.eq.0) then
          evcutbhq=.false.
       endif

* ------ early event skip?
       if (.not.(evcutalq.or.evcutblq.or.evcutahq.or.evcutbhq)) then
          goto 9990
       endif

* ----- 'pre-check' for generated events
       ierr=HZIBEAM(ibeam,idum)
       if (.not.(ierr.eq.1)) then
          write(6,*) 'HZ'//xxxx,' beams not found ! '
          goto 9990
       else
          Do i=1,4
             pbeam(i)=PHEP(i,IBEAM)
          enddo
       endif

       if (lp) write(6,*) ' pbeam= ',pbeam

       eb=real(PHEP(4,idum))
       if (abs(abs(eb)-ee).gt.0.2) then
          if (nentry.lt.10) then
             write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,'  ! '
          elseif (nentry.eq.10) then
             write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     &            ' ...last message ! '
          endif
          goto 9990
       endif

       if (lp) write(6,*) ' eb= ',eb

       ierr=HZIPGAM(ph)
       if (ierr.eq.-1) then
          write(6,*) 'HZ'//xxxx,' boson vector not found ! '
          goto 9990
       else
          Do i=1,4
             pgam(i)=ph(i)
          enddo
       endif

       if (lp) write(6,*) ' pgam= ',pgam

* ----- initialize boost to cms
       call HZHCMINI(pbeam,pgam,ierr)
       if (ierr.eq.-1) then
          write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
          goto 9990
       endif

       if (lp) write(6,*) ' nhep= ',nhep,' iel= ',iel


* ---- reset all quantities needed to calc. Et flow for one event
       etcent=0
       etfrag=0

       if (evcutalq) then
          call hreset(binalq+1000,' ')
       endif
       if (evcutblq) then
          call hreset(binblq+1020,' ')
       endif
       if (evcutahq) then
         call hreset(binahq+1040,' ')
       endif
       if (evcutbhq) then
          call hreset(binbhq+1050,' ')
       endif

* ---- loop over all particles of the haronic final state
       do 2000 ihep=1,nhep

* ------- skip unstable particles (they represent additional information and NOT
*         particles of the hadronic final state) and the scat. el.
          if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 2000

* ------- transform 4vec of particle into CMS (4vec CMS: pcm)
          Do i=1,4
             Phc(i)=PHEP(i,ihep)
          enddo
          call HZHCM(phc,pcm,ierr)
          if (ierr.eq.-1) then
             write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
             goto 9990
          endif

* ------- calc. transverse energy (et) for the particle
          p      = real(sqrt(pcm(1)**2+pcm(2)**2+pcm(3)**2 ))
          pt     = real(sqrt( pcm(1)**2+pcm(2)**2 ))
          if (p.eq.0.) then
             write(6,*) xxxx,' p(',ihep,') = ',p
             goto 2000
          endif
          et     = real(pcm(4)) * pt / p


* ------- calc. pseudorapidity of particle
          th     = (acos(real(pcm(3))/p))
          if (abs(     th*rd).lt.1.e-4 .or.
     &         abs(180.-th*rd).lt.1.e-4 ) then
             goto 2000
          else
             rap    = -log(tan( th/2. ))
          endif

          if (lp) write(6,*) 'Hz'//xxxx,
     &         'lab: et,pt,rap,th ',et,pt,rap,th*rd

* -------- sum Et central rap./photon frag. region
          if (rap.gt.-0.5.and.rap.lt.0.5) then
             etcent=etcent+et
          endif
          if (rap.gt.2.0.and.rap.le.3.0) then
             etfrag=etfrag+et
          endif

* -------- sum Et for low/high Q2 sel. a)/b)
          if (evcutalq) then
             call hf1(1000+binalq, rap, et)
          endif
          if (evcutblq) then
             call hf1(1020+binblq, rap, et)
          endif
          if (evcutahq) then
             call hf1(1040+binahq, rap, et)
          endif
          if (evcutbhq) then
             call hf1(1050+binbhq, rap, et)
          endif

 2000  continue

* --- fill all histogramms concerning the whole event

       if (evcutalq) then
          call h9091fil(binalq,1000+binalq,wtx)
          call hfill(31,real(binalq),x,wtx)
          call hfill(32,real(binalq),q2,wtx)
          call hfill(33,real(binalq),obf,wtx)
          call hf1(35,real(binalq),wtx)
       endif
       if (evcutblq) then
          call h9091fil(20+binblq,1020+binblq,wtx)
          call hzmeanhi(26,dble(q2),dble(etcent),wtx)
          call hzmeanhi(27,dble(q2),dble(etfrag),wtx)
          call hfill(34,real(binblq),q2,wtx)
          call hf1(36,real(binblq),wtx)
       endif
       if (evcutahq) then
          call h9091fil(40+binahq,1040+binahq,wtx)
          call hfill(61,real(binahq),x,wtx)
          call hfill(62,real(binahq),q2,wtx)
          call hfill(63,real(binahq),obf,wtx)
          call hf1(65,real(binahq),wtx)
       endif
       if (evcutbhq) then
          call h9091fil(50+binbhq,1050+binbhq,wtx)
          call hzmeanhi(54,dble(q2),dble(etcent),wtx)
          call hzmeanhi(55,dble(q2),dble(etfrag),wtx)
          call hfill(64,real(binbhq),x,wtx)
          call hf1(66,real(binbhq),wtx)
       endif

9990   continue

*********************************************************************
*
*                      Termination
*
*********************************************************************

      Else if(iflag.eq.3) then

*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory

         call hcdir('//PAWC/'//xxxx,' ')

         do i=1,17
            call hdelet(1000+i)
            call hzhinrm(i,0,1.,1)
            call hzchisq(-i,i)
         enddo
         do i=21,25
            call hdelet(1000+i)
            call hzhinrm(i,0,1.,1)
            call hzchisq(-i,i)
         enddo
         call hzchisq(-26,26)
         call hzchisq(-27,27)

         do i=41,47
            call hdelet(1000+i)
            call hzhinrm(i,0,1.,1)
            call hzchisq(-i,i)
         enddo
         do i=51,53
            call hdelet(1000+i)
            call hzhinrm(i,0,1.,1)
            call hzchisq(-i,i)
         enddo
         call hzchisq(-54,54)
         call hzchisq(-55,55)

* fill generated crosssection and number of events into histograms
         call hf1(71,0.5,real(xsec))
         call hf1(72,0.5,real(ntot))

      endif

      RETURN
      END
      SUBROUTINE h9091fil(id1,id2,weight)

* --- each channel of histo id1 is filled with the help of HZMEANHI  individually
*     with its content and a specific weight into histo id2
*     for maximum number of bins and histos of the type that HZMEANHI
creates
*     see that subroutine (7.12.99 = HZVERS ...: MAXHISTS=50, MAXBINS=20)

      IMPLICIT NONE

      character*80 ctit
      integer incX1, incX2, incY, inwt, idum
      real Xmin1, Xmax1, Xmin2, Xmax2, Ymin, Ymax, Xleft

      integer i,id1,id2
      real hi,lowx1,highx1,lowx2,highx2,weight

* --- get some histo information
      call hgive(id1,ctit,incX1,Xmin1,Xmax1,incY,Ymin,Ymax,inwt,idum)
      if (incY.ne.0) then
         write(6,*) 'h9091fil: ERROR for hist ID ',id1,
     &        'can only handle 1d-histos !'
         return
      endif
      call hgive(id2,ctit,incX2,Xmin2,Xmax2,incY,Ymin,Ymax,inwt,idum)
      if (incY.ne.0) then
         write(6,*) 'h9091fil: ERROR for hist ID ',id2,
     &        'can only handle 1d-histos !'
         return
      endif

* --- safety check
      if ((incX1.ne.incX2).or.(Xmin1.ne.Xmin2).or.(Xmax1.ne.Xmax2)) then
         write(6,*) 'h9091fil: ERROR, histogram specifications for',
     &        'hist ID ',id1,'and ID ',id2,' differ'
         return
      endif

* --- loop over all channels
      do i=1,incX1
         call hix(id1,i,lowx1)
         call hix(id1,i+1,highx1)
         call hix(id2,i,lowx2)
         call hix(id2,i+1,highx2)
* ------ safety check again
         if ((lowx1.ne.lowx2).or.(highx1.ne.highx2)) then
            write(6,*) 'h9091fil: ERROR, histogram specifications for',
     &           'hist ID ',id1,'and ID ',id2,' differ'
            return
         endif
* ------ main fill
         call hzmeanhi(id1,dble((lowx2+highx2)/2.),dble(hi(id2,i))
     &        ,weight)
      enddo

      return
      end
*
