*-- Author :  H. Jung 27-01-2000
      subroutine hz99126(IFLAG)
***********************************************
* bbar data H1  in photoproduction
*
***********************************************
      IMPLICIT NONE
*
      Real pi,dpi,rd,ee,eb,dphi,Qpi,qqradp,sigma_tot,xntot
      real p,pt,et,rap,th,phang,xd,dst_xsec
      real ps,pts,ets,raps,ths,phangs
      Logical lp
      data lp/.false./
*
      Character string*20
*
      real alph_em
      Parameter (alph_em=7.29927e-3)
      Real gev2nb,lum,fact,lumnb

      Integer iqbin,i1,i3,idhisto,idpaw
      Parameter (gev2nb=0.389e6)
      Integer maxhi
      Parameter (maxhi=10000)
      Real nev(maxhi)
      Integer nentry
      Real n2,nall,nall2,nall3
      Real xw
      Data nall/0/
      
      Integer jcut,ncut,iel,idum,id,idq2,idx
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
*
      integer err_flag
      real x,y,w2,q2

      double precision dq
      real f2pdf
      DOUBLE PRECISION XXX,QQ,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU,
     +VAL(20)
      CHARACTER*20 PARM(20)
      Integer npdf
      DATA NPDF/0/,UPV,DNV,USEA,DSEA,STR,CHM,BOT,TOP,GLU/9*0.D0/
      LOGICAL PDFFIRST
      COMMON /W50516/PDFFIRST
*
*



      Real conten2(30),contene2(30)
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"
*
      Double precision plab(5,NMXHEP),jetsi(MAXHZJETS,8)
      Double precision dbx,dby,dbz,pold(4),pnew(4),ptot
      Integer iflag,ihep,i,j,k,l,ik,ib
      Logical bottom,muon
      Real ptcut,rapcut,thlcut,thhcut,q2lcut,q2hcut,xbottom
      Real ylcut,yhcut,xevb
      Integer ndstar,idstar,imuon,ij,idtest,igl2

      Double Precision Q2C,YY,YY_BAR,XG,XG_BAR,KT2_1,KT2_2,PT2H,SHH
      COMMON/CASKIN/Q2C,YY,YY_BAR,XG,XG_BAR,KT2_1,KT2_2,PT2H,SHH
      real xkt2,x2
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'99126'/
      Real xnb,xsec_bb,xsec_mu
      common/cwnco1/x,y,Q2
      Integer iq(9)
      Data iq/1,-10,2,3,4,-10,5,-10,6/
      Integer ix(8)
      Data ix/1,-10,2,-10,3,-10,4,5/


      Integer chjet
      SAVE chjet
C --- choose same jet finder as in the paper --- CONE
      DATA chjet/2/
      CHARACTER*6 jetf

C --- information returned by jet finder
      INTEGER NJET
      DOUBLE PRECISION CONER
      SAVE CONER
      Integer imu_acc,mujet
C ---
      INTEGER loop, njrap
      DOUBLE PRECISION rapj(50),Etj(50),Etmujet,rapmujet

      save xnb, mujet


*
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
         xnb=0.
*
         write(6,*)' hz99126 my private Version'
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
*****************************
*  Make histograms
*****************************
*
         call hbook1(221,'  y     ',100,0.,1.,0.)
         call hbook1(222,'  Q2     ',100,0.,100.,0.)
         call hbook1(1301,' log(xg) (muon + jets)',50,-5.,0.,0.)
         call hbook1(1302,' kt_2 (muon + jets)',50,0.,10.,0.)
         call hbook1(1401,' log(xg) (muon)',50,-5.,0.,0.)
         call hbook1(1402,' kt_2 (muon)',50,0.,10.,0.)
         call hbook1(1001,' Et  of muon jet',50,0.,25.,0.)
         call hbook1(1002,' eta of muon jet',50,-4.,4.,0.)
         call hbook1(401,' pri. p_muon in Lab ',50,0.,25.,0.)
         call hbook1(402,' pri. p_muon in CMS of B-hadron ',50,0.,25.,
     +   0.)
         call hbook1(501,' sec. p_muon in Lab ',50,0.,25.,0.)
         call hbook1(502,' sec. p_muon in CMS of B-hadron ',50,0.,25.,
     +   0.)
C --- standard cone radius is 1.0
         CALL HZJETRAD(2,CONER)
         IF (CONER.lt.0.0) THEN
            CONER=1.0
         ENDIF
         CALL HZJTNAME(chjet,jetf)

         WRITE(6,*)'**********************************************'
         WRITE(6,*)'* hz99126 called, histograms will be output. *'
         WRITE(6,*)'*     Jet finder selected : ',jetf,'           *'
         WRITE(6,1001)'*        with cone radius : ',CONER,'   *'
         WRITE(6,*)'**********************************************'

 1001     FORMAT(A29,F5.2,A13)
*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
         mujet = 0
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         nall=nall+wtx
*
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*
         eb=real(PHEP(4,idum))
         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
            return
         endif
*
         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            call VZERO(ph,5)
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif
         q2=real(hzdiskin(1))
         x=real(hzdiskin(2))
         y=real(hzdiskin(3))
         w2=real(hzdiskin(4))

         bottom=.false.
         muon=.false.
         ptcut = 2.0
         thlcut = 35.
         thhcut = 130.
         ylcut=0.1
         yhcut=0.8
         q2lcut=0.
         q2hcut=1.
         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            call VZERO(ph,5)
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif
*
         call HZHCMINI(pbeam,pgam,ierr)
         if (ierr.eq.1) then
            write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
            return
         endif
         Do  ihep=1,nhep
            If(Iabs(idhep(ihep)).eq.5) bottom=.true.
         enddo
         if(bottom) xbottom=xbottom+1.
         xevb = 0.
         imu_acc=0
         if(gen(1:3).eq.'RAP') then
               igl2=6
c          elseif(gen(1:3).eq.'PYT') then
c          igl2= 6
               endif
         xkt2 = real(sqrt(phep(1,igl2)**2+phep(2,igl2)**2))
         x2=(phep(4,igl2)+dabs(phep(3,igl2)))/2d0/phep(4,2)
         IF(bottom) then
            if(y.gt.ylcut.and.y.lt.yhcut.and. q2.gt.q2lcut.and.q2.lt.
     +      q2hcut) then
               Do 10 ihep=1,nhep

* Assume JETSET gets the correct branching fraction
                  if ( Iabs(idhep(ihep)) .eq. 13 ) then
                     imuon=ihep
c          write(6,*) ' muon found ',Jmohep(1,imuon),Jmohep(2,imuon)
c          write(6,*) ' muon found ',idhep(Jmohep(1,imuon)),
c     +    idhep(Jmohep(2,imuon))
                     ij=Jmohep(1,imuon)
                     idtest=Iabs(idhep(ij))
                     if(idtest.eq.523.or.idtest.eq.521.or.idtest.eq.
     +               513.or.idtest.eq.511.or.idtest.eq.531. or.idtest.
     +               eq.5122) then
c                        if(idtest.eq.523.or.idtest.eq.521.or.idtest.eq.
c     +                  513.or.idtest.eq.511.or.idtest.eq.511) then
                        ib= Jmohep(1,imuon)
                        call hfill(501,real(p),0.,1.)
c              ptot=phep(1,ib)**2+phep(2,ib)**2+phep(3,ib)**2
c              ptot=dsqrt(ptot)
                        dbx = -phep(1,ib)/phep(4,ib)
                        dby = -phep(2,ib)/phep(4,ib)
                        dbz = -phep(3,ib)/phep(4,ib)
                        do ik=1,4
c              pold(ik)=phep(ik,ib)
                           pold(ik)=phep(ik,imuon)
                        enddo
                        p = real(sqrt(pold(1)**2+pold(2)**2+pold(3)**2
     +                  ))
                        call hfill(401,real(p),0.,1.)

c              write(6,*) ' old vector ',pold,ib,idtest
                        call hzboost(dbx,dby,dbz,pold,pnew)
c              write(6,*) ' new vector ',pnew
                        p = real(sqrt(pnew(1)**2+pnew(2)**2+pnew(3)**2
     +                  ))
                        call hfill(402,real(p),0.,1.)
                     endif
                     pt = real(sqrt(phep(1,imuon)**2+phep(2,imuon)**2))
                     p = real(sqrt(phep(1,imuon)**2+phep(2,imuon)**2+
     +               phep(3,imuon)**2 ))
                     ib= Jmohep(1,ij)
                     idtest=Iabs(idhep(ib))
c                     if(idtest.eq.523.or.idtest.eq.521.or.idtest.eq.
c     +                  513.or.idtest.eq.511.or.idtest.eq.511) then
                     if(idtest.eq.523.or.idtest.eq.521.or.idtest.eq.
     +                  513.or.idtest.eq.511.or.idtest.eq.531.
     +                  or.idtest.eq.5122) then

                        call hfill(501,real(p),0.,1.)
c              ptot=phep(1,ib)**2+phep(2,ib)**2+phep(3,ib)**2
c              ptot=dsqrt(ptot)
                        dbx = -phep(1,ib)/phep(4,ib)
                        dby = -phep(2,ib)/phep(4,ib)
                        dbz = -phep(3,ib)/phep(4,ib)
                        do ik=1,4
c              pold(ik)=phep(ik,ib)
                           pold(ik)=phep(ik,imuon)
                        enddo
                        p = real(sqrt(pold(1)**2+pold(2)**2+pold(3)**2
     +                  ))
                        call hfill(501,real(p),0.,1.)

c              write(6,*) ' old vector ',pold,ib,idtest
                        call hzboost(dbx,dby,dbz,pold,pnew)
c              write(6,*) ' new vector ',pnew
                        p = real(sqrt(pnew(1)**2+pnew(2)**2+pnew(3)**2
     +                  ))
                        call hfill(502,real(p),0.,1.)

                     endif
                     pt = real(sqrt(phep(1,imuon)**2+phep(2,imuon)**2))
                     p = real(sqrt(phep(1,imuon)**2+phep(2,imuon)**2+
     +               phep(3,imuon)**2 ))
                     th = (acos(real(phep(3,imuon))/p))
                     th=th*rd
c                 write(6,*) ' pt,th ',pt,th
                     if(pt.gt.ptcut .and.th.gt.thlcut.and.th.lt.thhcut)
     +               then
                        imu_acc = imuon
                        xevb = xevb +1.
c                 if(xevb.le.1)
                        xnb=xnb+1.
                        call hfill(1401,real(log10(x2)),0.,1.)
                        call hfill(1402,real(sqrt(xkt2)),0.,1.)

c        write(6,*) ' muon id = ',
c     &     idhep(imuon),' imother = ',idhep(Jmohep(1,imuon))
                     endif
cc                     endif
                  endif
   10          Continue
c find the jets....
               CALL hzjtfind(chjet,CONER,NJET,Jetsi)
               IF (NJET.ge.2) THEN
                  njrap = 0
                  DO loop=1,NJET
                     If(Jetsi(loop,3).ge.6.) then
                        njrap = njrap + 1
                        Etj(njrap)=Jetsi(loop,3)
                        rapj(njrap)=Jetsi(loop,1)
                     Endif
                  ENDDO
                  if(imu_acc.gt.0) then
c                     write(6,*) ' muon ',imu_acc,' belongs to jet ',
c     +               iJetNo(imu_acc)
                     Etmujet = Jetsi(iJetNo(imu_acc),3)
                     rapmujet = Jetsi(iJetNo(imu_acc),1)
c                     write(6,*) ' Et = ',Etmujet,rapmujet,njrap
                     if(njrap.ge.2.and.Etmujet.ge.6) Then
                        mujet = mujet + 1
                        call hfill(1001,real(Etmujet),0.,1.)
                        call hfill(1002,real(rapmujet),0.,1.)
                        call hfill(1301,real(log10(x2)),0.,1.)
                        call hfill(1302,real(sqrt(xkt2)),0.,1.)
c                 write(6,*) ' muon - jet accepted  ',mujet,
c     +           ' out of muons ',xnb
c                     write(6,*) ' Et = ',Etmujet,rapmujet
                     endif
                  endif
               endif
               If(xevb.gt.1) write(6,*) ' more than 1 B -> mu in event '
     +         , xevb

            endif
         endif
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         if (lp) then
*
*
* Obtain total cross-section
            write(6,*) ' Total Cross section ',xsec,nall
*
            write(6,*)'      '
         endif
*
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif
         write(6,*) ' Total Cross section [pb] ',xsec,nall
         lumnb =real(nall)/real(0.001*xsec)
         xsec_bb=xnb/lum/2.
c         xsec_bb=xnb/lum
         write(6,*) 'hz',xxxx,' xnb ',xnb,nall,xsec
         write(6,*) 'hz',xxxx,' B -> mu x section [pb] = ',xsec_bb
         xsec_mu=real(mujet)/lum/2.
         write(6,*) 'hz',xxxx,' Nr mu-jets = ',mujet
         write(6,*) 'hz',xxxx,' mu-jet x section [pb]= ',xsec_mu

c         do i=1001,1002
c            idpaw = i
c            call hzhinrm( idpaw, 0, 1., 1 )
c            call hopera(idpaw,'+E',idpaw,idpaw,1./lum,0.)
c         enddo
*
*
*
      endif
      RETURN
      END
