      subroutine HZH0108047(IFLAG)
****************************************************************************
* Purpose: diffractive charm in DIS
*  
*  H1 Collab., C. Adloff et al., Phys. Lett. B520 (2001) 191 ,   08/01
*  hep-ex/0108047  DESY-01-105
*
* Event selection:
*
* 2 GeV2 < Q2 < 100 GeV2
* 0.05 < y < 0.7
* xpom < 0.04
* MY < 1.6 GeV
* |t| < 1 GeV2
* pt(D*)[lab] > 2 GeV
* |eta(D*)[lab]| < 1.5
*
* Beams: 27.5 GeV positrons, 820 GeV protons   [1996/97 HERA running]
*
* Arguments: iflag=1 initialisation
*            iflag=2 filling
*            iflag=3 termination
*
* written by: Paul Thompson
****************************************************************************
      IMPLICIT NONE

#include "hzfunc.inc"
#include "hepevtp.inc"
#include "heracmn.inc"

*
      integer ikpipis
      common /ikeep/ ikpipis
*
      integer ncharmq
* common that gives the position of particles in X and Y system
      integer nxobj,nyobj,nxgag,nygag
      double precision pom
      common /diffhad/pom(5),nxobj(5000),nyobj(5000),nxgag,nygag


      Double precision plab(5,NMXHEP)
*
      Integer i,iflag,ihep
      Character*8 xxxx
*
      Real pi,rd,eb,ee,epb
c      Parameter (ee=27.5)
      Integer ierr,ibeam,igam,iel,idum,idhe,idmo1,idmo2
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phc(4)
      double precision phb(4)
*
      integer err_flag
      real xnd0,alphem,sigma_tot,x_d,p,pt,et,rap,dst_xsec
      real dst_xsec_error
      Parameter (pi=3.1415927,rd=180./pi)
      Integer nentry
      Real x,y,q2,enel,thel,phiel,efwd,th,lx,lxj
*
      Integer maxhi,modjet,maxjet
      Parameter (maxhi=2000,modjet=2,maxjet=30)
      Real  selj(maxjet,4),help,empz,empzh,xg,empzl,empzhl,xgl
      Integer ipjet(maxjet),l,k
      Real nev(maxhi),lum,xw,nev2(maxhi)
      Real deta,ptj2,thj
      Real xpom,xpom2,xpom3
      real x_pom,beta,xgluon,shat,p_sh(4),p_mx(4),mx2,mx
      real shat_12,xgobs_12
      Real xmas,ymas,t
      Real pj1,pj2,pr
      Integer njet,nj,nsel,ij,nhst,iy,iprot,ndplus,nd0,ndstar
      integer ndstar2,ndstar3,ndstar4
      real kpisflag
      Integer nq,nphi,idstar
      Real ptdcut,rapcut
      Double precision rcone
      Parameter (rcone=1.)
      Double Precision phi,hzscaprod,hzabsvec,phit,sphi
      Double Precision gxpe(3),gxpq(3),pv1(3),pv2(3),pv3(3),pv3n(3)
c info from generator
      Integer iprog
      Real pthg,shg,xpg,zqg,phig,tg,xpomg,w2
      Common/partons/pthg,shg,xpg,zqg,phig,tg,xpomg,iprog
      Logical lp,charmdis,charmdif,ldstar
      Data lp/.false./
**********hadgap
      real ehg,pxhg,pyhg,pzhg,exg,pxxg,pyxg,pzxg
****egamfind
      real eg,thg
      real rq2g,ryg,rxbjg
      integer ivscl,ivgam
      integer irad,idph
      integer ikinq2y,i_do_radcor
      real epzg,epzeg
*********************************************************************
      Real n2,nall,nall2,nall3
      save xxxx,nev,nall, nall2, nall3
      Data xxxx/'H0108047'/,NENTRY/0/
* additions from PT
      integer idiff
      real xbj
      real ps,pts,ets,ths,phangs,phang,raps,xd,xgobs,weight
      real cqmass(1)
* vectors for binning
      integer nq2bin(1),nxpombin(1),nxbjbin(1)
      integer npttbin(1),netabin(1),nxgbin(1)
* diffraction
      real q2bin(3),xpombin(3),xbjbin(3)
      real pttbin(3),etabin(3),xgbin(3)
      real sigmadat(1),q2dat(2),xpomdat(2),xbjdat(2)
      real pttdat(2),etadat(2),xgdat(2)
      real sigmadate(1),q2date(2),xpomdate(2),xbjdate(2)
      real pttdate(2),etadate(2),xgdate(2)
* data vectors plus statistical error vector
      data nq2bin / 2 /
      data nxpombin / 2 /
      data nxbjbin / 2 /
      data npttbin / 2 /
      data netabin / 2 /
      data nxgbin / 2 /
      data q2bin /0.30103,0.903,2 /
      data xpombin / 0.001,0.02,0.04 /
      data xbjbin / -2.8,-1.6,-0.4 /
      data pttbin / 0.0,2.5,10.0 /
      data etabin / -1.5,0.0,1.5 /
      data xgbin / 0.0,0.2,1.0 /
* charm quark mass in the reconstruction of zpom
      data cqmass / 1.5 /
* data cross sections
      data sigmadat / 0.246 /
      data q2dat / 0.280 , 0.084 /
      data xpomdat / 5.300 , 7.834 /
      data xgdat / 0.676 , 0.149 /
      data pttdat / 0.059 , 0.014 /
      data etadat / 0.118 , 0.048 /
      data xbjdat / 0.099 , 0.090 /
* Statistical plus systemmatic error for cross sections
      data sigmadate / 0.078 /
      data q2date / 0.101 , 0.035 /
      data xpomdate / 2.249 , 3.041 /
      data xgdate / 0.256 , 0.062 /
      data pttdate / 0.023 , 0.005 /
      data etadate / 0.040 , 0.025 /
      data xbjdate / 0.037 , 0.038 /
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
* reset counters
         nall=0.
         nall2=0.
         nall3=0.
         n2=0.
         call Vzero(nev,maxhi)
         call Vzero(nev2,maxhi)
*
*
* Initialisation: The following MUST always be done
* (i) make subdirectory in PAWC
* - use the name as the xxxxxx in HZxxxxxx subroutine
* (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
* data
*
         call hbook1(-10890,'sigma',1,0.,1.,0.)
         call hbook1(10891,'sigma',1,0.,1.,0.)
         call hbookb(-10900,'q2',nq2bin,q2bin,0.)
         call hbookb(10901,'q2',nq2bin,q2bin,0.)
         call hbookb(-10910,'pt(D*)(cms)',npttbin,pttbin,0.)
         call hbookb(10911,'pt(D*)(cms)',npttbin,pttbin,0.)
         call hbookb(-10920,'beta',nxbjbin,xbjbin,0.)
         call hbookb(10921,'beta',nxbjbin,xbjbin,0.)
         call hbookb(-10930,'eta(D*)(lab)',netabin,etabin,0.)
         call hbookb(10931,'eta(D*)(lab)',netabin,etabin,0.)
         call hbookb(-10940,'zpomobs',nxgbin,xgbin,0.)
         call hbookb(10941,'zpomobs',nxgbin,xgbin,0.)
         call hbookb(-10990,'xpom',nxpombin,xpombin,0.)
         call hbookb(10991,'xpom',nxpombin,xpombin,0.)


* fill data histos
         call hpak(-10890,sigmadat)
         call hpake(-10890,sigmadate)
         call hpak(-10900,q2dat)
         call hpake(-10900,q2date)
         call hpak(-10910,pttdat)
         call hpake(-10910,pttdate)
         call hpak(-10920,xbjdat)
         call hpake(-10920,xbjdate)
         call hpak(-10930,etadat)
         call hpake(-10930,etadate)
         call hpak(-10940,xgdat)
         call hpake(-10940,xgdate)
         call hpak(-10990,xpomdat)
         call hpake(-10990,xpomdate)

         write(6,*) ' in ',xxxx

*
*********************************************************************
*
*                      Event Processing
*
*********************************************************************
      Else if (iflag.eq.2) then
*
* Filling: The following MUST always be done
* (i) move to the correct sub-directory in PAWC
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         xw=1.
         nall=nall+xw
* output flag
         ikpipis=0
*
* `STEERING' for the routine
* inclusive/diffractive flag 0/1
         idiff=1
*--------------------------------------------------------------------
* Get beam and boson vectors
*--------------------------------------------------------------------
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
* Take the beam energy from the steering
         epb=real(PHEP(4,ibeam))
         eb=real(PHEP(4,idum))
         ee=eb
c         if (abs(abs(eb)-ee).gt.0.1) then
c            if (nentry.lt.10) then
c               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
c            elseif (nentry.eq.10) then
c               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
c     +              ' ...last message ! '
c            endif
c            return
c         endif

         ierr=HZIPGAM(ph)
         if (ierr.eq.-1) then
            write(6,*) 'HZ'//xxxx,' boson vector not found ! '
            call VZERO(ph,5)
         else
            Do i=1,4
               pgam(i)=ph(i)
            enddo
         endif

*
* get electron variables for kinematic selection
*
         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(*,*) 'Hz'//xxxx,' electron not found '
            return
         endif
         enel=real(PHEP(4,iel))
         thel=real(HZPHMANG(PHEP(3,iel), sqrt(PHEP(1,iel)**2+PHEP(2,
     +   iel)**2)))*rd
         phiel=real(HZPHMANG(phep(1,iel),phep(2,iel)))


*--------------------------------------------------------------------
* Get Event Kinematics
*--------------------------------------------------------------------
         q2=real(HZDISKIN(1))
         x =real(HZDISKIN(2))
         y =real(HZDISKIN(3))
         w2=q2*(1.-x)/x
*
         if (lp) then
            write(*,*) 'Hz'//xxxx,' x y q2=',x,y,q2
         endif


* get diffractive kinematics
         do i=1,4
            p_mx(i)=0.
         enddo

         x_pom=1.
         xpom=999.
         call hzhadgap(xmas,ymas,xpom,t)
         mx2=xmas**2


         if (( xpom.le.1.).and.(xpom.ge.x)) then
            x_pom=xpom
         else
            write (6,*)'Hz'//xxxx,' xpom out of range: xpom,x: ;',xpom,x
            return
         endif

         if (lp) then
            write(6,*) 'Hz'//xxxx,' x_pom= ',x_pom,' m_x ',sqrt(mx2)
            write(6,*) 'Hz'//xxxx,' m_y= ',ymas,' t=',t
         endif


* xbj and xpom different for inclusive and diffraction
         if (idiff.eq.0) then
            xbj=x
            x_pom=0.0
         elseif (idiff.eq.1) then
            Do 10   ihep=1,nhep
*     do not count scattered electron
               if(ihep.eq.iel) goto 10
               idhe=idhep(ihep)
*  proton tag
               if ( abs(idhe).eq.2212.and.jmohep(1,ihep).eq.2 ) then
                  iprot = ihep
               endif
* real pomeron
               if ( abs(idhe).eq.100) then
                  do i=1,4
                     pbeam(i)=PHEP(i,ihep)
                  enddo
               endif
 10         continue


c               if(jmohep(1,5).ne.2) write(6,*)'mother not a proton',
c     &              irad,jmohep(1,5)
c               if(idhep(5).ne.100) write(6,*)'not a pomeron',
c     &              irad,jmohep(1,5)


c            if( xpom.le.x_pom) x_pom=xpom
            if (lp) then
               write(6,*) 'Hz'//xxxx,' enel= ',enel,' thel= ',thel
               write(6,*) 'Hz'//xxxx,' y= ',y,' q2= ',q2
               write(6,*) 'Hz'//xxxx,' x_pom= ',x_pom,' m_x ',
     &              sqrt(mx2)
            endif
            if(x_pom.lt.x) then
               if(lp) then
                  write(6,*) ' hzdcharm: x < x_pom = '
                  write(6,*) ' hzdcharm: x = ',x,'
     &                 x_pom = ',xpom,'t = ',t
                  write(6,*) ' hzdcharm: xmas = ',xmas,' ymas = ',ymas
                  write(6,*) ' hzdcharm: q2 = ',q2,' y = ',y
                  write(6,*) 'Hz'//xxxx,' nxgag,nygag ',nxgag,nygag
                  write(6,*) 'Hz'//xxxx,' nxobj ',(nxobj(i),i=1,nxgag)
                  write(6,*) 'Hz'//xxxx,' nyobj ',(nyobj(i),i=1,nygag)
               endif
               return
            endif
* define beta
            xbj=(q2)/(q2+mx2)
         endif
*------------------------------------------------------------------__
* DIS and diffractive selection
*------------------------------------------------------------------__
         charmdis=.true.
         charmdif=.true.
         ldstar = .false.
c this is for final publication
         if (y.lt.0.05) charmdis=.false.
         if (y.gt.0.7) charmdis=.false.
         if (q2.lt.2.) charmdis=.false.
         if (q2.gt.100.) charmdis=.false.
         if (idiff.eq.1) then
            if (x_pom.gt.0.04) charmdif=.false.
            if (ymas.gt.1.6) charmdif=.false.
            if (abs(t).gt.1.0) charmdif=.false.
         endif
* D* cuts
         ptdcut = 2.0
         rapcut = 1.5
* Histogram weight
         weight=1.0

***************************************
* MY
         do 15 ihep=1,nhep
            if ( Iabs(idhep(ihep)) .eq. 413 ) then
* do not count scattered electron
               if(ihep.eq.iel) goto 15
* do not count particles assigned to Y system
               do iy=1,nygag
                  if(ihep.eq.nyobj(iy)) goto 15
               enddo

               Do i=1,4
                  Phb(i)=PHEP(i,ihep)
               enddo


* LAB variables
               call hzgetvar(phb,p,pt,et,th,phang,rap,err_flag)
               if ( err_flag.ne.0 ) goto 15


               if(y.gt.0.05.and.y.lt.0.7
     &              .and.q2.gt.2.0.and.q2.lt.100.0
     &              .and.x_pom.lt.0.04.and.abs(t).lt.1.0
     &              .and.pt.gt.ptdcut.and.abs(rap).le.rapcut
     &              ) then



               endif
* t
               if(y.gt.0.05.and.y.lt.0.7
     &              .and.q2.gt.2.0.and.q2.lt.100.0
     &              .and.x_pom.lt.0.04.and.ymas.lt.1.6
     &              .and.pt.gt.ptdcut.and.abs(rap).le.rapcut
     &              ) then


               endif
            endif
 15      continue

* dis

         if (charmdis) then

            if (charmdif) then

*
               idstar = -1000
               nall2=nall2+xw

***
* check if there is a charm quark
               ncharmq=0
               do ihep=1,nhep
                  if(abs(idhep(ihep)).eq.4) ncharmq=ncharmq+1
               enddo
               if (ncharmq.gt.0) nall3=nall3+xw

               if (ncharmq.gt.0) then
c     write(6,*)'diffractive charm quark produced ipro=',ipro
               endif



* initialize boost
               call HZHCMINI(pbeam,pgam,ierr)
               if (ierr.eq.1) then
                  write(6,*) 'HZ'//xxxx,
     &                 ' problem with initial boost to cms ! '
                  return
               endif
*
*       loop and boost
*
               ndstar3=0
               ndstar4=0
               empzh=0.
               empzhl=0.
               nhst = 1
               do 20 ihep=nhst,nhep
                  Do i=1,4
                     Ph(i)=PHEP(i,ihep)
                     Plab(i,ihep)=PHEP(i,ihep)
                     phep(i,ihep)=0.0
                  enddo
*
                  Do i=1,4
                     Phc(i)=PLAB(i,ihep)
                  enddo

* do not count scattered electron
                  if(ihep.eq.iel) goto 20
* do not count particles assigned to Y system
                  do iy=1,nygag
                     if(ihep.eq.nyobj(iy)) goto 20
                  enddo
                  call HZHCM(ph,pcm,ierr)
                  if (ierr.eq.1) then
                     write(6,*)
     &                    'HZ'//xxxx,'problem with boost to cms!'
                     return
                  endif
*
                  do i=1,4
                     PHEP(i,ihep)=Pcm(i)
                  enddo

                  idmo1=jmohep(1,ihep)
c                  idmo2=idhep(idmo1)

* LAB variables
                  call hzgetvar(phc,p,pt,et,th,phang,rap,err_flag)
                  if ( err_flag.ne.0 ) goto 20
* CMS variables
                  call hzgetvar(pcm,ps,pts,ets,ths,
     &                 phangs,raps,err_flag)
                  if ( err_flag.ne.0 ) goto 20

* Assume JETSET gets the correct branching fraction
                  if ( Iabs(idhep(ihep)) .eq. 413 ) then
                     ndstar3=ndstar3+1
                     idstar=ihep

c         write(6,*)'ndstar3,kpisflag',ndstar3,kpisflag(idstar)
* cross section range
                     if(pt.gt.ptdcut.and.abs(rap).le.rapcut) then

                        ndstar = ndstar + 1
                        ndstar4 = ndstar4 + 1

c                     if(kpisflag(idstar).eq.1.0)
c     &                    write(6,*)'kpisflag!',kpisflag(idstar)

                        if(kpisflag(idstar).eq.1.0) ikpipis=1

c                  write(6,*)'',ndstar4,kpisflag(idstar)

*
* get xgobs/zpomobs
*
* need 'z' of the D*
                        xd=(real(phc(4))-real(phc(3)))/(2.*y*ee)
*
                        shat = ( (1.2*pts)**2+cqmass(1)**2)/
     &                       (xd*(1.-xd))
cfs                        xgobs = xbj*(1.+shat_12/q2)
                        xgobs = xbj*(1.+shat/q2)

*sigma
                        call hfill(10891,0.5,0.,weight)
*q2
                        call hfill(10901,log10(q2),0.,weight)
*xBJ/beta
                        if (idiff.eq.0) then
                           call hfill(10921,log10(xbj),0.,weight)
                        elseif(idiff.eq.1) then
                           call hfill(10921,log10(xbj),0.,weight)
                        endif

*xpom
                        call hfill(10991,x_pom,0.,weight)
*eta(lab)
                        call hfill(10931,rap,0.,weight)
*pt(cms)
                        call hfill(10911,pts,0.,weight)
*xg/zpom(observable)
                        if ( idiff.eq.0 ) then
                           call hfill(10941,log10(xgobs),0.,weight)
                        elseif(idiff.eq.1) then
                           call hfill(10941,xgobs,0.,weight)
                        endif
*

                     endif
                  endif
 20            continue




c calculate phi: cos phi = (g x p_e)*(g x p_q)/|g x p_e|/|g x p_q|
c g = gluon, p_e = electron, p_q = final quark
               nq=8
               if(iprog.eq.21.or.iprog.eq.20) then
                  nq=6
               endif
               do i=1,3
c pv1 = beam
                  pv1(i)=phep(i,5)
c pv2 = electron
                  pv2(i)=phep(i,idum)
c     pv3 = quark
                  pv3(i)=phep(i,nq)
               enddo
               SPHI = HZPHMANG(PV2(1),PV2(2))
               call HZPHMROT(-sphi,0.d0,PV3,PV3N)
               phit = HZPHMANG(PV3N(1),PV3N(2))
c     write(6,*) ' hzexjet q ',pv3,pv3n
               if(phit.le.0.0) then
                  PHIT = ABS(PHIT)
               else
                  PHIT = SNGL(2.*PI-PHIT)
               endif
               call hzvecprod(pv1,pv2,gxpe)
               call hzvecprod(pv1,pv3,gxpq)
c               write(6,*) 'hzexjet sca_pord',hzscaprod(gxpe,gxpq)
c               write(6,*) ' hzdcharm: pv1 ',pv1
cc               write(6,*) ' hzdcharm: pv2 ',pv2
c               write(6,*) ' hzdcharm: pv3 ',pv3
c           write(6,*) ' hzdcharm: gxpe ',gxpe
c           write(6,*) ' hzdcharm: gxpq ',gxpq
               phi=dacos(hzscaprod(gxpe,gxpq)
     &              /hzabsvec(gxpe)/hzabsvec(gxpq))
c         write(6,*) ' hzdcharm phi_cal,phi_gen',phi,
c     &          phig,phig-pi
               phi = phit
               if(idstar.gt.0.and.ldstar) then
                  nphi=nphi+1

                  call hzvecprod(pv1,pv2,gxpe)
                  do i=1,3
                     pv3(i)=phep(i,idstar)
                  enddo
                  call hzvecprod(pv1,pv3,gxpq)

c               write(6,*) 'hzexjet sca_pord',hzscaprod(gxpe,gxpq)
                  phi=dacos(hzscaprod(gxpe,gxpq)/hzabsvec(gxpe)
     $                 /hzabsvec(gxpq))
                  call HZPHMROT(-sphi,0.d0,PV3,PV3N)
                  phit = HZPHMANG(PV3N(1),PV3N(2))
                  if(phit.le.0.0) then
                     PHIT = ABS(PHIT)
                  else
                     PHIT = SNGL(2.*PI-PHIT)
                  endif
                  phi = phit
c                  call hfill(401,real(phi),0.,1.)
c                  call hfill(402,real(phig),0.,1.)

               endif
*
* fill original PHEP vectors
               do ihep=nhst,nhep
                  Do i=1,4
                     PHEP(i,ihep)= Plab(i,ihep)
                  enddo
               enddo
            endif
         endif

*********************************************************************
*
*                      Termination
*
*********************************************************************

      Else if(iflag.eq.3) then

* Termination: The following MUST always be done
* (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
         lum=999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)*1000.
         else
            write(hzunit,*) 'hz',xxxx,' xsec=0 ! '
         endif
*
         write(6,*) '*************************************************'
         write(6,*) 'hz',xxxx
         write(6,*) 'hzdcharm(DIFFRACTIVE)'
         write(6,*) 'lumi (pb-1): ',lum
         write(6,*) 'Total Cross Section (nb): ',real(xsec)
         write(6,*) 'number of events generated:  ',nall
         write(6,*) 'number of diff events:       ',nall2
         write(6,*) 'number of diff charm events: ',nall3
         write(6,*) 'number of diff charm D* events ?: ',ndstar
         write(6,*) 'number of diff charm D* events: ',ndstar3
         write(6,*) 'number of diff charm D* events in pt,eta range: ',
     &               ndstar4


*
*      normalize the histos
*

         dst_xsec= real(ndstar)/real(nall)*xsec*.001
         dst_xsec_error=dst_xsec*(sqrt(real(ndstar))/real(ndstar))

        write(6,*) 'hz',xxxx,'  D* x section (nb) ',dst_xsec,'+/-',
     &        dst_xsec_error

         write(6,*) ''
         write(6,*) ''



c         write(6,*)'check!!!!!',nall,nall2,ndstar,xsec,dst_xsec,lum

         if(nall2.gt.1) then
*
* now do the cross section normalisation
ccc            call hopera(400,'+E',400,400,1./real(nphi),0.)
c            call hopera(400,'+E',400,400,1./lum,0.)
c            call hopera(401,'+E',401,401,1./lum,0.)
c            call hopera(402,'+E',402,402,1./lum,0.)

* final points

            call hopera(10891,'+E',10891,10891,1./lum,0.)
            call hopera(10901,'+E',10901,10901,1./lum,0.)
            call hopera(10911,'+E',10911,10911,1./lum,0.)
            call hopera(10921,'+E',10921,10921,1./lum,0.)
            call hopera(10931,'+E',10931,10931,1./lum,0.)
            call hopera(10941,'+E',10941,10941,1./lum,0.)
            call hopera(10991,'+E',10991,10991,1./lum,0.)

            call hzhinrm(10891,0, 1., 1 )
            call hzhinrm(10901,0, 1., 1 )
            call hzhinrm(10911,0, 1., 1 )
            call hzhinrm(10921,0, 1., 1 )
            call hzhinrm(10931,0, 1., 1 )
            call hzhinrm(10941,0, 1., 1 )
            call hzhinrm(10991,0, 1., 1 )


         endif
*

      endif
*
      RETURN
      END

