*CMZ :          20/07/2001  10.26.51  by   H. Jung
*-- Author :
      subroutine HZH0401010(IFLAG)
****************************************************************************
* Purpose: produced histograms for the inclusive dijet cross-section
*          Event selection: 2  < q2 < 80 Gevsq
*                           0.1 < y < 0.85
*                           kt algorithm:
*                           Et(jet1) > 7 GeV
*                           Et(jet2) > 5 GeV
*                           Et(jet1) + Et(jet2) > 12 GeV
*                           -2.5 < eta(jet1) < 0
*                           -2.5 < eta(jet2) < 0
*
*          Reference:  hep-ex/0401010
*
* Arguments: iflag=1 initialisation
*            iflag=1 filling
*            iflag=3 termination
*
* Author: K. Sedlak
*
****************************************************************************
      IMPLICIT NONE
*
*      include 'hzkamil.include'
      Double Precision rapj(50),Etj(50),phij(50),Ej(50),pzj(50),
     +                 rapcut(2),Etcut(3)
      Real     q2, xbjo, ykin, xgam, x2, eppzjetvip
      Integer  jetf,hwsgen_ks
c      Common /predavka/ rapcut,Etcut,
c     +                  rapj,Etj,phij,Ej,pzj,q2,xbjo,ykin,xgam,x2,
c     +                  eppzjetvip,jetf,hwsgen_ks
      data jetf,hwsgen_ks/3,0/
      data Etcut/7.d0,5.d0,0.d0/
      data rapcut/-2.5d0,0.d0/

C --- cuts arrays
      Real  ycut(2),q2cut(2)
      Data Q2cut/2.,80./
      Data ycut/0.1,0.85/

#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzjetcmn.inc"
*
c --- Parameters from the personal steering file:
cx      character*20 chdummy,steerfilekam
cx      logical      anone
*      integer      ijetalg     

*
      Integer Nacc,ihep,iflag,ibin,iloop,ier,ierr,iel,idum,njets
      integer loop,i,j,id
      integer jgam, jbeam, ilep, ipro, npart, mjet(2048)
      double precision pgam(5), ppro(4),ppho(4),pcms(4),ph(5),ph2(5)
      double precision plab(5,NMXHEP)
*
c --- Variables for the histograms:
      Integer iq2bins,iybins,ixgbins,ietbins,
     +        iRbins,ix4gbins,iUbins,
     +        iR1bins,iR2bins,iR3bins,
     +        iR12bins,iR21bins,
     +        ixpbins,ifbins,
     +        iEtppbins,iRppbins,ixgppbins,
     +        iEtshbins,iRshbins,ixgshbins,
     +        iE12bins,iE21bins,
     +        iy1bins,iR5bins,iR52bins,
     +        iE31bins,iE32bins,iq3bins,
     +        ibbins,id1bins,iE4bins
      Real    wq2bins,wybins,wxgbins,wetbins,
     +        wRbins,wx4gbins,wUbins,
     +        wR1bins,wR2bins,wR3bins,
     +        wR12bins,wR21bins,
     +        wxpbins,wfbins,
     +        wEtppbins,wRppbins,wxgppbins,
     +        wEtshbins,wRshbins,wxgshbins,
     +        wE12bins,wE21bins,
     +        wy1bins,wR5bins,wR52bins,
     +        wE31bins,wE32bins,wq3bins,
     +        wbbins,wd1bins,wE4bins
      Integer nq2bins,nybins,nxgbins,netbins,
     +        nRbins,nx4gbins,nUbins,
     +        nR1bins,nR2bins,nR3bins,
     +        nxpbins,nfbins,
     +        nE1bins,
     +        ny1bins,nR5bins,
     +        nE31bins,nq3bins,
     +        nbbins,nd1bins,nE4bins
      Parameter (nq2bins=4,nybins=5,nxgbins=4,netbins=3,
     +           nRbins=3,nx4gbins=2,nUbins=4,
*     +           nRbins=5,nx4gbins=2,nUbins=4,
     +           nR1bins=5,nR2bins=4,nR3bins=5,
     +           nxpbins=8,nfbins=6,nE1bins=6,
     +           ny1bins=3,nR5bins=5,
     +           nE31bins=3,nq3bins=4,
     +           nbbins=7,nd1bins=5,nE4bins=4)

      Real  q2bins(nq2bins+1),
     +      ybins(nybins+1), xgbins(nxgbins+1),et2mean(netbins+1),
     +      Rbins(nRbins+1),x4gbins(nx4gbins+1),Ubins(nUbins+1),
     +      R1bins(nR1bins+1),R2bins(nR2bins+1),R3bins(nR3bins+1),
     +      xpbins(nxpbins+1),fbins(nfbins+1),E1bins(nE1bins+1),
     +      y1bins(ny1bins+1),R5bins(nR5bins+1),
     +      E31bins(nE31bins+1),q3bins(nq3bins+1),
     +      bbins(nbbins+1),d1bins(nd1bins+1),E4bins(nE4bins+1)
      Integer ioffQEy, ioffQRy, ioffQxy, ioffQEx, ioffQx4y,
     +        ioffEx4Q, ioffUxy, ioffUx4y, ioffQR1,
     +        ioffQR2, ioffQR3, ioffQEg, ioffQxg, ioffQP,
     +        ioffQEf, ioffQxf, ioffQgf,
     +        ioffQRpy, ioffQEpxpp, ioffQEpy,
     +        ioshQRy, ioshQEx, ioshQEy,
     +        ioffQE1x, ioffQE12x, ioffQE12R12, 
     +        ioffQR12y, ioffQR12,
     +        ioffQRE1,ioffQE1R5,ioffQy1R5,
     +        ioffQE3x,ioffQE3R5,ioffQ3bd1,ioffQ3bE4,ioffQ3bR5
      Parameter (ioffQEy=0, ioffQRy=1, ioffQxy=2, ioffQEx=3, 
     +        ioffQx4y=8, ioffEx4Q=15, ioffUxy=17, ioffUx4y=18,
     +        ioffQR1=22,ioffQR2=23,ioffQR3=24,
     +        ioffQEg=40,ioffQxg=41,ioffQP=42,
     +        ioffQEf=43,ioffQxf=44,ioffQgf=45,
     +        ioffQRpy=46,ioffQEpxpp=47,ioffQEpy=48,
     +        ioshQRy=90, ioshQEx=91, ioshQEy=92,
     +        ioffQE1x=25, ioffQE12x=26, ioffQE12R12=27, 
     +        ioffQR12y=28, ioffQR12=29,
     +        ioffQRE1=30,ioffQE1R5=31,ioffQy1R5=32,
     +        ioffQE3x=33,ioffQE3R5=34,ioffQ3bd1=35,
     +        ioffQ3bE4=36,ioffQ3bR5=37   )
      Logical yes_Q2,yes_y,yes_xg,yes_Et,yes_R,yes_x4,yes_U,
     +        yes_R1,yes_R2,yes_R3,yes_xp,yes_f
      Logical yes_Q2R1, yes_Q2Ety, yes_Q2Ry, yes_Q2xgy,
     +        yes_Q2Etxg, yes_Q2x4y, yes_Etx4q, yes_Uxgy,
     +        yes_Ux4y, yes_Q2Etxp, yes_Q2xgxp
      Integer          ih_QEy,ih_QRy,ih_QEx,ih_Qx4y,ih_QP,
     +                 ih_QE1x,ih_QE12x,ih_QE12R12,ih_QR12y,
     +                 ih_QR12,ih_QRE1,ih_QE1R5,ih_Qy1R5,
     +                 ih_QE3x,ih_QE3R5,ih_Q3bd1,ih_Q3bE4,ih_Q3bR5
      Double precision ah_QEy(nq2bins*netbins*nybins),
     +                 ahe_QEy(nq2bins*netbins*nybins),
     +                 ahd_QEy(nq2bins*netbins*nybins),
     +                 ahtest_QEy(nq2bins*netbins*nybins),
     +                 ah_QRy(nq2bins*nrbins*nybins),
     +                 ahe_QRy(nq2bins*nrbins*nybins),
     +                 ahd_QRy(nq2bins*nrbins*nybins),
     +                 ah_QEx(nq2bins*netbins*nxgbins),
     +                 ahe_QEx(nq2bins*netbins*nxgbins),
     +                 ahd_QEx(nq2bins*netbins*nxgbins),
     +                 ah_Qx4y(nq2bins*nx4gbins*nybins),
     +                 ahe_Qx4y(nq2bins*nx4gbins*nybins),
     +                 ahd_Qx4y(nq2bins*nx4gbins*nybins),
     +                 ah_QP(nq2bins*nRbins),
     +                 ahe_QP(nq2bins*nRbins),
     +                 ahd_QP(nq2bins*nRbins),
     +                 ah_QE1x(nq2bins*ne1bins*nxgbins),
     +                 ahe_QE1x(nq2bins*ne1bins*nxgbins),
     +                 ahd_QE1x(nq2bins*ne1bins*nxgbins),
     +                 ah_QE12x(nq2bins*ne1bins*nxgbins),
     +                 ahe_QE12x(nq2bins*ne1bins*nxgbins),
     +                 ahd_QE12x(nq2bins*ne1bins*nxgbins),
     +                 ah_QE12R12(nq2bins*ne1bins*nRbins),
     +                 ahe_QE12R12(nq2bins*ne1bins*nRbins),
     +                 ahd_QE12R12(nq2bins*ne1bins*nRbins),
     +                 ah_QR12y(nq2bins*nRbins*nybins),
     +                 ahe_QR12y(nq2bins*nRbins*nybins),
     +                 ahd_QR12y(nq2bins*nRbins*nybins),
     +                 ah_QR12(nq2bins*nRbins),
     +                 ahe_QR12(nq2bins*nRbins),
     +                 ahd_QR12(nq2bins*nRbins),
     +                 ah_QRE1(nq2bins*nRbins*nE1bins),
     +                 ahe_QRE1(nq2bins*nRbins*nE1bins),
     +                 ahd_QRE1(nq2bins*nRbins*nE1bins),
     +                 ah_QE1R5(nq2bins*ne1bins*nR5bins),
     +                 ahe_QE1R5(nq2bins*ne1bins*nR5bins),
     +                 ahd_QE1R5(nq2bins*ne1bins*nR5bins),
     +                 ah_Qy1R5 (nq2bins*ny1bins*nR5bins),
     +                 ahe_Qy1R5 (nq2bins*ny1bins*nR5bins),
     +                 ahd_Qy1R5 (nq2bins*ny1bins*nR5bins),
     +                 ah_QE3x(nq2bins*ne31bins*nxgbins),
     +                 ahe_QE3x(nq2bins*ne31bins*nxgbins),
     +                 ahd_QE3x(nq2bins*ne31bins*nxgbins),
     +                 ah_QE3R5(nq2bins*ne31bins*nR5bins),
     +                 ahe_QE3R5(nq2bins*ne31bins*nR5bins),
     +                 ahd_QE3R5(nq2bins*ne31bins*nR5bins),
     +                 ah_Q3bd1(nq3bins*nbbins*nd1bins),
     +                 ahe_Q3bd1(nq3bins*nbbins*nd1bins),
     +                 ahd_Q3bd1(nq3bins*nbbins*nd1bins),
     +                 ah_Q3be4(nq3bins*nbbins*nE4bins),
     +                 ahe_Q3be4(nq3bins*nbbins*nE4bins),
     +                 ahd_Q3be4(nq3bins*nbbins*nE4bins),
     +                 ah_Q3bR5(nq3bins*nbbins*nR5bins),
     +                 ahe_Q3bR5(nq3bins*nbbins*nR5bins),
     +                 ahd_Q3bR5(nq3bins*nbbins*nR5bins),
     +                 temp_QEy,temp_QRy,temp_QEx,temp_Qx4y,temp_QP,
     +                 temp_QE1x,temp_QE12x,temp_QE12R12,temp_QR12y,
     +                 temp_QR12,temp_QRE1,temp_QE1R5,temp_Qy1R5

      Common /ah_common/ ah_QEy,ah_QRy,ah_QEx,ah_Qx4y,ah_QP,
     +                   ah_QE1x,ah_QE12x,ah_QE12R12,ah_QR12y,
     +                   ah_QR12,ah_QRE1,ah_QE1R5,ah_Qy1R5,
     +                   ahe_QEy,ahe_QRy,ahe_QEx,ahe_Qx4y,ahe_QP,
     +                   ahe_QE1x,ahe_QE12x,ahe_QE12R12,ahe_QR12y,
     +                   ahe_QR12,ahe_QRE1,ahe_QE1R5,ahe_Qy1R5,
     +                   ahd_QEy,ahd_QRy,ahd_QEx,ahd_Qx4y,ahd_QP,
     +                   ahd_QE1x,ahd_QE12x,ahd_QE12R12,ahd_QR12y,
     +                   ahd_QR12,ahd_QRE1,ahd_QE1R5,ahd_Qy1R5,
     +                   ah_QE3x,ahe_QE3x,ahd_QE3x,
     +                   ah_QE3R5,ahe_QE3R5,ahd_QE3R5,
     +                   ah_Q3bd1,ahe_Q3bd1,ahd_Q3bd1,
     +                   ah_Q3be4,ahe_Q3be4,ahd_Q3be4,
     +                   ah_Q3bR5,ahe_Q3bR5,ahd_Q3bR5,
     +                   temp_QEy,temp_QRy,temp_QEx,temp_Qx4y,temp_QP,
     +                   temp_QE1x,temp_QE12x,temp_QE12R12,temp_QR12y,
     +                   temp_QR12,temp_QRE1,temp_QE1R5,temp_Qy1R5,
     +                   ahtest_QEy,
     +                   ih_QEy,ih_QRy,ih_QEx,ih_Qx4y,ih_QP,
     +                   ih_QE1x,ih_QE12x,ih_QE12R12,ih_QR12y,
     +                   ih_QR12,ih_QRE1,ih_QE1R5,ih_Qy1R5,
     +                   ih_QE3x,ih_QE3R5,ih_Q3bd1,ih_Q3bE4,ih_Q3bR5
* ---------------

*      data et2mean/36.,48.0,65.0,110.0,500.0/
      data et2mean/36.,60.,120.,500./
      Data q2bins/2., 4.4, 10. , 25. , 80.0/
*      Data q2bins/1.4, 2.4, 10. , 25. , 80.0/
      Data ybins/0.1,0.25,0.40,0.55,0.7,0.85/
      Data xgbins/0.12,0.35,0.55,0.75,1./
      Data x4gbins/0.,0.75,1./
      data Rbins/-2.5,-1.7,-1.3,0./
*      data Rbins/-2.5,-2.,-1.5,-1.,-0.5,0./
      data R1bins /-2.5,-1.8,-1.4,-1.,-0.5,0./
      data R2bins /-2.5,-2.25,-2.,-1.5,0./
      data R3bins /0.,0.15,0.3,0.5,0.7,1.25/
      data Ubins /0.45,4.0,10.,20.,150./
      data xpbins /0.0000001,0.0001,0.001,0.01,0.02,0.05,0.1,0.5,1./
      data fbins /0.,0.524,1.047,1.571,2.094,2.618,3.142/
      data E1bins /5.,7.,10.,15.,20.,30.,60./
      data y1bins /0.1,0.25,0.5,0.85/
      data R5bins /-2.5,-2.0,-1.5,-1.,-0.5,0./
      data E31bins /5.,10.,20.,60./
      data q3bins /2.,5.,10.,30.,100./
      data bbins  /2.3e-5,7.e-5,1.e-4,1.7e-4,3.e-4,5.e-4,
     +                                          10.e-4,100.e-4/
      data d1bins /0.,0.7,1.4,2.1,2.8,3.5/
      data E4bins /5.,10.,20.,30.,60./

c ---------------
      real eppzj,eppz
      CHARACTER*6 chjet

C --- information returned by jet finder
      INTEGER NJET
      DOUBLE PRECISION Jetsi(MAXHZJETS,8)
      DOUBLE PRECISION CONER

C --- cuts arrays
      real invlumi
      Real eb,ee,pbeam(4)
      Parameter (ee=27.6)
      Integer ibeam,nentry

      Character string*80
      character*80 chnazev

*     DESY Preprint number
      Character*8 xxxx
      Data xxxx/'h0310019'/
*
*
* Data points from plots
      Integer nev
*
      logical lp
      Data lp/.false./

      save Nacc, CONER, nentry

*      Data lp/.true./

c ================================================================
c ---    INITIALIZATION ------------------------------------------
c ================================================================
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
c
      IF (iflag.eq.1) then
         Nacc= 0
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
*      book your histograms
*
         chnazev='d(sigma)/dQ2 dE3 dxg'
         call hzkhisdef(nq2bins,nE31bins,chnazev,ioffQE3x,
     &        nxgbins,xgbins)
         chnazev='d(sigma)/dQ2 dx4g dy'
         call hzkhisdef(nq2bins,nx4gbins,chnazev,ioffQx4y,nybins,ybins)
         chnazev='d(sigma)/dQ2 dy1 dR5'
         call hzkhisdef(nq2bins,ny1bins,chnazev,ioffQy1R5,
     &      nR5bins,R5bins)
         chnazev='d(sigma)/dQ2 dR dE1'
         call hzkhisdef(nq2bins,nRbins,chnazev,ioffQRE1,nE1bins,E1bins)

         CONER=1.0
         CALL HZJTNAME(jetf,chjet)

         WRITE(6,*)'**********************************************'
         WRITE(6,*)'* HZ03206 called, histograms will be output. *'
         WRITE(6,*)'*     Jet finder selected : ',chjet,'           *'
         WRITE(6,1001)'*        with cone radius : ',CONER,'   *'
         WRITE(6,*)'**********************************************'
         call HLDIR(' ','T')

 1001    FORMAT(A29,F5.2,A13)

*
*
*
c ================================================================
c ---     EVENT  LOOP  --------------------------------------
c ================================================================
c
      Else if(iflag.eq.2) then
*        Filling: The following MUST always be done
*        (i) move to the correct sub-directory in PAWC
         call hcdir('//PAWC/'//xxxx,' ')

         nentry = nentry + 1

         q2 = 0.
         ykin = 0.
         ierr=HZIBEAM(ibeam,idum)
         if (.not.(ierr.eq.1)) then
            write(6,*) 'HZ'//xxxx,' beams not found ! '
            return
         else
            Do i=1,4
               pbeam(i)=PHEP(i,IBEAM)
            enddo
         endif
*     
         eb=real(PHEP(4,idum))

         if (abs(abs(eb)-ee).gt.0.1) then
            if (nentry.lt.10) then
               write(6,*) 'HZ'//xxxx,' Electron not at ',ee,' ! ',eb
            elseif (nentry.eq.10) then
               write(6,*) 'HZ'//xxxx,' Electron beam not at ',ee,
     +         ' ...last message ! '
            endif
            return
         endif


cks      Use correct weight of the event:
*         IF ((gen(1:3).eq.'HRW').or.(gen(1:6).eq.'RAPGAP')) then
         IF (gen(1:3).eq.'HRW') then
*           wtx=vaha
           wtx=1.
         elseif (gen(1:6).eq.'RAPGAP') then
           wtx=1.
         ENDIF


         q2 = real(hzdiskin(1))
         ykin = real(hzdiskin(3))

         nev = nev + wtx

cks      Skip if not in  Q^2  or  y  kinematic range:

         IF ((ykin.lt.ycut(1)).or.(ykin.gt.ycut(2))) goto 50
         IF ((q2.lt.q2cut(1)).or.(q2.gt.q2cut(2))) goto 50

C--Find the proton and photon

         IF (gen(1:3).eq.'HRW') then
            jgam = hzipgamn(pgam)
         else
            jgam = hzipgam(pgam)
         endif

         if (jgam.ne.1) then
            write(6,*) 'ERROR: No photon found'
            goto 50
         endif

         jbeam = hzibeam(ipro,ilep)

         if (jbeam.ne.1) then
            write(6,*) 'ERROR: Problem finding beams'
            goto 50
         endif

         do iloop=1,4
            ppro(iloop) = phep(iloop,ipro)
            ppho(iloop) = pgam(iloop)
         enddo

C--set up the boost

         call hzhcmini(ppro,ppho,ierr)

         if (ierr.eq.1) then
            write(6,*) 'ERROR: Problem with boost'
            goto 50
         endif

C--Find the scattered electron

         iel=HZIDELEC(idum)
         if (iel.eq.-1) then
            write(6,*) 'Hz'//xxxx,' electron not found '
            goto 50
         endif

C---Sort out all stable particles and boost them

         npart = 0
	 eppz=0.
         do 20 ihep=1,nhep
           npart = npart + 1
           Do i=1,4
             Ph(i)=PHEP(i,ihep)
             Plab(i,ihep)=PHEP(i,ihep)
             phep(i,ihep)=0.0
           enddo

*     skip unstable particles and electron
           if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 20
           call HZHCM(ph,pcms,ierr)
           Do i=1,4
             PHEP(i,ihep)=Pcms(i)
             if(i.eq.3) PHEP(i,ihep)=-Pcms(i)
           enddo
           eppz = eppz + phep(4,ihep) - phep(3,ihep)
           if (ierr.eq.1) then
             write(6,*) 'HZ'//xxxx,' problem with boost to cms ! '
             goto 17
           endif
   20    continue



         if (lp) then
           write(*,*)
*           write(*,*)'hzkamil.f: HZLIHEP(2):'
*           call hzlihep(2)
           write(*,*)'Q2,y=',q2,ykin
         endif

         xgam = -1.

 30      continue
         CALL hzjtfind(jetf,CONER,NJET,Jetsi)
*     Parameters of hzjtfind:
*           jetf:  2 ... pxcone;   3 ... ktclus
*           Jetsi:  1 ... pseudorap, 2 ... phi,  3 ... Et,  4 ... E,  
*                   5 ... px,  6 ... py,  7 ... pz,  8 ... m

         if (lp) then
           write(*,*)'njet=',njet
           do i=1,njet
             write(*,*)'Jetsi(i,j)=',(jetsi(i,j),j=1,3)
           enddo
           write(*,*)'----'
         endif

         if (NJET.lt.2) GOTO 17

         do loop=1,2
           Etj(loop)=Jetsi(loop,3)
           rapj(loop)=Jetsi(loop,1)
           phij(loop) = Jetsi(loop,2)
           Ej(loop) = Jetsi(loop,4)
           Pzj(loop) = Jetsi(loop,7)
         enddo


         if (.not. ((rapj(1).ge.rapcut(1)).and.
     +              (rapj(1).le.rapcut(2)).and.
     +              (rapj(2).ge.rapcut(1)).and.
     +              (rapj(2).le.rapcut(2)))  )  GOTO 17

         if (.not. (Etj(1).ge.Etcut(1).and.Etj(2).ge.Etcut(2).and.
     +		   (Etj(1)+Etj(2)).ge.Etcut(3)) )   GOTO 17


         Nacc = Nacc + 1
         
         eppzj=Ej(1) - pzj(1) + Ej(2) - pzj(2)
         if (eppz.ne.0.) then
           xgam=min(0.99999 , eppzj/eppz)
         else
           xgam=-999.
         endif
         if ((xgam.le.0.).or.(xgam.gt.1.)) then
           write(*,*)'Strange xgam !!!'
           write(*,*)'eppzj,eppz,xgam=',eppzj,eppz,xgam
         endif

cks:   Do my binning here:
*
         call hzkbins(iq2bins,wq2bins,Q2,nq2bins,q2bins,ier)   ! Q2
         call hzkbins(iybins,wybins,ykin,nybins,ybins,ier)     ! y
         call hzkbins(ixgbins,wxgbins,xgam,nxgbins,xgbins,ier) ! xg
         call hzkbins(ix4gbins,wx4gbins,xgam,nx4gbins,x4gbins,ier) ! x4g
         call hzkbins(iE12bins,wE12bins,real(Etj(1)),nE1bins,
     &       E1bins,ier) ! E12
         call hzkbins(iE21bins,wE21bins,real(Etj(2)),nE1bins,
     &     E1bins,ier) ! E21
         call hzkbins(iE31bins,wE31bins,real(Etj(1)),nE31bins,
     &     E31bins,ier) ! E31
         call hzkbins(iE32bins,wE32bins,real(Etj(2)),nE31bins,
     &     E31bins,ier) ! E32
         call hzkbins(iy1bins,wy1bins,ykin,ny1bins,y1bins,ier) ! y1
         call hzkbins(iR5bins,wR5bins,real(rapj(1)),nR5bins,R5bins,ier) ! R5
         call hzkbins(iR52bins,wR52bins,real(rapj(2)),nR5bins,
     &     R5bins,ier) ! R52
         call hzkbins(iR12bins,wR12bins,real(rapj(1)),nRbins,Rbins,ier) ! R12
         call hzkbins(iR21bins,wR21bins,real(rapj(2)),nRbins,Rbins,ier) ! R21

cks:  Fill the histograms:
cks
         call hzkhisfil(iq2bins,iE31bins,xgam,wq2bins,wE31bins,
     +                      wxgbins,nE31bins,ioffQE3x,wtx)
         call hzkhisfil(iq2bins,iE32bins,xgam,wq2bins,wE32bins,
     +                      wxgbins,nE31bins,ioffQE3x,wtx)
cks
*    d(sigma)/dQ2 dx4 dy
         call hzkhisfil(iq2bins,ix4gbins,ykin,wq2bins,wx4gbins,wybins,
     +                              nx4gbins,ioffQx4y,wtx)
cks
         call hzkhisfil(iq2bins,iy1bins,real(rapj(1)),wq2bins,wy1bins,
     +                      wR5bins,ny1bins,ioffQy1R5,wtx)
         call hzkhisfil(iq2bins,iy1bins,real(rapj(2)),wq2bins,wy1bins,
     +                      wR52bins,ny1bins,ioffQy1R5,wtx)
cks
         call hzkhisfil(iq2bins,iR12bins,real(Etj(1)),wq2bins,wR12bins,
     +                      wE12bins,nRbins,ioffQRE1,wtx)
         call hzkhisfil(iq2bins,iR21bins,real(Etj(2)),wq2bins,wR21bins,
     +                      wE21bins,nRbins,ioffQRE1,wtx)
cks



 17      continue
         do ihep=1,nhep
            do i=1,4
               PHEP(i,ihep)= Plab(i,ihep)
            enddo
         enddo
         
 50      continue
*
*
*
c ================================================================
c --- DO BEFORE TERMINATION --------------------------------------
c ================================================================
*
      Else if(iflag.eq.3) then
         write(*,*)'HZ03206 - Last step'
*         Termination: The following MUST always be done
*         (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
*     Normalise the histograms by the luminosity
c         IF (gen(1:3).eq.'HRW') then
c            xsec=SIGMT
cks            xsec=kamilsigma
*         elseif (gen(1:6).eq.'RAPGAP') then
*            nev=NEVTKAMIL
c         endif

         invlumi = xsec/real(nev)

cks: Normalise my histograms to the luminosity and the nr. of events:
         call hzkhisnorm(nq2bins,nE31bins,ioffQE3x,invlumi)
         call hzkhisnorm(nq2bins,nx4gbins,ioffQx4y,invlumi)
         call hzkhisnorm(nq2bins,ny1bins,ioffQy1R5,invlumi)
         call hzkhisnorm(nq2bins,nRbins,ioffQRE1,invlumi)

         Write(6,*) 'hz'//xxxx,' X-section is',xsec
         Write(6,*) '           number of accepted events:',Nacc
         Write(6,*) '           total nr of gen. events:  ',ntot
         Write(6,*) '           nr of gen. events entering hzkamil is',
     +                                                  nev


      endif

      RETURN
      END

*==========================================================
