*CMZ :  1.01/07 08/10/97  17.41.35  by  Tancredi Carli
*CMZ :  1.01/05 29/01/97  14.27.55  by  Tancredi Carli
*CMZ :  1.01/03 15/05/96  18.54.11  by  Tancredi Carli
*CMZ :  1.01/02 09/04/96  19.08.20  by  Tancredi Carli
*-- Author :    Tancredi Carli   08/04/96
	Subroutine HZth003(iflag)
*****************************************************************************
* Produce (2+1) jet rates vs Q2, Jet profiles etc.
*
*****************************************************************************
*
	IMPLICIT NONE
*
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzjetcmn.inc" 
*
      Integer chjet,iflag,ihep
      DATA chjet/5/
      CHARACTER*6 jetf,xxxx
      Data xxxx/'TH003'/
*
      Integer iel,idum,numjet,njets
      Integer ijetb,ijetf
      Real nev
      Real thmax,thmin,th,et
      Real x,y,q2,w2,thel,enel,rd,pi,dpi,thjet
      Parameter (pi=3.14159,rd=180./pi,dpi=2*pi)
      Logical lp,evcut,evcut1,evcut2
      Data lp/.false./
      Integer njet
      DOUBLE PRECISION coner
      Real qb(6),deta,dphi,eta,phi
      Data qb/10.,18.,30.,100.,400.,4000./
*
      INTEGER i,j,k

	save nev

*
      IF (iflag.eq.1) then
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
       Call hcdir('//PAWC',' ')
       call hmdir(xxxx,'S')
       Call hcdir('//HISTO',' ')
       call hmdir(xxxx,'S')
*
       call hbookb(1,'sample 1+1',5,qb,0.)
       call  hcopy(1,2,'sample 2+1')
       call  hcopy(1,3,'total')
       call hbook1(10,' Dphi eflow forw.',50,-pi,pi,0.)
       call hbook1(11,' Dphi eflow back.',50,-pi,pi,0.)
       call hbook1(12,' Deta eflow forw.',50,-3.,4.,0.)
       call hbook1(13,' Deta eflow back.',50,-3.,4.,0.)
*
* print-out name of jet-algo used
*
      CALL HZJTNAME(chjet,jetf)
      WRITE(6,*) '**********************************************'
      WRITE(6,*) '* HZ,',xxxx,' called                         *'
      WRITE(6,*) '* Jet finder selected : ',jetf,'             *'
      WRITE(6,*) '**********************************************'
*
      nev=0.
*
*                      Event Processing
*
      Else if(iflag.eq.2) then
*      Filling: The following MUST always be done
*      (i) move to the correct sub-directory in PAWC
*
       call hcdir('//PAWC/'//xxxx,' ')
*
*                                             Event selection
*
       q2=real(HZDISKIN(1))
       x =real(HZDISKIN(2))
       y =real(HZDISKIN(3))
       w2=real(HZDISKIN(4))
*
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' x= ',x,' q2 ',q2,' y= ',y,' w2= ',w2
*
*                                             get electron variables
*
       iel=HZIDELEC(idum)
       if (iel.eq.-1) then
        write(6,*) 'Hz'//xxxx,' electron not found '
        goto 9990
       endif
       enel=real(PHEP(4,iel))
       thel=real(HZPHMANG(PHEP(3,iel),
     &               sqrt(PHEP(1,iel)**2+PHEP(2,iel)**2)))*rd
*
       if (lp) write(6,*) 'Hz'//xxxx,
     & ' enel= ',enel,' thel= ',thel
*
*                                             kinematic selection
*
       evcut= q2.gt.10. .and. q2.lt.100. .and. enel.gt.14.
       evcut= thel.gt.160. .and. thel.lt.172.5 .and. evcut
       evcut1=evcut
       evcut= q2.gt.100. .and. y.lt.0.7 .and.thel .lt.148.
       evcut= w2.ge.5000..and. evcut
       evcut2=evcut
*
       evcut=w2.gt. 5000. and. (evcut1 .or. evcut2)
*
       if(.not.evcut) goto 9990
*	
       coner=0.02
       if (lp) then
        write(6,*) ' ..calling hzjtfind chjet= ',chjet,' ycut= ',coner
       endif
*
       CALL hzjtfind(chjet,CONER,NJET,Jets)
*
       thmin=999.
       thmax=-999.
*
       numjet=0
       do i=1,njet
        if (lp) then
         write(6,'(a,4(x,f9.3))') ' e,px,py,pz= ',
     &   (real(jets(i,j)),j=4,7)
        endif
*
        thjet=real(acos(jets(i,7)/jets(i,4)))*rd
        if (thjet.ge.10. .and. thjet.le.145.) then
         numjet=numjet+1
         if (thjet.gt.thmax) then
          thmax=thjet
          ijetf=i
         endif
         if (thjet.lt.thmin) then
          thmin=thjet
          ijetb=i
         endif
        endif
       enddo
*
       if (lp) then
        write(6,*) ' njet= ',njet,' numjet= ',numjet
       endif
*
       if (numjet.eq.1 .and. njet.eq.2) then
        call hfill(1,q2,0.,wtx)
       elseif (numjet.eq.2 .and. njet.eq.3) then
        call hfill(2,q2,0.,wtx)
        nev=nev+wtx
*
        if (lp) then
         write(6,*) ' ijetf= ',ijetf,' ijetb= ',ijetb
        endif
*
        iel=HZIDELEC(idum)
        if (iel.eq.-1) then
         write(6,*) 'Hz'//xxxx,' electron not found '
         return
        endif
        Do 10 ihep=1,nhep
         if (isthep(ihep).ne.1.or.ihep.eq.iel) goto 10
*
         th=real(HZPHMANG(PHEP(3,ihep),
     &              sqrt(PHEP(1,ihep)**2+PHEP(2,ihep)**2)))
         et=real(PHEP(4,ihep))*sin(th)
         eta=-log(tan( th/2. ))
         phi=real(HZPHMANG(PHEP(1,ihep),PHEP(2,ihep)))
*
         deta=real(JETS(ijetb,1))-eta
         dphi=real(JETS(ijetb,2))-phi
*
         call hfill(13,deta,0.,et*wtx)
         call hfill(11,dphi,0.,et*wtx)
*
         deta=real(JETS(ijetf,1))-eta
         dphi=real(JETS(ijetf,2))-phi
         call hfill(12,deta,0.,et*wtx)
         call hfill(10,dphi,0.,et*wtx)
*
 10     continue
       endif
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
      Else if(iflag.eq.3) then
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
       call hcdir('//PAWC/'//xxxx,' ')
       call HZHINRM(10,0,nev,1)
       call HZHINRM(11,0,nev,1)
       call HZHINRM(12,0,nev,1)
       call HZHINRM(13,0,nev,1)
*
      ENDIF
*
 9990 continue
      RETURN
      END
*
