*CMZ :  2.00/04 31/07/2000  21.11.45  by  Tancredi Carli
*CMZ :  0.03/03 16/08/91  13.43.37  by  G. Knies
*-- Author :    G. KNIES   24/07/91
      SUBROUTINE HEDECX(IFLAG)
************************************************************************
* * SR EDECX , HEDECX for HZTOOL
* * PURPOSE:                                                           *
*      EXECUTE EVENT DECO LOOPS                                        *
*       over all multiplets from 2 =< jetmul <=maxmul                  *
*            over all requested jet functions (jetf(indec)> 0)         *
*      CALLS EVENT DECO AND RESULT SAVING ROUTINES (jetmul,indec)      *
* * INPUT:  MOMENTUM VECTORS OF AN EVENT, IN /QCTBUF/                  *
*           INSTRUCTIONS ON DECOMPOSITION MODES, IN /QCOCOM/           *
* * OUTPUT: JET VECTORS,PARTICLE MEMBER LISTS OF JETS,                 *
*           TOPOLOGICAL JET FUNCTION VALUES                            *
*           FOR UP TO 4 MULTIPLETS (2-5)                               *
*           FOR UP TO 10 JETFUNCTIONS                                  *
*           in common/QRECOM/                                          *
* * AUTHOR: GERHARD KNIES   04-02-1991                                 *
*           modific. 19-07-91 for h1phan environment                   *
*           modific. 08-08-91 for L=1 bank and test print              *
*
*     14/02/99: adapted for HZTOOL environment: remved CALL QESAVE     *
C **********************************************************************

#include "decoma.inc"
#include "qjmacs.inc"
*
      DIMENSION ITBOR(JPARMX,JTBOMX)
      EQUIVALENCE(QTBOR(1,1),ITBOR(1,1))
      CHARACTER*4 NAMOUL
C  ***  DECOMPOSE EVENTS INTO  SUBSETS
C  WITH GROWING MULTIPLICITY L, I.E. INTO 2-, 3-, 4-AND 5-JET SYSTEMS
C  THE EVENT WILL BE DECOMPOSED INTO A SEQUENCE OF JET MULTIPLETS
C   MULTIPLETS L             JET NAMES JND
C   FULL EVENT=1             1,
C               =>2            2,3,
C                  =>3             4,5,6,
C                     =>4                7,8,9,10,
C                        =>5                      11,12,13,14,15
C
C  *******************  OUTPUT PARAMETERS   **************************
C   THE RESULTS OF THE DECOMPOSITION ARE:
C   1. JET MEMBER LIST:
C     ITR = LPJ(I,JND,INDEC)  FOR QPI(,ITR) 2<I FOR TRAX I IN JET JND
C   2. JET MOMENTA
c      PJET(K,JND,INDEC)
c    K=1,..5  px,..m
C      6      charge
C      7      neutrals
C      8      momentum
C    JND=1,..15; JETS for DECOMPOSITION from call nr. INDEC
C **********************************************************************
C
C   DECO IS CONTROLLED BY THE CHOICE OF THE JET FUNCTION "JETFU",
C    PARAMETER JETFU SELECTS THE JETFUNCTION TO BE MINIMIZED
C     JETFU    1    (2)     3    4   (5)     6     7  8  9  10  *****
C             -P  (-BETA)   M   M**2 (PETEE) USER   USER USER
C
C   DECO CAN BE INFLUENCED BY SOME BOUNDARY CONDITIONS.
C    MAXMUL = JET MULTIPLICITY UP TO WHICH THE DECOMPOSITION
C     IS TO BE PERFORMED. MAXMUL<=5
C    MINPA = MINIMUM NO OF PARTICLES IN A JET
C   (EC2: A CUT-OFF PARAMETER FOR BETA; NOT USED)
C   IFRAME CONTROLS THE FRAME OF REFERENCE IN WHICH TO DECOMPOSE
C       for initial sign of life
      IF(NEVPRI.LE.1) GOTO 1
      DO 2 I=1,10
      IF(JETF(I).EQ.0) GOTO 2
      PRINT *,'EDECX, INDEC=',I,' JETFU=',JETF(I),' JETNAME=',JETNAM(I)
     1,' IFRAME=',IFRAME(I),'ITROFF=',ITROFF(I),'INIMU=',INIMUL(I)
     2,'MAXMUL',MAXMUL
   2  CONTINUE
      DO 3 I=1,JTBI
      IF(QPI(4,I).LE.0.) GOTO 3
      PRINT *,'EDECX1, TRAX#, QX,Y,Z,E,M=',I,(QPI(K,I),K=1,5)
   3  CONTINUE
   1  CONTINUE
C

************************************************************************
*       CLEAR AND INITIALIZE JET LISTS LPJ(I,JET,INDEX)   0<I<153      *
*                            JET VECTORS PJET(K,JET,INDEX) 0<K<11      *
************************************************************************
C clear ...
      DO 13 INDEC=1,10
      IF(JETF(INDEC).LE.0) GOTO 13
      DO 19 L=1,5
      FTOP(L,INDEC)=0.
   19 CONTINUE
      DO 12 JND=1,15
      DO 11 I11=1,IPTMAX+2
      LPJ(I11,JND,INDEC)=0
   11 CONTINUE
      DO 14 I14=1,10
   14 PJET(I14,JND,INDEC)=0.
   12 CONTINUE
   13 CONTINUE
C INITIALIZE JET MEMBER LIST LPJ(I>2,JND=1,INDEC)
C    SETTLE STARTING JET ADDRESS JP, AND VECTOR PJET(,JP,INDEC)
C    FOR ALL REQUESTED DECO MODES INDEC
      IEVT=1+IPTMAX
      DO 15 INDEC=1,10
      IF(JETF(INDEC).LE.0) GOTO 15
      JP = 1
      LPJ(1,1,INDEC)=JTBI
      LPJ(2,1,INDEC)=JP
      DO 16 I=1,JTBI
      LPJ(I+2,1,INDEC)=I
   16 CONTINUE
      DO 17 K=1,5
   17 PJET(K,JP,INDEC)=QPI(K,ITROFF(INDEC) + IEVT)
      PJET(6,JP,INDEC)=QTBIR(1,ITROFF(INDEC) + IEVT)
c  save and test print initialisation
      IF(JETF(INDEC).EQ.4) FTOP(1,INDEC)=PJET(5,1,INDEC)**2
      IF(JETF(INDEC).EQ.3) FTOP(1,INDEC)=PJET(5,1,INDEC)
      JETMUL=1
C14/02/99      CALL QESAVE(INDEC,JETMUL)
      IF(MODUS.EQ.1)  CALL HEPHAN(INDEC,JETMUL)
         IF(NEVPRI.GE.1) THEN
         DFTOP=0.
         NAMOUL=JETNAM(INDEC)
         FTOPO=FTOP(JETMUL,INDEC)
         PRINT *,'MULTIPLET=',JETMUL,' INDEC=',INDEC
     1,'JET NAME=',NAMOUL,' TOPOL FU =',FTOPO,'CHANGE=',DFTOP
      JND=1
      PRINT *,'JET NAME,#,MOM,CH,NPJ='
     1,NAMOUL,JND,(PJET(K,JND,INDEC),K=1,6),LPJ(1,JND,INDEC)
         ENDIF
   15 CONTINUE

************************************************************************
*       MINIMIZATION PART                                              *
************************************************************************
* ------   JET MULTIPLICITY LOOP   ------------------------------------*
*
      DO 100 JETMUL=2,MAXMUL
C                           DECOMPOSITION :  JETMUL-1 => JETMUL
C   range of jet numbers: JNDL =< JND =< JNDH
      JNDH=JETMUL*(JETMUL+1)/2
      JTMLM1=JETMUL-1
      JNDL=JNDH-JTMLM1
      JNDHM1=JNDH-1
      JNDLM1=JNDL-1
C
*-------   JET FUNCTIONS LOOP JETFU(INDEC)  ---------------------------*
*
      DO 110 INDEC=1,10
      JETFU=JETF(INDEC)
      IF (JETFU.LE.0) GOTO 110
      NAMOUL=JETNAM(INDEC)
      INIMU=INIMUL(INDEC)
      IF(INDEC.EQ.1) INIMU= -1
************************************************************************
*          INITIALIZE STARTING CONFIGURATION FOR JETMUL FROM           *
*            - (same jetfu, Previos jetMul)  IDECPM,inimul=-1          *
*            - (Previos jetFu, same jetmul)  IDECPF,inimul= 0          *
************************************************************************
      IF(NEVPRI.GE.2)
     1PRINT *,'EDECX3, INIMU=',INIMU,'INDEC=',INDEC,'JND=',JNDL,JNDH
     2,'JETFU=',JETFU
      IF(INIMU.EQ.-1) CALL QDECPM(JETMUL,INDEC)
      IF(INIMU.EQ.0) CALL QDECPF(JETMUL,INDEC,IDPREV(INDEC))
        FTOPO=0.
************************************************************************
*      DO DECOMPOSITION UNTIL MIN VALUE OF EVENT SHAPE FUNCTION FOUND  *
************************************************************************
       CALL QEMIN1(JETMUL,INDEC,DFTOP,FTOPO)
      FTOP(JETMUL,INDEC)=FTOPO
C
          IF(NEVPRI.GE.2)THEN
         PRINT *,'**DECO** 1. MINIMUM, MULTIPLET=',JETMUL,'INDEC=',INDEC
     1,'JET NAME=',JETNAM(INDEC),'TOPOL FU =',FTOPO,'CHANGE=',DFTOP
      DO 103 J=1,JETMUL
      JND=J+JNDLM1
      IF(PJET(4,JND,INDEC).LE.0.) GOTO 103
      PRINT *,'JET NAME,#,MOM,CH,NPJ='
     1,NAMOUL,J,(PJET(K,JND,INDEC),K=1,6),LPJ(1,JND,INDEC)
 103  CONTINUE
          ENDIF
C
************************************************************************
*      GO REVERSE GEAR, IF REQUESTED, FOR MREV STEPS                   *
************************************************************************
      IF(IREV(INDEC).LT.1) GOTO 101
       MREV=LPJ(1,1,INDEC)*0.13
       CALL QEMIN2(JETMUL,INDEC,DFT,FT,MREV,NEW,IFLAG)
      IF (IFLAG.NE.0) GOTO 99
      IF(NEW.EQ.0) GOTO 101
      FTOPO=FT
      FTOP(JETMUL,INDEC)=FTOPO
      DFTOP=DFTOP + DFT
          IF(NEVPRI.GE.2)THEN
         PRINT *,'**DECO** 2. MINIMUM FOUND'
          ENDIF
C
 101    CONTINUE
         IF(NEVPRI.GE.1) THEN
         PRINT *,'MULTIPLET=',JETMUL,' INDEC=',INDEC
     1,'JET NAME=',JETNAM(INDEC),' TOPOL FU =',FTOPO,'CHANGE=',DFTOP
      DO 104 J=1,JETMUL
      JND=J+JNDLM1
      IF(PJET(4,JND,INDEC).LE.0.) GOTO 104
      PRINT *,'JET NAME,#,MOM,CH,NPJ='
     1,NAMOUL,J,(PJET(K,JND,INDEC),K=1,6),LPJ(1,JND,INDEC)
 104  CONTINUE
         ENDIF
C                                                  END JET FUNCTION LOOP
C                        SAVE RESULT FOR THIS MULTIPLET AND JET FUNCTION
C  FILL MULTIPLET BANK
C14/02/99      CALL QESAVE(INDEC,JETMUL)
C  FILL QCTBUF, HEPHAN does not invoke any PHAN stuff, except for qctbuf
      IF(MODUS.EQ.1)  CALL HEPHAN(INDEC,JETMUL)
 110    CONTINUE
C                                              END JET MULTIPLICITY LOOP
 100    CONTINUE
      RETURN
C ERROR EXIT
  99  CONTINUE
      PRINT *,'** ERROR ** WITH EMIN2, AT L=',JETMUL,'INDEC=',INDEC
      RETURN
      END
