*CMZ :  2.00/04 31/07/2000  21.11.45  by  Tancredi Carli
*CMZ :  0.03/03 16/08/91  13.31.06  by  G. Knies
*-- Author :    G. Knies   24/07/91
         SUBROUTINE HEPHAN(INDEC,JETMUL)
C----------------------------------------------------------------
C        Write result from EVENT DECOMPOSITION algorithm EVDECO
C             for ONE JET FUNCTION(INDEC) and ONE MULTIPLET(JETMUL)
C             to common/QCTBUF/
C
C        INPUT:
C               COMMON/RECOM/,/COCOM/
C        OUTPUT:
C               COMMON/QCTBUF/
C         QPO(1,2,3,4,5;JND) is the 4-vector of jet JND>1
C         QTBOR(1,2,3,4,5;JND) has charge(1),no of particles(2)
C         JTBOF(L,I) jet # to which particle I is asigned in multipl. L
C
C
C   AUTHOR: G.KNIES, 22/07/91
C----------------------------------------------------------------
*

#include "decoma.inc"

#include "qjmacs.inc"

      DIMENSION ITBOR(5,JTBOMX)
      EQUIVALENCE(QTBOR(1,1),ITBOR(1,1))

*                                                  *******************

C  FILL QCTBUF
C     JTBO       NUMBER OF OUTPUT JETS (<=15)
C     QPO(K,J)   MOMENTUM VECTOR FOR JET J (j=2, ... ,jtbo
C                  K=1,2,3,4:PX,PY,PZ,E; 5=mass,
C                  J= (2,3);(4,5,6);(7,8,9,10);(11,12,13,14,15)
C                for L= 2      3        4             5, multiplet
C     JTBOF(L,I) JET # JL TO WHICH PARTICLE I BELONGS IN MULTIPLET L
C                 (JL= 1,2; 1,2,3; 1,2,3,4; 1,2,3,4,5)
C     QTBOR(K,J)  FURTHER INFORMATION ON JET J
C                 k=1=charge,2=particles,3=neutrals,
*
      JNDH=JETMUL*(JETMUL+1)/2
      JNDLM1=JNDH - JETMUL
      JTBO=JNDH
      DO 102 J=1,JETMUL
        JND=J+JNDLM1
        NPJ=LPJ(1,JND,INDEC)
        ITBOR(2,JND)=NPJ
        QTBOR(1,JND)=PJET(6,JND,INDEC)
       DO 103 I=1,NPJ
       IPA=LPJ(2+I,JND,INDEC)
       JTBOF(JETMUL,IPA)=J
C         IPA=THE QPI(,IPA) PARTICLE AT POSITION I IN JET J
C         LPJ: INPUT MOMENTUM QPI(,LPJ(I))
  103 CONTINUE
C
      DO 104 I=1,5
      QPO(I,JND)=PJET(I,JND,INDEC)

  104 CONTINUE
c      print *,'jnd,indec',jnd,indec
c      print *,'pjet(i,jnd,indec)',(pjet(i,jnd,indec),i=1,5)
  102 CONTINUE
      QTBOR(2,1)=FTOP(JETMUL,INDEC)
          IF(NEVPRI.GE.2)THEN
      PRINT *,'QCTBUF MADE, FOR MULTIPLET',JETMUL
     1,' TOPOL FU=',JETNAM(INDEC),' INDEC=',INDEC
            IF(JETMUL.EQ.MAXMUL) THEN
      DO 200 I=1,JTBI
      PRINT *,' QPI(1-5,I), I,IVEC=',I,JTBIT(I),(QPI(K,I),K=1,5)
      PRINT *,' QTBIR(1-5,I), I=',I,(QTBIR(K,I),K=1,5)
      PRINT *,' JET MEMBERSHIP IN L=1-5:',(JTBOF(L,I),L=1,5)
  200 CONTINUE
             ENDIF
      DO 201 J=1,JTBOMX
      PRINT *,' QPO(1-5,J), J=',J,(QPO(K,J),K=1,5)
      PRINT *,' QTBOR(1-5,J), J=',J,(QTBOR(K,J),K=1,5)
  201 CONTINUE
          ENDIF



         RETURN
         END
