*CMZ :  2.00/04 31/07/2000  21.11.45  by  Tancredi Carli
*CMZ :  2.03/09 02/11/96  23.51.48  by  Joerg Marks
*CMZ :  1.06/00 07/03/94  21.45.36  by  P. Schleper
*CMZ :  1.01/02 12/05/92  10.27.54  by  M. Erdmann
*CMZ :  1.00/00 10/03/92  14.25.00  by  M. Erdmann
*CMZ :          07/03/94  19.12.56  by  G. Knies
*-- Author :    G. Knies   07/03/94
      SUBROUTINE QDECPM(JETML,INDEC)
      INTEGER JETML,INDEC
************************************************************************
*   PURPOSE:
*      DOES INITIALIZATION FOR DECOMPOSITION
*       idecPM initializes deco step from Previos Multiplet
*       idecSM initializes deco step from Same Multiplet of previosly
*        performed deco with another topological function(jetfu(index))
*        here index < indec !
*      SEARCHES FOR (1.) MINIMUM,
*        without repeated migration of a particle
*
*  AUTHOR: Gerhard Knies,
C
C     VERSION OF 31/1/91  CAN BE CALLED FOR JETMULTIPL    2<=JETMUL<=5
C     VERSION OF 15/2/91  CAN BE CALLED JETFUNCTION INDEX 1<=INDEC<=10
C     VERSION OF 10/6/91  covariant N-directional thrust included
C  ***************  INPUT PARAMETERS  ********************************
C  *
C   JETMUL = THE RESULTING MULTIPLICITY OF JETS,
C     COLD START: THE I=JETMUL-1 RESULT IS STARTING CONFIGURATION
C     WARM START: REFINEMENT OF A J=JETMUL MULTPLICITY DECOMPOSITION
C   MAXMUL = THE MAXIMUM NUMBER OF JETS INTO WHICH THE EVENT SHALL
C     BE DECOMPOSED.
C     IF JETMUL > MAXMUL, ONLY INITIALISATION OF STARTING CONFIGURATION.
C   MINPA  = MINIMUM NUMBER OF PARTICLES REQUESTED FOR A JET
C
C     VIA COMMON/QCTBUF/
C   JTBI  = NUMBER OF INPUT VECTORS FOR CURRENT EVENT (MAX : JTBIMX)
C   QPI(I,IPA) THE INPUT PARTICLE MOMENTUM VECTORS, 1=<IPA<=JTBI
C               I=1,2,3,4,5: PX,PY,PZ,E,M; I=6: CHARGE
C  *
C  *******************  OUTPUT PARAMETERS   **************************
C  *
C   PJET(10,15,10) provides space for ALL RESULTING JETS
C    CONTENT of PJET(K,JND,INDEC)
C    K=1,..5  px,..m
C      6      charge
C      7      neutrals
C      8      momentum
C  *
C  ****************  INTERNAL PARAMETERS  **************************
C  *
C   THE (INTERNAL) JET "NAMES" ARE "JND":
C    1-JET DECO: JND = 1 (TRIVIAL, UNDECOMPOSED EVENT)
C    2-JET DECO: JND = 2,3
C    3-JET DECO: JND = 4,5,6
C    4-JET DECO: JND = 7,8,9,10
C    5-JET DECO: JND = 11,12,13,14,15
C    JINDH = HIGHEST JET NAME AT JND= JETMUL*(JETMUL+1)/2
C    JINDL = LOWEST JET NAME AT JND = JINDH - (JETMUL-1)
C
C   LIST OF PARTICLE ASSIGNMENTS TO JETS IN ARRAY LPJ(I,JND,INDEC)
C    LPJ(I,JND,INDEC) = IPA INDEX FOR PARTICLES IN SUBSET JND, AT I>2
C    LPJ(1,JND,INDEC) = (CURRENT) NO. OF PARTICLES IN JET JND
C    LPJ(2,JND,INDEC) = JND (redundant)
C  *
C  *********************************************************************
C
C   THE DECOMPOSITION
C    IS CONTROLLED BY THE CHOICE OF THE JET FUNCTION "JETFU",
C    AND CAN BE INFLUENCED BY SOME BOUNDARY CONDITIONS.
C   JETFU SELECTS THE JETFUNCTION TO BE MINIMIZED
C     JETFU    1     2      3    4    5      6     7  8  9  10  *****
C             -P   -BETA    M   M**2  PETEE  USER   USER USER
C
c
C                                                        INTERNAL ARRAYS
C     LDC(I)     NO OF CURRENT VALID PARTICLES IN SET I
C     LDA(I)     NO OF ORIGINAL + IMMIGRATED PARTICLES IN SET I
C
*D: QEMIN1 10000 gk. data statement added to avoid compilat.complaints
*D: QEMIN1 10102 me. lower case to upper case
*D: QEMIN1 10600 ps. remove unreachable code
*D: QEMIN1 20309 jm. fix compiler bug on the VAX found by S.B.
*****
#include "decoma.inc"
#include "qjmacs.inc"


       INTEGER JETMUL
       DIMENSION LDC(5),NHLS(5),IDP(5),LD(2*JPTMAX+2,5),LDA(5)
       DIMENSION P(5,JPTMAX+50),PR(5,JPTMAX+50)
       EQUIVALENCE (P(1,1),QPI(1,1))
       EQUIVALENCE (PR(1,1),QTBIR(1,1))
C
C
       integer j
       double precision eve,evx,evy,evz,evs,ej,ejh,pj,tjet,pr,p
       double precision sjh,pjh,pjhc,fmeq,ejt,pjt,sjt,pjtc,tne,tnx
       double precision tny,tnz,enj,pnj,snj,hne,hnx,hny,hnz,smsq
       integer ldc,nhls,idp,ld,lda
       double precision dmm,dmmt,dmij,dmml,dmh0,dmt0,dmt1
c      double precision eve,evx,evy,evz,evs,he,hx,hy,hz,te,tx,ty,tz,ej
c      double precision p,pr 
      DATA JCAL/0/
      DATA JND,JNDL,JNDH,JNDLM1,JETFU,NEVENT /0,0,0,0,0,0/
      SAVE JETMUL

      JETFU=JETF(INDEC)

      JETMUL = JETML
************************************************************************
*                                                                      *
*      INITIALIZE JET MULTIPLET FROM PREVIOUS (LOWER) MULTIPLET        *
*      OF THE SAME JET FUNCTION                                        *
************************************************************************
C                          THE RANGE OF JET NAMES JND FOR CURRENT JETMUL
    8 JNDH=JETMUL*(JETMUL+1)/2
      JTMLM1=JETMUL-1
      JNDL=JNDH-JTMLM1
      JNDHM1=JNDH-1
      JNDLM1=JNDL-1
C                           INITIALIZE JET MEMBER LISTS FOR THE NEW JETS
      DO 3 I=1,IPTMAX+2
      LPJ(I,JNDH,INDEC)=0
 3    CONTINUE
      DO 1 J=JNDL,JNDHM1
      IMAX=LPJ(1,J-JTMLM1,INDEC)+2
      DO 2 I=1,IPTMAX+2
      LPJ(I,J,INDEC)=0
      IF(I.GT.IMAX) GOTO 2
      LPJ(I,J,INDEC)=LPJ(I,J-JTMLM1,INDEC)
  2   CONTINUE
      JND =LPJ(2,J-JTMLM1,INDEC) + JTMLM1
      LPJ(2,J,INDEC)=JND
C     CALL SETP(JND-JTMLM1,JND)
      DO 5 I=1,6
  5   PJET(I,JND,INDEC)=PJET(I,JND-JTMLM1,INDEC)
  1   CONTINUE
      LPJ(2,JNDH,INDEC)=LPJ(2,JNDHM1,INDEC)+1
C   AND THE NEW VIRGIN JET MOMENTUM
      DO 6 I=1,10
      PJET(I,JND+1,INDEC)=0.
  6   CONTINUE
      EC2=ECONF
      DMMT=0.

           IF(NEVPRI.GE.2) THEN
             PRINT *,'INI"ON FROM PREVIOS MULT FINISHED'
             PRINT *,
     1 JNDL,'=< JND <=',JNDH,('JET#,-LIST LPJ=',JND,(LPJ(I,JND,INDEC),
     2I=1,(LPJ(1,JND,INDEC)+2)),JND=JNDL,JNDH)
                           ENDIF
      RETURN
************************************************************************
*      ENTRY POINT IDECSM                                              *
*      INITIALIZE JET MULTIPLET FROM PREVIOS JET DECOMPOSITION INDEX,  *
*      BUT SAME MULTIPLET
************************************************************************    
       ENTRY QDECPF(JTMUL,INDEC,INDEX)
C     IF(INIMUL.EQ.1) CALL IDECPF(JETMUL,INDEC,INDEX,DFJET) in sr edecx
     
       IF(INDEX.LE.0) GOTO 99
       IF(INDEX.GE.INDEC) GOTO 99

       IF(JTMUL.EQ.JETMUL) GOTO 7
       IF(JTMUL.NE.(JETMUL+1)) GOTO 99
       INDEC=INDEX
       JETMUL=JTMUL
       GOTO 8
    7 CONTINUE
      DO 21 J=JNDL,JNDH
      IMAX=LPJ(1,J,INDEX)+2
      DO 22 I=1,IPTMAX+2
      LPJ(I,J,INDEC)=0
      IF(I.GT.IMAX) GOTO 22
      LPJ(I,J,INDEC)=LPJ(I,J,INDEX)
  22   CONTINUE
  21   CONTINUE
C                                                 INITIALIZE JET MOMENTA
      JPL=LPJ(2,JNDL,INDEC)
      JPH=LPJ(2,JNDH,INDEC)
C     CALL SETP(J-20*(INDEX-INDEC),J)
   
      DO 24 J=JPL,JPH
      DO 25 I=1,10
  25  PJET(I,J,INDEC)=PJET(I,J,INDEX)
  24   CONTINUE
      EC2=ECONF
      DMMT=0.
*070394    IF(NEVENT.GE.2) THEN
*            PRINT *,'QEMIN1, INI"ON FROM PREVIOS JET FUNCTION '
*            PRINT *,
*    1 JNDL,'=< JND <=',JNDH,('JET#,-LIST LPJ=',JND,(LPJ(I,JND,INDEC),
*    2I=1,(LPJ(1,JND,INDEC)+2)),JND=JNDL,JNDH)
*     PRINT *,'PJET NR + VEC :'
*     PRINT *,(JND,(PJET(K,JND,INDEC),K=1,6),JND=JNDL,JNDH)
*                          ENDIF
      RETURN
************************************************************************
*                                                                      *
*      ENTRY POINT EMIN1                                               *
*      M I N I M I Z A T I O N    L O O P                              *
*                                                                      *
************************************************************************
      ENTRY QEMIN1(JETML,INDEC,DFTOP,FTOPO)
*     mepj=0(1) for multiple exchange of a particle between jets
C               forbidden(allowed)
      JETMUL = JETML
      EC2=ECONF
  9   CONTINUE
      IF(JCAL.GT.0) GOTO 1001
      JCAL=JCAL+1
      WRITE(6,1000) INDEC
 1001  CONTINUE
 1000 FORMAT(' ****  MEMBER EMIN1 IN ACTION ****   for INDEC=',I4)
C**   IF(MAXMUL.LT.5)  RETURN
C  LDC(I) =CURRENT # OF PARTICLES IN SET I
C  LDA(I) =# OF PARTICLES IN SET I AT START + THE IMMIGRANTS
C  NHLS(I)=# OF PARTICLES IN SET I AT START
C  IDP(I) = P - VECTOR INDEX FOR SET #I
C  MINPA IS THE MINIMUM NUMBER OF PARTICLES TO BE LEFT IN A JET

      DO 10 J=1,5
      IDP(J)=0
      LDC(J)=0
      LDA(J)=0
      NHLS(J)=0
  10  CONTINUE
      DO 11 J=1,JETMUL
      IDP(J)=LPJ(2,JNDLM1+J,INDEC)
      LDC(J)=LPJ(1,JNDLM1+J,INDEC)
      LDA(J)=LPJ(1,JNDLM1+J,INDEC)
      NHLS(J)=LPJ(1,JNDLM1+J,INDEC)
  11  CONTINUE
      DO 12 I=1,5
      DO 14 J=1,2*IPTMAX+2
 14   LD(J,I)=0
 12   CONTINUE
      DO 13 J=1,JETMUL
      LD(1,J)=LPJ(1,JNDLM1+J,INDEC)
      LD(2,J)=LPJ(2,JNDLM1+J,INDEC)
      DO 13 K=3,IPTMAX+2
      LD(K,J)=LPJ(K,JNDLM1+J,INDEC) + ITROFF(INDEC)
 13   CONTINUE
C* Event 4-vector
      J1=LPJ(2,1,INDEC)
      EVE=PJET(4,J1,INDEC)
      EVX=PJET(1,J1,INDEC)
      EVY=PJET(2,J1,INDEC)
      EVZ=PJET(3,J1,INDEC)
      EVS=PJET(5,J1,INDEC)**2

C                                    M I N I M I Z A T I O N   S T A R T
      DMMT=0.
  15  CONTINUE
C                                       M I N I M I Z A T I O N  L O O P
C   LOOK FOR THAT PARICLE TRANSITION FROM ANY (HOME) JET TO
C   ANY (TARGET) JET YIELDING THE LARGEST REDUCTION OF THE JETFUNCTION
      DMM=0.
C INDEX OF BEST HOME SET
      IHBEST=0
C INDEX OF BEST TARGET SET
      ITBEST=0
C INDEX OF BEST PARTICLE TO FLIP
      IPBEST=0
       FTOPO=0.
C                                             H O M E  S E T  L O O P  I
       DO 100 I=1,JETMUL
C                                                      HOME JET SELECTED
C                  ENOUGH PARTICLES IN HOME JET FOR FURTHER EMIGRATION ?
       IF(LDC(I).LE.MINPA) GOTO 100
C IF ONLY ORIGINAL MEMBERS OF HOMESET ARE ADMITTED FOR MIGRATION
       NHL=NHLS(I)+2
C IF ORIGINAL MEMBERS OF HOMESET AND IMMIGRANTS ARE ADMITTED
Cc     NHL=LDA(I)+2
       IPH=IDP(I)
C      CALL FMEQ(DMH0,IPH,EC2,JETFU)
C         CALCULATE CONTRIBUTION OF PRESENT HOME JET TO THE JET FUNCTION
       HE = PJET(4,IPH,INDEC)
       HX = PJET(1,IPH,INDEC)
       HY = PJET(2,IPH,INDEC)
       HZ = PJET(3,IPH,INDEC)
 
       EJH = HE*HE
       PJH = HX*HX + HY*HY + HZ*HZ
       SJH = EJH - PJH
C  GO TO THE REQUESTED JET FUNCTION
       GOTO (301,302,303,304,310,310,310,310,310,310),JETFU
  301   PJHC=HE*EVE-HX*EVX-HY*EVY-HZ*EVZ
        PJHC = PJHC*PJHC/EVS - SJH
        IF(PJHC.LT.0.) PJHC=0.
        DMH0=-SQRT(PJHC)
        GOTO 16
  302   FMEQ=EJH-PJH
        FMEQ=FMEQ/(EJH+EC2)
        DMH0=-SQRT(1.-FMEQ)
        GOTO 16
  303   FMEQ=EJH-PJH
C because of rounding errors when beam pipe particles present
        IF(FMEQ.LT.0.) FMEQ=0.
        DMH0=SQRT(FMEQ)
        GOTO 16
  304   DMH0=EJH-PJH
        GOTO 16
  310   DMH0=0.

   16 CONTINUE
        FTOPO=FTOPO + DMH0
       IF(NHL.LE.2) GOTO 100

C                                         T A R G E T  S E T  L O O P  J
         DO 110 J=1,JETMUL
C                                                    TARGET JET SELECTED
         IF(J.EQ.I) GOTO 110
         IPT=IDP(J)
C        CALL FMEQ(DMT0,IPT,EC2,JETFU)
C      CALCULATE CONTRIBUTION OF SELECTED TARGET JET TO THE JET FUNCTION
       TE=PJET(4,IPT,INDEC)
       TX = PJET(1,IPT,INDEC)
       TY = PJET(2,IPT,INDEC)
       TZ = PJET(3,IPT,INDEC)
       EJT = TE*TE
       PJT = TX*TX + TY*TY + TZ*TZ
       SJT = EJT - PJT
C                                       GO TO THE REQUESTED JET FUNCTION
       GOTO (311,312,313,314,320,320,320,320,320,320),JETFU
  311   PJTC=TE*EVE-TX*EVX-TY*EVY-TZ*EVZ
        PJTC = PJTC*PJTC/EVS - SJT
        IF(PJTC.LT.0) PJTC=0.
        DMT0=-SQRT(PJTC)
        GOTO 17
  312   FMEQ=EJT-PJT
        FMEQ=FMEQ/(EJT+EC2)
        DMT0=-SQRT(1.-FMEQ)
        GOTO 17
  313   FMEQ=EJT-PJT
C because of rounding errors when virgin target jet empty:
        IF(FMEQ.LT.0.) FMEQ=0.
        DMT0=SQRT(FMEQ)
        GOTO 17
  314   DMT0=EJT-PJT
        GOTO 17
  320   DMT0=0.
   17    DMIJ=DMH0 + DMT0
C  ************************  P A R T I C E L  S E A R C H   L O O P  IJP
C  *                                                                   *
        DO 111 ILH=3,NHL
        IJP=LD(ILH,I)
C                              TEST PARTICLE IJP FROM HOME SET SELECTED
        IF(IJP.LE.0) GOTO 111
C       CALL AFMEQ(DMT1,IPT,IJP,EC2,JETFU)
C   CALCULATE JET FUNCTION FOR TARGET JET + IMMIGRATED TEST PARTICLE
       TNE=TE + P(4,IJP)
       TNX=TX + P(1,IJP)
       TNY=TY + P(2,IJP)
       TNZ=TZ + P(3,IJP)
       ENJ = TNE*TNE
       PNJ = TNX*TNX + TNY*TNY + TNZ*TNZ
       SNJ = ENJ - PNJ
       GOTO (321,322,323,324,330,330,330,330,330,330),JETFU
  321   PJTC=TNE*EVE-TNX*EVX-TNY*EVY-TNZ*EVZ
        PJTC = PJTC*PJTC/EVS - SNJ
        IF(PJTC.LT.0.) PJTC=0.
        DMT1=-SQRT(PJTC)
        GOTO 18
  322   FMEQ=ENJ-PNJ
        FMEQ=FMEQ/(ENJ+EC2)
        DMT1=-SQRT(1.-FMEQ)
        GOTO 18
  323   FMEQ=ENJ-PNJ
C because of rounding errors when virgin target jet empty:
        IF(FMEQ.LT.0.) FMEQ=0.
        DMT1=SQRT(FMEQ)
        GOTO 18
  324   DMT1=ENJ-PNJ
        GOTO 18
  330   DMT1=0.
   18  CONTINUE
C       CALL SFMEQ(DMH1,IPH,IJP,EC2,JETFU)
C   CALCULATE JET FUNCTION FOR HOME JET - EMIGRATED TEST PARTICLE
       ENJ=(HE-P(4,IJP))*(HE-P(4,IJP))
       PNJ=(HX-P(1,IJP))*(HX-P(1,IJP))
     1   +(HY-P(2,IJP))*(HY-P(2,IJP))
     2   +(HZ-P(3,IJP))*(HZ-P(3,IJP))
       HNE=HE - P(4,IJP)
       HNX=HX - P(1,IJP)
       HNY=HY - P(2,IJP)
       HNZ=HZ - P(3,IJP)
       ENJ = HNE*HNE
       PNJ = HNX*HNX + HNY*HNY + HNZ*HNZ
       SNJ = ENJ - PNJ
       GOTO (331,332,333,334,340,340,340,340,340,340),JETFU
  331   PJHC=HNE*EVE-HNX*EVX-HNY*EVY-HNZ*EVZ
        PJHC = PJHC*PJHC/EVS - SNJ
        IF(PJHC.LT.0.) PJHC=0.
        DMH1=-SQRT(PJHC)
        GOTO 19
  332   FMEQ=ENJ-PNJ
        FMEQ=FMEQ/(ENJ+EC2)
        DMH1=-SQRT(1.-FMEQ)
        GOTO 19
  333   FMEQ=ENJ-PNJ
C because of rounding errors when NEARLY  jet empty:
        IF(FMEQ.LT.0.) FMEQ=0.
        DMH1=SQRT(FMEQ)
        GOTO 19
  334   DMH1=ENJ-PNJ
        GOTO 19
  340   DMH1=0.
C  IS JET FUNCTION WITH CURRENT TEST PARICLE
C    SMALLER THAN FOR ANY PREVIOS ONE ? -- THEN REMEMBER IT!
   19  DM = DMH1 + DMT1 - DMIJ
         IF(DM.GE.DMM) GOTO 111
         DMM=DM
         IHBEST=I
         ITBEST=J
         IPBEST=ILH
C                                                                 *
C *****************  END PARTICLE SEARCH LOOP *********************
 111     CONTINUE
C                                                                  *
C *****************  END TARGET JET LOOP ***************************
 110    CONTINUE
C                                                                   *
C *****************  END HOME JET LOOP ******************************
 100   CONTINUE
C   DMM WAS THE REDUCTION IN JET FUNCTION ACHIEVED FOR THE BEST
C    PARTICLE MIGRATION BETWEEN ANY TWO JETS.
C   DMMT IS THE REDUCTION ACCUMULATED SINCE BEGINNING THE DECOMPOSITION
      DMMT=DMMT+DMM
      IF(NEVPRI.GE.2)
     1PRINT *,'QEMIN1, END OF SEARCH LOOP, DMM=',DMM
     2,'PART. I FROM HOME TO TARGET JET',LD(IPBEST,IHBEST)
     3,IHBEST,ITBEST
      IF(DMM.EQ.0)  GOTO  200
C   A  B E T T E R  S O L U T I O N  H A S  B E E N  F O U N D
C    F L I P  P A R T I C E L P(,IJ)  F R O M
C         IJ =  LD(ILH,IH)=>LD(ILT,JT)
      IH=IHBEST
      JT=ITBEST
      ILH=IPBEST
      IJ=LD(ILH,IH)
CC    IF(IJ.LE.0) GOTO 200
      LDC(IH)=LDC(IH) - 1
      LDC(JT)=LDC(JT) + 1
      LDA(JT)=LDA(JT) + 1
      ILT=LDA(JT)+2
      LD(ILT,JT)=LD(ILH,IH)
      LD(ILH,IH)=-LD(ILH,IH)
      IPH=IDP(IH)
      IPT=IDP(JT)
C  PARTICEL IJ HAS BEEN INVALIDATED IN LD(HOME)
C  PARTICEL IJ HAS BEEN ADDED     TO LD(TARGET)
C  UPDATE FOUR MOMENTA OF MODIFIED JETS
C     CALL SUB(IPH,IJ,IPH)
C     CALL ADD(IPT,IJ,IPT)
      DO 130 I=1,4
      PJET(I,IPH,INDEC)=PJET(I,IPH,INDEC)-P(I,IJ)
      PJET(I,IPT,INDEC)=PJET(I,IPT,INDEC)+P(I,IJ)
  130 CONTINUE
      PJET(6,IPH,INDEC)=PJET(6,IPH,INDEC)-PR(1,IJ)
      PJET(6,IPT,INDEC)=PJET(6,IPT,INDEC)+PR(1,IJ)
C    N O W  S E A R C H  F O R  N E X T  B E S T  F L I P
      GOTO 15
 200  CONTINUE
C   NO BETTER VALUE OF THE JET FUNCTION HAS BEEN FOUND
C    BY TRYING A NEW JET ASSIGNMENT FOR EACH SINGLE PARTICLE.
C    E N D  O F  M I N I M I Z A T I O N
C   D E C O M P O S I T I O N  D O N E
      DFTOP=DMMT
C   C O M P R E S S  LD   A R R A Y S
      DO 30 J=1,JETMUL
      LDC(J)=0
       DO 31 I=3,2*IPTMAX+2
       M1=LD(I,J)
       IF(M1.LE.0) GOTO 31
       LDC(J)=LDC(J) + 1
       LDCJ=LDC(J)
       LD(LDCJ+2,J)=M1
  31   CONTINUE
      NL3=LDC(J)+3
      IF(NL3.GT.(2*IPTMAX+2)) GOTO 30
      DO 32 I=NL3,2*IPTMAX+2
  32  LD(I,J)=0
  30  LD(1,J)=LDC(J)
      DO 40 J=1,JETMUL
      JP=JNDLM1+J
      LPJ(1,JP,INDEC)=LD(1,J)
      LPJ(2,JP,INDEC)=LD(2,J)
      DO 41 I=1,IPTMAX+2
C  UPDATE JET MEMBER LISTINGS
      LPJ(I,JP,INDEC)=LD(I,J) - ITROFF(INDEC)
   41 CONTINUE
      JND=LPJ(2,JP,INDEC)
C  ADD M AND |P| TO JET VECTORS
      EJ=PJET(4,JND,INDEC)**2
      PJ=0.
      DO 42 I=1,3
      PJ=PJ+PJET(I,JND,INDEC)**2
   42 CONTINUE
      SMSQ=EJ-PJ
      IF (SMSQ.LT.0.) SMSQ=0.
      PJET(5,JND,INDEC)=SQRT(SMSQ)
C because of rounding errors when NEARLY  jet empty:
      PJET(8,JND,INDEC)=SQRT(PJ)
  40  CONTINUE
      RETURN
  99  RETURN
      END
