*CMZ :  1.01/07 02/10/97  12eV#_f-g
*-- Author :
C}}}
C{{{  jade
      SUBROUTINE JADEJET(P,NPA,YCUT,SCALE,IDIS,IRECOM,NUM,V)
C{{{  description
CN  jadejet -- jade jet algorithm
CS  call jadejet(p,npa,ycut,scale,idis,irecom,num*,v*)
CA  Thomas Hadig
CT  $Date: 2001-08-08 14:06:45 +0200 (Mi, 08. Aug 2001) $
CV  $Revision: 207 $
CF  $RCSfile$
CI. P(4,*) -- array of input vectors
CI. NPA -- number of input vectors
CI. YCUT -- cut value for second step
CI. SCALE -- value used to scale kt (Q**2)
CI. IDIS -- distance measure ( 1: JADE, 2 : E,P,E0)
CI. IRECOM -- recombination scheme (1 : E/JADE, 2 : E0, 3 : P)
CO. NUM -- number of jets
CO. V -- array of jets
CP  No options available
CB  No bugs known
CD  jadejet -- calculates the number of jets and the jet vectors for the
CD+ jade algorithm.
C}}}
 
      IMPLICIT NONE
 
      DOUBLE PRECISION P(4,*),V(4,*),YCUT,SCALE
      INTEGER NUM,NPA,IRECOM,IDIS
 
      double precision yij,mat(4,4)
      integer i,j,k,l
 
      double precision dist
 
C{{{  copy all particles
      do i=1,NPA
        call dvcopy(P,i,V,i)
      enddo
      NUM=NPA
C}}}
100   continue
C{{{  get all yij, and lowest yij
      yij=1D100
      do i=1,NUM
        do j=1,i-1
          mat(i,j)=dist(V,i,V,j,IDIS)
          if (mat(i,j).lt.yij) then
            yij=mat(i,j)
            k=i
            l=j
          endif
        enddo
      enddo
C}}}
C{{{  stop or go on ?
      if (yij.gt.SCALE*YCUT) goto 101
      if (k.le.l) then
        write (*,*) 'kt : internal error'
        stop
      endif
C add k+l -> l
      call dvadd(V,k,V,l,IRECOM)
C remove k from list
102   continue
      if (k.lt.NUM) then
        call dvcopy (V,k+1,V,k)
        k=k+1
        goto 102
      endif
      NUM=NUM-1
      goto 100
C}}}
 
101   continue
      RETURN
      END
