* Author Brian Cox
*
* This subroutine fills jetprofiles in eta and phi, in histograms hnoeta 
* and hnophi. 
* Max pt on the Y axis is set by pteta and ptphi.
      SUBROUTINE JETPROFILE(detajet,dphijet,hnoeta,hnophi,phase)
      IMPLICIT NONE
*
#include "hepevtp.inc"
#include "heracmn.inc"
 
      DOUBLE PRECISION detajet,dphijet
      REAL eppz,empz,rp,dfi,det,pi
      REAL etajet,phijet
      INTEGER hnophi,hnoeta,iloop,phase
      REAL pteta,ptphi,phi,ptobj
      REAL px,py
      REAL profbin(32)
      DATA profbin/-3.1,-2.9,-2.7,-2.5,-2.3,-2.1,-1.9,-1.7,-1.5,
     &     -1.3,-1.1,-0.9,-0.7,-0.5,-0.3,-0.1,
     &     0.1,0.3,0.5,0.7,0.9,1.1,1.3,1.5,
     &     1.7,1.9,2.1,2.3,2.5,2.7,2.9,3.1/
      pi=3.1415927
      etajet=real(detajet)
      phijet=real(dphijet)      

C book histograms 
      if (phase.eq.1) then
         CALL HBOOKB(hnophi,'phi profile',31,profbin,0)
         CALL HBOOKB(hnoeta,'eta  profile',31,profbin,0)
      endif
C	    CALL HWUEPR
C      write(*,*) etajet,phijet
C       --- loop from 6 to avoid final state electron
C       --- HERA SPECIFIC AT PRESENT !!!
      DO 10 iloop=6,nhep
         if (ISTHEP(iloop).eq.1) then
            eppz=REAL(PHEP(4,iloop)+PHEP(3,iloop))
            empz=REAL(PHEP(4,iloop)-PHEP(3,iloop))      
            if (eppz.gt.0) then
               rp=-0.5*log(empz/eppz)
            else 
               write(*,*) '*JETPROF* problem with rapidity calculation'
               goto 10
            endif
            px=REAL(PHEP(2,iloop))
            py=REAL(PHEP(1,iloop))
            phi=atan2(px,py)
            ptobj=SQRT(px**2+py**2)
*     jet profiles 
            
            dfi = phi-phijet
            det = rp-etajet
            if (dfi.gt.pi) then
               dfi=dfi-(2*pi)
            else if (dfi.lt.-pi) then
               dfi=dfi+(2*pi)
            end if
*            write(*,*) rp,ptobj,iloop,PHEP(4,iloop)
            if (abs(det).lt.1.0) then
               call hfill(hnophi,dfi,0,ptobj)
            end if
            if (abs(dfi).lt.1.0) then
               call hfill(hnoeta,det,0,ptobj)
            end if
         endif
 10   continue            

         return
         end

