      SUBROUTINE HZSNLO(ID0,ID1,ID2)
#ifdef NEVER
c     --------------------------------------
c     ID0 = final cross section histogram
c     ID1 = accumulated results of iterations for current process
c     ID2 = results for this iteration
c
c     This routine is called everytime "newiter" is set true in accum
c
c     For every call, take results in ID2 and add them to ID1.
c     Store the sum of squared results in the error of ID1 for 
c     later use in calculating errors.
c
c     If this is a new subprocess (as well as a new iteration),
c     calculate the errors on ID1 and then add the results from ID1 to
c     ID0 (dealing with normalisation correctly) and reset ID1.
c
c     
      IMPLICIT NONE

      INTEGER ID0,ID1,ID2,NENT1,NENT2

      CHARACTER*80 TIT
      INTEGER MXBIN,NBINS,I,EOFFSET,IOFFSET
      PARAMETER(MXBIN=30)
      PARAMETER(EOFFSET=50000)
      REAL ERRORS1(MXBIN),CONTENT1(MXBIN),ERRORS2(MXBIN)
     &     ,CONTENT2(MXBIN),ERRORS3(MXBIN)
     &     ,CONTENT3(MXBIN)
      REAL XXX,XSUMSQ,XSUM,XNORM

      REAL XMI,XMA,YMI,YMA,PROB,HSTATI,ERRTMP
      INTEGER NY,LOC,NWT
      LOGICAL HEXIST

#include "rfparam_hera.inc"

      IF (.NOT.NEW_ITERATION) RETURN

       IF (.NOT.HEXIST(ID2)) THEN
         WRITE(*,*) 'HZSNLO:No histogram ',ID2
     &        ,' : Errors not fixed.'
         RETURN
      ENDIF
      IF (.NOT.HEXIST(ID1)) THEN
         CALL HCOPY(ID2,ID1,' ')
         CALL HRESET(ID1,' ')
c         WRITE(*,*) 'HZSNLO:No histogram ',ID2
c     &        ,' : Errors not fixed.'
c         RETURN
      ENDIF

      CALL HGIVE (ID1,TIT,NBINS,XMI,XMA,NY,YMI,YMA,NWT,LOC)
      IF (NBINS.GT.MXBIN) THEN
         WRITE(*,*) 'HZSNLO Error: Too many bins. Increase MXBIN!'
         STOP
      ENDIF
         
*      WRITE(*,*) 'HZSNLO: Adding contents of ',ID2,' to ',ID1
      
c     Get the errors and contents for each histogram.
      CALL HUNPKE(ID1,ERRORS1,' ',1)
      CALL HUNPAK(ID1,CONTENT1,' ',1)
      
      CALL HUNPAK(ID2,CONTENT2,' ',1)
      CALL HUNPKE(ID2,ERRORS2,' ',1)
      
c     First fix the errors and normalisation on ID2 
c      CALL HNOENT(ID2,NENT2)
c      CALL HNOENT(ID1,NENT1)
      
c     write(*,*) 'Number of entries in ID1=',NENT1
c     write(*,*) 'Number of entries in ID2=',NENT2
         
      DO I=1,NBINS
            
c     Add the contents 
         CONTENT3(I)= CONTENT1(I) + CONTENT2(I)
         ERRORS3(I) = ERRORS1(I) + CONTENT2(I)**2
c         WRITE(*,*) 'Bin,ID1(e),ID2(e)',I,content3(i),errors3(i)
c     &        ,content2(i),errors2(i)

         
      ENDDO
      CALL HPAK(ID1,CONTENT3)
      CALL HPAKE(ID1,ERRORS3)
      CALL HRESET(ID2,' ')

      
      IF (NEWSUBP) THEN
   
         IF (subp.EQ.1.OR.subp.EQ.5) THEN
            XNORM=1./FLOAT(2*n0)
         ELSE
            XNORM=1./FLOAT(2*n3)
         ENDIF

*         WRITE(*,*) 'HZSNLO: Adding contents of ',ID1,' to ',ID0

         DO I=1,NBINS

c     Calculate the errors on the last subprocess

            XSUMSQ=ERRORS3(I)
            XSUM=CONTENT3(I)
            ERRORS3(I) = SQRT(ABS(XSUMSQ-XSUM**2*XNORM))

*            IF (XSUM.NE.0) THEN
*               WRITE(*,*) 'Bin,ID1(e),ID2(e)',I,content3(i),errors3(i)
*     &           ,content2(i),errors2(i)
*            ENDIF

         ENDDO
         CALL HPAKE(ID1,ERRORS3)
         
c     Normalisation is to the number of iterations. This is the
c     effective "number of events". (see the jetint routine accum: each
c     integration is an event.)
         
         CALL HOPERA(ID1,'+e',ID0,ID0,XNORM,1.0)
         CALL HRESET(ID1,' ')
         
      ENDIF

#endif NEVER

      RETURN
      END


