      subroutine hzh0307080(IFLAG)
***********************************************
* charm cross sections  at fermilab, hep-ex/0307080
* xsection numbers checked with publication PRL 91, 241804
* checked on 28.12.2004
*
***********************************************
      IMPLICIT NONE
*
      Real pi,dpi,rd,ee,eb,dphi,Qpi,qqradp,sigma_tot,xntot
      real p,ptb,et,rapb,th,phang,xd,dst_xsec
      real ptbb,rapbb
      real ps,pts,ets,raps,ths,phangs
      Logical lp
      data lp/.false./
*
      Character string*20
*
      real alph_em
      Parameter (alph_em=7.29927e-3)
      Real gev2nb,lum,fact,lumnb

      Integer iqbin,i1,i3,idhisto,idpaw

      Parameter (gev2nb=0.389e6)
      Integer maxhi
      Parameter (maxhi=10000)
      Real nev(maxhi)
      Integer nentry
      Real n2,nall,nall2,nall3
      Real xw
      Data nall/0/
      Integer jcut,ncut,iel,idum,id,idq2,idx
      Parameter (ncut=4,pi=3.1415927,dpi=2.*pi,rd=180./pi,ee=27.5)
*
      Integer ierr,ibeam,igam
      Double precision pbeam(4),pgam(4),pcm(4),ph(5),phb(4),phbb(4)
      Double Precision Phc(4)
      Real rap,pt
      Integer imuon,ij,idtest
      Double Precision phbbar(4)
*
      integer err_flag
      real x,y,w2,q2

      Double Precision Q2C,YY,YY_BAR,XG,XG_BAR,KT2_1,KT2_2,PT2H,SHH
      COMMON/CASKIN/Q2C,YY,YY_BAR,XG,XG_BAR,KT2_1,KT2_2,PT2H,SHH
*
#include "hzfunc.inc"
#include "hzhbook.inc"
#include "hepevtp.inc"
#include "heracmn.inc"
*
      Double precision plab(5,NMXHEP)
      Integer iflag,ihep,i,j,k,l,nb,nbb
      Logical charm,ldstar
      Real ptcut,rapcut,nbtot,nbsel
      Integer ipt,nptbin,nptcdf
      Parameter (nptbin=6)
	real ptbin(7)
      data ptbin/5.5,6.,7.,8.,10.,12.,20./
	real dsid0(6),dsid0st(6),dsid0sy(6)
	data dsid0/7837.,4056.,2052.,890.,327.,39.9/
	data dsid0st/220.,93.,58.,25.,15.,2.3/
	data dsid0sy/884.,441.,227.,107.,41.,5.3/
	real dsidst(6),dsidstst(6),dsidstsy(6)
	data dsidst/0.,2421.,1147.,427.,148.,23.8/
	data dsidstst/0,108.,48.,16.,8.,1.3/
	data dsidstsy/0,424,145.,54.,18.,3.2/
	real dsidpl(6),dsidplst(6),dsidplsy(6)
	data dsidpl/0,1961,986,375,136,19.0/
	data dsidplst/0,69,28,9,4,0.6/
	data dsidplsy/0,332,156,62,24,3.2/
	real dsids(6),dsidsst(6),dsidssy(6)
	data dsids/0,0,0,236,64,9/
	data dsidsst/0,0,0,20,9,1.2/
	data dsidssy/0,0,0,67,19,2.7/
	real dsid0to(6),dsidstto(6),dsidplto(6),dsidsto(6)

      Real xkt1,xkt2,x1,x2
      Integer igl1,igl2
	Integer id1,id2
*     DESY Preprint number
      Character*5 xxxx
      Data xxxx/'0307080'/
      Integer MINT
      Double Precision VINT
      COMMON/PYINT1/MINT(400),VINT(400)
*
*
*********************************************************************
*
*                      Initialization
*
*********************************************************************
      NENTRY=NENTRY+1
*
      IF (iflag.eq.1) then
*
         write(6,*)' hzh0307080 '
         Qpi = 4.*atan(1.)
         qqradp = 180./qpi
         nbtot = 0.
         nbsel = 0.
*
*
*      Initialisation: The following MUST always be done
*      (i) make subdirectory in PAWC
*       - use the name as the xxxxxx in HZxxxxxx subroutine
*      (i) make subdirectory in o/p file
*
         Call hcdir('//PAWC',' ')
         call hmdir(xxxx,'S')
         Call hcdir('//HISTO',' ')
         call hmdir(xxxx,'S')
*
*****************************
*  Make histograms of b cross section
*****************************
*
*

         call hbook1(21,' beam1 log(xg) (all)',50,-5,0.,0.)
         call hbook1(31,' beam2 log(xg) (all)',50,-5,0.,0.)
         call hbook1(22,' beam1 kt_2 (all)',50,0.,10.,0.)
         call hbook1(32,' beam2 kt_2 (all)',50,0.,10.,0.)
         call hbook1(210,' beam1 log(xg) (acc)',50,-5,0.,0.)
         call hbook1(310,' beam2 log(xg) (acc)',50,-5,0.,0.)
         call hbook1(220,' beam1 kt_2 (acc)',50,0.,10.,0.)
         call hbook1(320,' beam2 kt_2 (acc)',50,0.,10.,0.)
         call hbook2(12,'pt D0 vrs kt_2',100,0.,20.,100,0.,20.,0.)
         call hbookb(101,' dsig/dpt D0 ',nptbin,ptbin,0.)
         call hbookb(102,' dsig/dpt D*+ ',nptbin,ptbin,0.)
         call hbookb(103,' dsig/dpt D+ ',nptbin,ptbin,0.)
         call hbookb(104,' dsig/dpt Ds+',nptbin,ptbin,0.)
         call hbook1(111,' dsig/dpt D0 ',50,3.,23.,0.)
         call hbook1(112,' dsig/dpt D*+ ',50,3.,23.,0.)
         call hbook1(113,' dsig/dpt D+ ',50,3.,23.,0.)
         call hbook1(114,' dsig/dpt Ds+',50,3.,23.,0.)
         call hbookb(-101,' data stat dsig/dpt D0 ',nptbin,ptbin,0.)
         call hbookb(-102,' data stat dsig/dpt D*+ ',nptbin,ptbin,0.)
         call hbookb(-103,' data stat dsig/dpt D+ ',nptbin,ptbin,0.)
         call hbookb(-104,' data stat dsig/dpt Ds+',nptbin,ptbin,0.)
         call hbookb(-111,' data all dsig/dpt D0 ',nptbin,ptbin,0.)
         call hbookb(-112,' data all dsig/dpt D*+ ',nptbin,ptbin,0.)
         call hbookb(-113,' data all dsig/dpt D+ ',nptbin,ptbin,0.)
         call hbookb(-114,' data all dsig/dpt Ds+',nptbin,ptbin,0.)
	   do i=1,6
	   dsid0to(i) = sqrt(dsid0st(i)**2 + dsid0sy(i)**2)
	   dsidstto(i) = sqrt(dsidstst(i)**2 + dsidstsy(i)**2)
	   dsidplto(i) = sqrt(dsidplst(i)**2 + dsidplsy(i)**2)	   
	   dsidsto(i) = sqrt(dsidsst(i)**2 + dsidssy(i)**2)
	   enddo
         call hpak(-101,dsid0)
         call hpake(-101,dsid0st)
         call hpak(-111,dsid0)
         call hpake(-111,dsid0to)
         call hpak(-102,dsidst)
         call hpake(-102,dsidstst)
         call hpak(-112,dsidst)
         call hpake(-112,dsidstto)
         call hpak(-103,dsidpl)
         call hpake(-103,dsidplst)
         call hpak(-113,dsidpl)
         call hpake(-113,dsidplto)
         call hpak(-104,dsids)
         call hpake(-104,dsidsst)
         call hpak(-114,dsids)
         call hpake(-114,dsidsto)

*
*
*********************************************************************
*                      Event Processing
*
*********************************************************************
*
      Else if(iflag.eq.2) then
*
         call hcdir('//PAWC/'//xxxx,' ')
*
* total number of generated events
         nall=nall+wtx
*
c         ierr=HZIBEAM(ibeam,idum)
c         if (.not.(ierr.eq.1)) then
c            write(6,*) 'HZ'//xxxx,' beams not found ! '
c            return
c         else
c            Do i=1,4
c               pbeam(i)=PHEP(i,IBEAM)
c            enddo
c         endif
*

         charm=.false.
         rapcut = 1.
         nb=0
         nbb=0
c         call hzlihep(0)
         Do  ihep=1,nhep
            If(idhep(ihep).eq.4.and.nb.eq.0.and.
     +   (isthep(ihep).eq.2.or.isthep(ihep).eq.1)) then
               charm=.true.
               nb=nb+1
               Do i=1,4
                  Phb(i)=PHEP(i,ihep)
               enddo
c        write(6,*) ' id = ',idhep(ihep),isthep(ihep),ihep,nb
            endif
            If(idhep(ihep).eq.-4.and.nbb.eq.0.and.
     +   (isthep(ihep).eq.2.or.isthep(ihep).eq.1)) then
               nbb=nbb+1
               Do i=1,4
                  Phbb(i)=PHEP(i,ihep)
                  Phbbar(i) = Phb(i) + Phbb(i)
               enddo
c        write(6,*) ' id = ',idhep(ihep),isthep(ihep),ihep,nbb
            endif
c        write(6,*) ' id = ',idhep(ihep),isthep(ihep),ihep,nb
            if(gen(1:3).eq.'RAP'.or.gen(1:3).eq.'CAS') then
               igl1=4
               igl2=6
            elseif(gen(1:3).eq.'PYT') then
               igl1= 5
               igl2= 6
            endif
            xkt1 = real(sqrt(phep(1,igl1)**2+phep(2,igl1)**2))
            xkt2 = real(sqrt(phep(1,igl2)**2+phep(2,igl2)**2))
c        write(6,*) 'kt ', xkt1,sqrt(kt2_1),xkt2,sqrt(kt2_2)
            x1=real(yy)
            x2=real(xg)
            x1=(phep(4,igl1)+dabs(phep(3,igl1)))/2d0/phep(4,1)
            x2=(phep(4,igl2)+dabs(phep(3,igl2)))/2d0/phep(4,2)
c        write(6,*) ' x',x1,yy,x2,xg
            call hfill(21,real(log10(x1)),0.,1.)
            call hfill(31,real(log10(x2)),0.,1.)
            call hfill(22,xkt1,0.,1.)
            call hfill(32,xkt2,0.,1.)
	   
* Assume JETSET gets the correct branching fraction
* LAB variables
         Do i=1,4
            Phc(i)=phep(i,ihep)
         enddo
c         call hzgetvar(phc,p,pt,et,th,phang,rap,err_flag)
c         write(6,*) ihep,idhep(ihep),p,pt,rap,err_flag
         If (Phc(3).ge.Phc(4)) then
               rap=1000.
         Elseif (Phc(3).le.-Phc(4)) then
               rap=-1000.
         Else
               rap=0.5*Log((Phc(4)+Phc(3))/(Phc(4)-Phc(3)))
         Endif
	   pt = sqrt(phc(1)**2+phc(2)**2)
         if ( err_flag.eq. 0 ) then 
            if(abs(rap).le.rapcut) then
		if(iabs(idhep(ihep)).eq.421.or.
     &         iabs(idhep(ihep)).eq.413.or.
     &         iabs(idhep(ihep)).eq.411.or.
     &         iabs(idhep(ihep)).eq.431) then		
c            write(6,*) ' id = ',idhep(ihep),isthep(ihep),ihep,nb
            call hfill(210,real(log10(x1)),0.,1.)
            call hfill(310,real(log10(x2)),0.,1.)
            call hfill(220,xkt1,0.,1.)
            call hfill(320,xkt2,0.,1.)
		if (iabs(idhep(ihep)).eq.421) then
		   call hfill(101,pt,0.,wtx/2.)
		   call hfill(111,pt,0.,wtx/2.)
		   
	         call hfill(12,pt,max(xkt1,xkt2),1.)
 		elseif (iabs(idhep(ihep)).eq.413) then
		   call hfill(102,pt,0.,wtx/2.)
		   call hfill(112,pt,0.,wtx/2.)
		elseif (iabs(idhep(ihep)).eq.411) then
		   call hfill(103,pt,0.,wtx/2.)
		   call hfill(113,pt,0.,wtx/2.)
		elseif (iabs(idhep(ihep)).eq.431) then
		   call hfill(104,pt,0.,wtx/2.)
		   call hfill(114,pt,0.,wtx/2.)
		endif
	      endif
	      endif
	  endif
        enddo
  10    Continue
*
*********************************************************************
*
*                      Termination
*
*********************************************************************
*
      Else if(iflag.eq.3) then
*
*      Termination: The following MUST always be done
*      (i) Move to the correct PAW subdirectory
*
         call hcdir('//PAWC/'//xxxx,' ')
*
*
*
* Obtain total cross-section
         write(6,*) ' hz',xxxx
         write(6,*) ' hz',xxxx,' Total Cross section in nb',xsec/1000.
         write(6,*) ' hz',xxxx,' nall ',nall
*
*
         lum=999999999.
         lumnb = 999999999.
         if (xsec.ne.0.) then
            lum=real(nall)/real(xsec)
            lumnb = lum*1000
         else
            write(6,*) 'hz',xxxx,' xsec=0 ! '
         endif

*      normalize the histos
	 call hzhinrm(101, 0, lumnb, 1 )
	 call hzhinrm(102, 0, lumnb, 1 )
	 call hzhinrm(103, 0, lumnb, 1 )
	 call hzhinrm(104, 0, lumnb, 1 )
	 call hzhinrm(111, 0, lumnb, 1 )
	 call hzhinrm(112, 0, lumnb, 1 )
	 call hzhinrm(113, 0, lumnb, 1 )
	 call hzhinrm(114, 0, lumnb, 1 )
* 
*
*
      endif
      RETURN
      END
