************************************************************************
 
 
 
 
 
 
 
********************************************
* SUBROUTINES used by subroutine Hz:
********************************************
 
 
      subroutine H1Histo (iid, chtitl, incx, xbins, n, ae, ye)
************************************************************************
*     Subroutine H1Histo builds up 3 histos with H1 data:
*       Histo-ID = - id        for combined errors (ce)
*                = - (1000+id)  for statist. errors (ae) only
*                = - (2000+id)  for syst. errros (ye) only
*
 
      Implicit None
 
      Integer      iid, incx, i
      Real         n, ae, ye, xbins
      Real         ce(20)
      Character*80 chtitl
      Dimension xbins(incx+1)
      Dimension n(incx)
      Dimension ae(incx)
      Dimension ye(incx)
 
      do i = 1, incx
         ce(i) = sqrt( ae(i)**2. + ye(i)**2. )
      enddo
 
      call hbookb(-iid, chtitl, incx, xbins, 0.)
      call hpak(-iid, n)
      call hpake(-iid, ce)
 
      call hbookb(-1000-iid, chtitl, incx, xbins, 0.)
      call hpak(-1000-iid, n)
      call hpake(-1000-iid, ae)
 
      call hbookb(-2000-iid, chtitl, incx, xbins, 0.)
      call hpak(-2000-iid, n)
      call hpake(-2000-iid, ye)
 
      end
