*CMZ :  1.01/07 15/10/97  17.46.40  by  Tancredi Carli
*CMZ :  1.01/05 22/08/96  20.58.04  by   Tancredi Carli
*CMZ :  0.00/08 14/02/96  10.17.48  by  Tancredi Carli
*-- Author :
      Subroutine HzChisq(iddat,idmc)
*********************************************************************
*                                                                   *
* HzChisq                                                           *
* =======                                                           *
* Author: N Brook                                                   *
*                                                                   *
* Input arguments:                                                  *
* Iddat - histogram ID of data                                      *
* Idmc  - Histogram ID of Monte Carlo                               *
*                                                                   *
* Output arguments:                                                 *
* none                                                              *
*                                                                   *
* Routine calculates Chi-sq between Iddat and Idmc and stores       *
* the Iddat, Chi-sq and NdoF in Ntuple 999 in each subdirectory     *
* If ID=999 doesn't exist this routine creates it                   *
*                                                                   *
* Limitations:  The number of bins and range of histograms Iddat    *
*               and idmc have to be an identical                    *
*                                                                   *
*********************************************************************
*
      Implicit None
*
      Integer Ndatpts
      Parameter(Ndatpts=1000)
      Real xdum(Ndatpts),exdum(Ndatpts),ydat(Ndatpts),eydat(Ndatpts)
      Real ymc(Ndatpts), eymc(Ndatpts)
      Real xmi,xma,ymi,yma
      Real xmj,xmb,ymj,ymb,chi
      Integer iddat, idmc, loc, nwt, ndof
      Integer nx, ny, nx1, ny1, ierr, Ichi, ndat
      Double Precision chi2
      Character*80 chtit
      Logical Hexist,lp
      Character*4 tags(3)
      Character rout*10
      Real evt(3)
      Data Tags/'id','chi2','ndof'/,rout/'hzchisq'/,lp/.false./
*
      If(.not.Hexist(999)) then
       Call Hbookn(999,' Chi squares',3,' ',100,Tags)
       if (lp) write(6,*) rout,' book ntuple 9999 '
      endif
*
      Call Hgive(iddat,chtit,nx,xmi,xma,ny,ymi,yma,nwt,loc)
      Call Hgive(idmc,chtit,nx1,xmj,xmb,ny1,ymj,ymb,nwt,loc)
*
      Ierr=1
      If(nx1.ne.nx.or.
     +   xmi.ne.xmj.or.
     1   xma.ne.xmb) Then
        Write(6,*) rout,' Histos:',iddat,
     +             ' and ',idmc,' are different ! '
        Return
      Endif
      Ierr = 0
*
      Call Hrebin(iddat,xdum,ydat,exdum,eydat,nx,1,nx)
      Call Hrebin(idmc,xdum,ymc,exdum,eymc,nx,1,nx)
*     Call Hunpak(idmc,ymc,' ',0)
*
      chi = 0.0
      ndat = 0
      Do Ichi = 1, Nx
        If(eydat(ichi).gt.0.0) Then
          if (eymc(ichi)**2+eydat(ichi)**2.gt.0.) then
           chi = chi + (ymc(ichi)-ydat(ichi))**2/
     1        (eymc(ichi)**2+eydat(ichi)**2)
          else
           chi=-999.
          endif
          ndat = ndat + 1
        Endif
      Enddo
      chi2 = dble(chi)
      evt(1) = real(iddat)
      evt(2) = chi
      evt(3) = real(ndat)
      if (lp) then
       write(6,*) rout,' filling 999 = ',evt
      endif
      Call hfn(999,evt)
*
      Return
      End
