*CMZ :  2.00/00 13/08/99  15.28.43  by  Tancredi Carli
*-- Author :
      Function Hzeegamn(pgam1,pgam2)
*********************************************************
* Purpose:
* Hzipgam flags whether two virtual photons are found
* or not
* Input: none
* Output:
* If found it's 5vec (px,py,px,e,m) for both photons
* are passed back via an argument. pgam1 is the photon
* from the electron, pgam2 is that from the positron.
*
* Original Author: N. Brook
* Modifications for photoproduction : M. Hayes
* Modifications for NLC by J. Butterworth
* PYTHIA and PHOJET modifications: J.Elmsheuser
*
* last change: 02 Aug 99
*********************************************************
      Implicit None
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
*
      Integer intnev
      Data intnev/0/
      DOUBLE PRECISION Pgam1(5), Pgam2(5)

      INTEGER ielectron, ipositron, iloop, emother, pmother
*
      intnev=intnev+1
      Hzeegamn = 1
      if(gen(1:3).eq.'HRW') then
	ielectron=-1
        ipositron=-1
	Do iloop=NHEP,1,-1
	  If (IDHEP(iloop).eq.11.and.ISTHEP(iloop).eq.1) Then
	    ielectron=iloop
	  ENDIF
	  If (IDHEP(iloop).eq.-11.and.ISTHEP(iloop).eq.1) Then
	    ipositron=iloop
	  ENDIF
	Enddo
	Do iloop=NHEP,1,-1
	  If (IDHEP(iloop).eq.11) Then
	    emother=iloop
	  ENDIF
	  If (IDHEP(iloop).eq.-11) Then
	    pmother=iloop
	  ENDIF
	Enddo
	IF (ielectron.ne.-1.and.ipositron.ne.-1) Then
          pgam1(1) = phep(1,emother)-phep(1,ielectron)
          pgam1(2) = phep(2,emother)-phep(2,ielectron)
          pgam1(3) = phep(3,emother)-phep(3,ielectron)
          pgam1(4) = phep(4,emother)-phep(4,ielectron)
          pgam1(5) = phep(5,emother)-phep(5,ielectron)
          pgam2(1) = phep(1,pmother)-phep(1,ipositron)
          pgam2(2) = phep(2,pmother)-phep(2,ipositron)
          pgam2(3) = phep(3,pmother)-phep(3,ipositron)
          pgam2(4) = phep(4,pmother)-phep(4,ipositron)
          pgam2(5) = phep(5,pmother)-phep(5,ipositron)
	  return
	else
          hzeegamn = -1
          Write(6,*)
     &         'Hzeegamn: scattered e+/- not found from ',gen(1:3)
          Return
        endif
*
      ElseIf(gen(1:3).eq.'PHO') then
        If ((IDHEP(3).eq.11).and.(IDHEP(5).eq.-11)) Then
          pgam1(1)=phep(1,4)
          pgam1(2)=phep(2,4)
          pgam1(3)=phep(3,4)
          pgam1(4)=phep(4,4)
          pgam1(5)=phep(5,4)
          pgam2(1)=phep(1,6)
          pgam2(2)=phep(2,6)
          pgam2(3)=phep(3,6)
          pgam2(4)=phep(4,6)
          pgam2(5)=phep(5,6)
	else
          hzeegamn = -1
          Write(6,*)
     &         'Hzeegamn: scattered e+/- not found from ',gen(1:3)
          Return
        Endif
*
      ElseIf(gen(1:3).eq.'PYT') then
	ielectron=-1
        ipositron=-1
	If ((IDHEP(3).eq.11).and.(IDHEP(4).eq.-11)) Then
           ielectron=3
           ipositron=4
	ENDIF
	If ((IDHEP(3).eq.-11).and.(IDHEP(4).eq.11)) Then
	   ielectron=4
           ipositron=3
	ENDIF
	If ((IDHEP(1).eq.11).and.(IDHEP(2).eq.-11)) Then
           emother=1
           pmother=2
        EndIf
	If ((IDHEP(1).eq.-11).and.(IDHEP(2).eq.11)) Then
           emother=2
           pmother=1
	ENDIF
	IF (ielectron.ne.-1.and.ipositron.ne.-1) Then
          pgam1(1) = phep(1,emother)-phep(1,ielectron)
          pgam1(2) = phep(2,emother)-phep(2,ielectron)
          pgam1(3) = phep(3,emother)-phep(3,ielectron)
          pgam1(4) = phep(4,emother)-phep(4,ielectron)
          pgam1(5) = phep(5,emother)-phep(5,ielectron)
          pgam2(1) = phep(1,pmother)-phep(1,ipositron)
          pgam2(2) = phep(2,pmother)-phep(2,ipositron)
          pgam2(3) = phep(3,pmother)-phep(3,ipositron)
          pgam2(4) = phep(4,pmother)-phep(4,ipositron)
          pgam2(5) = phep(5,pmother)-phep(5,ipositron)
	  return
	else
          hzeegamn = -1
          Write(6,*)
     &        'Hzeegamn: scattered e+/- not found from ',gen(1:3)
          Return
        endif
*
      else
        hzeegamn = -1
        Write(6,*) 'Hzeegamn: Unknown Generator ',gen(1:3)
        Return
      endif

      Return
      End
