*CMZ :  1.02/02 23/10/98  11.02.43  by  Tancredi Carli
*-- Author :
      FUNCTION HzEt (ipart)
************************************************************************
*     input:  ipart:        index of particle in HEP common
*     output: return value: transverse energy of particle
*     no other subroutines are called
*     written by: Andreas von Manteuffel
************************************************************************

      IMPLICIT NONE

#include "hepevtp.inc"

      Double Precision HzEt
      Integer ipart
      Double Precision dpx, dpy, dpz, dp, dpt2, dE, dEt

c --- check particle index
      if ((ipart.lt.1).or.(ipart.gt.NHEP)) then
         dEt = 0.D0
      else

c --- get particle momentum components
         dpx = PHEP(1,ipart)
         dpy = PHEP(2,ipart)
         dpz = PHEP(3,ipart)
         dE = PHEP(4,ipart)
         dpt2 = dpx**2+dpy**2
         dp = SQRT(dpt2+dpz**2)

c --- check if calculation is possible
         if (dp.eq.0.D0) then
            dEt = 0.D0
         else

c --- get Et
            dEt = dE*sqrt(dpt2)/dp
         endif
      endif

      HzEt = dEt

      RETURN
      END
