*CMZ :  1.02/02 23/10/98  11.02.43  by  Tancredi Carli
*-- Author :
      FUNCTION HzEta (ipart)
************************************************************************
*     input:  ipart:        index of particle in HEP common
*     output: return value: pseudo-rapidity of particle,
*                           or +/-20.D0 if calculation not possible
*     no other subroutines are called
*     written by: Andreas von Manteuffel
************************************************************************
      IMPLICIT NONE

#include "hepevtp.inc"

      Double Precision HzEta
      Integer ipart
      Double Precision dpx, dpy, dpz, dpt2, dtemp, deta

c --- check particle index
      if ((ipart.lt.1).or.(ipart.gt.NHEP)) then
        deta = 20.D0
      else

c --- get particle momentum components
         dpx = PHEP(1,ipart)
         dpy = PHEP(2,ipart)
         dpz = PHEP(3,ipart)
         dpt2 = dpx**2+dpy**2
         dtemp = (SQRT(dpt2+dpz**2)+ABS(dpz))**2

c --- check if calculation is possible
         if (dpt2.le.4.25E-18*dtemp) then
            deta = 20.D0
         else

c --- get amount of pseudo-rapidity
            deta = 0.5D0*LOG(dtemp/dpt2)
         endif
         deta=SIGN(deta,dpz)

      endif

c --- assign pseudo-rapidity with correct sign to return variable
      HzEta=deta
      RETURN
      END
