*CMZ :  1.01/15 15/05/98  22.31.33  by  Tancredi Carli
*CMZ :  1.00/03 14/03/96  10.18.09  by  Tancredi Carli
*CMZ :  1.00/02 12/03/96  19.17.13  by  Tancredi Carli
*CMZU:  0.00/04 26/01/96  11.57.51  by  Tancredi Carli
*CMZ :  0.00/01 05/01/96  18.26.05  by  HZtool
*-- Author :
      Subroutine HZHCMINI(pbeam,pgam,Ierr)
C#*****************************************************************
C#      Subroutine HZHCMINI(pbeam,pgam,Ierr)
C#      Entry HZHCM(p,pnew,Ierr)
C#
C# HZHCMINI/HZHCM (entry point) : Lorentz boost to hadronic centre of mass
C# PURPOSE : Lorentz boost to hadronic centre of mass
C#
C# INPUT :
C#   PBEAM    =  the 4 vector of the proton beam
C#   PGAM     =  the 4 vector of the virtual exchanged boson
C#   P        =   the vector to be acted upon
C# OUTPUT :
C#   PNEW     =  the boosted vector
C#   IERR     =  an error flag (1 = failed)
C#
C# HZHCMINI - called once an event to set up boost and rotation
C#          variables
C# HZHCM  - perform the actual boost of particles
C#
C# Author: N Brook
C# Modified: introduce SAVE T. Carli May 1998
C#*****************************************************************
*
      Implicit Double Precision (A-H,O-Z)
*
#include "hzfunc.inc"
*
      Dimension pbeam(4), pgam(4)
      Dimension p(4), phcm(4), pnew(4),phcm3(3)
      Dimension Robo(3)
      Logical Lboost
      Save
*
      Ierr = 1
* set up boost parameters
      do 5 ivec = 1, 3
 5    robo(ivec) = (pbeam(ivec)+pgam(ivec))/(pbeam(4)+pgam(4))
c      call hzlihep(0)
c      write(6,*) ' pbeam ', (pbeam(i),i=1,4)
c      write(6,*) ' pgam  ', (pgam(i),i=1,4)
*
      chksq = robo(1)**2+robo(2)**2+robo(3)**2
c        write(6,*) 'HZhcmini chksq = ',chksq, robo(1),robo(2),robo(3)
      If(chksq.gt.1.) then 
        write(6,*) 'HZhcmini chksq = ',chksq, robo(1),robo(2),robo(3)
        Return
        Endif 
* ... and necessary rotation angles
      call hzboost(-robo(1),-robo(2),-robo(3),pgam,phcm)
      phi = HZPHMANG(phcm(1),phcm(2))
      Do 6 ivec=1,3
 6    phcm3(ivec)=phcm(ivec)
      call hzphmrot(-phi,0.d0,phcm3,phcm3)
      Do 7 ivec=1,3
 7    phcm(ivec)=phcm3(ivec)
      theta = HZPHMANG(phcm(3),sqrt(phcm(2)**2+phcm(1)**2))
*
      Ierr = 0
      Return
*
      Entry HZHCM(p,pnew,Ierr)
*
      Ierr = 1
* boost and rotate particle to HZHCM
      call hzboost(-robo(1),-robo(2),-robo(3),p,phcm)
      Do 8 ivec=1,3
 8    phcm3(ivec)=phcm(ivec)
      call hzphmrot(-phi,  0.d0,phcm3,phcm3)
      call hzphmrot(0.d0,-theta,phcm3,phcm3)
      Do ivec = 1, 3
       pnew(ivec)=phcm3(ivec)
      enddo
      pnew(4) = phcm(4)
*
      Ierr = 0
      Return
      End
