*CMZ :  2.00/05 23/04/2001  22.28.48  by  Frank-Peter Schilling
*CMZ :  1.01/13 25/02/98  12.38.39  by  Tancredi Carli
*CMZ :  1.01/12 08/01/98
*-- Author :

      SUBROUTINE HZHCMTOL(IOPT,PLEP2,PHAD2,POUT,P2,Q2,IRET)

       IMPLICIT NONE

*******************************************************************************
* BOOST PARTICLES BETWEEN HADRONIC CMS AND LAB (BOTH DIRECTIONS)
* (wrapping KTFRAM)
*
* Input: IPOT:     0 (boost lab->CMS) 1 (boost CMS->lab)
*        PLEP2(4): 4-vector of of lepton
*        PHAD2(4): 4-vector of of proton
*        POUT2(4): 4-vector of of scattered lepton
*        P2(4):    4-vector of particle before boost
*
* Output: Q2(4):   4-vector of particle after boost
*         IRET:    Error flag (=0: OK)
*
* Author: F.-P.Schilling
*******************************************************************************

      INTEGER N,i,IRET,IOPT
      DOUBLE PRECISION PLEP,PHAD,P(4,1),Q(4,1),p2(4),q2(4),
     &  CMF(4),Z(4),plep2(4),phad2(4),pout(4)

      IRET = 1

      N=1

      do i=1,4
         p(i,1)=p2(i)
      enddo

      plep = plep2(3)
      phad = phad2(3)

C---FIND 4-MOMENTUM OF HADRONIC CMF

      CMF(1)=         -POUT(1)
      CMF(2)=         -POUT(2)
      CMF(3)=    PLEP -POUT(3)+    PHAD
      CMF(4)=ABS(PLEP)-POUT(4)+ABS(PHAD)

C---FIND ROTATION TO PUT INCOMING HADRON BACK ON Z-AXIS

      Z(1)=0.d0
      Z(2)=0.d0
      Z(3)=PHAD
      Z(4)=ABS(PHAD)

      CALL KTFRAM(IOPT,CMF,PHAD,Z,POUT,N,P,Q,*999)
*      CALL KTFRAM(IOPT,CMF,-PHAD,Z,POUT,N,P,Q,*999)

      do i=1,4
         q2(i)=q(i,1)
      enddo

      IRET = 0
      RETURN
 999  print *,'ERROR in HZHCMTOL!!! <<<<<<<<<<<<<<<< !!!'
      iret = 1
      return
      END
