*CMZ :  1.02/03 28/11/98  13.37.06  by  Tancredi Carli
*-- Author :
      FUNCTION HzIdntro (idum)
************************************************************************
*  purpose:
*     HzIdntro returns index of first neutrino in HEP common
*     (for CC events)
*
*     note: current version will only work with LEPTO !
*
*  input:
*     currently only dummy variable
*  output:
*     returned value: id of neutrino in HEP common (if found)
*                     -1 if neutrino finding was not successful
*  structure:
*     no other subroutines are called
*  written by:
*     Andreas von Manteuffel (Oct.98)
*  modified:
*
************************************************************************
      IMPLICIT NONE
*
#include "hepevtp.inc"
#include "heracmn.inc"
*
c --- input argument (dummy variable)
      Integer idum
c --- returned value (id of neutrino in HEP common, -1 for error)
      Integer HzIdntro
*
c --- internal stuff
      Integer iNmess, INMXMESS
      Parameter (INMXMESS=10)
      Data iNmess /0/
      save iNmess
      Integer ihep, ineutrin
*
c --- return -1 if neutrino finding not successful
      ineutrin = -1
*
c --- in current version neutrino finding is only implemented
c     for LEPTO; for other generators the scheme will propably
c     be similiar (see HzIdelec)
*
      if (gen(1:3).eq.'LEP') then
         do ihep = 1, NHEP
            if ((Isthep(ihep).eq.1).and.(abs(Idhep(ihep)).eq.12)) then
               ineutrin = ihep
               goto 200
            endif
         enddo
      else
         if (iNmess.le.INMXMESS) then
            write(6,*)'HzIdntro: unknown generator !'
            iNmess = iNmess + 1
         endif
      endif
*
 200  continue
      HzIdntro = ineutrin
*
      RETURN
      END
