      Function Hzipgamn(pgam)
*********************************************************
* Purpose:
* Hzipgam flags whether a virtual photon is found or not
* Input: none
* Output:
* If found it's 5vec (px,py,px,e,m) are passed back
* via an argument
*
* Original Author: N. Brook
* Modifications for photoproduction : M. Hayes
*********************************************************
      Implicit Double Precision (A-H,O-Z)
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
*
      Integer intnev
      Data intnev/0/
      Dimension Pgam(5)
*
      intnev=intnev+1
      Hzipgamn = 1
      if(gen(1:3).eq.'LEP'.or.gen(1:3).eq.'DSN') Then
        ivirt = 3
        if (intnev.lt.3) then
	 PRINT*,'HZIPGAMn : Warning! You are using a DIS Monte Carlo'
	 PRINT*,'           in a photoproduction routine.'
        endif
*
      elseif(gen(1:3).eq.'DJA') Then
        ivirt = 3
        if (intnev.lt.3.or.intnev.eq.100) then
	 PRINT*,'HZIPGAMn : Warning! You are using a DIS Monte Carlo'
	 PRINT*,'           (DJANGO) in a photoproduction routine.'
        endif
*
      elseif(gen(1:3).eq.'RAP'.or.gen(1:3).eq.'CAS') Then
        ivirt = 3
      elseif(gen(1:3).eq.'SMA') Then
        ivirt = 5
      elseif(gen(1:3).eq.'RID') Then
        if (intnev.lt.3) then
	 PRINT*,'HZIPGAMn : Warning! You are using a DIS Monte Carlo'
	 PRINT*,'           in a photoproduction routine.'
        endif
        pgam(1) = phep(1,1)-phep(1,3)
        pgam(2) = phep(2,1)-phep(2,3)
        pgam(3) = phep(3,1)-phep(3,3)
        pgam(4) = phep(4,1)-phep(4,3)
        pgam(5) = phep(5,1)-phep(5,3)
        return
      elseif(gen(1:3).eq.'PHO') Then
	ivirt=4
      elseif(gen(1:3).eq.'PYT'.or.gen(1:3).eq.'ARI') Then
	ielectron=-1
	Do iloop=NHEP,1,-1
	  If (abs(IDHEP(iloop)).eq.11.and.ISTHEP(iloop).eq.1) Then
	    ielectron=iloop
	  ENDIF
	Enddo
	IF (ielectron.ne.-1) Then
           mother=JMOHEP(1,ielectron)
C     Deal here with new e/gamma mode - JMB, 19/3/99
           IF (JMOHEP(1,mother).ne.0) THEN
              mother = JMOHEP(1,mother)
           ENDIF	
           pgam(1) = phep(1,mother)-phep(1,ielectron)
           pgam(2) = phep(2,mother)-phep(2,ielectron)
           pgam(3) = phep(3,mother)-phep(3,ielectron)
           pgam(4) = phep(4,mother)-phep(4,ielectron)
           pgam(5) = phep(5,mother)-phep(5,ielectron)
           return
        else 
c     try and find an incoming photon if we are in gamma-p mode. JMB 14/1/05
           Do iloop=1,NHEP
              If (abs(IDHEP(iloop)).eq.22.and.ISTHEP(iloop).ne.1) Then
                 pgam(1) = phep(1,iloop)
                 pgam(2) = phep(2,iloop)
                 pgam(3) = phep(3,iloop)
                 pgam(4) = phep(4,iloop)
                 pgam(5) = phep(5,iloop)
                 return
              ENDIF
           Enddo
           hzipgamn = -1
           Write(6,*)
     &          'HZIPGAMn: scattered e+/- not found from ',gen(1:3)
           Return
        endif
      elseif(gen(1:3).eq.'HRW') then
	ielectron=-1
	Do iloop=NHEP,1,-1
	  If (abs(IDHEP(iloop)).eq.11.and.ISTHEP(iloop).eq.1) Then
	    ielectron=iloop
	  ENDIF
	Enddo
	Do iloop=NHEP,1,-1
	  If (abs(IDHEP(iloop)).eq.11) Then
	    mother=iloop
	  ENDIF
	Enddo
	IF (ielectron.ne.-1) Then
          pgam(1) = phep(1,mother)-phep(1,ielectron)
          pgam(2) = phep(2,mother)-phep(2,ielectron)
          pgam(3) = phep(3,mother)-phep(3,ielectron)
          pgam(4) = phep(4,mother)-phep(4,ielectron)
          pgam(5) = phep(5,mother)-phep(5,ielectron)
	  return
	else
          hzipgamn = -1
          Write(6,*)
     &        'HZIPGAMn: scattered e+/- not found from ',gen(1:3)
          Return
        endif
      elseif(gen(1:3).eq.'HO1') then
          pgam(1) = phep(1,3)
          pgam(2) = phep(2,3)
          pgam(3) = phep(3,3)
          pgam(4) = phep(4,3)
          pgam(5) = phep(5,3)
          return
      else
        hzipgamn = -1
        Write(6,*) 'HZIPGAMn: Unknown Generator ',gen(1:3)
        Return
      endif
*
        pgam(1) = phep(1,ivirt)
        pgam(2) = phep(2,ivirt)
        pgam(3) = phep(3,ivirt)
        pgam(4) = phep(4,ivirt)
        pgam(5) = phep(5,ivirt)
      IF (IDHEP(ivirt).eq.22.or.IDHEP(ivirt).eq.23) Then
      ELSE
C        hzipgamn = -1
        Write(6,*) 'HZIPGAMn: photon misidentified in ',gen(1:3)
	Write(6,*) '          particle found id ',IDHEP(ivirt)
      Endif
*
      Return
      End
