*==========================================================

      SUBROUTINE hzkbins(ibin,wbin,x,n,bins,ier)
c
c       Find to which bin (ibin) falls the variable x.
c       Input:  x ... variable
c               n ... number of bins
c               bins(n+1) ... array of bins of variable x
c       Output: ibin ... nr. of bin, to which x actually belonged
c               wbin ... bin width of the bin to which x belonged
c               ier  ... OK flag: 0=O.K., 1=error
c
      implicit none
      
      integer i,n,ibin,nmax,ier
      parameter(nmax=100)
      real x,bins(nmax),wbin

      ibin=-1000
      wbin=-1000.
      ier = 0

      if ((x.lt.bins(1)).or.(x.gt.bins(n+1))) then
        goto 10
      endif

      do i=1,n
        if (x.le.bins(i+1)) then
          ibin=i
          wbin=bins(i+1)-bins(i)
          goto 10
        endif
      enddo
      write(*,*)'kbins: You should never come here !'
      write(*,*)'kbins: x=',x
      ier=1
*      STOP

 10   continue
*      write(*,*)'kbins: ibin,wbin,x,n,bins=',ibin,wbin,x,n,bins
      return
      END
