*CMZ :  1.02/06 03/03/99  18.02.14  by  Tancredi Carli
*CMZ :  1.01/13 23/03/98  18.27.38  by  Tancredi Carli
*CMZ :  1.00/02 12/03/96  18.22.08  by  Tancredi Carli
*CMZ :  0.00/03 08/01/96  16.55.31  by  HZtool
*CMZ :  0.00/01 03/01/96  12.05.22  by  HZtool
*-- Author :
      FUNCTION HZLCOMP(KF)
******************************************************************
* Purpose: to compress the standard KF codes for use in mass and decay
*...arrays; also to check whether a given code actually is defined.
* 0: means not defined
* Input: KF particle code
*Output:
*Author: N. Brook
******************************************************************
*KEEP,HZDAT.
      Integer KCHG
      COMMON/HZDAT/KCHG(500,3)
*
*KEEP,HZFUNC.
*
* Function declarations for Hztool functions
*
          DOUBLE PRECISION HzPhmang
          DOUBLE PRECISION HzDiskin
          DOUBLE PRECISION HzPhokin
          DOUBLE PRECISION HZETA
          DOUBLE PRECISION HZPHI
          DOUBLE PRECISION HZET
          DOUBLE PRECISION HZPT
          DOUBLE PRECISION HZTHETA
          DOUBLE PRECISION hzeekin
          Integer hzeebeam
          Integer hzeegamn
          Integer HzIpgamn
          Integer HzIdelec
          Integer HzIpgam
          Integer HzIbeam
          Integer HzLchge
          Integer HzLcomp
          Integer HzIdntro
*
*KEND.
*
* A. Solano 15.12.98
* The first time the program enters this function ( from hzluhepc(1)
* called by hzfilhep ) COMMON/HZDAT/KCHG(500,3) is still empty, since
* is filled at the first call of function HZLCHGE ( called by hzluncop,
* called by hzfilhep right after hzluhepc(1) ).
* Fill KCHG here copying from HZLCHGE
*      SAVE /LUDAT2/
      DIMENSION KFTAB(25),KCTAB(25)
      logical lp
      DATA KFTAB/211,111,221,311,321,130,310,213,113,223,
     &313,323,2112,2212,210,2110,2210,110,220,330,440,30443,30553,0,0/
      DATA KCTAB/101,111,112,102,103,221,222,121,131,132,
     &122,123,332,333,281,282,283,284,285,286,287,231,235,0,0/
*
      data lp/.false./
*
      Integer i,Loca(500,3)
      Logical Init
      Data Init /.true./
      DATA (LOCA(I,1),I=   1, 500)/-1,2,-1,2,-1,2,-1,2,2*0,-3,0,-3,0,
     &-3,0,-3,6*0,3,9*0,3,2*0,3,0,-1,44*0,2,-1,2,-1,2,3,11*0,3,0,2*3,0,
     &3,0,3,0,3,10*0,3,0,2*3,0,3,0,3,0,3,10*0,3,0,2*3,0,3,0,3,0,3,10*0,
     &3,0,2*3,0,3,0,3,0,3,10*0,3,0,2*3,0,3,0,3,0,3,10*0,3,0,2*3,0,3,0,
     &3,0,3,70*0,3,0,3,28*0,3,2*0,3,8*0,-3,8*0,3,0,-3,0,3,-3,3*0,3,6,0,
     &3,5*0,-3,0,3,-3,0,-3,4*0,-3,0,3,6,-3,0,3,-3,0,-3,0,3,6,0,3,5*0,
     &-3,0,3,-3,0,-3,114*0/
      DATA (LOCA(I,2),I=   1, 500)/8*1,12*0,2,16*0,2,1,50*0,-1,410*0/
      DATA (LOCA(I,3),I=   1, 500)/8*1,2*0,8*1,5*0,1,9*0,1,2*0,1,0,2*1,
     &41*0,1,0,7*1,10*0,10*1,10*0,10*1,10*0,10*1,10*0,10*1,10*0,10*1,
     &10*0,10*1,70*0,3*1,22*0,1,5*0,1,0,2*1,6*0,1,0,2*1,6*0,2*1,0,5*1,
     &0,6*1,4*0,6*1,4*0,16*1,4*0,6*1,114*0/
*
      If(Init) Then
        Init = .false.
C*TC>
        do i=1,500
         kchg(i,1)=loca(i,1)
         kchg(i,2)=loca(i,2)
         kchg(i,3)=loca(i,3)
        enddo
C       Call Ucopy(loca,kchg,1500)
C*TC<
      Endif
*
C...Starting values.
      HZLCOMP=0
      KFA=IABS(KF)
*
      if (lp) then
       write(6,*) ' KF= ',KF,' KFA= ',KFA
      endif
C...Simple cases: direct translation or table.
      IF(KFA.EQ.0.OR.KFA.GE.100000) THEN
        RETURN
      ELSEIF(KFA.LE.100) THEN
        HZLCOMP=KFA
        IF(KF.LT.0.AND.KCHG(KFA,3).EQ.0) HZLCOMP=0
        if (lp) write(6,*) 'kfa<100: HZLCOMP= ',HZLCOMP,KCHG(KFA,3)
        RETURN
      ELSE
        DO 100 IKF=1,23
        IF(KFA.EQ.KFTAB(IKF)) THEN
          HZLCOMP=KCTAB(IKF)
          IF(KF.LT.0.AND.KCHG(HZLCOMP,3).EQ.0) HZLCOMP=0
          if (lp) write(6,*) 'else HZLCOMP= ',HZLCOMP
          RETURN
        ENDIF
  100   CONTINUE
      ENDIF

C...Subdivide KF code into constituent pieces.
      KFLA=MOD(KFA/1000,10)
      KFLB=MOD(KFA/100,10)
      KFLC=MOD(KFA/10,10)
      KFLS=MOD(KFA,10)
      KFLR=MOD(KFA/10000,10)

C...Mesons.
      IF(KFA-10000*KFLR.LT.1000) THEN
        IF(KFLB.EQ.0.OR.KFLB.EQ.9.OR.KFLC.EQ.0.OR.KFLC.EQ.9) THEN
        ELSEIF(KFLB.LT.KFLC) THEN
        ELSEIF(KF.LT.0.AND.KFLB.EQ.KFLC) THEN
        ELSEIF(KFLB.EQ.KFLC) THEN
          IF(KFLR.EQ.0.AND.KFLS.EQ.1) THEN
            HZLCOMP=110+KFLB
          ELSEIF(KFLR.EQ.0.AND.KFLS.EQ.3) THEN
            HZLCOMP=130+KFLB
          ELSEIF(KFLR.EQ.1.AND.KFLS.EQ.3) THEN
            HZLCOMP=150+KFLB
          ELSEIF(KFLR.EQ.1.AND.KFLS.EQ.1) THEN
            HZLCOMP=170+KFLB
          ELSEIF(KFLR.EQ.2.AND.KFLS.EQ.3) THEN
            HZLCOMP=190+KFLB
          ELSEIF(KFLR.EQ.0.AND.KFLS.EQ.5) THEN
            HZLCOMP=210+KFLB
          ENDIF
        ELSEIF(KFLB.LE.5) THEN
          IF(KFLR.EQ.0.AND.KFLS.EQ.1) THEN
            HZLCOMP=100+((KFLB-1)*(KFLB-2))/2+KFLC
          ELSEIF(KFLR.EQ.0.AND.KFLS.EQ.3) THEN
            HZLCOMP=120+((KFLB-1)*(KFLB-2))/2+KFLC
          ELSEIF(KFLR.EQ.1.AND.KFLS.EQ.3) THEN
            HZLCOMP=140+((KFLB-1)*(KFLB-2))/2+KFLC
          ELSEIF(KFLR.EQ.1.AND.KFLS.EQ.1) THEN
            HZLCOMP=160+((KFLB-1)*(KFLB-2))/2+KFLC
          ELSEIF(KFLR.EQ.2.AND.KFLS.EQ.3) THEN
            HZLCOMP=180+((KFLB-1)*(KFLB-2))/2+KFLC
          ELSEIF(KFLR.EQ.0.AND.KFLS.EQ.5) THEN
            HZLCOMP=200+((KFLB-1)*(KFLB-2))/2+KFLC
          ENDIF
        ELSEIF((KFLS.EQ.1.AND.KFLR.LE.1).OR.(KFLS.EQ.3.AND.KFLR.LE.2)
     &  .OR.(KFLS.EQ.5.AND.KFLR.EQ.0)) THEN
          HZLCOMP=80+KFLB
        ENDIF

C...Diquarks.
      ELSEIF((KFLR.EQ.0.OR.KFLR.EQ.1).AND.KFLC.EQ.0) THEN
        IF(KFLS.NE.1.AND.KFLS.NE.3) THEN
        ELSEIF(KFLA.EQ.9.OR.KFLB.EQ.0.OR.KFLB.EQ.9) THEN
        ELSEIF(KFLA.LT.KFLB) THEN
        ELSEIF(KFLS.EQ.1.AND.KFLA.EQ.KFLB) THEN
        ELSE
          HZLCOMP=90
        ENDIF

C...Spin 1/2 baryons.
      ELSEIF(KFLR.EQ.0.AND.KFLS.EQ.2) THEN
        IF(KFLA.EQ.9.OR.KFLB.EQ.0.OR.KFLB.EQ.9.OR.KFLC.EQ.9) THEN
        ELSEIF(KFLA.LE.KFLC.OR.KFLA.LT.KFLB) THEN
        ELSEIF(KFLA.GE.6.OR.KFLB.GE.4.OR.KFLC.GE.4) THEN
          HZLCOMP=80+KFLA
        ELSEIF(KFLB.LT.KFLC) THEN
          HZLCOMP=300+((KFLA+1)*KFLA*(KFLA-1))/6+(KFLC*(KFLC-1))/2+KFLB
        ELSE
          HZLCOMP=330+((KFLA+1)*KFLA*(KFLA-1))/6+(KFLB*(KFLB-1))/2+KFLC
        ENDIF

C...Spin 3/2 baryons.
      ELSEIF(KFLR.EQ.0.AND.KFLS.EQ.4) THEN
        IF(KFLA.EQ.9.OR.KFLB.EQ.0.OR.KFLB.EQ.9.OR.KFLC.EQ.9) THEN
        ELSEIF(KFLA.LT.KFLB.OR.KFLB.LT.KFLC) THEN
        ELSEIF(KFLA.GE.6.OR.KFLB.GE.4) THEN
          HZLCOMP=80+KFLA
        ELSE
          HZLCOMP=360+((KFLA+1)*KFLA*(KFLA-1))/6+(KFLB*(KFLB-1))/2+KFLC
        ENDIF
      ENDIF

      RETURN
      END
