*CMZ :  0.00/03 29/10/98  11.22.03  by  Tancredi Carli
*-- Author :
      SUBROUTINE HzMghepc (imode)
*************************************************************************
*  purpose:   this subroutine saves (imode=1) or recovers (imode=2) the
*             HEP event prime common (using an internal copie)
*
*  structure: no other subroutines or function are called
*
*  comment:   you should not call this subroutine directly, use
*             HzSvhepc or HzRchepc instead !
*
*  written by: Andreas von Manteuffel (Oct. 1998)
*************************************************************************
      IMPLICIT NONE
#include "hepevtp.inc"
c --- subroutine specific declarations

c --- argument
      Integer imode

c --- variables for HEP event prime common copie
      Integer xNEVHEP,xNHEP,xISTHEP(NMXHEP),xIDHEP(NMXHEP)
      Integer xJMOHEP(2,NMXHEP),xJDAHEP(2,NMXHEP)
      Double Precision xPHEP(5,NMXHEP),xVHEP(4,NMXHEP)

      Save xNEVHEP,xNHEP,xISTHEP,xIDHEP
      Save xJMOHEP,xJDAHEP
      Save xPHEP,xVHEP

c --- other variables
      Integer ihad, icount
c ------------------------------------

      if (imode.eq.1) then
c --- SAVE THE COMMON
         xNEVHEP = NEVHEP
         xNHEP = NHEP
         do ihad = 1, NMXHEP
            xISTHEP(ihad) = ISTHEP(ihad)
            xIDHEP(ihad) = IDHEP(ihad)
            do icount = 1, 2
               xJMOHEP(icount,ihad) = JMOHEP(icount,ihad)
               xJDAHEP(icount,ihad) = JDAHEP(icount,ihad)
            enddo
            do icount = 1, 5
               xPHEP(icount,ihad) = PHEP(icount,ihad)
            enddo
            do icount = 1, 4
               xVHEP(icount,ihad) = VHEP(icount,ihad)
            enddo
         enddo
      elseif (imode.eq.2) then
c --- RECOVER THE COMMON
         NEVHEP = xNEVHEP
         NHEP = xNHEP
         do ihad = 1, NMXHEP
            ISTHEP(ihad) = xISTHEP(ihad)
            IDHEP(ihad) = xIDHEP(ihad)
            do icount = 1, 2
               JMOHEP(icount,ihad) = xJMOHEP(icount,ihad)
               JDAHEP(icount,ihad) = xJDAHEP(icount,ihad)
            enddo
            do icount = 1, 5
               PHEP(icount,ihad) = xPHEP(icount,ihad)
            enddo
            do icount = 1, 4
               VHEP(icount,ihad) = xVHEP(icount,ihad)
            enddo
         enddo
      else
         write(6,*)'HzHepc: Bad routine call !'
         write(6,*)'HzHepc: This routine should not be called directly,'
         write(6,*)'please use HzSvhepc and HzRchepc instead.'
      endif

      RETURN
      END
