
      Function Hzppbbeam(ip,ipb)

*******************************************************
* Purpose:
* Find posn of proton and anti-proton beam
* returns
* If find both beams Hzppbeam = 1
* if find only proton beam Hzppbeam = 0
* if find only anti-proton beam Hzppbeam = -1
* Input: 
* Output: ip  pointer to proton
*         ipb pointer to anti-proton
*
* Author; Emily Nurse, James Monk
*******************************************************
C      Implicit Double Precision (A-H,O-Z)
      implicit none
      integer ip, ipb, ipinc, ipbinc, ihep
      Logical  laprot,lprot,lp
      Data lp/.false./
*
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
*
c      write(6,*) ' enter hzppbbeam'
      hzppbbeam = -2
      lprot  = .false.
      laprot = .false.
      ip=-1
      ipb=-1

c     James: We can just find the beam particles by looking 
c            for the line without a mother

c      write(6,*) ' start hzppbbeam '
      ipinc = 1
      ipbinc = 2

      do ihep = 1, nhep
         if( jmohep(1, ihep).le.0 
     &        .or.
     &        jmohep(1, ihep).eq.ihep) then

            if(idhep(ihep).eq.2212)then
               ip = ihep
               if(ipinc.lt.0) then
                  ipinc = 0
               else
                  hzppbbeam = hzppbbeam + ipinc
c                  write(6,*) ' proton beam found ',ip
                  ipinc = -1
               endif
            else if(idhep(ihep).eq.-2212) then
               ipb = ihep
               if(ipbinc.lt.0) then
                  ipbinc = 0
               else
c                  write(6,*) ' anti-proton beam found ',ipb
                  hzppbbeam = hzppbbeam + ipbinc
                  ipbinc = -2
               endif
            endif
         endif
      enddo
      
c      write(6,*) ' hzppbeam ', hzppbbeam
      
c      if(hzppbbeam.le.0) call pylist(1)

c      if(hzppbbeam.eq.1) then
C         write(*,*) 'found beam particle ids: ',
C     &        ip, ', ', ipb
C         write(*,*) 'centre of mass energy = ',
C     &        phep(4, ip) + phep(4, ipb)
c         return
c      endif

      return

c      If(gen(1:3).eq.'PYT'.or.gen(1:3).eq.'ARI'
c     & .or.gen(1:3).eq.'CAS' )Then
c       Do Ihep = 1,Nhep,1

c         If(Isthep(ihep).eq.3
c     +      .and.idhep(ihep).eq.2212) Then
c           ip = ihep
c           hzppbbeam = hzppbbeam + 1
c         Else if(Isthep(ihep).eq.3
c     +           .and.abs(idhep(ihep)).eq.-2212) Then
c     &          .and.abs(idhep(ihep)).eq.2212) then
c           ipb = ihep
c           hzppbbeam = hzppbbeam + 2
c         Endif
c         If(hzppbbeam.eq.1) Return
c       Enddo
c      Else If(gen(1:3).eq.'HRW'.or.gen(1:3).eq.'INS' ) Then
c       Do Ihep = Nhep,1,-1
c         If((Isthep(ihep).eq.101.or.Isthep(ihep).eq.102
c     +   .or.Isthep(ihep).eq.201.or.Isthep(ihep).eq.202)
c     +      .and.idhep(ihep).eq.2212) Then
c           ip = ihep
c           hzppbbeam = hzppbbeam + 1
c         else If((Isthep(ihep).eq.101.or.Isthep(ihep).eq.102
c     +   .or.Isthep(ihep).eq.201.or.Isthep(ihep).eq.202)
c     +      .and.idhep(ihep).eq.-2212) Then
c           ipb = ihep
c           hzppbbeam = hzppbbeam + 2
c         Endif
c         If(hzppbbeam.eq.1) Return
c       Enddo
c      Else If(gen(1:3).eq.'PHO') Then
* Trivial since the Proton should be particle 1, anti-proton part. 2
c	IF (idhep(1).eq.2212) Then
c           ip = 1
c           hzppbbeam = hzppbbeam + 1
c         Endif
c        If (idhep(2).eq.-2212) Then
c          ipb = 2
c           hzppbbeam = hzppbbeam + 2
c         Endif
c         If(hzppbbeam.eq.1) Return
c      Else If(gen(1:3).eq.'POM') Then
* Trivial since the Proton should be particle 1, anti-proton part. 2
c	IF (idhep(1).eq.2212) Then
c           ip = 1
c           hzppbbeam = hzppbbeam + 1
c         Endif
c        If (idhep(2).eq.-2212) Then
c           ipb = 2
c           hzppbbeam = hzppbbeam + 2
c         Endif
c         If(hzppbbeam.eq.1) Return
c      Else
c       write(6,*) '**hzppbeam: generator not found gen=',gen
c      Endif
*
c      Return
      End
