*CMZ :  1.02/02 23/10/98  11.02.43  by  Tancredi Carli
*-- Author :
      FUNCTION HzRap (ipart)
************************************************************************
*     input:  ipart:        index of particle in HEP common
*     output: return value: rapidity of particle,
*                           or -1 if E <= pz, -2 if particle does not exist
*     no other subroutines are called
*     written by: Oliver Gutsche
************************************************************************
      IMPLICIT NONE
 
*KEEP,HEPEVTP.
*
* HEP event prime common
* (for explanation see manual)
      Integer NMXHEP
      PARAMETER (NMXHEP=4000)
      Integer NEVHEP,NHEP,ISTHEP,IDHEP
      Integer JMOHEP,JDAHEP
      Double Precision PHEP,VHEP
      COMMON/HEPEVTP/NEVHEP,NHEP,ISTHEP(NMXHEP),IDHEP(NMXHEP),
     & JMOHEP(2,NMXHEP),JDAHEP(2,NMXHEP),PHEP(5,NMXHEP),VHEP(4,NMXHEP)
*
*KEND.
 
      Double Precision HzRap
      Integer ipart
      Double Precision dpz, de, drap
 
c --- check particle index
      if ((ipart.lt.1).or.(ipart.gt.NHEP)) then
        drap = -2.D0
      else
 
c --- get particle momentum components
         dpz = PHEP(3,ipart)
         de =  PHEP(4,ipart)
 
c --- check if calculation is possible, else caluclate
         if (de.le.dpz) then
            drap = -1.D0
         else
            drap = 0.5D0*LOG((de+dpz)/(de-dpz))
         endif
      endif
 
      HzRap=drap
      RETURN
      END
