**********************************************************   
      Subroutine hzxgam2j(jet1, jet2, iel, Xgamma)
*
* Calculate Xgamma via sum_{jets}(E-pz)/sum_{HFS}(E-pz)
* jet1/jet2 are jet indices in jet common, 
* iel is index of scattered lepton in PHEP
* Xgamma is the output
      IMPLICIT NONE
* arguments
      Integer jet1, jet2, iel
      Double Precision Xgamma
* commons
#include "hepevtp.inc"
#include "heracmn.inc"
#include "hzfunc.inc"
#include "hzjetcmn.inc"
*
*
*
* local variables      
      Double Precision JetSum, HFSsum
      Integer I
      
      HFSSum = 0.d0 ! sum over all HFS
      JetSum = 0.d0 ! sum over jets

      Do I=1, NHEP
         If (I.ne.iel) Then
            If (ISTHEP(I).eq.1) then
               HFSsum= HFSsum + (PHEP(4,I) - PHEP(3,I))
            endif
            If (IJETNO(I).eq.jet1.or.IJETNO(I).eq.jet2) Then
               JetSum= JetSum + (PHEP(4,I) - PHEP(3,I))
            End If  
	 End If  
      End Do

      Xgamma = JetSum/HFSsum

      RETURN
      END

