 
**********************************************************************
      subroutine seterror( iid, iidnew, syserr )
**********************************************************************
* Normalize a given 1-dim histogram with factors 1/nevt and 1/binwidth
* works also for non-equidistant bins (from hzhinrm by M.Kuhlen)
*
* Arguments:
* iid      histogram id to be normalized
* iidnew   new histo id (if 0, old histo is modified)
* revt     normalization factor (usually # events)
* iifl     flag=1: normalize errors too, otherwise they are zeroed
* ibin     divide by bin width 0-no, 1-yes
**********************************************************************
      IMPLICIT NONE
*
      Integer   id, idnew,  ifl, iifl, iid, iidnew,nmax, ibin, iibin
*! max # of bins
      Parameter(nmax=200)
      Real      cont(nmax), err(nmax), zeroes(nmax), revt, rrevt
      Integer nx,ny,ntw,iad,i,idfill
      Real xmin,xmax,ymin,ymax,xleft,xright,binw,hie,hi
      Real Hsum
      Character*80  title,rout*10
      Logical hexist
      real syserr(*)
      Data zeroes / nmax*0. /,rout/'TW:NORMAL:'/
*
*                                         PAW gets confused with types
      id    = iid
      idnew = iidnew
      revt  = rrevt
      ifl   = iifl
      ibin  = iibin
*                                             check existence of histo
      if( .not.hexist(id) ) then
         write(6,*) rout,' non-existent histo id ',id
         goto 9999
      endif
*                                            get title, number of bins
      call hgive(id, title, nx, xmin, xmax, ny, ymin, ymax, ntw, iad)
*
      if( nx .eq. 0 ) then
         write(6,*) rout,' histo with 0 bins, id= ',id
         goto 9999
      elseif( nx .gt. nmax ) then
         write(6,*) rout,' histo with #bins>max, id= ',id,nx,nmax
         goto 9999
      endif
*                                         loop over histogram channels
*                                               careful with last bin!
      do i=1,nx
*                                                    lower edge of bin
         call hix(id,i,xleft)
*                                                    upper edge of bin
         xright=xmax
         if(i.lt.nx) call hix(id,i+1,xright)
*                                                            bin width
         binw = xright-xleft
         if(ibin.eq.0) binw=1.0
*                                                          bin content
         cont(i) = hi(id,i)
*                                                  corresponding error
         err(i)  = hie(id,i)
         err(i) = sqrt((err(i)/cont(i))**2 + syserr(i)**2)*cont(i)
 
      enddo
 
      print *,'hz99094',id,idnew
      call hcopy(id,idnew,title)
*                                                   reset target histo
      call hreset(idnew,title)
*
*                                  pack normalized contents into histo
*
      call hpak(idnew,cont)
      call hpake(idnew,err)
 
*
*
 9999 continue
      return
      end
