 
 
 
**********************************************************************
*  subroutines called by hz98038:
**********************************************************************
 
      subroutine ZSpsi (id, chtitl, psi, erra, errtu, errtd)
*****************************************************************************
*     Subroutine ZSpsi builds up 3 histos with ZEUS data:
*       Histo-ID = - (100+id)  for statist. errors (erra) only
*                = - (300+id)  for total up errors (errtu)
*                = - (400+id)  for total down errors (errtd)
*
 
      Implicit None
 
      Integer      id
      Real         psi, erra, errtu, errtd
      Character*80 chtitl
      Dimension psi(10)
      Dimension erra(10)
      Dimension errtu(10)
      Dimension errtd(10)
 
      call hbook1(-100-id, chtitl, 10, 0.05, 1.05, 0.)
      call hpak(-100-id, psi)
      call hpake(-100-id, erra)
 
      call hbook1(-300-id, chtitl, 10, 0.05, 1.05, 0.)
      call hpak(-300-id, psi)
      call hpake(-300-id, errtu)
 
      call hbook1(-400-id, chtitl, 10, 0.05, 1.05, 0.)
      call hpak(-400-id, psi)
      call hpake(-400-id, errtd)
 
      end
